
# put the *.o files in the a.out, not the shared library
LINK_INTO = $(LINK_INTO/$(VERSION))
LINK_INTO/debug     = AOUT
#LINK_INTO/optimized = AOUT
LINK_INTO/optimized = LIBJVM

# apply this setting to link into the shared library even in the debug version:
LINK_INTO = LIBJVM

# If MAKE_OPTO is null, then we will compile with the -DOPTO.
# That switch, despite its name, has the effect of __disabling__ OPTO.
$(MAKE_OPTO)CFLAGS += -DOPTO

CFLAGS += -fPIC
CFLAGS += -Winline
CFLAGS += -fwritable-strings
CFLAGS += -fno-rtti
CFLAGS += -fhandle-exceptions
CFLAGS += -D__STDC__=1 -D_LARGEFILE64_SOURCE -DTEMPLATE_TABLE_BUG
CFLAGS += -D__GNU__ -D_REENTRANT
CFLAGS += -fcheck-new

# Set GCC_SAVE_TEMPS=-save-temps to keep temporary files (.ii, .s).
CFLAGS += $(GCC_SAVE_TEMPS)

# The flags to use for an Optimized g++ build
OPT_CFLAGS += -O3

# Set the environment variable HOTSPARC_HOTSPARC_GENERIC to "true"
# to inhibit the effect of the previous line on CFLAGS.

CPP = g++
CC  = gcc

AOUT_FLAGS += -export-dynamic 
DEBUG_CFLAGS += -g
