# Sets make macros for making optimized version of Gamma VM
# (This is the "product", not the "release" version.)

# Compiler specific OPT_CFLAGS are passed in from gcc.make, sparcWorks.make
OPT_CFLAGS/DEFAULT= $(OPT_CFLAGS)
OPT_CFLAGS/BYFILE = $(OPT_CFLAGS/$@)$(OPT_CFLAGS/DEFAULT$(OPT_CFLAGS/$@))

# (OPT_CFLAGS/SLOWER is also available, to alter compilation of buggy files)

# If you set HOTSPARC_GENERIC=yes, you disable all OPT_CFLAGS settings
CFLAGS$(HOTSPARC_GENERIC) += $(OPT_CFLAGS/BYFILE)

# Linker mapfiles
MAPFILE = $(GAMMADIR)/build/solaris/makefiles/mapfile-vers

# From top level Makefile, not exported ---
OS		= $(subst SunOS,solaris,$(shell uname))
ARCH		= $(subst i386,i486,$(shell uname -p))

REORDERFILE = $(GAMMADIR)/build/solaris/makefiles/reorder_$(TYPE)_$(ARCH)

# Take a platform-specific action to strip libjvm.so to its minimum size:
# This macro is defined initially as a no-op, but see sparcWorks.make, etc.
STRIP_LIB.CC/POST_HOOK = 
LINK_LIB.CC/POST_HOOK += $(STRIP_LIB.CC/POST_HOOK)

# Set the environment variable HOTSPARC_GENERIC to "true"
# to inhibit the effect of the previous line on CFLAGS.

G_SUFFIX =
SYSDEFS += -DPRODUCT
SYSDEFS += -xF
VERSION = optimized
