# @(#)rules.make	1.1 00/02/10 09:20:22
# Common rules/macros for the vm, adlc.

# Tell make that .cpp is important
.SUFFIXES: .cpp $(SUFFIXES)

# For now.  Other makefiles use CPP as the c++ compiler, but that should really
# name the preprocessor.
ifeq	($(CCC),)
CCC		= $(CPP)
endif

DEMANGLER	= c++filt
DEMANGLE	= $(DEMANGLER) < $@ > .$@ && mv -f .$@ $@

# $(CC) is the c compiler (cc/gcc), $(CCC) is the c++ compiler (CC/g++).
C_COMPILE	= $(CC) $(CPPFLAGS) $(CFLAGS)
CC_COMPILE	= $(CCC) $(CPPFLAGS) $(CFLAGS)

COMPILE.c	= $(C_COMPILE) -c
GENASM.c	= $(C_COMPILE) -S
LINK.c		= $(CC) $(LFLAGS) $(AOUT_FLAGS) $(PROF_AOUT_FLAGS)
LINK_LIB.c	= $(CC) $(LFLAGS) -G
PREPROCESS.c	= $(C_COMPILE) -E

COMPILE.CC	= $(CC_COMPILE) -c
GENASM.CC	= $(CC_COMPILE) -S
LINK.CC		= $(CCC) $(LFLAGS) $(AOUT_FLAGS) $(PROF_AOUT_FLAGS)
LINK_NOPROF.CC	= $(CCC) $(LFLAGS) $(AOUT_FLAGS)
LINK_LIB.CC	= $(CCC) $(LFLAGS) -G
PREPROCESS.CC	= $(CC_COMPILE) -E

# Synonyms.
COMPILE.cpp	= $(COMPILE.CC)
GENASM.cpp	= $(GENASM.CC)
LINK.cpp	= $(LINK.CC)
LINK_LIB.cpp	= $(LINK_LIB.CC)
PREPROCESS.cpp	= $(PREPROCESS.CC)

# 'gmake MAKE_VERBOSE=y' or 'gmake QUIETLY=' gives all the gory details.
QUIETLY$(MAKE_VERBOSE)	= @

# With parallel makes, print a message at the end of compilation.
ifeq	($(findstring j,$(MFLAGS)),j)
COMPILE_DONE	= && { echo Done with $<; }
endif

%.o: %.cpp
	@echo Compiling $<
	$(QUIETLY) $(COMPILE.CC) -o $@ $< $(COMPILE_DONE)

%.s: %.cpp
	@echo Generating assembly for $<
	$(QUIETLY) $(GENASM.CC) -o $@ $<
	$(QUIETLY) $(DEMANGLE) $(COMPILE_DONE)

# Intermediate files (for debugging macros)
%.i: %.cpp
	@echo Preprocessing $< to $@
	$(QUIETLY) $(PREPROCESS.CC) $< > $@ $(COMPILE_DONE)
