@echo off
REM  @(#)create.bat	1.8 99/05/11 16:46:23
REM 
REM Copyright 1993-1997 Sun Microsystems, Inc. 901 San Antonio Road,
REM Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
REM 
REM This software is the confidential and proprietary information of Sun
REM Microsystems, Inc. ("Confidential Information").  You shall not
REM disclose such Confidential Information and shall use it only in
REM accordance with the terms of the license agreement you entered into
REM with Sun.
REM 
REM CopyrightVersion 1.2

REM This is the interactive build setup script (as opposed to the batch
REM build execution script). It creates $HotSpotBuildSpace if necessary,
REM copies the appropriate files out of $HotSpotWorkSpace into it, and
REM builds and runs MakeDeps in it. This has the side-effect of creating
REM the vm.dsp file in the buildspace, which is then used in Visual C++.
REM 
REM The generated project file depends upon the include databases. If
REM those are changed then MakeDeps is rerun.

if not "%2" == ""      goto usage
if "%1" == "core"      goto start
if "%1" == "compiler1" goto start
if "%1" == "compiler2" goto start
goto usage

:start

REM Test all environment variables to see whether the directories they
REM reference exist

if exist %HotSpotWorkSpace% goto test1

echo Error: directory pointed to by HotSpotWorkSpace environment
echo variable does not exist, or the variable is not set.
echo.
goto usage

:test1
if exist %HotSpotBuildSpace% goto test2
echo Error: directory pointed to by HotSpotBuildSpace environment
echo variable does not exist, or the variable is not set.
echo.
goto usage

:test2
if exist %HotSpotBinDest% goto makedir
echo Error: directory pointed to by HotSpotBinDest environment
echo variable does not exist, or the variable is not set.
echo.
goto usage

:makedir
echo NOTE: Using the following environment variable settings:
echo   HotSpotWorkSpace=%HotSpotWorkSpace%
echo   HotSpotBuildSpace=%HotSpotBuildSpace%
echo   HotSpotBinDest=%HotSpotBinDest%

if EXIST %HotSpotBuildSpace% goto copyfiles
mkdir %HotSpotBuildSpace%

REM This is now safe to do.
:copyfiles
copy %HotSpotWorkSpace%\build\win32_i486\projectfiles\%1\* %HotSpotBuildSpace%

REM Build MakeDeps in the buildspace

pushd %HotSpotBuildSpace%
nmake
popd

goto end

:usage
echo Usage: create version
echo.
echo where version is "core", "compiler1" or "compiler2".
echo.
echo This is the interactive build setup script (as opposed to the batch
echo build execution script). It creates $HotSpotBuildSpace if necessary,
echo copies the appropriate files out of $HotSpotWorkSpace into it, and
echo builds and runs MakeDeps in it. This has the side-effect of creating
echo the vm.dsp file in the build space, which is then used in Visual C++.
echo.
echo The generated project file depends upon the include databases. If
echo those are changed then MakeDeps is rerun.
echo.
echo NOTE that it is now NOT safe to modify any of the files in the build
echo space, since they may be overwritten whenever this script is run or
echo nmake is run in that directory.

:end

