# @(#)makedeps.make	1.8 00/03/27 14:27:45
# 
# Copyright 1993-1997 Sun Microsystems, Inc. 901 San Antonio Road,
# Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
# 
# This software is the confidential and proprietary information of Sun
# Microsystems, Inc. ("Confidential Information").  You shall not
# disclose such Confidential Information and shall use it only in
# accordance with the terms of the license agreement you entered into
# with Sun.
# 
# CopyrightVersion 1.2

# These are the commands used externally to compile and run MakeDeps.

!ifdef BootStrapDir
MakeDepsJava=$(BootStrapDir)\bin\java
MakeDepsJavaC=$(BootStrapDir)\bin\javac
!else
MakeDepsJava=java
MakeDepsJavaC=javac
!endif

# This is used externally by both batch and IDE builds, so can't
# reference any of the HOTSPOTWORKSPACE, HOTSPOTBUILDSPACE, or
# HOTSPOTBINDEST environment variables.
#
# NOTE: unfortunately the MakeDepsSources list must be kept
# synchronized between this and the Solaris version
# (build/solaris/makefiles/makedeps.make).

MakeDepsSources=\
	$(WorkSpace)\src\share\tools\MakeDeps\Database.java \
	$(WorkSpace)\src\share\tools\MakeDeps\DirectoryTree.java \
	$(WorkSpace)\src\share\tools\MakeDeps\DirectoryTreeNode.java \
	$(WorkSpace)\src\share\tools\MakeDeps\FileFormatException.java \
	$(WorkSpace)\src\share\tools\MakeDeps\FileList.java \
	$(WorkSpace)\src\share\tools\MakeDeps\FileName.java \
	$(WorkSpace)\src\share\tools\MakeDeps\Macro.java \
	$(WorkSpace)\src\share\tools\MakeDeps\MacroDefinitions.java \
	$(WorkSpace)\src\share\tools\MakeDeps\MakeDeps.java \
	$(WorkSpace)\src\share\tools\MakeDeps\MetroWerksMacPlatform.java \
	$(WorkSpace)\src\share\tools\MakeDeps\Platform.java \
	$(WorkSpace)\src\share\tools\MakeDeps\UnixPlatform.java \
	$(WorkSpace)\src\share\tools\MakeDeps\WinGammaPlatform.java

# This is only used internally
MakeDepsIncludesPRIVATE=\
	-relativeInclude src\share\vm\c1 -relativeInclude src\share\vm\compiler -relativeInclude src\share\vm\code -relativeInclude src\share\vm\interpreter -relativeInclude src\share\vm\ci -relativeInclude src\share\vm\jvmci -relativeInclude src\share\vm\lookup -relativeInclude src\share\vm\asm -relativeInclude src\share\vm\memory -relativeInclude src\share\vm\oops -relativeInclude src\share\vm\prims -relativeInclude src\share\vm\runtime -relativeInclude src\share\vm\utilities -relativeInclude src\share\vm\libadt -relativeInclude src\share\vm\opto -relativeInclude src\os\win32\vm -relativeInclude src\os_cpu\win32_i486\vm -relativeInclude src\cpu\i486\vm

# This is referenced externally by both the IDE and batch builds
MakeDepsOptions=-firstFile functionAtStart.cpp -lastFile functionAtEnd.cpp

# This is used externally, but only by the IDE builds, so we can
# reference environment variables which aren't defined in the batch
# build process.

# Common options for the IDE builds for core, c1, and c2
MakeDepsIDEOptions=\
	-sourceBase $(HOTSPOTWORKSPACE) -startAt src -dspFileName $(HOTSPOTBUILDSPACE)\vm.dsp -envVar HotSpotWorkSpace -dllLoc $(HOTSPOTBINDEST) -define ALIGN_STACK_FRAMES -conditionalPerFileLine interpreter_abs.cpp "" " ADD CPP /Ze" -perFileLine java.cpp " ADD CPP /Yc\"incls/_precompiled.incl\"" -perFileLine functionAtStart.cpp " SUBTRACT CPP /YX /Yc /Yu" -perFileLine functionAtEnd.cpp " SUBTRACT CPP /YX /Yc /Yu" -perFileLine os_win32.cpp " SUBTRACT CPP /YX /Yc /Yu" -perFileLine os_win32_i486.cpp " SUBTRACT CPP /YX /Yc /Yu" -perFileLine osThread_win32.cpp " SUBTRACT CPP /YX /Yc /Yu" -perFileLine conditionVar_win32.cpp " SUBTRACT CPP /YX /Yc /Yu" -perFileLine getThread_win32_i486.cpp " SUBTRACT CPP /YX /Yc /Yu" -conditionalPerFileLine templateTable_i486.cpp " ADD CPP /Yu" "" -additionalFile includeDB_adlc -additionalFile includeDB_ci -additionalFile includeDB_compiler1 -additionalFile includeDB_compiler2 -additionalFile includeDB_core -additionalFile includeDB_coreonly $(MakeDepsIncludesPRIVATE)

# Add in build-specific options
!if "$(Variant)" == "compiler1"
MakeDepsIDEOptions=$(MakeDepsIDEOptions) -define COMPILER1 -perFileLine c1_RInfo_i486.cpp " SUBTRACT CPP /YX /Yc /Yu"
!endif

!if "$(Variant)" == "compiler2"
MakeDepsIDEOptions=$(MakeDepsIDEOptions) -define COMPILER2 -additionalFile win32_i486.ad -ignoreFile ad_i486.cpp -ignoreFile ad_i486.hpp -ignoreFile dfa_i486.cpp -ignoreFile adGlobals_i486.hpp -additionalGeneratedFile HotSpotBuildSpace incls ad_i486.cpp -additionalGeneratedFile HotSpotBuildSpace incls ad_i486.hpp -additionalGeneratedFile HotSpotBuildSpace incls dfa_i486.cpp -additionalGeneratedFile HotSpotBuildSpace incls adGlobals_i486.hpp -perFileLine opcodes.cpp " SUBTRACT CPP /YX /Yc /Yu"
!endif
