/*
 * @(#)adapters_i486.cpp	1.11 00/03/17 16:31:43
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

#include "incls/_precompiled.incl"
#include "incls/_adapters_i486.cpp.incl"

// sets up the C2I adapter when a deoptimization happens so that
// code can now be transferred to the interpreted frames
frame C2IAdapter::unpack_c2i_adapter(jint *caller_sp, vframeArray* vframe_array) {
  frame adapter_frame(caller_sp - frame_size(), NULL, return_from_interpreter());
  return adapter_frame;
}

// this function returns the adjust size (in number of words) to a c2i adapter
// activation for use during deoptimization
int Deoptimization::last_frame_adjust(int callee_parameters, int callee_locals ) {
  return 0;
}

// Machine dependent code for computing the 'last_i2c_frame' adjust amount.
int vframeArray::i2c_frame_adjust( int callee_parameters, int callee_locals ) {
  // Need size of I2C adapter to pop.  The I2C's sp starts where the de-opting
  // frame ends, at array->sp()+array->frame_size().  The I2C's frame ends at
  // the next frame's sp, last_i2c_frame.  Compute I2C's framesize as the diff.
  return _last_i2c_frame.sp() - (sp()+frame_size());
}

