// @(#)c1_AllocTable_i486.hpp	1.4 00/03/15 11:37:30
// 
// Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
// Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
// 
// This software is the confidential and proprietary information of Sun
// Microsystems, Inc. ("Confidential Information").  You shall not
// disclose such Confidential Information and shall use it only in
// accordance with the terms of the license agreement you entered into
// with Sun.
// 
// CopyrightVersion 1.2


public:
  enum {
    nofRegs = FrameMap::nof_cpu_regs
  };

  enum {
    nofRegsExp2   = 64,               // 2 ** nofRegs
    allFreeState  = 0,                // state when all registers are released
    noneFreeState = nofRegsExp2 - 1   // state when no registers are free
  };

private:
  // the statics are initialized with init_free_reg_table
  static int _reg_mask [nofRegs];
  static int _free_reg [nofRegsExp2];

  int _state;    // bitmap: 0x0 means that all registers free
  int _or_state; // or's all states: amm registers used
  int _lock_out; // debugging: check that no wrong registers get locked
                 // any register specified in _lock_out should never be locked

  void reg_check (int rnr) const { assert(0 <= rnr && rnr < nofRegs, "wrong register number"); }

public:
  static void init_tables ();
