// @(#)c1_CodeEmitter_i486.hpp	1.152 01/02/09 14:42:50
// 
// Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road,
// Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
// 
// This software is the confidential and proprietary information of Sun
// Microsystems, Inc. ("Confidential Information").  You shall not
// disclose such Confidential Information and shall use it only in
// accordance with the terms of the license agreement you entered into
// with Sun.
// 
// CopyrightVersion 1.2


 private:

  Address::ScaleFactor array_element_size(BasicType type) const;
  Assembler::Condition icond2acond(Instruction::Condition cond) const;

  // FPU stack simulation
  void fpu_push(RInfo reg);
  void fpu_pop (RInfo reg);
  void fpu_on_tos    (RInfo reg); // makes sure that reg is on tos
  void fpu_two_on_tos(RInfo tos0, RInfo tos1, bool must_be_ordered);
  bool must_swap_two_on_tos(RInfo tos0, RInfo tos1);

  Address  item2addr_with_offset  (Item* item, int offset);
  Address  item2addr_with_offsetLO(Item* item, int offset);
  Address  item2addr_with_offsetHI(Item* item, int offset);

  Address  item2array_addr  (Item* array, Item* index, BasicType dst_type, int offset = 0);
  Address  item2array_addrLO(Item* array, Item* index, BasicType dst_type);
  Address  item2array_addrHI(Item* array, Item* index, BasicType dst_type);

  Address  receiver_address_in_prolog ();

  // code emission
  void move_reg            (Register to, Register from);
  void swap_reg_with_tmp   (Register a, Register b, Register tmp);

  void ac_check_for_negative  (Register reg, int v, Label* l);
  void ac_check_length (Register arr, Register lng_reg, Register pos_reg, int pos_v, Register tmp, Label* l);
  void ac_memory_start (Register arr, Register pos_reg, int pos_v, Register tmp, BasicType type);

  // CPU stack tracker
  void push_int  (jint i);
  void push_oop  (jobject o);
  void push_addr (Address addr);
  void push_reg  (Register reg);
  void pop       (Register reg);
  void dec_stack (int nof_words);
  void dec_stack_after_call(int nof_words);
  void remove_all_stack();

  void monitorenter(Register obj_reg, Register lock_reg, Register hdr, int monitor_no, CodeEmitInfo* info);
  void monitorexit (Register obj_reg, Register lock_reg, Register hdr, int monitor_no, Register exception);

  void nops_for_zombie();

//---------------------------------PUBLIC-------------------------------------
 public:


  // ======================== code emission ==================================


  // used by CodeStubs only
  Register receiver_reg() const; 
