/*
 * @(#)c2_globals_i486.hpp	1.16 01/02/09 14:42:53
 *
 * Copyright 1993-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2
//
// Sets the default values for platform dependent flags used by the server compiler.
// (see c2_globals.hpp).  Alpha-sorted.

define_pd_global(bool, BackgroundCompilation,        true);
define_pd_global(bool, CICompileOSR,                 true);
define_pd_global(bool, InlineIntrinsics,             true);
define_pd_global(bool, PreferInterpreterNativeStubs, true);
define_pd_global(bool, UseC2CallingConventions,      true);
define_pd_global(bool, UseOnStackReplacement,        true);
define_pd_global(bool, UseTypeProfile,               false); 
define_pd_global(int,  CompileThreshold,             10000);
define_pd_global(int,  CompileThresholdMax,          100000);
define_pd_global(int,  CompileThresholdMin,          2000);
define_pd_global(int,  ConditionalMoveLimit,         4); // Design center runs on 1.3.1
define_pd_global(int,  FLOATPRESSURE,                6);
define_pd_global(int,  FreqInlineSize,		     325);
define_pd_global(int,  INTPRESSURE,                  6);
define_pd_global(int,  InteriorEntryAlignment,       0);
define_pd_global(int,  NewRatio,                     8); // Design center runs on 1.3.1
define_pd_global(int,  NewSizeThreadIncrease,        4*K);
define_pd_global(int,  OptoLoopAlignment,            16);
define_pd_global(int,  RegisterCostAreaRatio,        16000);

// Peephole and CISC spilling both break the graph, and so makes the
// scheduler sick.
define_pd_global(bool, OptoPeephole,                 true);
define_pd_global(bool, UseCISCSpill,                 true);
define_pd_global(bool, OptoScheduling,               false);
define_pd_global(bool, OptoBundling,                 false);
define_pd_global(int,  LoopUnrollLimit,		     25); // Design center runs on 1.3.1
define_pd_global(int,  MaxPermSize,		     64*M );
