/*
 * @(#)extendedPC_i486.cpp	1.6 99/06/22 16:37:37
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

# include "incls/_precompiled.incl"
# include "incls/_extendedPC_i486.cpp.incl"


ExtendedPC ExtendedPC::adjust(address begin, address end, address new_begin) {
  assert(is_contained_in(begin, end), "must be contained");

  // The compiler inserts the nop, nop sequence in loops to provide safepoints.
  // This nop, nop sequence is getting patched to an illegal instruction by
  // the safepoint code. If we stopped at the second nop instruction, the pc
  // will no longer point to a valid instruction.
  while(nativeInstruction_at(_pc)->is_nop()) {    
    _pc += NativeInstruction:: nop_instruction_size;       
  }
  address new_pc = new_begin + (_pc - begin);      
  return ExtendedPC(new_pc);
}


address ExtendedPC::contained_pc() { 
  return _pc; 
}


bool ExtendedPC::is_contained_in(address begin, address end) {
  return begin <= _pc && _pc < end;
}
