/*
 * @(#)interpreterRT_i486.hpp	1.13 99/06/22 16:37:44
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2


// native method calls

class SignatureHandlerGenerator: public NativeSignatureIterator {
 private:
  MacroAssembler* _masm;

  void move(int from_offset, int to_offset);
  void box(int from_offset, int to_offset);

  void pass_int()                                { move(-offset(), offset() + 1); }
  void pass_long()                               { move(-offset(), offset() + 2); move(-offset() - 1, offset() + 1); }
  void pass_object()                             { box (-offset(), offset() + 1); }

 public:
  // Creation
  SignatureHandlerGenerator(methodHandle method, CodeBuffer* buffer) : NativeSignatureIterator(method) {
    _masm = new MacroAssembler(buffer);
  }

  // Code generation
  void generate();

  // Code generation support
  static Register from();
  static Register to();
  static Register temp();
};


static void    prepare_native_call   (JavaThread* thread, methodOop method);
static address slow_signature_handler(JavaThread* thread, methodOop method, jint* from, jint* to);

