/*
 * @(#)jniTypes_i486.hpp	1.9 00/01/04 11:39:26
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// This file holds platform-dependent routines used to write primitive jni 
// types to the array of arguments passed into JavaCalls::call

class JNITypes : AllStatic {
  // these functions scribble a java primitive type to a jint array to be passed as arguments to JavaCalls:calls

public:
  static inline void    put_int(jint* from, jint* to, int& pos)       { assert((int(to) & 3) == 0, "must be int aligned"); to[pos++] = from[0]; }
  static inline void    put_int2(jint* from, jint* to, int& pos)      { assert((int(to) & 3) == 0, "must be int aligned"); to[pos++] = from[1]; to[pos++] = from[0]; }

  static inline void    put_long(jlong* from, jint* to, int& pos)     { put_int2((jint*)from, to, pos); }
  static inline void    put_obj(jobject* from, jint* to, int& pos)    { put_int((jint*)from, to, pos);  }
  static inline void    put_float(jfloat* from, jint* to, int& pos)   { put_int((jint*)from, to, pos);  }
  static inline void    put_double(jdouble* from, jint* to, int& pos) { put_int2((jint*)from, to, pos); }

  static inline jlong   get_long(jint *from)                          { return *((jlong *)from); }
  static inline jfloat  get_float(jint *from)                         { return *((jfloat *)from); }
  static inline jdouble get_double(jint *from)                        { return *((jdouble *)from); }

  static inline void    put_float(jfloat *from, jint *to)             { *(jfloat *)to = *from; }
  // note: "raw" functions below do not swap words like put_long and put_double
  static inline void    put_raw_double(jdouble *from, jint *to)       { *(jdouble *)to = *from; }
  static inline void    put_raw_long(jlong *from, jint *to)           { *(jlong *)to = *from; }
};
