// @(#)memory_i486.hpp	1.5 00/08/03 15:04:17
// 
// Copyright 1993-1999 Sun Microsystems, Inc. 901 San Antonio Road,
// Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
// 
// This software is the confidential and proprietary information of Sun
// Microsystems, Inc. ("Confidential Information").  You shall not
// disclose such Confidential Information and shall use it only in
// accordance with the terms of the license agreement you entered into
// with Sun.
// 
// CopyrightVersion 1.2


  // Inline functions for memory copy and fill:

  static void pd_copy_oops(oop* from, oop* to, int count) {
    memcpy(to,from, count * oopSize);
  }

  static void pd_copy_oops_aligned(oop* from, oop* to, int count) {
    memcpy(to,from, count * oopSize);
  }

  static void pd_copy_oops_overlapping(oop* from, oop* to, int count) {
    memmove(to,from, count * oopSize);
  }

  static void pd_copy_oops_overlapping_atomic(oop* from, oop* to, int count) {
    // Do better than this for Merlin, inline memmove body
    if (from > to) {
      while (count-- > 0) *to++ = *from++; // copy forwards
    } else {
      from = &from[count];
      to = &to[count];
      while (count-- > 0) *--to = *--from; // copy backwards
    }
  }

  static void pd_copy_oops_aligned_overlapping(oop* from, oop* to, int count) {
    memmove(to,from, count * oopSize);
  }

  static void pd_set_oops(oop* to, int count, oop value) {
    while (count-- > 0) *to++ = value;
  }

  static void pd_copy_bytes_overlapping(void* from, void* to, int count) {
    memmove(to,from, count);
  }

  static void pd_set_words(jint* to, int count, int value) {
    while (count-- > 0) *to++ = value;
  }
