/*
 * @(#)stubRoutines_i486.hpp	1.49 01/02/09 14:43:05
 *
 * Copyright 1993-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// This file holds the platform specific parts of the StubRoutines
// definition. See stubRoutines.hpp for a description on how to
// extend it.

enum platform_dependent_constants {
  code_size1 =  9000,		// simply increase if too small (assembler will crash if too small)
  code_size2 = 22000		// simply increase if too small (assembler will crash if too small)
};

class i486 {
 friend class StubGenerator;

 private:
  static address _handler_for_divide_by_zero_entry;
  static address _handler_for_null_exception_entry;
  static address _handler_for_stack_overflow_entry;  
  static address _get_previous_fp_entry;  
#ifndef CORE
  static address _dsin_fast_wrapper;
  static address _dcos_fast_wrapper;
#endif

 public:
  // Call back points for traps in compiled code
  static address handler_for_divide_by_zero()                { return _handler_for_divide_by_zero_entry; }
  static address handler_for_null_exception()                { return _handler_for_null_exception_entry; }
  static address handler_for_stack_overflow()                { return _handler_for_stack_overflow_entry; }
  static address get_previous_fp_entry()                     { return _get_previous_fp_entry; }

#ifndef CORE
  // Versions used when not calling StrictMath
  static address dsin_fast_wrapper();
  static address dcos_fast_wrapper();
  static jdouble dsin_fast(jdouble x);
  static jdouble dcos_fast(jdouble x);
  // Accurate argument reduction for using hardware sin/cos routines
  static int __ieee754_rem_pio2(double x, double *y);
#endif
};

