/*
 * @(#)adapters_sparc.cpp	1.11 00/03/17 16:49:25
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

#include "incls/_precompiled.incl"
#include "incls/_adapters_sparc.cpp.incl"

// sets up the C2I adapter when a deoptimization happens so that
// code can now be transferred to the interpreted frames
frame C2IAdapter::unpack_c2i_adapter(jint *caller_sp, vframeArray* vframe_array) {
  Deoptimization::UnrollBlock* info = vframe_array->unroll_block();
  int callee_locals_size = (info->frame_sizes()[0]/wordSize - frame_size());
  assert(callee_locals_size == round_to(callee_locals_size, WordsPerLong), 
	 "must align");
  frame adapter_frame(caller_sp - info->frame_sizes()[0]/wordSize, frame::unpatchable, return_from_interpreter());
  jint *oldSP = adapter_frame.sp() + callee_locals_size;

  *(adapter_frame.register_addr( IsavedSP )) = (jint)oldSP;
  *(adapter_frame.register_addr( Lesp )) = (jint)(caller_sp - 1);
  *(adapter_frame.register_addr( IsizeCalleeParms )) = 0;
  return adapter_frame;
}

// this function returns the adjust size (in number of words) to a c2i adapter
// activation for use during deoptimization
int Deoptimization::last_frame_adjust(int callee_parameters, int callee_locals ) {
  assert( callee_locals >= callee_parameters, 
	  "test and remove; got more parms than locals" );
  if( callee_locals < callee_parameters )
    return 0;			// No adjustment for negative locals
  return round_to((callee_locals - callee_parameters), WordsPerLong);
}

// Machine dependent code for computing the 'last_i2c_frame' adjust amount.
int vframeArray::i2c_frame_adjust( int callee_parameters, int callee_locals ) {
  int i2c_frame_adjust = Deoptimization::last_frame_adjust(callee_parameters, callee_locals);
  _last_i2c_frame.set_sp( _last_i2c_frame.sp() - i2c_frame_adjust );
  return i2c_frame_adjust;
}

//Reconciliation History
// 1.2 98/10/07 14:20:20 adapters_i486.cpp
// 1.3 98/11/15 18:22:55 adapters_i486.cpp
// 1.6 99/06/28 10:59:51 adapters_i486.cpp
//End
