/*
 * @(#)c1_AllocTable_sparc.hpp	1.1 00/01/12 10:17:23
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

 public:
  enum {
    max = 32
  };

  static void init_tables ();

 private:
  // the statics are initialized with init_reg_table
  static int _reg_mask[max];

  int _size;           // number of valid bits
  int _state;          // bitmap: 0 means all registers free
  int _or_state;       // or of all states over time
  int _lockout;        // any register specified in _lockout should never be locked
  int _none_available; // bitmap when all registers are locked

  void reg_check (int rnr) const { assert(0 <= rnr && rnr < _size, "wrong register number"); }
  bool is_lockout(int rnr) const { reg_check(rnr); return _reg_mask[rnr] & _lockout; }
