/*
 * @(#)c1_CodeStubs_sparc.cpp	1.23 01/02/09 14:43:14
 *
 * Copyright 1993-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2


#include "incls/_precompiled.incl"
#include "incls/_c1_CodeStubs_sparc.cpp.incl"


#define __ ce->masm()->

void StaticCallStub::emit_code(CodeEmitter* ce) {
//   int nof_reg_args = FrameMap::nof_reg_args;
//   int argcnt = sig_types()->length();
//   GrowableArray<int> reg_args = GrowableArray<int>(nof_reg_args, nof_reg_args, -1);
//   CallingConvention* parameters = FrameMap::calling_convention(*sig_types(), &reg_args);
//   FrameMap fm(0, false);
//   fm.set_size_arguments(sig_types()->length());
//   fm.set_size_locals   (sig_types()->length());
//   for (int r = 0; r < nof_reg_args; r++) {
//     int idx = reg_args.at(r);
//     if (idx == -1) break; // no more arguments in registers
//     BasicType t = sig_types()->at(r);
//     switch (t) {
//     case T_INT:
//     case T_OBJECT:
//     case T_ARRAY:
//       __ st(Register('o', r), Address(SP, 0, fm.local_offset_from_fp(idx, false)));
//       break;
//     default:
//       ShouldNotReachHere();
//       break;
//     }
//   }
  __ relocate(static_stub_Relocation::spec(_call_pc));
  __ set_oop(NULL, G5);
  // must be set to -1 at code generation time
  Address a(G3, (address)-1);
  __ jump_to(a, 0);
  __ delayed()->nop();
}

void RangeCheckStub::emit_code(CodeEmitter* ce) { 
  __ bind(_entry);

  // Note: do not use %o registers as they may contain oops
  __ set(_pc_offset, G1);
  __ call(Runtime1::entry_for(Runtime1::range_check_failed_id), relocInfo::runtime_call_type);
  __ delayed()->nop();  
}


void DivByZeroStub::emit_code(CodeEmitter* ce) {
  __ bind(_entry);

  // Note: do not use %o registers as they may contain oops
  __ set(_pc_offset, G1);
  __ call(Runtime1::entry_for(Runtime1::throw_div0_exception_id), relocInfo::runtime_call_type);
  __ delayed()->nop();
}


void NullExceptionStub::emit_code(CodeEmitter* ce) {
  // Note: do not use %o registers as they may contain oops
  Unimplemented();
}


// Implementation of CheckCastStub

CheckCastStub::CheckCastStub(Register k, CodeEmitInfo* info, Register dst, int esp_offset): 
_k(k), _info(NULL), _esp_offset(esp_offset), _dst(dst) {
  _info = new CodeEmitInfo(info);
}


// Note: %g1 and %g3 are already in use
void CheckCastStub::emit_code(CodeEmitter* ce) {
  __ bind(_entry);
  __ mov(_dst, G4); // _dst contains the object to test
  __ call(Runtime1::entry_for(Runtime1::checkcast_id), relocInfo::runtime_call_type);
  __ delayed()->mov_or_nop(_k, G5);
  ce->add_call_info_here(_info);
  __ br(Assembler::always, false, Assembler::pt, _continuation);
  __ delayed()->mov_or_nop(G5, _dst);
}


InstanceOfStub::InstanceOfStub(Register obj_klass, Register result, Register k, CodeEmitInfo* info, int esp_offset): 
_obj_klass(obj_klass), _result(result), _k(k), _info(NULL), _esp_offset(esp_offset) {
  _info = new CodeEmitInfo(info);
}

// Implementation of InstanceOfStub

// Note: %g1 and %g3 are already in use
void InstanceOfStub::emit_code(CodeEmitter* ce) {
  __ bind(_entry);
  __ mov(_obj_klass, G4);
  __ call(Runtime1::entry_for(Runtime1::instanceof_id), relocInfo::runtime_call_type);
  __ delayed()->mov_or_nop(_k, G5);
  ce->add_call_info_here(_info);
  __ br(Assembler::always, false, Assembler::pt, _continuation);
  __ delayed()->mov_or_nop(G5, _result);
}

// Implementation of ArrayStoreCheckStub

ArrayStoreCheckStub::ArrayStoreCheckStub(Register array, Register value, Register index, int index_const, CodeEmitInfo* info, int esp_offset):
_array(array), _value(value), _index(index), _index_const(index_const), _esp_offset(esp_offset) {
  _info = new CodeEmitInfo(info);
}


void ArrayStoreCheckStub::emit_code(CodeEmitter* ce) {
  __ bind(_entry);
  __ mov(_array, G4);
  __ mov(_value, G5);
  __ call(Runtime1::entry_for(Runtime1::store_check_id), relocInfo::runtime_call_type);
  __ delayed()->nop();
  ce->add_call_info_here(_info);

  __ mov(G4, _array);
  __ mov(G5, _value);
  __ br(Assembler::always, false, Assembler::pt, _continuation);
  __ delayed()->nop();

}




// Implementation of ICacheStub

void ICacheStub::emit_code(CodeEmitter* ce) {
  const Register temp_reg = Gscratch;
  Address ic_miss(temp_reg, Runtime1::entry_for(Runtime1::handle_ic_miss_id));
  __ bind(_entry);
  __ jump_to(ic_miss, 0);
  __ delayed()->nop();
}

// Implementation of NewInstanceStub

NewInstanceStub::NewInstanceStub(Register klass, CodeEmitInfo* info, int esp_offset) {
  assert(esp_offset == 0, "esp_offset not used for sparc");
  _klass = klass;
  _info = new CodeEmitInfo(info);
}


void NewInstanceStub::emit_code(CodeEmitter* ce) {
  __ bind(_entry);
  __ mov (_klass, G4);
  __ call(Runtime1::entry_for(Runtime1::new_instance_id), relocInfo::runtime_call_type);
  __ delayed()->nop();
  ce->add_call_info_here(_info);
  __ br(Assembler::always, false, Assembler::pt, _continuation);
  __ delayed()->nop();
}


// Implementation of NewTypeArrayStub

NewTypeArrayStub::NewTypeArrayStub(BasicType elt_type, Register length, Register result, CodeEmitInfo* info, int esp_offset) {
  assert(esp_offset == 0, "esp_offset not used for sparc");
  _elt_type = elt_type;
  _length = length;
  _result = result;
  _info = new CodeEmitInfo(info);
}


void NewTypeArrayStub::emit_code(CodeEmitter* ce) {
  __ bind(_entry);
  __ mov(_length, G5);
  ce->constant_2_reg((jint)_elt_type, FrameMap::_g4_RInfo);
  __ call(Runtime1::entry_for(Runtime1::new_type_array_id), relocInfo::runtime_call_type);
  __ delayed()->nop();
  ce->add_call_info_here(_info);
  __ br(Assembler::always, false, Assembler::pt, _continuation);
  __ delayed()->mov_or_nop(G4, _result);
}


// Implementation of NewObjectArrayStub

NewObjectArrayStub::NewObjectArrayStub(Register klass, Register length, Register result, CodeEmitInfo* info, int esp_offset) {
  assert(esp_offset == 0, "esp_offset not used for sparc");
  _klass = klass;
  _length = length;
  _result = result;
  _info = new CodeEmitInfo(info);
}


void NewObjectArrayStub::emit_code(CodeEmitter* ce) {
  __ bind(_entry);
  __ mov(_length, G5);
  __ mov(_klass, G4);
  __ call(Runtime1::entry_for(Runtime1::new_object_array_id), relocInfo::runtime_call_type);
  __ delayed()->nop();
  ce->add_call_info_here(_info);
  __ br(Assembler::always, false, Assembler::pt, _continuation);
  __ delayed()->mov_or_nop(G4, _result);
}


// Implementation of MonitorAccessStubs

MonitorEnterStub::MonitorEnterStub(Register obj_reg, Register lock_reg, CodeEmitInfo* info, int esp_offset)
           : MonitorAccessStub(obj_reg, lock_reg) {
  assert(esp_offset == 0, "esp_offset not used for sparc");
  _info = new CodeEmitInfo(info);
}


void MonitorEnterStub::emit_code(CodeEmitter* ce) {
  __ bind(_entry);
  __ mov(_obj_reg, O0);
  __ call(Runtime1::entry_for(Runtime1::monitorenter_id), relocInfo::runtime_call_type);
  __ delayed()->mov_or_nop(_lock_reg, O1);
  ce->add_call_info_here(_info);
  __ br(Assembler::always, true, Assembler::pt, _continuation);
  __ delayed()->nop();
}


void MonitorExitStub::emit_code(CodeEmitter* ce) {
  __ bind(_entry);
  if (_compute_lock) {
    Register reg = _lock_addr.base();
    int offset = _lock_addr.disp();
    // compute pointer to BasicLock
    if (_lock_addr.is_simm13()) {
      __ add(reg, offset, _lock_reg);
    }
    else {
      __ set(offset, _lock_reg);
      __ add(reg, _lock_reg, _lock_reg);
    }
  }
  __ mov(_obj_reg, G4); 
  __ call(Runtime1::entry_for(Runtime1::monitorexit_id), relocInfo::runtime_call_type);
  __ delayed()->mov_or_nop(_lock_reg, G5);
  __ br(Assembler::always, true, Assembler::pt, _continuation);
  __ delayed()->nop();
}

// Implementation of patching: 
// - Copy the code at given offset to an inlined buffer (first the bytes, then the number of bytes)
// - Replace original code with a call to the stub
// At Runtime:
// - call to stub, jump to runtime 
// - in runtime: preserve all registers (especially objects, i.e., source and destination object)
// - in runtime: after initializing class, restore original code, reexecute instruction 

void PatchingStub::emit_code(CodeEmitter* ce) {
  // copy original code here
  assert(NativeCall::instruction_size <= _bytes_to_copy && _bytes_to_copy <= 0xFF,
	 "not enough room for call");
  assert((_bytes_to_copy & 0x3) == 0, "must copy a multiple of four bytes");

  // This is the way I found this code (copying a byte at a time).  It was no doubt a carryover
  // from the i486 code.  We should be able to do this a word at a time since on Sparc we will
  // always have a multiple of four bytes to copy.  Unfortunately, I don't know at the moment
  // how to emit a 4-byte word (I found emit_byte() and emit_long(), but no emit_word()), so 
  // this code lives a little longer...
  for (int i = 0; i < _bytes_to_copy; i++) {
    address ptr = (address)(_pc_start + i);
    int a_byte = (*ptr) & 0xFF;
    __ a_byte (a_byte);
  }
  // We need to emit a full word, so let's insert three bytes of zeroes to fill the high order bits.
  // See the preceding comment.
  __ a_byte(0);
  __ a_byte(0);
  __ a_byte(0);
  __ a_byte(_bytes_to_copy);
  address entry = __ pc();
  NativeCall::insert((address)_pc_start, entry);
  address target = NULL;
  switch (_id) {
    case access_field_id:  target = Runtime1::entry_for(Runtime1::init_check_patching_id); break;
    case load_klass_id:    target = Runtime1::entry_for(Runtime1::load_klass_patching_id); break;
    default: ShouldNotReachHere();
  }

  __ save_frame(0);
  __ call(target, relocInfo::runtime_call_type);
  __ delayed()->restore();
  if (_id == load_klass_id) {
    CodeBuffer* cb = __ code();
    address pc = (address)_pc_start;
    RelocIterator iter(cb, pc, pc + 1);
    relocInfo::change_reloc_info_for_address(&iter, (address) pc, relocInfo::oop_type, relocInfo::none);

    pc = (address)(_pc_start + 2*wordSize);
    RelocIterator iter2(cb, pc, pc+1);
    relocInfo::change_reloc_info_for_address(&iter2, (address) pc, relocInfo::oop_type, relocInfo::none);
  }

}

ArrayCopyStub::ArrayCopyStub(ArrayCopyDesc* desc, CodeEmitInfo* info, int esp_offset):
      _desc(desc), _esp_offset(esp_offset) {
  _info = new CodeEmitInfo(info);
}


void ArrayCopyStub::push_parameter(CodeEmitter* ce, int param_ix, Register r) {
  int nof_params = 5;
  FrameMap f(0, NULL);
  f.set_size_arguments(nof_params);
  f.set_size_locals   (nof_params);
  int offset_in_words = f.local_offset_from_fp(param_ix, false, false);
  int offset_from_sp = offset_in_words  * wordSize;
  ce->store(r, SP, offset_from_sp, T_INT   );
}


void ArrayCopyStub::push_params(CodeEmitter* ce) {
  // push parameters
  // Change this to this when passing parameters in registers
  if (PassParametersInRegisters) {
    NEEDS_CLEANUP    // use calling_convention
    // we know current calling convention and implement it simple
    __ mov(src(),         O0);
    __ mov(src_pos_reg(), O1);
    __ mov(dst(),         O2);
    __ mov(dst_pos_reg(), O3);
    __ mov(length_reg(),  O4);
  } else {
    push_parameter(ce, 0, src());
    push_parameter(ce, 1, src_pos_reg());
    push_parameter(ce, 2, dst());
    push_parameter(ce, 3, dst_pos_reg());
    push_parameter(ce, 4, length_reg());
  }
}

void ArrayCopyStub::emit_code(CodeEmitter* ce) {
  assert(!UseC2CallingConventions, "not implemented");
  __ bind(_entry);

  //---------------slow case: call to native-----------------
  push_params(ce);
  { StaticCallStub* stub = new StaticCallStub(__ pc(), NULL);
    // This append is OK, as ArrayCopyStub is not part of call_stubs
    ce->_call_stubs->append(stub);
    __ call(Runtime1::entry_for(Runtime1::resolve_invokestatic_id), relocInfo::static_call_type);
    __ delayed()->nop();
    ce->add_call_info_here(_info);
  }

  __ br(Assembler::always, false, Assembler::pt, _continuation);
  __ delayed()->nop();

  //-----------------fast case: call to runtime, no checks -----------------------------------------
  // for array copy without checks
  __ bind(_noCheckEntry);
  __ unimplemented();
}



#undef __


//Reconciliation History
// 1.28 99/09/03 10:59:57 c1_CodeStubs_i486.cpp
//End
