/*
 * @(#)c1_FrameMap_sparc.hpp	1.15 01/02/09 14:43:16
 *
 * Copyright 1993-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2



 public:
  enum {
    pd_stack0 = 96     // *** or is it 128?
  };
  enum {
    nof_reg_args = 6   // registers o0-o5 are available for parameter passing
  };


  static RInfo _g0_RInfo;
  static RInfo _g1_RInfo;
  static RInfo _g2_RInfo;
  static RInfo _g3_RInfo;
  static RInfo _g4_RInfo;
  static RInfo _g5_RInfo;
  static RInfo _g6_RInfo;
  static RInfo _g7_RInfo;
  static RInfo _O0_RInfo;
  static RInfo _O1_RInfo;
  static RInfo _O2_RInfo;
  static RInfo _O3_RInfo;
  static RInfo _O4_RInfo;
  static RInfo _O5_RInfo;
  static RInfo _O6_RInfo;
  static RInfo _O7_RInfo;
  static RInfo _L0_RInfo;
  static RInfo _L1_RInfo;
  static RInfo _L2_RInfo;
  static RInfo _L3_RInfo;
  static RInfo _L4_RInfo;
  static RInfo _L5_RInfo;
  static RInfo _L6_RInfo;
  static RInfo _L7_RInfo;
  static RInfo _I0_RInfo;
  static RInfo _I1_RInfo;
  static RInfo _I2_RInfo;
  static RInfo _I3_RInfo;
  static RInfo _I4_RInfo;
  static RInfo _I5_RInfo;
  static RInfo _I6_RInfo;
  static RInfo _I7_RInfo;

  static RInfo _noRInfo;
  static RInfo _I0_I1_RInfo;
  static RInfo _O0_O1_RInfo;
  static RInfo _O2_O3_RInfo;
  static RInfo _f0_RInfo;
  static RInfo _f0_double_RInfo;

 private:
  static FloatRegister  _fpu_regs [nof_fpu_regs];

  static c1_RegMask _callee_save_regs;
  static c1_RegMask _caller_save_regs;
  
 public:
  static FloatRegister nr2floatreg (int rnr);

  static c1_RegMask callee_save_regs()  { return _callee_save_regs; }
  static c1_RegMask caller_save_regs()  { return _caller_save_regs; }

  static bool is_caller_save_register (RInfo  reg, bool is_C_call = false);
  static bool is_caller_save_register (Register r, bool is_C_call = false);
  static RInfoCollection* caller_save_registers   (bool is_C_call = false);

  void add_spill_slots        (int nof_slots);
  int local_offset_from_fp   (int local_index, bool is_two_word, bool for_hi_word) const;
  int spill_offset_from_fp   (int spill_index, bool is_two_word, bool for_hi_word) const;
  int monitor_offset_from_fp (int monitor_index) const;
