/*
 * @(#)c1_RInfo_sparc.cpp	1.8 00/01/20 15:38:21
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

# include "incls/_precompiled.incl"
# include "incls/_c1_RInfo_sparc.cpp.incl"


//-------------------------------------------------------
//                 RInfo
//-------------------------------------------------------

FloatRegister RInfo::as_float_reg() const {
  return FrameMap::nr2floatreg(float_reg());
}

FloatRegister RInfo::as_double_reg() const {
  return FrameMap::nr2floatreg(double_reg());
}

void RInfo::set_word_reg(const Register& r) {
  set_word_reg(FrameMap::cpu_reg2rnr(r));
}

void RInfo::set_long_reg(const Register& lo, const Register& hi) {
  set_long_reg(FrameMap::cpu_reg2rnr(lo), FrameMap::cpu_reg2rnr(hi));
}

void RInfo::set_float_reg(const FloatRegister& f) {
  set_float_reg(f.number());
}

void RInfo::set_double_reg(const FloatRegister& d) { 
  set_double_reg(d.number());
}
