/*
 * @(#)c1_RInfo_sparc.hpp	1.10 00/04/05 09:49:15
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2



 public:
  FloatRegister as_float_reg   () const;
  FloatRegister as_double_reg  () const;

  RInfo(const Register& r)                                { set_word_reg(r);      }
  RInfo(const Register& lo, const Register& hi)           { set_long_reg(lo, hi); }
  RInfo(const FloatRegister& f, bool is_double) {
    if (is_double) {
      set_double_reg(f);
    } else {
      set_float_reg(f);
    }
  }

  void set_word_reg   (const Register& r);
  void set_long_reg   (const Register& lo, const Register& hi);
  void set_float_reg  (const FloatRegister& f);
  void set_double_reg (const FloatRegister& d);
  void pd_print_fpu () const {
    if (is_float()) {
      tty->print(as_float_reg().name());
    } else {
      assert(is_double(), "must be an fpu rinfo");
      tty->print(as_double_reg().name());
    }
  }
