/*
 * @(#)c2_globals_sparc.hpp	1.13 01/02/09 14:43:19
 *
 * Copyright 1993-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2
//
// Sets the default values for platform dependent flags used by the server compiler.
// (see c2_globals.hpp).  Alpha-sorted.

define_pd_global(bool, BackgroundCompilation,        true);
define_pd_global(bool, CICompileOSR,                 true);
define_pd_global(bool, InlineIntrinsics,             false);
define_pd_global(bool, PreferInterpreterNativeStubs, true);
define_pd_global(bool, UseC2CallingConventions,      true); 
define_pd_global(bool, UseOnStackReplacement,        true);
define_pd_global(bool, UseTypeProfile,               true); // Deutsch-Shiffman inlining buys us a few percent
define_pd_global(int,  CompileThreshold,             10000);
define_pd_global(int,  CompileThresholdMax,          100000);
define_pd_global(int,  CompileThresholdMin,          2000);
define_pd_global(int,  ConditionalMoveLimit,         4);
define_pd_global(int,  FLOATPRESSURE,                24);
define_pd_global(int,  FreqInlineSize,		     100);  // Design center runs on 1.3.1
define_pd_global(int,  INTPRESSURE,                  26);
define_pd_global(int,  InteriorEntryAlignment,       16);  // = CodeEntryAlignment
define_pd_global(int,  NewRatio,		     2);
define_pd_global(int,  NewSizeThreadIncrease,	     4*K);
// The default setting 16/16 seems to work best.
// (For _228_jack 16/16 is 2% better than 4/4, 16/4, 32/32, 32/16, or 16/32.)
define_pd_global(int,  OptoLoopAlignment,            16);  // = 4*wordSize
define_pd_global(int,  RegisterCostAreaRatio,	     12000);
define_pd_global(int,  LoopUnrollLimit,	     	     60); // Design center runs on 1.3.1

// Peephole and CISC spilling both break the graph, and so makes the
// scheduler sick.
define_pd_global(bool, OptoPeephole,                 false);
define_pd_global(bool, UseCISCSpill,                 false);
define_pd_global(bool, OptoScheduling,               true );
define_pd_global(bool, OptoBundling,                 false);
define_pd_global(int,  MaxPermSize,		     64*M );
