/*
 * @(#)debug_sparc.cpp	1.11 00/07/04 23:31:36
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2


#include "incls/_precompiled.incl"
#include "incls/_debug_sparc.cpp.incl"

#ifndef PRODUCT

extern "C" void findpc(int x);


void pd_ps(frame f) {
  jint* sp = f.sp();
  jint* prev_sp = sp - 1;
  jint *pc = NULL;
  jint *next_pc = NULL;
  int count = 0;
  tty->print("register window backtrace from %#x:\n", sp);
  while (sp != NULL && ((int)sp & 7) == 0 && sp > prev_sp && sp < prev_sp+1000) {
    pc      = next_pc;
    next_pc = (jint*) sp[I7.sp_offset_in_saved_window()];
    tty->print("[%d] sp=%#x pc=", count, sp);
    findpc((int)pc);
    if (WizardMode && Verbose) {
      // print register window contents also
      tty->print_cr("    L0..L7: {%#x %#x %#x %#x %#x %#x %#x %#x}",
		    sp[0+0],sp[0+1],sp[0+2],sp[0+3],
		    sp[0+4],sp[0+5],sp[0+6],sp[0+7]);
      tty->print_cr("    I0..I7: {%#x %#x %#x %#x %#x %#x %#x %#x}",
		    sp[8+0],sp[8+1],sp[8+2],sp[8+3],
		    sp[8+4],sp[8+5],sp[8+6],sp[8+7]);
      // (and print stack frame contents too??)

#ifndef CORE
      CodeBlob *b = CodeCache::find_blob((address) pc);
      if (b != NULL) {
	if (b->is_nmethod()) {
#ifdef COMPILER1
	  methodOop m = ((nmethod*)b)->method();
	  int nlocals = m->max_locals();
	  int nparams  = m->size_of_parameters();
	  tty->print_cr("compiled java method (locals = %d, params = %d)", nlocals, nparams);
	  
	  jint *fp = (jint *)sp[FP.sp_offset_in_saved_window()];

	  // print params
	  tty->print_cr("params:");
	  for (int p=nparams-1; p>=0; p--) {
	    tty->print_cr("  %8x:[fp+%3d]: %#x",fp+23+p,23+p,*(fp+23+p));
	  }

	  // print locals
	  tty->print_cr("locals:",nlocals);
	  for (int l=0; l<nlocals; l++) {	    
	    tty->print_cr("  %8x:[fp-%3d]: %#x",fp-(l+1),l+1,*(fp-(l+1)));
	  }
	  // print oops???
	  // print monitors???
	  // print spills???
#endif	  
	} else if (b->is_java_method()) {
	  tty->print_cr("interpreted java method");
	} else if (b->is_native_method()) {
	  tty->print_cr("native method");
	} else if (b->is_osr_method()) {
	  tty->print_cr("osr method");
	}	
      }
#endif // NOT CORE
    }
    prev_sp = sp;
    sp = (jint *)sp[FP.sp_offset_in_saved_window()];
    count += 1;
  }
  if (sp != NULL)
    tty->print("[%d] sp=%#x [bogus sp!]", count, sp);
}

#endif // PRODUCT

// This function is used to add platform specific info
// to the error reporting code.

void pd_obfuscate_location(char *buf,int buflen) {
  const char *tag = NULL;

#ifndef PRODUCT
  if( is_init_completed() ) {
    if(os::Solaris::mutator_libthread()) {
      tag = " [ Patched ]";
    } else {
      tag = " [ Unpatched ]";
    }
  } else {
    tag = " [ Unknown ]";
  }
#else

  // State info
  // 0x00 = unpatched
  // 0x01 = patched
  // 0xFF = unknown

  if( is_init_completed() ) {
    if(os::Solaris::mutator_libthread()) {
      tag = " 01";
    } else {
      tag = " 00";
    }
  } else {
    tag = " FF";
  }  
#endif

  if(strlen(buf) + strlen(tag) + 1 < buflen) {
    strcat(buf,tag);
  }

}

//Reconciliation History
// 1.6 99/07/13 11:41:16 debug_i486.cpp
//End
