/*
 * @(#)extendedPC_sparc.cpp	1.4 99/06/22 16:38:12
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

# include "incls/_precompiled.incl"
# include "incls/_extendedPC_sparc.cpp.incl"


ExtendedPC ExtendedPC::adjust(address begin, address end, address new_begin) {
  assert(is_contained_in(_pc,  begin, end), "must be contained");
  assert(is_contained_in(_npc, begin, end), "must be contained");

  ExtendedPC addr(new_begin + (_pc  - begin), new_begin + (_npc - begin));
  return addr;
}

address ExtendedPC::contained_pc() { 
  return _npc; 
}

bool ExtendedPC::is_contained_in(address pc, address begin, address end) {
  return pc >= begin && pc < end;
}

bool ExtendedPC::is_contained_in(address begin, address end) {
  // if the npc must be in the range
  return is_contained_in(_npc, begin, end);
}
