/*
 * @(#)globals_sparc.hpp	1.13 01/02/09 14:43:22
 *
 * Copyright 1993-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2
//
// Sets the default values for platform dependent flags used by the runtime system.
// (see globals.hpp)
//

// For sparc we do not do call backs when a thread is in the interpreter, because the
// interpreter dispatch needs at least two instructions - first to load the dispatch address
// in a register, and second to jmp. The swapping of the dispatch table may occur _after_
// the load of the dispatch address and hence the jmp would still go to the location
// according to the prior table. So, we let the thread continue and let it block by itself.
define_pd_global(bool, UseCallBackInInterpreter,    false);
define_pd_global(bool, DontYieldALot,               true);  // yield no more than 100 times per second
define_pd_global(bool, ConvertSleepToYield,         false); // do not convert sleep(0) to yield. Helps GUI 
define_pd_global(bool, ShareVtableStubs,            false); // improves performance markedly for mtrt and compress
define_pd_global(bool, CountInterpCalls,            false); // not implemented in the interpreter
define_pd_global(bool, EnforceStrictFP,             true);  // enforce strict FP semantics by default
define_pd_global(bool, UseStackBanging,             true);  // detect stack overflows efficiently

define_pd_global(int, CodeEntryAlignment,    16); 
define_pd_global(size_t, NewSize,            (2048 * K) + (2 * (64 * K))); 
define_pd_global(size_t, MaxNewSize,         32 * K * K); 

// The following set by design center runs for 1.3.1
define_pd_global(int, SurvivorRatio,         25);
define_pd_global(int, InlineFrequencyCount,  50);
define_pd_global(int, PreInflateSpin,        40);
define_pd_global(size_t, ThreadStackSize,    512); // javac can't build the jdk with 256
