/*
 * @(#)interpreterRT_sparc.hpp	1.14 99/07/12 23:53:42
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2


static int binary_search(int key, LookupswitchPair* array, int n);

static address iload (JavaThread* thread);
static address aload (JavaThread* thread);
static address istore(JavaThread* thread);
static address astore(JavaThread* thread);
static address iinc  (JavaThread* thread);



// native method calls

class SignatureHandlerGenerator: public NativeSignatureIterator {
 private:
  MacroAssembler* _masm;

  void pass_word(int size_of_arg, int offset_in_arg);
  void pass_int()    { pass_word(1, 0); }
  void pass_long();
  void pass_double();
  void pass_object();

 public:
  // Creation
  SignatureHandlerGenerator(methodHandle method, CodeBuffer* buffer) : NativeSignatureIterator(method) {
    _masm = new MacroAssembler(buffer);
  }

  // Code generation
  void generate();
};


static void    prepare_native_call   (JavaThread* thread, methodOop method);
static address slow_signature_handler(JavaThread* thread, methodOop method, jint* from, jint* to);



//Reconciliation History
// 1.9 98/05/05 16:49:15 interpreterRT_i486.hpp
// 1.10 98/05/29 09:28:04 interpreterRT_i486.hpp
// 1.11 98/06/23 18:19:25 interpreterRT_i486.hpp
// 1.13 99/06/22 16:37:44 interpreterRT_i486.hpp
//End
