/*
 * @(#)registerMap_sparc.hpp	1.8 00/04/28 04:42:41
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// machine-dependent implemention for register maps
  friend class frame;

#ifndef CORE
 private:
  jint* _window;         // register window save area (for L and I regs)
  jint* _younger_window; // previous save area (for O regs, if needed)

  address pd_location(VMReg::Name reg) const; // {return NULL;}
  void pd_clear();
  void pd_initialize_from(const RegisterMap* map) {
    _window         = map->_window;
    _younger_window = map->_younger_window;
    _location_valid[0] = 0;  // avoid the shift_individual_registers game
  }
  void pd_initialize() {
    _window = NULL;
    _younger_window = NULL;
    _location_valid[0] = 0;  // avoid the shift_individual_registers game
  }
  void shift_window(jint* sp, jint* younger_sp) {
    _window         = sp;
    _younger_window = younger_sp;
    assert(Register::nofRegisters == BitsPerWord, "one word has valid bits for int-regs");
    // Throw away locations for %i, %o, and %l registers:
    // But do not throw away %g register locs.
    if (_location_valid[0] != 0)  shift_individual_registers();
  }
  void shift_individual_registers();
  // When popping out of compiled frames, we make all IRegs disappear.
  void make_integer_regs_unsaved() { _location_valid[0] = 0; }
#endif
