//
// @(#)atomic_linux.inline.hpp	1.4 01/04/23
// 
// Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road,
// Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
// 
// This software is the confidential and proprietary information of Sun
// Microsystems, Inc. ("Confidential Information").  You shall not
// disclose such Confidential Information and shall use it only in
// accordance with the terms of the license agreement you entered into
// with Sun.
// 
// CopyrightVersion 1.2

// Implementation of class atomic

inline jint atomic::add(jint* dest, jint add_value) {
  return (*os::Linux::atomic_increment_func)(add_value, dest);
}

inline void atomic::increment(jint* dest) {
  (*os::Linux::atomic_increment_func)(1, dest);
}

inline void atomic::decrement(jint* dest) {
  (*os::Linux::atomic_increment_func)(-1, dest);
}

inline jint atomic::exchange(jint* dest, jint exchange_value) {
  return (*os::Linux::atomic_exchange_func)(exchange_value, dest);
}

inline jint atomic::compare_and_exchange(jint* dest, jint exchange_value, jint compare_value) {
  return (*os::Linux::atomic_compare_and_exchange_func)(exchange_value, dest, compare_value);
}

inline intptr_t atomic::add_ptr(intptr_t* dest, intptr_t add_value) {
  return (intptr_t)(*os::Linux::atomic_increment_func)((jint)add_value, (jint*)dest);
}

inline void atomic::increment_ptr(intptr_t* dest) {
  (*os::Linux::atomic_increment_func)(1, (jint*)dest);
}

inline void atomic::decrement_ptr(intptr_t* dest) {
  (*os::Linux::atomic_increment_func)(-1, (jint*)dest);
}

inline intptr_t atomic::exchange_ptr(intptr_t* dest, intptr_t exchange_value) {
  return (intptr_t)(*os::Linux::atomic_exchange_func)((jint)exchange_value, (jint*)dest);
}

inline intptr_t atomic::compare_and_exchange_ptr(intptr_t* dest, intptr_t exchange_value, intptr_t compare_value) {
  return (*os::Linux::atomic_compare_and_exchange_func)((jint)exchange_value, (jint*)dest, (jint)compare_value);
}

inline void atomic::membar() {
}

inline void atomic::prefetch_read(void *address) {
   // no-op
}

inline void atomic::prefetch_write(void *address) {
   // no-op
}

// Reconciliation History
// atomic_solaris.inline.hpp	1.4 99/08/30 15:48:48
// End
