/*
 * @(#)jvm_linux.cpp	1.3 01/02/09
 *
 * Copyright 1993-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

#include "incls/_precompiled.incl"
#include "incls/_jvm_linux.cpp.incl"

#include <signal.h>

/*
 * FIXME: This is temporary hack to keep Linux Runtime.exec()
 * code happy. See $JDK/src/linux/native/java/lang/UnixProcess_md.c
 */
int _JVM_native_threads = 1;

// sun.misc.Signal ///////////////////////////////////////////////////////////
// Signal code is mostly copied from classic vm, signals_md.c	1.4 98/08/23
/*
 * This function is included primarily as a debugging aid. If Java is
 * running in a console window, then pressing <CTRL-\\> will cause
 * the current state of all active threads and monitors to be written
 * to the console window.
 */

JVM_ENTRY_NO_ENV(void*, JVM_RegisterSignal(jint sig, void* handler))
  // Copied from classic vm
  // @(#)signals_md.c	1.4 98/08/23
  void* newHandler = handler == (void *)2
                   ? os::user_handler()
                   : handler;
  switch (sig) {
    /* The following are already used by the VM. */
    case INTERRUPT_SIGNAL:
    case SIGFPE:
    case SIGILL:
    case SIGSEGV:

    /* The following signal is used by the VM to dump thread stacks unless
       ReduceSignalUsage is set, in which case the user is allowed to set
       his own _native_ handler for this signal; thus, in either case,
       we do not allow JVM_RegisterSignal to change the handler. */
    case BREAK_SIGNAL:
      return (void *)-1;

    /* The following signals are used for Shutdown Hooks support.
       However, if ReduceSignalUsage is set, Shutdown Hooks are
       not supported, Java is not allowed to make use of these signals,
       and the user is allowed to set his own _native_ hanlder for these
       signals. */
    case SHUTDOWN1_SIGNAL:
    case SHUTDOWN2_SIGNAL:
    case SHUTDOWN3_SIGNAL:
      if (ReduceSignalUsage) return (void*)-1;
  }

  void* oldHandler = os::signal(sig, newHandler);
  if (oldHandler == os::user_handler()) {
      return (void *)2;
  } else {
      return oldHandler;
  }
JVM_END


JVM_ENTRY_NO_ENV(void, JVM_RaiseSignal(jint sig))
  os::signal_raise(sig);
JVM_END


JVM_ENTRY_NO_ENV(jint, JVM_FindSignal(const char *name))
  if (!strcmp(name, "ABRT"))  return SIGABRT;
  if (!strcmp(name, "FPE"))   return SIGFPE;
  if (!strcmp(name, "SEGV"))  return SIGSEGV;
  if (!strcmp(name, "INT"))   return SIGINT;
  if (!strcmp(name, "TERM"))  return SIGTERM;
  if (!strcmp(name, "ILL"))   return SIGILL;
  if (!strcmp(name, "HUP"))   return SIGHUP;
  return -1;
JVM_END


// Reconciliation History
// jvm_solaris.cpp	1.7 99/08/30 18:13:04
// End
