/*
 * @(#)threadLocalEden_linux.inline.hpp	1.1 99/12/23
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

inline void TLEQueue::acquire() {
  intptr_t current_thread = (intptr_t) Thread::current();
  int tries = 0;
  while(1) {
    intptr_t lock_state = atomic::compare_and_exchange_ptr(
      (intptr_t*) lock_addr(), current_thread, 0);
    if (lock_state == 0) break;
    assert(lock_state != current_thread, "Recursive locking of TLEQueue");
    os::yield_all(tries++);
  }
}

inline void TLEQueue::release() {
  *lock_addr() = 0;
}
