/*
 * @(#)mutex_solaris.inline.hpp	1.5 99/06/22 16:38:49
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

inline bool Mutex::lock_implementation() {
  int status = ((os::Solaris::Event*)_lock_event)->trylock();
  if (status != 0) { 
    debug_only(_lock_count++); 
    return true; 
  } 
  return false;
}

inline bool Mutex::try_lock_implementation() {
  // Same on Solaris.
  return lock_implementation();
}


inline void Mutex::wait_for_lock_implementation() {
  ((os::Solaris::Event*)_lock_event)->lock();
  debug_only(_lock_count++;)
}


inline void Mutex::wait_for_lock_blocking_implementation(JavaThread *thread) {
  StateSaver sv(thread);
  ThreadBlockInVM tib(thread);
  wait_for_lock_implementation();
}
