/*
 * @(#)mutex_win32.inline.hpp	1.6 99/07/02 10:23:39
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

inline bool Mutex::lock_implementation() {
  return InterlockedIncrement(&_lock_count)==0;
}


inline bool Mutex::try_lock_implementation() {
  // We can only get the lock, if we can atomicly increase the _lock_count 
  // from -1 to 0. Hence, this is like lock_implementation, except that we
  // only count if the initial value is -1.
  return (atomic::compare_and_exchange(&_lock_count, 0, -1) == -1);
}
