/*
 * @(#)osThread_win32.hpp	1.14 01/02/09 14:44:00
 *
 * Copyright 1993-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

typedef void* HANDLE;

 private:
  // Win32-specific thread information
  HANDLE _thread_handle;        // Win32 thread handle
  unsigned long _thread_id;     // Win32 thread id
  HANDLE _interrupt_event;      // Event signalled on thread interrupt
  bool _interrupted;            // Shadow thread interruption
  ThreadState _last_state;

 public:
  // The following will only apply in the Win32 implementation, and should only
  // be visible in the concrete class, not this which should be an abstract base class 
  HANDLE thread_handle() const                     { return _thread_handle; }
  void set_thread_handle(HANDLE handle)            { _thread_handle = handle; }
  HANDLE interrupt_event() const                   { return _interrupt_event; }
  void set_interrupt_event(HANDLE interrupt_event) { _interrupt_event = interrupt_event; } 
  bool interrupted() const                         { return _interrupted; }
  void set_interrupted(bool interrupted)           { _interrupted = interrupted; }

  unsigned long thread_id() const                  { return _thread_id; }
#ifndef PRODUCT
  // Used for debugging, return a unique integer for each thread.
  int thread_identifier() const                    { return _thread_id; }
#endif
  void set_thread_id(unsigned long thread_id)      { _thread_id = thread_id; }

  // This is a temporary fix for the thread states during
  // suspend/resume until we throw away OSThread completely.
  // NEEDS_CLEANUP
  void set_last_state(ThreadState state)           { _last_state = state; }
  ThreadState get_last_state()                     { return _last_state; }

 private:
  void pd_initialize();
  void pd_destroy();
