/*
 * @(#)os_win32.hpp	1.23 99/09/02 13:54:46
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// Win32_OS defines the interface to windows operating systems

class win32 {
  friend void os_init();

 protected:
  static int  _vm_page_size;
  static int  _processor_type;
  static int  _processor_level;
  static int  _processor_count;
  static bool _is_nt;  
  static void initialize_system_info();
  static void setmode_streams();  


  // Windows-specific interface:

  // Processor info as provided by NT
  static int processor_type()  { return _processor_type;  }
  static int processor_level() { return _processor_level; }
  static int processor_count() { return _processor_count; }

 public:
  // Trace number of created threads
  static jint  _os_thread_limit;
  static jint  _os_thread_count;

  // Tells whether the platform is NT or Windown95
  static bool is_nt() { return _is_nt; }

  // Tells whether we're running on an MP machine
  static bool is_MP() {
    return processor_count() > 1;
  }

  // Returns the byte size of a virtual memory page
  static int vm_page_size() { return _vm_page_size; }
};
