/*
 * @(#)safepoint_win32.cpp	1.10 99/06/29 18:08:55
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

# include "incls/_precompiled.incl"
# include "incls/_safepoint_win32.cpp.incl"


bool SafepointSynchronize::can_be_at_safepoint_before_suspend(JavaThread *thread, JavaThreadState state) {
  return true;
}


bool SafepointSynchronize::can_be_at_safepoint_after_suspend(JavaThread *thread, JavaThreadState state) {
  assert(thread->thread_state() == _thread_in_vm_trans, "thread in wrong state");
  return false;
}


void SafepointSynchronize::save_thread_state_at_safepoint(JavaThread *thread) {
  // no state to save on Win32
}


// The patching of the return instruction is machine-specific
void SafepointSynchronize::patch_return_instruction_md(address cb_pc) {
  // The relocation info. is actually after the ret (i.e., where we are going to patch with
  // an illegal instruction.
  cb_pc -= NativeReturn::instruction_size;

  assert(((NativeInstruction*)cb_pc)->is_return(), "must be a return instruction");

  // In C1  code is part of ret eventually
  NOT_COMPILER1(assert(((NativeInstruction*)(cb_pc+1))->is_nop(), "must be a nop instruction");)
  NOT_COMPILER1(assert(((NativeInstruction*)(cb_pc+2))->is_nop(), "must be a nop instruction");)
  assert(NativePopReg::instruction_size + NativeIllegalInstruction::instruction_size == 3, "wrong code format");
  NativePopReg::insert(cb_pc, ebx); // Pop return address (it is getting pushed by the SafepointBlob again)
  NativeIllegalInstruction::insert(cb_pc + NativePopReg::instruction_size);        
}

// Nothing to do here (no special safepoint cleanup requirement)
bool SafepointSynchronize::pd_is_cleanups_needed() {
  return false;
}
