/*
 * @(#)assembler_linux_i486.cpp	1.5 01/04/21
 *
 * Copyright 1993-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

#include "incls/_precompiled.incl"
#include "incls/_assembler_linux_i486.cpp.incl"

// define _USE_PTHREAD_SPECIFIC in Makefile if you want to use 
// pthread_getspecific and pthread_setspecific for thread local 
// storage, even when we're running  with fixed stack pthread 
// library. DO NOT just define it in this file.

void Assembler::int3() {
  call(CAST_FROM_FN_PTR(address, os::breakpoint), relocInfo::runtime_call_type);
}

#ifndef _USE_PTHREAD_SPECIFIC
// variable exported by os_linux.cpp
extern "C" void* hotspot_thread_local_storage[];
extern "C" int hotspot_thread_local_storage_shift;
#endif

extern "C" bool is_floating_stack;

void MacroAssembler::get_thread(Register thread) {
#ifndef _USE_PTHREAD_SPECIFIC
 if (is_floating_stack) {
#endif
   // call pthread_getspecific
   // void * pthread_getspecific(pthread_key_t key);
   if (thread != eax) pushl(eax);
   pushl(ecx);
   pushl(edx);

   pushl(ThreadLocalStorage::thread_index());
   call(CAST_FROM_FN_PTR(address, pthread_getspecific), relocInfo::runtime_call_type);
   increment(esp, wordSize);

   popl(edx);
   popl(ecx);
   if (thread != eax) {
       movl(thread, eax);
       popl(eax);
   }

#ifndef _USE_PTHREAD_SPECIFIC
 } else {
  // This code does not work with customized linuxthreads
  // or user specified thread stack size or location.
  // compute thread local storage base address
  int base = (int) &hotspot_thread_local_storage[0];

  // copy current stack pointer
  movl(thread, esp);

  // compute tls offset in bytes
  shrl(thread, hotspot_thread_local_storage_shift - 2);

  // mask off extra bits at low end
  andl(thread, ~0x3);

  // load current thread pointer
  movl(thread, Address(thread, base));

  // done
 }
#endif
}

void MacroAssembler::get_thread_id(Register thread) {  
  // Use the TLS as the id.
  get_thread(thread);
}

// NOTE: since the linux kernel resides at the low end of
// user address space, no null pointer check is needed.
bool MacroAssembler::needs_explicit_null_check(int offset) {
  return (offset < 0 || offset >= 0x100000);
}
