/*
 * @(#)bytes_linux_i486.inline.hpp	1.1 99/12/21
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// Efficient swapping of data bytes from Java byte
// ordering to native byte ordering and vice versa.
inline u2   Bytes::swap_u2(u2 x) {
  u2 ret;
  ret = x & 0xff;
  ret <<= 8; x >>= 8;
  ret |= x & 0xff;
  return ret;
// TODO - Need to check this code out! kbt
//    u2 ret;
//    asm("  mov ax, x");
//    asm("  xchg al, ah");
//    asm("  mov ret, ax");
//    return ret;
}

inline u4   Bytes::swap_u4(u4 x) {
  u4 ret;
  ret = x & 0xff;
  ret <<= 8; x >>= 8;
  ret |= x & 0xff;
  ret <<= 8; x >>= 8;
  ret |= x & 0xff;
  ret <<= 8; x >>= 8;
  ret |= x & 0xff;
  return ret;
// TODO - Need to check this code out! kbt
//    u4 ret;
//    asm("  mov eax, x");
//    asm("  bswap eax");
//    asm("  mov ret, eax");
//    return ret;
}

// Helper function for swap_u8
inline u8   Bytes::swap_u8_base(u4 x, u4 y) {
  u8 ret;
  ret = x & 0xff;
  ret <<= 8; x >>= 8;
  ret |= x & 0xff;
  ret <<= 8; x >>= 8;
  ret |= x & 0xff;
  ret <<= 8; x >>= 8;
  ret |= x & 0xff;
  ret <<= 8;
  ret |= y & 0xff;
  ret <<= 8; y >>= 8;
  ret |= y & 0xff;
  ret <<= 8; y >>= 8;
  ret |= y & 0xff;
  ret <<= 8; y >>= 8;
  ret |= y & 0xff;
  return ret;
// TODO - Need to check this code out! kbt
//    u8 ret;
//    asm("  mov eax, y");
//    asm("  mov edx, x");
//    asm("  bswap eax");
//    asm("  bswap edx");
//    asm("  mov ret, edx:eax");
//    return ret;
}

// Reconciliation History
// 1.3 99/06/22 16:38:43 bytes_solaris_i486.inline.hpp
//
