/*
 * @(#)threadLS_solaris_i486.hpp	1.6 99/08/06 10:15:27
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// Processor dependent parts of ThreadLocalStorage

// The following comment is from sparc version of the code:
// In current versions of Solaris, thr_self and TSD can
// be accessed via short sequences of displaced indirections.
// The value of thr_self is available as %g7(36).
// The value of thr_getspecific(k) is stored in %g7(12)(4)(k*4-4),
// assuming that the current thread already has a value bound to k.

public:

  enum Constants {
    _pd_cache_size         =  8*2,   // projected max # of processors * 2
    _pd_min_page_size      =   4*K, // smallest possible thread-stack page size
    _pd_typical_stack_size = 512*K // typical "small" thread stack size
  };

  static address pd_sp_address() {
    int junk;
    return (address)&junk;
  }

  // Note:  Two sps from different threads must __not__ have the same page!
  static int pd_sp_page(address sp) {
    return (unsigned int)sp / _pd_min_page_size;
  }

  static int pd_sp_hash(unsigned int sp_page) {
    return (sp_page / 2)  /* pages tend to come in pairs */
         ^ (sp_page / (_pd_typical_stack_size/_pd_min_page_size));
  }

  // Java Thread
  static Thread* thread()  {
    // don't use specialized code if +UseMallocOnly -- may confuse Purify et al.
    debug_only(if (UseMallocOnly) return get_thread_slow(););
    return get_thread_via_cache();
  }

