/*
 * @(#)threadLS_win32_i486.hpp	1.6 99/06/29 18:08:57
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// Processor dependent parts of ThreadLocalStorage
public:
  enum Constants {
    _pd_cache_size         =   8*2, // projected max # of processors * 2
    _pd_min_page_size      =   4*K, // smallest possible thread-stack page size
    _pd_typical_stack_size = 512*K, // typical "small" thread stack size
  };

  static address pd_sp_address() { return os::current_stack_pointer(); }

  // Note:  Two sps from different threads must __not__ have the same page!
  static int pd_sp_page(address sp) {
    return (unsigned int)sp / _pd_min_page_size;
  }

  static int pd_sp_hash(unsigned int sp_page) {
    return (sp_page / 2)  /* pages tend to come in pairs */
         ^ (sp_page / (_pd_typical_stack_size/_pd_min_page_size));
  }

  // Support for assembly stub generation (Windows)
  // ex. fetching the thread:
  //     mov  eax, dword ptr fs:[array_offset()]
  //     mov  eax, dword ptr [eax + base_offset() + thread_offset()]
  static int array_offset();
  static int base_offset();
  static inline int thread_offset() {return thread_index() * sizeof(int);}

  // Java Thread
  inline static Thread* thread() {
    extern int ThreadLocalStorageOffset;
    Thread* current;

    __asm {
      // load thread information block (TIB) pointer from special segment
      mov eax, dword ptr FS:[18H];

      // load the offset of Thread::current()
      mov ecx, dword ptr [ThreadLocalStorageOffset];

      // load the Thread::current() from TIB
      mov eax, dword ptr [eax+ecx];

      // make compiler happy. the #prama does not work inside class declaration
      mov current, eax;
    }

    return current;
  }


