/*
 * @(#)MetroWerksMacPlatform.java	1.1 99/12/13 17:04:58
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

import java.io.*;

public class MetroWerksMacPlatform extends Platform {
    public void setupFileTemplates() {
	inclFileTemplate = new FileName(this,
	    ":incls:", "_", "",                  ".incl", "", ""
	);
        giFileTemplate = new FileName(this,
	    "",        "",  "precompiledHeader", ".pch",  "", ""
	);
        gdFileTemplate = dummyFileTemplate;
    }

    private static String[] suffixes = { ".cpp", ".c", ".s" };

    public String[] outerSuffixes() {
	return suffixes;
    }

    public boolean includeGIInEachIncl() {
	return true;
    }

    public int defaultGrandIncludeThreshold() {
	return 150;
    }

    public void writeGIPragma(PrintWriter out) {
	out.println("#pragma precompile_target \"" +
		    giFileTemplate.preStemAltSuff() +
		    "\"");
	out.println();
    }
    
    public String objFileSuffix() {
	throw new RuntimeException("Unimplemented in original makeDeps");
    }

    public String asmFileSuffix() {
	throw new RuntimeException("Unimplemented in original makeDeps");
    }

    public String dependentPrefix() {
	throw new RuntimeException("Unimplemented in original makeDeps");
    }
}
