/*
 * @(#)adlc.hpp	1.6 99/06/22 16:39:10
 *
 * Copyright 1997-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2
//
// Standard include file for ADLC parser
//

// standard library constants
# include "stdio.h"
# include "iostream.h"
# include "stdlib.h"
# include "string.h"
# include "ctype.h"
# include "stdarg.h"

// Booleans
#define bool    long

#define true    v_true
#define false   v_false

const bool true        = 1;
const bool false       = 0;

// Macros 
# define uint32 unsigned int
# define uint   unsigned int

// Macros
// Debugging note:  Put a breakpoint on "abort".
# define assert(cond, msg) { if (!(cond)) { fprintf(stderr, "assert fails %s %d: %s\n", __FILE__, __LINE__, msg); abort(); }}
# define max(a, b)   (((a)>(b)) ? (a) : (b))

// VM components
# include "opcodes.hpp" 

// ADLC components
# include "arena.hpp"
# include "adlcVMDeps.hpp"
# include "filebuff.hpp"
# include "dict2.hpp"
# include "forms.hpp"
# include "formsopt.hpp"
# include "formssel.hpp"
# include "archDesc.hpp"
# include "adlparse.hpp"

