/*
 * @(#)assembler_inline_abs.hpp	1.13 99/07/22 15:49:09
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2


inline void AbstractDisplacement::bind(Label &L, int pos, AbstractAssembler* masm) {
  ((Displacement*)this)->bind(L, pos, masm);
}


inline void AbstractDisplacement::next(Label& L) const {
  ((Displacement*)this)->next(L);
}

inline void AbstractAssembler::emit_byte(int x) {
  assert(isByte(x), "not a byte");
  *(unsigned char*)_code_pos = (unsigned char)x;
  _code_pos += sizeof(unsigned char);
  code()->set_code_end(_code_pos);
}


inline void AbstractAssembler::emit_long(jint x) {
  *(jint*)_code_pos = x;
  _code_pos += sizeof(jint);
  code()->set_code_end(_code_pos);
}


inline void AbstractAssembler::relocate(RelocationHolder const& rspec, int format) {
  assert(_inst_mark == NULL || _inst_mark == _code_pos, "call relocate() between instructions");
  code()->relocate(_code_pos, rspec, format);
}


inline void AbstractAssembler::relocate_raw(relocInfo::relocType rtype, const short* data, int datalen, int format) {
  assert(_inst_mark == NULL || _inst_mark == _code_pos, "call relocate() between instructions");
  code()->relocate_raw(_code_pos, rtype, data, datalen, format);
}


inline Displacement AbstractAssembler::disp_at(Label& L) const {
  return ((Assembler*)this)->disp_at(L);
}


inline void AbstractAssembler::disp_at_put(Label& L, Displacement& disp) {
  ((Assembler*)this)->disp_at_put(L, disp);
}


