/*
 * @(#)c1_Compiler.hpp	1.26 00/05/15 13:58:12
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2


// There is one instance of the Compiler per CompilerThread.

class Compiler: public AbstractCompiler {
 private:
  enum Constants {
    desired_max_code_buffer_size = 256*K,
    desired_max_locs_buffer_size =   8*K 
  };

  // For all compilations with this compiler
  // Note: These buffers are allocated once per compiler since allocation for
  //       each compilation seems to be too expensive (at least on Intel win32).
  address _code_buffer;
  address _locs_buffer;
  int     _code_buffer_size;
  int     _locs_buffer_size;

 public:
  // Creation
  Compiler();
  ~Compiler();

  // Name of this compiler
  virtual const char* name()                     { return "HotSpot Client Compiler"; }

  // Missing feature tests
  virtual bool supports_native()                 { return true; }
  virtual bool supports_osr   ()                 { return true; } 

  // Customization
  virtual bool needs_preloaded_classes()         { return false; }
  virtual bool needs_inlining_scope   ()         { return false; }
  virtual bool needs_adapters         ()         { return false; }
  virtual bool needs_stubs            ()         { return false; }

  // Initialization
  virtual void initialize();

  // Compilation entry point for methods
  virtual void compile_method(ciEnv* env, ciScope* scope, ciMethod* target, int entry_bci, bool reuse_env);

  // Print compilation timers and statistics
  virtual void print_timers();
};

