/*
 * @(#)c1_globals.hpp	1.7 00/04/18 19:17:21
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2
//
// Defines all global flags used by the client compiler.
//

#define C1_FLAGS(develop, develop_pd, product, product_pd)                  \
                                                                            \
  /* Printing */                                                            \
  develop(bool, PrintC1Statistics, false,                                   \
	  "Print Compiler1 statistics" )                                    \
                                                                            \
  develop(bool, PrintOopMap, false,                                         \
          "Print oop maps")                                                 \
                                                                            \
  develop(bool, PrintCFG, false,                                            \
          "Print control flow graph after each change")                     \
                                                                            \
  develop(bool, PrintCFG0, false,                                           \
          "Print control flow graph after construction")                    \
                                                                            \
  develop(bool, PrintCFG1, false,                                           \
          "Print control flow graph after optimizations")                   \
                                                                            \
  develop(bool, PrintCFG2, false,                                           \
          "Print control flow graph before code generation")                \
                                                                            \
  develop(bool, PrintIR, false,                                             \
          "Print full intermediate representation after each change")       \
                                                                            \
  develop(bool, PrintIR0, false,                                            \
          "Print full intermediate representation after construction")      \
                                                                            \
  develop(bool, PrintIR1, false,                                            \
          "Print full intermediate representation after optimizations")     \
                                                                            \
  develop(bool, PrintIR2, false,                                            \
          "Print full intermediate representation before code generation")  \
                                                                            \
  develop(bool, PrintSimpleStubs, false,                                    \
          "Print SimpleStubs")                                              \
                                                                            \
  develop(bool, PrintC1RegAlloc, false,                                     \
          "Trace register allocation in C1")                                \
                                                                            \
  product(bool, InstallMethods, true,                                       \
          "Install code after running C1 (JVMCI_install..)")                \
                                                                            \
  /* C1 optimizations */                                                    \
                                                                            \
  develop(bool, UseC1Optimizations, true,                                   \
          "Turn on C1 optimizations")                                       \
                                                                            \
  develop_pd(bool, CacheReceiver,                                           \
          "Cache receiver in a register througout the method")              \
                                                                            \
  develop(bool, CacheLocalsGlobally, true,                                  \
          "Cache locals in registers throughout the method")                \
                                                                            \
  develop_pd(bool, CacheLocalsInLoops,                                      \
          "Cache locals in registers inside leaf loops")                    \
                                                                            \
  develop(bool, TraceCachedLocals, false,                                   \
          "Trace cached local / register mapping")                          \
                                                                            \
  develop(bool, PrintCachedLocals, false,                                   \
          "Print cached local / register mapping")                          \
                                                                            \
  develop_pd(bool, SimpleLeafs,                                             \
          "Recognize methods that are simple leafs")                        \
                                                                            \
  develop(bool, OptimizeSimpleGetters, true,                                \
          "Optimized code for simple getter accessors")                     \
                                                                            \
  develop_pd(bool, UseCachedReceiver,                                       \
          "Use receiver cached in register")                                \
                                                                            \
  develop_pd(bool, DoCEE,                                                   \
          "Do Conditional Expression Elimination to simplify CFG")          \
                                                                            \
  develop(bool, PrintCEE, false,                                            \
          "Print Conditional Expression Elimination")                       \
                                                                            \
  develop_pd(bool, ComputeLoops,                                            \
          "Compute loop structures")                                        \
                                                                            \
  develop(bool, PrintLoops, false,                                          \
          "Print loop structures")                                          \
                                                                            \
  develop(bool, UseValueNumbering, true,                                    \
          "Use Value Numbering")                                            \
                                                                            \
  develop(bool, PrintValueNumbering, false,                                 \
          "Print Value Numbering")                                          \
                                                                            \
  develop( bool, EliminateLoads, true,                                      \
          "Eliminate unneccessary loads")                                   \
                                                                            \
  develop(bool, PrintLoadElimination, false,                                \
          "Print load elimination")                                         \
                                                                            \
  develop(bool, EliminateBlocks, true,                                      \
          "Eliminate unneccessary basic blocks")                            \
                                                                            \
  develop(bool, PrintBlockElimination, false,                               \
          "Print basic block elimination")                                  \
                                                                            \
  develop(bool, InlineSimpleMethods, true,                                  \
          "Inline simple methods that can be statically resolved")          \
                                                                            \
  develop(bool, CanonicalizeNodes, true,                                    \
          "Canonicalize graph nodes")                                       \
                                                                            \
  develop(bool, CanonicalizeExperimental, false,                            \
          "Canonicalize graph nodes, experimental code")                    \
                                                                            \
  develop(bool, PrintCanonicalization, false,                               \
          "Print graph node canonicalization")                              \
                                                                            \
  develop_pd(bool, OptimizeLibraryCalls,                                    \
          "Special versions of rt.jar library routines")                    \
                                                                            \
  develop_pd(bool, UseTableRanges,                                          \
          "Faster versions of lookup table using ranges")                   \
                                                                            \
  develop(bool, UseFastExceptionHandling, true,                             \
          "Faster handling of exceptions")                                  \
                                                                            \
  develop(bool, UseFastUnwind, false,                                       \
          "Faster stack unwinding when throwing exceptions")                \
                                                                            \
  develop(bool, UseCachedReceiver2, true,                                   \
          "Improved caching of receiver")                                   \
                                                                            \
  product_pd(bool, PassParametersInRegisters,                               \
          "Pass parameters in registers (SPARC only)")                      \
                                                                            \
  develop_pd(bool, RoundFloatsWithStore,                                    \
          "Use (memory) store to round floating point results")             \
                                                                            \
  /* C1 variable */                                                         \
                                                                            \
  develop(bool, C1TraceMethod, false,                                       \
          "trace method entry and exit in compiled code")                   \
                                                                            \
  develop(bool, C1Breakpoint, false,                                        \
          "Sets a breakpoint at entry of each compiled method")             \
                                                                            \
  develop(bool, ImplicitDiv0Checks, true,                                   \
          "Use implicit division by zero checks")                           \
                                                                            \
  develop(bool, PinAllInstructions, false,                                  \
          "All instructions are pinned")                                    \
                                                                            \
  develop(bool, UseFastNewInstance, true,                                   \
          "Use fast inlined instance allocation")                           \
                                                                            \
  develop(bool, UseFastNewTypeArray, true,                                  \
          "Use fast inlined type array allocation")                         \
                                                                            \
  develop(bool, UseFastNewObjectArray, true,                                \
          "Use fast inlined object array allocation")                       \
                                                                            \
  develop(bool, UseFastLocking, true,                                       \
          "Use fast inlined locking code")                                  \
                                                                            \
  develop(bool, UseSlowPath, false,                                         \
          "For debugging: test slow cases by always using them")            \
                                                                            \
  develop(bool, GenerateOopMaps, true,                                      \
          "Generates Oop Maps")                                             \
                                                                            \
  develop(bool, GenerateArrayStoreCheck, true,                              \
          "Generates code for array store checks")                          \
                                                                            \
  develop(bool, NullCheckAtCaller, true,                                    \
          "Generate explicit null check at caller instead at final callee") \
                                                                            \
  develop(bool, UseFPConstTables, true,                                     \
          "Use constant tables for fp constants")                           \
                                                                            \
  develop(bool, DeoptC1, false,                                             \
          "Use deoptimization in C1")                                       \
                                                                            \
  develop(bool, LateBailout, true,                                          \
          "Bailout as late as possible (i.e., during code generation)")     \
                                                                            \
  develop(bool, PrintBailouts, false,                                       \
          "Print bailout and its reason")                                   \
                                                                            \
  develop(bool, TracePatching, false,                                       \
         "Trace patching of field access on uninitialized classes")         \
                                                                            \
  develop(bool, UsePatching,  true,                                         \
          "Use code instead of patching when "                              \
          "class is not loaded/initialized")                                \
                                                                            \
  develop(bool, PrintCompilationDelay, false,                               \
          "Print when delaying compilational")                              \
                                                                            \
  develop(bool, AcceptJsrForOSR, true,                                      \
          "Do OSR on methods with JSR's")                                   \
                                                                            \
  develop(bool, PatchALot, false,                                           \
          "Marks all fields as having unloaded classes")                    \
                                                                            \
  develop_pd(bool, PrintNotLoaded,                                          \
          "Prints where classes are not loaded during code generation")     \
                                                                            \
  develop(bool, PrintSpilling, false,                                       \
          "Print all spills while compiling")                               \
                                                                            \
  develop(bool, TraceC1Priority, false,                                     \
          "Traces changes in the C1 priorities")                            \
                                                                            \
  develop(bool, UseSplitLongs, false,                                       \
          "Let half of a long live on stack and half on a register "        \
          "(sparc only)")                                                   \
                                                                            \
  develop(bool, C1InvalidateCachedOopLocation, false,                       \
          "Store a non-oop value after caching it into a register")         \
                                                                            \
  develop(bool, VerifyC1Code, false,                                        \
          "Adds verification code to the generated code")                   \


// Read default values for c1 globals
// #include "incls/_c1_globals_pd.hpp.incl"

C1_FLAGS(DECLARE_DEVELOPER_FLAG, DECLARE_PD_DEVELOPER_FLAG, DECLARE_PRODUCT_FLAG, DECLARE_PD_PRODUCT_FLAG)
