/*
 * @(#)ciCallProfile.hpp	1.1 99/11/10 14:47:45
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// ciCallProfile
//
// This class is used to determine the frequently called method
// at some call site
class ciCallProfile : StackObj {
private:
  friend class ciMethod;

  ciMethod* _method;
  ciKlass*  _receiver;

  ciCallProfile(ciMethod* method, ciKlass* receiver) {
    _method = method;
    _receiver = receiver;
  }

public:
  bool is_valid()      { return _method != NULL; }
  
  ciMethod* method()   { return _method; }
  ciKlass*  receiver() { return _receiver; }
};
