/*
 * @(#)ciFieldLayout.hpp	1.1 99/11/10 14:47:51
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// ciFieldLayout
//
// This class represents the layout of the fields in an instance klass.
class ciFieldLayout : public ResourceObj {
  CI_PACKAGE_ACCESS

private:
  ciFieldLayout(ciInstanceKlass* k);

  GrowableArray<BasicType>* _elements;
  int                       _header_count;

  void fill_in_header_fields(GrowableArray<BasicType>* fields, int& pos);
  void fill_in_instance_fields(GrowableArray<BasicType>* fields, int& pos, klassOop k);

public:
  BasicType type_at(int index) { return _elements->at(index); }

  int header_count() { return _header_count; }
  int count() { return _elements->length(); }

  void print_layout();
  void print();
};
