/*
 * @(#)ciFlags.cpp	1.2 99/12/01 15:43:42
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2
#include "incls/_precompiled.incl"
#include "incls/_ciFlags.cpp.incl"

// ciFlags
//
// This class represents klass or method flags

// ------------------------------------------------------------------
// ciFlags::print_klass_flags
void ciFlags::print_klass_flags() {
  if (is_public()) {
    tty->print("public");
  } else {
    tty->print("DEFAULT_ACCESS");
  }

  if (is_final()) {
    tty->print(",final");
  }
  if (is_super()) {
    tty->print(",super");
  }
  if (is_interface()) {
    tty->print(",interface");
  }
  if (is_abstract()) {
    tty->print(",abstract");
  }
}

// ------------------------------------------------------------------
// ciFlags::print_member_flags
void ciFlags::print_member_flags() {
  if (is_public()) {
    tty->print("public");
  } else if (is_private()) {
    tty->print("private");
  } else if (is_protected()) {
    tty->print("protected");
  } else {
    tty->print("DEFAULT_ACCESS");
  }

  if (is_static()) {
    tty->print(",static");
  }
  if (is_final()) {
    tty->print(",final");
  }
  if (is_synchronized()) {
    tty->print(",synchronized");
  }
  if (is_volatile()) {
    tty->print(",volatile");
  }
  if (is_transient()) {
    tty->print(",transient");
  }
  if (is_native()) {
    tty->print(",native");
  }
  if (is_abstract()) {
    tty->print(",abstract");
  }
  if (is_strict()) {
    tty->print(",strict");
  }
    
}

// ------------------------------------------------------------------
// ciFlags::print
void ciFlags::print() {
  tty->print(" flags=%x", _flags);
}
