/*
 * @(#)ciKlassKlass.hpp	1.2 99/12/13 14:32:57
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// ciKlassKlass
//
// This class represents a klassOop in the HotSpot virtual machine
// whose Klass part is a klassKlass or one of its subclasses
// (instanceKlassKlass, objArrayKlassKlass, typeArrayKlassKlass).
class ciKlassKlass : public ciKlass {
  CI_PACKAGE_ACCESS

protected:
  ciKlassKlass(klassOop k)
    : ciKlass(k, ciSymbol::make("unique_klassKlass")) {
    assert(k->klass_part()->oop_is_klass(), "wrong type");
  }
  ciKlassKlass(klassOop k, ciSymbol *name)
    : ciKlass(k, name) {}

  klassKlass* get_klassKlass() { return (klassKlass*)get_Klass(); }
  
  const char* type_name() { return "ciKlassKlass"; }

public:
  // What kind of ciObject is this?
  bool is_klass_klass() { return true; }

  // Return the distinguished ciKlassKlass instance.
  static ciKlassKlass* make();
};

