/*
 * @(#)ciObjArrayKlassKlass.hpp	1.1 99/11/10 14:48:03
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// ciObjArrayKlassKlass
//
// This class represents a klassOop in the HotSpot virtual machine
// whose Klass part is a objArrayKlassKlass.
class ciObjArrayKlassKlass : public ciArrayKlassKlass {
  CI_PACKAGE_ACCESS

private:
  ciObjArrayKlassKlass(klassOop k)
    : ciArrayKlassKlass(k, ciSymbol::make("unique_objArrayKlassKlass")) {
    assert(k->klass_part()->oop_is_objArrayKlass(), "wrong type");
  }

  objArrayKlassKlass* get_objArrayKlassKlass() {
    return (objArrayKlassKlass*)get_Klass();
  }
  
  const char* type_name() { return "ciObjArrayKlassKlass"; }

public:
  // What kind of ciObject is this?
  bool is_obj_array_klass_klass() { return true; }

  // Return the distinguished ciObjArrayKlassKlass instance.
  static ciObjArrayKlassKlass* make();
};

