/*
 * @(#)ciScope.hpp	1.4 00/01/31 19:11:58
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

class CompilationScope;

// ciScope
//
// This class represents a tree of potentially inlineable
// methods.
class ciScope : public ResourceObj {
private:
  friend class CompileBroker;
  
  jobject                    _method_handle;
  ciMethod*                  _method;
  GrowableArray<ciScope*>*   _subscopes;
  ciScope*                   _caller;
  int                        _caller_bci;

  // Helper method for subscope_at_bci
  int index_of_subscope_at_bci(int bci) const;

  ciScope(CompilationScope* scope);
  ciScope(ciScope* caller, CompilationScope* scope);

  jobject   method_handle() { return _method_handle; }

public:

  ciMethod* method();
  ciScope*  subscope_at_bci(int bci) const;
  ciScope*  caller()               { return _caller; }
  int       caller_bci()           { return _caller_bci; }

  int       number_of_subscopes()  { return _subscopes->length(); }
  ciScope*  subscope_at(int index) { return _subscopes->at(index); }

  void      print_codes( int indent );
  void      print();
};

