/*
 * @(#)ciSymbol.hpp	1.2 00/03/24 15:08:09
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// ciSymbol
//
// This class represents a symbolOop in the HotSpot virtual
// machine.
class ciSymbol : public ciObject {
  CI_PACKAGE_ACCESS

private:
  ciSymbol(symbolOop s) : ciObject(s) {}

  symbolOop get_symbolOop() { return (symbolOop)get_oop(); }

  const char* type_name() { return "ciSymbol"; }
  
  void print_impl();

  int         byte_at(int i);
  jbyte*      base();

  // Make a ciSymbol from a C string (implementation).
  static ciSymbol* make_impl(const char* s);

public:
  // The text of the symbol as a null-terminated utf8 string.
  const char* as_utf8();
  int         utf8_length();

  // What kind of ciObject is this?
  bool is_symbol() { return true; }

  void print_symbol();

  // Make a ciSymbol from a C string.
  static ciSymbol* make(const char* s);
};
