/*
 * @(#)ciTypeArrayKlass.cpp	1.2 99/12/22 16:32:56
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2
#include "incls/_precompiled.incl"
#include "incls/_ciTypeArrayKlass.cpp.incl"

// ciTypeArrayKlass
//
// This class represents a klassOop in the HotSpot virtual machine
// whose Klass part in a TypeArrayKlass.

// ------------------------------------------------------------------
// ciTypeArrayKlass::ciTypeArrayKlass
ciTypeArrayKlass::ciTypeArrayKlass(klassOop k) : ciArrayKlass(k) {
  assert(get_Klass()->oop_is_typeArray(), "wrong type");
  _element_type = get_typeArrayKlass()->type();
}

// ------------------------------------------------------------------
// ciTypeArrayKlass::make_impl
//
// Implementation of make.
ciTypeArrayKlass* ciTypeArrayKlass::make_impl(BasicType t) {
  klassOop k = NULL;
  switch (t) {
  case T_BOOLEAN: k = Universe::boolArrayKlassObj();   break;
  case T_CHAR   : k = Universe::charArrayKlassObj();   break;
  case T_FLOAT  : k = Universe::singleArrayKlassObj(); break;
  case T_DOUBLE : k = Universe::doubleArrayKlassObj(); break;
  case T_BYTE   : k = Universe::byteArrayKlassObj();   break;
  case T_SHORT  : k = Universe::shortArrayKlassObj();  break;
  case T_INT    : k = Universe::intArrayKlassObj();    break;
  case T_LONG   : k = Universe::longArrayKlassObj();   break;
  default       : ShouldNotReachHere();
  }
  return CURRENT_ENV->get_object(k)->as_type_array_klass();
}

// ------------------------------------------------------------------
// ciTypeArrayKlass::make
//
// Make an array klass corresponding to the specified primitive type.
ciTypeArrayKlass* ciTypeArrayKlass::make(BasicType t) {
  GUARDED_VM_ENTRY(return make_impl(t);)
}

