/*
 * @(#)ciUtilities.cpp	1.1 99/11/10 14:48:14
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2
#include "incls/_precompiled.incl"
#include "incls/_ciUtilities.cpp.incl"

// ciUtilities
//
// Miscellaneous internal compiler interface routines.

// ------------------------------------------------------------------
// basictype_to_str
const char* basictype_to_str(BasicType t) {
  switch(t) {
  case T_BOOLEAN:
    return "boolean";
  case T_CHAR:
    return "char";
  case T_FLOAT:
    return "float";
  case T_DOUBLE:
    return "double";
  case T_BYTE:
    return "byte";
  case T_SHORT:
    return "short";
  case T_INT:
    return "int";
  case T_LONG:
    return "long";
  case T_OBJECT:
    return "object";
  case T_ARRAY:
    return "array";
  case T_VOID:
    return "void";
  default:
    return "illegal";
  }
}

// ------------------------------------------------------------------
// basictype_to_char
const char basictype_to_char(BasicType t) {
  switch(t) {
  case T_BOOLEAN:
    return 'Z';
  case T_CHAR:
    return 'C';
  case T_FLOAT:
    return 'F';
  case T_DOUBLE:
    return 'D';
  case T_BYTE:
    return 'B';
  case T_SHORT:
    return 'S';
  case T_INT:
    return 'I';
  case T_LONG:
    return 'J';
  case T_OBJECT:
    return 'L';
  case T_ARRAY:
    return '[';
  case T_VOID:
    return 'V';
  default:
    return 'X';
  }
}
