/*
 * @(#)location.cpp	1.18 99/06/29 18:11:10
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

#include "incls/_precompiled.incl"
#include "incls/_location.cpp.incl"
  
void Location::print_on(outputStream* st) const {
  if (is_illegal()) {
    st->print("Illegal");
  } else {
    switch (where()) {
      case on_stack:    st->print("stack[%d]", stack_offset());    break;
      case in_register: st->print("reg %d",    register_number()); break;
      default:          st->print("Wrong Location 0x%x", where());
    }
    switch (type()) {
      case normal:                                 break;
      case oop:          st->print(",oop");         break;
      case float_in_dbl: st->print(",float");       break;
      default:           st->print("Wrong Location 0x%x", type());
    }
  }
}

Location::Location(DebugInfoReadStream* stream) {
  *(jchar*)this = stream->read_short();

}

void Location::write_on(DebugInfoWriteStream* stream) {
  stream->write_short(*(jchar*)this);
}
