/*
 * @(#)compilationScope.hpp	1.85 99/06/28 11:04:17
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2


// The class CompilationScope contains variables that are typical for each
// compiled method (or method scope)

class CompilationScope: public Scope {
 public:
  CompilationScope(methodHandle method, Scope* caller = NULL, int callerBCI = IllegalBCI);

  void inline_scopes();
  void resolve_string_constants(TRAPS);

  // redefined accessors (to centralize casts to CompilationScope
  CompilationScope* caller() const                         { return (CompilationScope*)_caller; }
  CompilationScope* subscope_at(int i) const               { return (CompilationScope*)Scope::subscope_at(i); }
  CompilationScope* subscope_at_bci(int bci) const         { return (CompilationScope*)Scope::subscope_at_bci(bci); }
  CompilationScope* subscope_at_bci(int bci, int i) const  { return (CompilationScope*)Scope::subscope_at_bci(bci, i); }

  void print(int indent) PRODUCT_RETURN;
}; 


