/*
 * @(#)compilerOracle.hpp	1.8 00/03/21 16:16:47
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// CompilerOracle is an interface for turning on and off compilation
// for some methods

class CompilerOracle : AllStatic {
 private:
  static const char* file_name;
  static void read_from_line(char* line);
 public:
  // Add element to should exclude list
  static void add_should_exclude(symbolOop class_name, symbolOop method_name);
 
  // Tells whether we to exclude compilation of method
  static bool should_exclude(methodOop method);

  // Add element to should exclude list
  static void add_should_inline(symbolOop class_name, symbolOop method_name);
 
  // Tells whether we to exclude compilation of method
  static bool should_inline(methodOop method);

  // Add element to should print list
  static void add_should_print(symbolOop class_name, symbolOop method_name);

  // Tells whether we should print the assembly for this method
  static bool should_print(methodOop method);

  // Add element to should break at list
  static void add_should_break_at(symbolOop class_name, symbolOop method_name);

  // Tells whether to break when compiling method
  static bool should_break_at(methodOop method);

  // Reads from file and adds to lists 
  static void parse_from_file();

  // For updating the oracle file
  static void append_comment_to_file(const char* message);
  static void append_exclude_to_file(methodOop method);
};
