/*
 * @(#)bytecodeStream.cpp	1.33 99/06/28 11:05:00
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

# include "incls/_precompiled.incl"
# include "incls/_bytecodeStream.cpp.incl"


BytecodeStream::BytecodeStream(methodHandle method) {
  _method = method;
  set_interval(0, _method->code_size());
}


void BytecodeStream::set_interval(int beg_bci, int end_bci) {
  assert(0 <= beg_bci && beg_bci <= method()->code_size(), "illegal beg_bci");
  assert(0 <= end_bci && end_bci <= method()->code_size(), "illegal end_bci");
  // setup of iteration pointers
  _bci      = beg_bci;
  _next_bci = beg_bci;
  _end_bci  = end_bci;
}

