/*
 * @(#)rewriter.hpp	1.8 99/06/22 16:40:25
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2


// The Rewriter adds caches to the constant pool and rewrites bytecode indices
// pointing into the constant pool for better interpreter performance.

class Rewriter: public AllStatic {
 private:
  static void compute_index_maps(constantPoolHandle pool, GrowableArray<int>*& index_map, GrowableArray<int>*& inverse_index_map);
  static constantPoolCacheHandle new_constant_pool_cache(GrowableArray<int>* inverse_index_map, TRAPS);
  static methodHandle rewrite_method(methodHandle method, GrowableArray<int>* index_map, TRAPS);

 public:
  static void rewrite(instanceKlassHandle klass, TRAPS);
};

