/*
 * @(#)shared.cpp	1.15 00/02/10 14:03:43
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2
#include "incls/_precompiled.incl"
#include "incls/_shared.cpp.incl"

// First register number that refers to a stack slot
OptoReg::Name SharedInfo::stack0;

// Register names
const char *SharedInfo::regName[128];

// Stack pointer register
OptoReg::Name SharedInfo::c_frame_pointer;



void SharedInfo::set_stack0(int n) {
  COMPILER2_ONLY(ShouldNotReachHere();)           // temporary solution
  assert(n % 32 == 0, "must be a multiple of 32");
  SharedInfo::stack0 = OptoReg::Name(n);
  assert(Register::nofRegisters < n, "too may registers");
  set_regName();
}

#ifdef COMPILER2

// Branch Frequency Table
FreqPair *SharedInfo::freqTable;

// Flush the Branch Frequency Tracking Table
void SharedInfo::flush_branch_freq_table(void) {
  for(int i = 0; i < nth_bit(BranchFreqTableSize); i++) {
    assert(CountInterpBranches,"Bad Branch table flush");
    freqTable[i]._taken = 0;
    freqTable[i]._not_taken = 0;
  }
}

// Dump the Branch Frequency Tracking Table
void SharedInfo::dump_freqTable(void) {
  for(int i = 0; i < nth_bit(BranchFreqTableSize); i++) {
    tty->print("Entry %d: Taken = %d, Not Taken = %d\n",i,freqTable[i]._taken,freqTable[i]._not_taken);
  }
}

// Call Frequency Table
int *SharedInfo::callTable;

// Flush the Call Frequency Tracking Table
void SharedInfo::flush_call_freq_table(void) {
  assert(CountInterpCalls,"Bad Call table flush");
  for(int i = 0; i < nth_bit(CallFreqTableSize); i++) {
    callTable[i] = 0;
  }
}

// Dump the Call Frequency Tracking Table
void SharedInfo::dump_callTable(void) {
  for(int i = 0; i < nth_bit(CallFreqTableSize); i++) {
    tty->print("Entry %d: Call Count = %d\n",i,callTable[i]);
  }
}

#endif
