/*
 * @(#)ageTable.hpp	1.14 01/02/09 14:44:59
 *
 * Copyright 1993-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

/*  Copyright 1992-2001 Sun Microsystems, Inc. and Stanford University.
   See the LICENSE file for license information. */

// Age table for adaptive feedback-mediated tenuring (scavenging)
//
// Note: all sizes are in oops

class ageTable VALUE_OBJ_CLASS_SPEC {
 public:
  // constants
  enum { table_size = markOopDesc::max_age + 1 };

  // instance variables
  jint sizes[table_size];

  // constructor
  ageTable()    { clear(); }

  // clear table
  void clear();

  // add entry
  void add(oop p, int oop_size) {
    int age = p->age();
    assert(age > 0 && age < table_size, "invalid age of object");
    sizes[age] += oop_size; 
  }

  // calculate new tenuring threshold based on age information
  int compute_tenuring_threshold(size_t survivor_capacity);
};
