/*
 * @(#)gcLocker.cpp	1.26 99/06/22 16:40:43
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

# include "incls/_precompiled.incl"
# include "incls/_gcLocker.cpp.incl"

jint GC_locker::_lock_count = 0;

// Implementation of No_GC_Verifier

#ifdef ASSERT

No_GC_Verifier::No_GC_Verifier(bool activate) {
  _activated = activate;
  if (_activated) {
    _old_scavenge_count = Scavenge::invoke_count();
    _old_mark_sweep_count  = MarkSweep::invoke_count();
  }
}


No_GC_Verifier::~No_GC_Verifier() {
  if (_activated) {
    if (_old_scavenge_count != Scavenge::invoke_count()) {
      fatal("scavenge in a No_GC_Verifier secured function");
    }
    if (_old_mark_sweep_count != MarkSweep::invoke_count()) {
      fatal("mark-sweep in a No_GC_Verifier secured function");
    }
  }
}

#endif
