/*
 * @(#)iterator.hpp	1.11 99/10/27 09:41:26
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// The following classes are C++ `closures` for iterating over objects, roots and spaces


// OopClosure is used for iterating through roots (oop*)

class OopClosure : public StackObj {
 public:
  // Called for each root
  virtual void do_oop(oop* o) = 0;
};


// ObjectClosure is used for iterating through an object space

class ObjectClosure : public StackObj {
 public:
  // Called for each object.
  virtual void do_object(oop obj) = 0;
};


// SpaceClosure is used for iterating over spaces

class Space;

class SpaceClosure : public StackObj {
 public:
  // Called for each space
  virtual void do_space(Space* s) = 0;
};


// MonitorClosure is used for iterating over monitors in the monitors cache

class ObjectMonitor;

class MonitorClosure : public StackObj {
 public:
  // called for each monitor in cache
  virtual void do_monitor(ObjectMonitor* m) = 0;
};
