/*
 * @(#)oopFactory.hpp	1.37 00/03/21 16:17:02
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// oopFactory is a class used for creating new objects.

class vframeArray;

class oopFactory: AllStatic {
 public:
  // Basic type leaf array allocation
  static typeArrayOop    new_boolArray  (int length, TRAPS) { return typeArrayKlass::cast(Universe::boolArrayKlassObj  ())->allocate(length, CHECK_0); }
  static typeArrayOop    new_charArray  (int length, TRAPS) { return typeArrayKlass::cast(Universe::charArrayKlassObj  ())->allocate(length, CHECK_0); }
  static typeArrayOop    new_singleArray(int length, TRAPS) { return typeArrayKlass::cast(Universe::singleArrayKlassObj())->allocate(length, CHECK_0); }
  static typeArrayOop    new_doubleArray(int length, TRAPS) { return typeArrayKlass::cast(Universe::doubleArrayKlassObj())->allocate(length, CHECK_0); }
  static typeArrayOop    new_byteArray  (int length, TRAPS) { return typeArrayKlass::cast(Universe::byteArrayKlassObj  ())->allocate(length, CHECK_0); }
  static typeArrayOop    new_shortArray (int length, TRAPS) { return typeArrayKlass::cast(Universe::shortArrayKlassObj ())->allocate(length, CHECK_0); }
  static typeArrayOop    new_intArray   (int length, TRAPS) { return typeArrayKlass::cast(Universe::intArrayKlassObj   ())->allocate(length, CHECK_0); }
  static typeArrayOop    new_longArray  (int length, TRAPS) { return typeArrayKlass::cast(Universe::longArrayKlassObj  ())->allocate(length, CHECK_0); }

  static typeArrayOop    new_charArray           (const char* utf8_str,  TRAPS);
  static typeArrayOop    new_permanent_charArray (int length, TRAPS);
  static typeArrayOop    new_permanent_byteArray (int length, TRAPS);  // used for class file structures
  static typeArrayOop    new_permanent_shortArray(int length, TRAPS);  // used for class file structures
  static typeArrayOop    new_permanent_intArray  (int length, TRAPS);  // used for class file structures
  
  static typeArrayOop    new_typeArray(BasicType type, int length, TRAPS);

  // Symbols
  static symbolOop       new_symbol(const char* name, int length, TRAPS);
  static symbolOop       new_symbol(char* name, TRAPS) { return new_symbol(name, strlen(name), CHECK_0); }
  static symbolOop       new_symbol(const char* name, TRAPS) { return new_symbol(name, strlen(name), CHECK_0); }
  // Constant pools
  static constantPoolOop      new_constantPool     (int length, TRAPS);
  static constantPoolCacheOop new_constantPoolCache(int length, TRAPS);

  // Instance classes
  static klassOop        new_instanceKlass(int vtable_len, int itable_len, int static_field_size, 
                                           int nonstatic_oop_map_size, ReferenceType rt, TRAPS);

  // Methods
  static methodOop       new_method(int byte_code_size, AccessFlags access_flags, int compressed_line_number_size, int localvariable_table_length, int checked_exceptions_length, TRAPS);

  // System object arrays
  static objArrayOop     new_system_objArray(int length, TRAPS);

  // Regular object arrays
  static objArrayOop     new_objArray(klassOop klass, int length, TRAPS);

  // Java level threads (named main, using main Thread Group)
  static oop		 new_thread(TRAPS);
  static oop		 new_threadGroup(TRAPS);

#ifndef CORE
  // For compiled ICs
  static compiledICHolderOop new_compiledICHolder(methodOop method, klassOop klass, TRAPS);
#endif
};

