/*
 * @(#)universe.cpp	1.258 01/02/09 14:45:17
 *
 * Copyright 1993-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

# include "incls/_precompiled.incl"
# include "incls/_universe.cpp.incl"

// Known objects 
klassOop Universe::_boolArrayKlassObj                 = NULL;
klassOop Universe::_byteArrayKlassObj                 = NULL;
klassOop Universe::_charArrayKlassObj                 = NULL;
klassOop Universe::_intArrayKlassObj                  = NULL;
klassOop Universe::_shortArrayKlassObj                = NULL;
klassOop Universe::_longArrayKlassObj                 = NULL;
klassOop Universe::_singleArrayKlassObj               = NULL;
klassOop Universe::_doubleArrayKlassObj               = NULL;
klassOop Universe::_symbolKlassObj                    = NULL;
klassOop Universe::_methodKlassObj                    = NULL;
klassOop Universe::_klassKlassObj                     = NULL;
klassOop Universe::_arrayKlassKlassObj                = NULL;
klassOop Universe::_objArrayKlassKlassObj             = NULL;
klassOop Universe::_typeArrayKlassKlassObj            = NULL;
klassOop Universe::_instanceKlassKlassObj             = NULL;
klassOop Universe::_constantPoolKlassObj              = NULL;
klassOop Universe::_constantPoolCacheKlassObj         = NULL;
#ifndef CORE
klassOop Universe::_compiledICHolderKlassObj          = NULL;
#endif
klassOop Universe::_systemObjArrayKlassObj            = NULL;
oop      Universe::_main_thread_group                 = NULL;
oop      Universe::_system_thread_group               = NULL;
typeArrayOop Universe::_the_empty_short_array         = NULL;
typeArrayOop Universe::_the_empty_int_array           = NULL;
objArrayOop Universe::_the_empty_system_obj_array     = NULL;
objArrayOop Universe::_the_empty_class_klass_array    = NULL;
methodOop Universe::_finalizer_register_method        = NULL;
methodOop Universe::_reflect_invoke_method            = NULL;
methodOop Universe::_loader_addClass_method           = NULL;
oop Universe::_out_of_memory_error_instance           = NULL;
oop Universe::_null_ptr_exception_instance            = NULL;
oop Universe::_arithmetic_exception_instance          = NULL;
oop Universe::_vm_exception                           = NULL;
bool Universe::_jvmpi_alloc_event_enabled             = false;
bool Universe::_jvmpi_move_event_enabled              = false;
bool Universe::_jvmpi_jni_global_alloc_event_enabled      = false;
bool Universe::_jvmpi_jni_global_free_event_enabled       = false;
bool Universe::_jvmpi_jni_weak_global_alloc_event_enabled = false;
bool Universe::_jvmpi_jni_weak_global_free_event_enabled  = false;
debug_only(objArrayOop Universe::_fullgc_alot_dummy_array = NULL;)
debug_only(int Universe::_fullgc_alot_dummy_next      = 0;)


// Heap  
size_t             Universe::_new_size = 0;
size_t             Universe::_reserved_new_size = 0;
size_t             Universe::_old_size = 0;
size_t             Universe::_reserved_old_size = 0;
size_t             Universe::_perm_size = 0;
size_t             Universe::_reserved_perm_size = 0;
int             Universe::_large_typearray_limit = 0;
NewGeneration*  Universe::_new_gen;
OldGeneration*  Universe::_old_gen;
PermGeneration* Universe::_perm_gen;

int             Universe::_verify_count = 0;

bool            Universe::_is_jdk12x_version = false;

int             Universe::_base_vtable_size = 0;
bool            Universe::_bootstrapping = false;
bool            Universe::_fully_initialized = false;

size_t          Universe::_heap_capacity_at_last_gc;
size_t          Universe::_heap_used_at_last_gc;
size_t          Universe::_heap_free_at_last_gc;

void Universe::basic_type_classes_do(void f(klassOop)) {
  f(boolArrayKlassObj());
  f(byteArrayKlassObj());
  f(charArrayKlassObj());
  f(intArrayKlassObj());
  f(shortArrayKlassObj());
  f(longArrayKlassObj());
  f(singleArrayKlassObj());
  f(doubleArrayKlassObj());
}


void Universe::system_classes_do(void f(klassOop)) {
  f(symbolKlassObj());
  f(methodKlassObj());
  f(klassKlassObj());
  f(arrayKlassKlassObj());
  f(objArrayKlassKlassObj());
  f(typeArrayKlassKlassObj());
  f(instanceKlassKlassObj());
  f(constantPoolKlassObj());
  f(systemObjArrayKlassObj());
}


void Universe::oops_do(void f(oop*)) {
  f((oop*)&_boolArrayKlassObj);
  f((oop*)&_byteArrayKlassObj);
  f((oop*)&_charArrayKlassObj);
  f((oop*)&_intArrayKlassObj);
  f((oop*)&_shortArrayKlassObj);
  f((oop*)&_longArrayKlassObj);
  f((oop*)&_singleArrayKlassObj);
  f((oop*)&_doubleArrayKlassObj);
  f((oop*)&_symbolKlassObj);
  f((oop*)&_methodKlassObj);
  f((oop*)&_klassKlassObj);
  f((oop*)&_arrayKlassKlassObj);
  f((oop*)&_objArrayKlassKlassObj);
  f((oop*)&_typeArrayKlassKlassObj);
  f((oop*)&_instanceKlassKlassObj);
  f((oop*)&_constantPoolKlassObj);
  f((oop*)&_constantPoolCacheKlassObj);
#ifndef CORE
  f((oop*)&_compiledICHolderKlassObj);
#endif
  f((oop*)&_systemObjArrayKlassObj);
  f((oop*)&_the_empty_short_array);
  f((oop*)&_the_empty_int_array);
  f((oop*)&_the_empty_system_obj_array);    
  f((oop*)&_the_empty_class_klass_array);    
  f((oop*)&_finalizer_register_method);  
  f((oop*)&_reflect_invoke_method);
  f((oop*)&_loader_addClass_method);
  f((oop*)&_out_of_memory_error_instance);
  f((oop*)&_null_ptr_exception_instance);
  f((oop*)&_arithmetic_exception_instance);
  f((oop*)&_main_thread_group);
  f((oop*)&_system_thread_group);
  f((oop*)&_vm_exception);
  debug_only(f((oop*)&_fullgc_alot_dummy_array);)
}


void Universe::check_alignment(size_t size, size_t alignment, const char* name) {
  if (size < alignment || size % alignment != 0) {
    ResourceMark rm;
    stringStream st;
    st.print("Size of %s (%u bytes) must be aligned to %u bytes", name, size, alignment);
    char* error = st.as_string();
    vm_exit_during_initialization(error);
  }
}


void Universe::initialize_heap() {
  // All calculations below are in bytes. 
  // All space sizes must be multiples of car size in order for the CarTable to work.
  // Note that the CarTable is used with and without train gc (for fast lookup).
  size_t min_alignment = (size_t) CarSpace::car_size();

  // The card marking array and the offset arrays for old generations are committed
  // in os pages as well. Make sure they are entirely full (to avoid partial page 
  // problems), e.g. if 512 bytes heap corresponds to 1 byte entry and the os page
  // size is 4096, the maximum heap size should be 512*4096 = 2MB aligned.
  size_t max_alignment = RememberedSet::card_size * os::vm_page_size();
  assert(max_alignment >= min_alignment && max_alignment % min_alignment == 0, "invalid alignment constraints");
  
  // User inputs from -mx and ms are aligned
  size_t initial_heap_size = align_size_up(Arguments::initial_heap_size(), min_alignment);
  size_t max_heap_size     = align_size_up(Arguments::max_heap_size()    , max_alignment);

  // Adjust max size parameters and disable newgen expansion for train gc
  if (NewSize > MaxNewSize || UseTrainGC) {
    MaxNewSize = NewSize;
  }
  if (PermSize > MaxPermSize) {
    MaxPermSize = PermSize;
  }

  // Check validity of heap flags
  check_alignment(NewSize,      min_alignment, "eden space");
  check_alignment(MaxNewSize,   min_alignment, "survivor space");
  check_alignment(OldSize,      min_alignment, "old space");
  check_alignment(MaxHeapSize,  max_alignment, "maximum old space");
  check_alignment(PermSize,     min_alignment, "permanent space");
  check_alignment(MaxPermSize,  max_alignment, "maximum permanent space");

  // Check validity of heap parameters from launcher
  if (initial_heap_size == 0) {
    initial_heap_size = NewSize + OldSize;
  } else {
    check_alignment(initial_heap_size, min_alignment, "initial heap");
  }
  if (max_heap_size == 0) {
    max_heap_size = MaxHeapSize;
  } else {
    check_alignment(max_heap_size,     max_alignment, "maximum heap");
  }

  // Check heap parameter properties
  if (initial_heap_size < M) {
    vm_exit_during_initialization("Too small initial heap");
  }
  if (initial_heap_size <= NewSize) {
     // make sure there is at least some room in old space
    vm_exit_during_initialization("Too small initial heap for new size specified");
  }
  if (NewSize < 3*min_alignment) {
     // make sure there room for eden and two survivor spaces
    vm_exit_during_initialization("Too small new size specified");
  }
  if (max_heap_size < initial_heap_size) {
    vm_exit_during_initialization("Incompatible initial and maximum heap sizes specified");
  }
  if (PermSize < M) {
    vm_exit_during_initialization("Too small initial permanent heap");
  }
  if (SurvivorRatio < 1 || NewRatio < 1) {
    vm_exit_during_initialization("Invalid heap ratio specified");
  }

  // Parameters are valid, compute area sizes.
  size_t max_new_size = align_size_down(max_heap_size / (NewRatio+1), min_alignment);
  max_new_size = min(max(max_new_size, NewSize), MaxNewSize);

  _reserved_new_size  = max_new_size;
  _reserved_old_size  = max_heap_size - _reserved_new_size;

  size_t desired_new_size = align_size_down(initial_heap_size / (NewRatio+1), min_alignment);
  _new_size = min(max(desired_new_size, NewSize), _reserved_new_size);
  _old_size           = initial_heap_size - _new_size;
  assert(_new_size + _old_size == initial_heap_size, "just checking");

  _perm_size          = PermSize;
  _reserved_perm_size = MaxPermSize;

  // Start of object heap must be car size aligned in order for the CarTable to work.
  // Note that the CarTable is used with and without train gc (for fast lookup).
  size_t heap_base_alignment = (size_t) CarSpace::car_size();

  // Reserve memory areas
  size_t heap_reserved_size = _reserved_new_size + _reserved_old_size + _reserved_perm_size;
  assert(heap_reserved_size == max_heap_size + MaxPermSize, "just checking");
  
  ReservedSpace heap_rs(heap_reserved_size, heap_base_alignment, (UseISM || UsePermISM));

  if (!heap_rs.is_reserved()) {
    vm_exit_during_initialization("Could not reserve enough space for object heap");
  }
  ReservedSpace new_rs     = heap_rs.first_part(_reserved_new_size);
  heap_rs                  = heap_rs.last_part(_reserved_new_size);
  ReservedSpace old_rs     = heap_rs.first_part(_reserved_old_size);
  ReservedSpace perm_rs    = heap_rs.last_part(_reserved_old_size);

  // Initialize each generation, will do memory commit
  _new_gen = new NewGeneration();
  _new_gen->initialize(new_rs, _new_size);
  _perm_gen = new PermGeneration();
  _perm_gen->initialize(perm_rs, _perm_size);
  if (UseTrainGC) {
    _old_gen = new TrainGeneration();
    train_gen()->initialize(old_rs);
  } else {
    _old_gen = new TenuredGeneration();
    tenured_gen()->initialize(old_rs, _old_size);
  }

  assert(_new_gen->high_boundary == _old_gen->low_boundary,  "heap allocation out of order");
  assert(_old_gen->high_boundary == _perm_gen->low_boundary, "heap allocation out of order");

  if(UseTLE) {
    ThreadLocalEden::initialize_fragmentation_ratio();
    if(ResizeTLE) {
      ThreadLocalEden::adjust_max_size();
    }
  }

  // Allocate remaining heap data structures
  CarTable::initialize();
  RememberedSet::initialize();

  if (VerifyOops) compute_verify_oop_data();

  _large_typearray_limit = CarSpace::car_size_in_oops();
}


size_t Universe::mem_capacity() {
  // Note: perm generation is excluded
  return _new_gen->capacity() + _old_gen->capacity();
}


size_t Universe::mem_free() {
  // Note: perm generation is excluded
  return _new_gen->free() + _old_gen->free();
}


size_t Universe::mem_used() {
  // Note: perm generation is excluded
  return _new_gen->used() + _old_gen->used();
}


void Universe::genesis(TRAPS) {
  ResourceMark rm;
  { FlagSetting fs(_bootstrapping, true);
      
    { MutexLocker mc(Compile_lock);

      // determine base vtable size; without that we cannot create the array klasses
      compute_base_vtable_size();

      _klassKlassObj          = klassKlass::create_klass(CHECK);
      _arrayKlassKlassObj     = arrayKlassKlass::create_klass(CHECK);

      _objArrayKlassKlassObj  = objArrayKlassKlass::create_klass(CHECK);
      _instanceKlassKlassObj  = instanceKlassKlass::create_klass(CHECK);
      _typeArrayKlassKlassObj = typeArrayKlassKlass::create_klass(CHECK);

      _symbolKlassObj         = symbolKlass::create_klass(CHECK);

      _boolArrayKlassObj      = typeArrayKlass::create_klass(T_BOOLEAN, sizeof(jboolean), CHECK);

      _charArrayKlassObj      = typeArrayKlass::create_klass(T_CHAR,    sizeof(jchar),    CHECK);
      _singleArrayKlassObj    = typeArrayKlass::create_klass(T_FLOAT,   sizeof(jfloat),   CHECK);
      _doubleArrayKlassObj    = typeArrayKlass::create_klass(T_DOUBLE,  sizeof(jdouble),  CHECK);
      _byteArrayKlassObj      = typeArrayKlass::create_klass(T_BYTE,    sizeof(jbyte),    CHECK);
      _shortArrayKlassObj     = typeArrayKlass::create_klass(T_SHORT,   sizeof(jshort),   CHECK);
      _intArrayKlassObj       = typeArrayKlass::create_klass(T_INT,     sizeof(jint),     CHECK);
      _longArrayKlassObj      = typeArrayKlass::create_klass(T_LONG,    sizeof(jlong),    CHECK);

      _methodKlassObj         = methodKlass::create_klass(CHECK);

      _constantPoolKlassObj       = constantPoolKlass::create_klass(CHECK);
      _constantPoolCacheKlassObj  = constantPoolCacheKlass::create_klass(CHECK);

  #ifndef CORE
      _compiledICHolderKlassObj   = compiledICHolderKlass::create_klass(CHECK);
  #endif
      _systemObjArrayKlassObj     = objArrayKlassKlass::cast(objArrayKlassKlassObj())->allocate_system_objArray_klass(CHECK);

      _the_empty_short_array      = oopFactory::new_permanent_shortArray(0, CHECK);
      _the_empty_int_array        = oopFactory::new_permanent_intArray(0, CHECK);
      _the_empty_system_obj_array = oopFactory::new_system_objArray(0, CHECK);

      _vm_exception               = oopFactory::new_symbol("vm exception holder", CHECK);
    }

    vmSymbols::initialize(CHECK);

    SystemDictionary::initialize(CHECK);

    klassOop ok = SystemDictionary::object_klass();
    // Set element klass for system obj array klass
    objArrayKlass::cast(_systemObjArrayKlassObj)->set_element_klass(ok);
    objArrayKlass::cast(_systemObjArrayKlassObj)->set_bottom_klass(ok);

    // Set super class for the classes created above
    Klass::cast(boolArrayKlassObj()     )->set_super(ok);
    Klass::cast(charArrayKlassObj()     )->set_super(ok);
    Klass::cast(singleArrayKlassObj()   )->set_super(ok);
    Klass::cast(doubleArrayKlassObj()   )->set_super(ok);
    Klass::cast(byteArrayKlassObj()     )->set_super(ok);
    Klass::cast(shortArrayKlassObj()    )->set_super(ok);
    Klass::cast(intArrayKlassObj()      )->set_super(ok);
    Klass::cast(longArrayKlassObj()     )->set_super(ok);
    Klass::cast(constantPoolKlassObj()  )->set_super(ok);
    Klass::cast(systemObjArrayKlassObj())->set_super(ok);
    Klass::cast(boolArrayKlassObj()     )->append_to_sibling_list();
    Klass::cast(charArrayKlassObj()     )->append_to_sibling_list();
    Klass::cast(singleArrayKlassObj()   )->append_to_sibling_list();
    Klass::cast(doubleArrayKlassObj()   )->append_to_sibling_list();
    Klass::cast(byteArrayKlassObj()     )->append_to_sibling_list();
    Klass::cast(shortArrayKlassObj()    )->append_to_sibling_list();
    Klass::cast(intArrayKlassObj()      )->append_to_sibling_list();
    Klass::cast(longArrayKlassObj()     )->append_to_sibling_list();
    Klass::cast(constantPoolKlassObj()  )->append_to_sibling_list();
    Klass::cast(systemObjArrayKlassObj())->append_to_sibling_list();
  } // end of core bootstrapping
  
  #ifdef ASSERT
  if (FullGCALot) {
    // Allocate array of dummies at bottom of heap. We allocate dummies at the bottom
    // of both old generation and permanent generation to ensure all objects move.
    int size;
    if (UseTrainGC) {
      warning("Using +FullGCALot with train gc will not force all objects to relocate");
      size = FullGCALotDummies;
    } else {
      size = FullGCALotDummies * 2;
    }
    _fullgc_alot_dummy_array = oopFactory::new_system_objArray(size, CHECK);
    int i = 0;
    while (i < size) {
      if (!UseTrainGC) {
        // Allocate dummy in old generation
        oop dummy = instanceKlass::cast(SystemDictionary::object_klass())->allocate_instance(CHECK);
        _fullgc_alot_dummy_array->obj_at_put(i++, dummy);
      }
      // Allocate dummy in permanent generation
      oop dummy = instanceKlass::cast(SystemDictionary::object_klass())->allocate_permanent_instance(CHECK);
      _fullgc_alot_dummy_array->obj_at_put(i++, dummy);
    }
    assert(i == _fullgc_alot_dummy_array->length(), "just checking");
  }
  #endif
}    


class FixupMirrorClosure: public ObjectClosure {
 public:
  void do_object(oop obj) {
    if (obj->is_klass()) {
      EXCEPTION_MARK;
      KlassHandle k(THREAD, klassOop(obj));
      // We will never reach the CATCH below since Exceptions::_throw will cause
      // the VM to exit if an exception is thrown during initialization
      java_lang_Class::create_mirror(k, CATCH);
    }
  }
};


void Universe::fixup_mirrors(TRAPS) {
  // Bootstrap problem: all classes gets a mirror (java.lang.Class instance) assigned eagerly,
  // but we cannot do that for classes created before java.lang.Class is loaded. Here we simply
  // walk over permanent objects created so far (mostly classes) and fixup their mirrors. Note
  // that the number of objects allocated at this point is very small.
  assert(SystemDictionary::class_klass_loaded(), "java.lang.Class should be loaded");
  FixupMirrorClosure blk;
  _perm_gen->object_iterate(&blk);
}


static bool has_run_finalizers_on_exit = false;

void Universe::run_finalizers_on_exit() {
  if (has_run_finalizers_on_exit) return;
  has_run_finalizers_on_exit = true;

  // Called on VM exit. This ought to be run in a separate thread.
  if (TraceReferenceGC) tty->print_cr("Callback to run finalizers on exit");
  { 
    PRESERVE_EXCEPTION_MARK;
    KlassHandle finalizer_klass(THREAD, SystemDictionary::finalizer_klass());
    JavaValue result(T_VOID);
    JavaCalls::call_static(
      &result, 
      finalizer_klass, 
      vmSymbolHandles::run_finalizers_on_exit_name(), 
      vmSymbolHandles::void_method_signature(),
      THREAD
    );
    // Ignore any pending exceptions
    CLEAR_PENDING_EXCEPTION;
  }
}


void Universe::set_generation_saved_marks_to_top() {
  _new_gen->set_saved_marks_to_top();
  _old_gen->set_saved_marks_to_top();
  _perm_gen->set_saved_marks_to_top();
}


void Universe::compute_new_generation_sizes() {
  _old_gen->compute_new_generation_size();
  _perm_gen->compute_new_generation_size();
  // We adjust new generation last so the old generation can adjust first
  _new_gen->compute_new_generation_size();
}


void Universe::reinitialize_vtable_of(Klass* k, TRAPS) {  
  // init vtable of k and all subclasses
  klassVtable* vt = k->vtable();
  if (vt) vt->initialize_vtable();
  if (k->oop_is_instance()) {
    instanceKlass* ik = (instanceKlass*)k;
    for (Klass* s = ik->subklass(); s != NULL; s = s->next_sibling()) {
      reinitialize_vtable_of(s, CHECK);
    }
  }
}


void initialize_itable_for_klass(klassOop k) {
  instanceKlass::cast(k)->itable()->initialize_itable();        
}


void Universe::reinitialize_itables() {
  SystemDictionary::classes_do(initialize_itable_for_klass);

}


bool Universe::on_page_boundary(void* addr) {
  return ((int) addr) % os::vm_page_size() == 0;
}


void Universe::object_iterate(ObjectClosure* blk) {
  _new_gen->object_iterate(blk);
  _old_gen->object_iterate(blk);
  _perm_gen->object_iterate(blk);
}


void Universe::space_iterate(SpaceClosure* blk) {
  _new_gen->space_iterate(blk);
  _old_gen->space_iterate(blk);
  _perm_gen->space_iterate(blk);
}


static jint non_oop_bits = 0;

void* Universe::non_oop_word() {
  // Neither the high bits nor the low bits of this value is allowed
  // to look like (respectively) the high or low bits of a real oop.
  //
  // High and low are CPU-specific notions, but low always includes
  // the low-order bit.  Since oops are always aligned at least mod 4,
  // setting the low-order bit will ensure that the low half of the
  // word will never look like that of a real oop.
  //
  // Using the OS-supplied non-memory-address word (usually 0 or -1)
  // will take care of the high bits, however many there are.

  if (non_oop_bits == 0) {
    non_oop_bits = (jint)os::non_memory_address_word() | 1;
  }

  return (void*)non_oop_bits;
}


void universe_init() {
  assert (!Universe::_fully_initialized, "called after initialize_vtables");
  TraceTime timer("Genesis", TraceStartupTime);
  GC_locker::lock();  // do not allow gc during bootstrapping
  SymbolTable::initialize();
  StringTable::initialize();
  Universe::initialize_heap();
  // We will never reach the CATCH below since Exceptions::_throw will cause
  // the VM to exit if an exception is thrown during initialization
}


void universe2_init() {
  EXCEPTION_MARK;
  Universe::genesis(CATCH);
  if (VerifyBeforeScavenge) {
    Universe::update_offset_tables();
    Universe::verify();   // make sure we're starting with a clean slate
  }
}


// This function is defined in JVM.cpp
extern void initialize_converter_functions();

void universe_post_init() {
  Universe::_fully_initialized = true;
  EXCEPTION_MARK;
  { ResourceMark rm;
    Interpreter::initialize();      // needed for interpreter entry points
    Universe::reinitialize_vtable_of(Klass::cast(SystemDictionary::object_klass()), CHECK);
    Universe::reinitialize_itables();
  }
  // Setup preallocated empty java.lang.Class array
  Universe::_the_empty_class_klass_array = oopFactory::new_objArray(SystemDictionary::class_klass(), 0, CHECK);
  // Setup preallocated OutOfMemoryError error
  klassOop k = SystemDictionary::resolve_or_fail(vmSymbolHandles::java_lang_OutOfMemoryError(), NULL, NULL, true, CHECK);
  Universe::_out_of_memory_error_instance = instanceKlass::cast(k)->allocate_permanent_instance(CHECK);
  // Setup preallocated NullPointerException
  // (this is currently used for a cheap & dirty solution in compiler exception handling)
  k = SystemDictionary::resolve_or_fail(vmSymbolHandles::java_lang_NullPointerException(), NULL, NULL, true, CHECK);
  Universe::_null_ptr_exception_instance = instanceKlass::cast(k)->allocate_permanent_instance(CHECK);
  // Setup preallocated ArithmeticException
  // (this is currently used for a cheap & dirty solution in compiler exception handling)
  k = SystemDictionary::resolve_or_fail(vmSymbolHandles::java_lang_ArithmeticException(), NULL, NULL, true, CHECK);
  Universe::_arithmetic_exception_instance = instanceKlass::cast(k)->allocate_permanent_instance(CHECK);
  oop msg = java_lang_String::create_from_str("/ by zero", CHECK);
  java_lang_Throwable::set_message(Universe::_arithmetic_exception_instance, msg);
  Universe::update_max_heap_capatity();
  if (PrintHeapUsageOverTime) Universe::print_heap_usage_header();
  
  // Setup static method for registering finalizers
  // The finalizer klass must be linked before looking up the method, in
  // case it needs to get rewritten.
  instanceKlass::cast(SystemDictionary::finalizer_klass())->link_class(CHECK);
  methodOop m = instanceKlass::cast(SystemDictionary::finalizer_klass())->find_method(
                                    vmSymbols::register_method_name(), 
                                    vmSymbols::register_method_signature());
  if (m == NULL || !m->is_static()) {
    THROW_MSG(vmSymbols::java_lang_NoSuchMethodException(), "java.lang.ref.Finalizer.register");
  }
  Universe::_finalizer_register_method = m;

  // Resolve on first use and initialize class. 
  // Note: No race-condition here, since a resolve will always return the same result

  // Setup method for security checks 
  k = SystemDictionary::resolve_or_fail(vmSymbolHandles::java_lang_reflect_Method(), NULL, NULL, true, CHECK);  
  instanceKlass::cast(k)->link_class(CHECK);
  m = instanceKlass::cast(k)->find_method(vmSymbols::invoke_name(), vmSymbols::object_array_object_object_signature());
  if (m == NULL || m->is_static()) {
    THROW_MSG(vmSymbols::java_lang_NoSuchMethodException(), "java.lang.reflect.Method.invoke");
  }
  Universe::_reflect_invoke_method = m;  

  // Setup method for registering loaded classes in class loader vector 
  instanceKlass::cast(SystemDictionary::classloader_klass())->link_class(CHECK);
  m = instanceKlass::cast(SystemDictionary::classloader_klass())->find_method(vmSymbols::addClass_name(), vmSymbols::class_void_signature());
  if (m == NULL || m->is_static()) {
    THROW_MSG(vmSymbols::java_lang_NoSuchMethodException(), "java.lang.ClassLoader.addClass");
  }
  Universe::_loader_addClass_method = m;  

  // Compute is_jdk12x_version flag. Only 1.3 or later has the java.lang.Shutdown class.
  k = SystemDictionary::resolve_or_null(vmSymbolHandles::java_lang_Shutdown(), NULL, NULL, THREAD);
  CLEAR_PENDING_EXCEPTION;          // ignore exceptions (NoClassDefFoundError on jdk1.2.x)
  Universe::_is_jdk12x_version = (k == NULL);

  // Ideally this should be done more lazily as it preloads the StrictMath
  // class in order to get the StrictMath sine & cosine native entry points.
  // Note: StrictMath doesn't exist for JDK 1.2!
  if (!Universe::is_jdk12x_version()) SharedRuntime::initialize_StrictMath_entry_points();

  // The folowing is initializing converter functions for serialization in
  // JVM.cpp. If we clean up the StrictMath code above we may want to find
  // a better solution for this as well.
  initialize_converter_functions();

  // This needs to be done before the first scavenge/gc
  Universe::set_heap_capacity_at_last_gc(Universe::mem_capacity());
  Universe::set_heap_free_at_last_gc(Universe::mem_free());
  Universe::set_heap_used_at_last_gc(Universe::mem_used());

  GC_locker::unlock();  // allow gc after bootstrapping
}


void Universe::compute_base_vtable_size() {
  _base_vtable_size = ClassLoader::compute_Object_vtable();
}


void Universe::update_offset_tables() {
  _old_gen->update_offset_array();
  _perm_gen->update_offset_array();
}


#ifndef CORE
// Flushes compiled methods dependent on dependee.
void Universe::flush_dependents_on(instanceKlassHandle dependee) {  
  assert_lock(Compile_lock);  
  if (CodeCache::number_of_nmethods_with_dependencies() == 0) return;

  // We are holding the VM_lock at this time, so no changes to the CodeCache
  // is going to happen at this point. 
  
  // Mark all dependee and all its superclasses
  for (klassOop d = dependee(); d != NULL; d = instanceKlass::cast(d)->super()) {
    assert(!instanceKlass::cast(d)->is_marked_dependent(), "checking");
    instanceKlass::cast(d)->set_is_marked_dependent(true);
  }

  // Compute the dependent nmethods
  if (CodeCache::mark_for_deoptimization(dependee()) > 0) {
    // At least one nmethod has been marked for deoptimization 
    VM_Deoptimize op(dependee);  
    VMThread::execute(&op);    
  }

  // Unmark all dependee and all its superclasses
  for (klassOop e = dependee(); e != NULL; e = instanceKlass::cast(e)->super()) {
    instanceKlass::cast(e)->set_is_marked_dependent(false);
  }
}
#endif


oop* Universe::clear_allocate_local(KlassHandle klass, int size, int length, bool is_array, TRAPS) {
  assert(UseTLE, "should use UseTLE");
  oop* obj;

  oop* top = THREAD->tle().top();
  oop* end = THREAD->tle().end();
  
  assert(top <= end, "Incorrect top in clear_allocate_local");
  assert(size >= 0,  "Incorrect size in clear_allocate_local");

  // This condition was changed from (top + size <= end) because of unsigned arithmetic
  // wraparound (bug 4294774).
  if (end - top >= size) {
    // successful thread-local allocation
    if (!ZeroTLE) {                         // need to clear individual objects
      Memory::set_oops(top, size);
    }
    THREAD->tle().set_top(top + size);

    assert(THREAD->tle().invariants(), "TLE integrity violated");
    if( is_array ) { post_allocation_setup_array(klass, top, size, length); }
    else           { post_allocation_setup      (klass, top, size); }
    return top;
  }

  // A large object that does not fit in the TLE - allocated in the shared space
  if( size > (THREAD->tle().size() >> ThreadLocalEden::log2_fragmentation_ratio())) {
    if( is_array ) { obj = Universe::clear_allocate_array_shared(klass, size, length, CHECK_0); }
    else           { obj = Universe::clear_allocate_shared      (klass, size, CHECK_0); }
    assert(THREAD->tle().invariants(), "TLE integrity violated");
    return obj;
  }

  // This is a "small" object that does not fit in the TLE: create a new TLE
  // To minimize fragmentation, the last TLE may be smaller than the rest

  int aligned_header_size = align_object_size(typeArrayOopDesc::header_size(T_INT));
  size_t new_tle_size = THREAD->tle().compute_new_size(size + aligned_header_size);

  THREAD->tle().reset();

  bool found = false;
  
  // first try to get a tle from the maintained list of partially full ones
  // if this fails, cleate a new tle
  
  if(ParkTLE) {
    while(!found) {
      int tries = 0;
      TLEQueue::unpark(&THREAD->tle());   // try to steal some other tle from the parked queue
      if(THREAD->tle().top() != NULL) {
	if(THREAD->tle().end() - THREAD->tle().top() >= size) {
	  found = true;
	  obj = THREAD->tle().top();
	  if(!ZeroTLE) {
	    Memory::set_oops(obj, size);
	  }
	  THREAD->tle().set_top(THREAD->tle().top() + size);
          if( is_array ) { post_allocation_setup_array(klass, obj, size, length); }
          else           { post_allocation_setup      (klass, obj, size); }
	}
	else {
	  //  too little available space, throw it away (other policies possible)
	  THREAD->tle().reset();
	}
      }
      else {
	// the TLE queue is empty
	break;
      }
    }
  } 

  if(!found) {			// create a new tle
    if(ZeroTLE) {		// Allocate and clear the entire TLE
      if( is_array ) { obj = Universe::clear_allocate_array_shared(klass, new_tle_size, length, CHECK_0); }
      else           { obj = Universe::clear_allocate_shared      (klass, new_tle_size, CHECK_0); }
    }
    else {			// Allocate the entire TLE
      if( is_array ) { obj = Universe::allocate_array(klass, new_tle_size, length, CHECK_0); }
      else           { obj = Universe::allocate      (klass, new_tle_size, CHECK_0); }
      Memory::set_oops(obj, size); // But clear just the allocated object
      // Clearing wiped the header bits; reinstall them
      if( is_array ) { post_allocation_setup_array(klass, obj, size, length); }
      else           { post_allocation_setup      (klass, obj, size); }
    }
    
    // end is initialized in a way that allows some room for the filler array
    THREAD->tle().initialize(obj, obj + size, obj + new_tle_size - aligned_header_size, new_tle_size);
  }

  assert(THREAD->tle().invariants(), "TLE integrity violated");
  return obj;
}

// This is done at safepoint to present the GC with an illusion of contiguous Eden
void Universe::fill_all_tles() {
  assert(UseTLE, "should not reach here");
  if(ParkTLE) {
    TLEQueue::reset_at_safepoint();
  }

  for(JavaThread *thread = Threads::first(); thread; thread = thread->next()) {
     thread->tle().reset();
  }
}


bool Universe::is_non_oop(oop x) {
  // return true if the low bits are odd:
  if (((int)x&1) == 1)  return true;

  // This choice should be safe; hopefully we don't have to factor across CPUs.
  const jint high_bits_to_check = 8;

  // return true if the high bits match:
  return ((((jint)x^non_oop_bits) >> (BitsPerWord-high_bits_to_check)) == 0);
}


//---------------------------------------------------------------------------------------------
// Non-product code
#ifndef PRODUCT

void Universe::verify(bool allow_dirty, bool  silent) {
  ResourceMark rm;
  HandleMark hm;  // Handles created during verification can be zapped
  _verify_count++;

  if (!silent) tty->print("[Verifying ");
  if (!silent) tty->print("threads ");     
  Threads::verify();
  if (!silent) tty->print("permgen ");     
  _perm_gen->verify(allow_dirty);
  if (!silent) tty->print("oldgen ");      
  _old_gen->verify(allow_dirty);
  if (!silent) tty->print("ct ");          
  CarTable::verify();
  if (!silent) tty->print("newgen ");      
  _new_gen->verify(allow_dirty);
  if (!silent) tty->print("rset ");        
  RememberedSet::verify();
  if (!silent) tty->print("syms ");        
  SymbolTable::verify();
  if (!silent) tty->print("strs ");        
  StringTable::verify();
#ifndef CORE
  {
    MutexLocker mu(CodeCache_lock);
    if (!silent) tty->print("zone ");      
    CodeCache::verify();
  }
#endif
  if (!silent) tty->print("dict ");        
  SystemDictionary::verify();
  if (!silent) tty->print("hand ");        
  JNIHandles::verify();
  if (!silent) tty->print("C-heap ");      
  os::check_heap();
  if (!silent) tty->print_cr("]");
}


void Universe::print() {
  tty->print_cr("Heap");
  _new_gen->print();
  _old_gen->print();
  _perm_gen->print();
}


void Universe::print_heap_usage_header() {
  tty->print_cr("elapsed_time,mem_used,prev_mem_used,mem_capacity,newgen_capacity,type");
}


void Universe::print_heap_usage_stamp(size_t prev_mem_used, const char* type) {
  tty->print_cr("%.2lf,%u,%u,%u,%u,%s",
    os::elapsedTime(),
    mem_used() / K,
    prev_mem_used / K,
    mem_capacity() / K,
    new_gen()->capacity() / K,
    type);
}


bool Universe::no_gc_in_progress() {
  return !Scavenge::is_active() && !MarkSweep::is_active();
}


void Universe::update_max_heap_capatity() {
  _new_gen->update_max_capacity();
  _old_gen->update_max_capacity();
  _perm_gen->update_max_capacity();
}


void Universe::print_max_heap_capacity() {
  _new_gen->print_max_capacity();
  _old_gen->print_max_capacity();
  _perm_gen->print_max_capacity();
}


#endif // PRODUCT

// Oop verification (see MacroAssembler::verify_oop)

static jint _verify_oop_data[2]   = {0,-1};
static jint _verify_klass_data[2] = {0,-1};


static void calculate_verify_data(jint verify_data[2],
				  oop* low_boundary,
				  oop* high_boundary) {
  assert(low_boundary < high_boundary, "bad interval");

  // decide which low-order bits we require to be clear:
  jint alignSize = ALIGN_ALL_OBJECTS ? 2 * wordSize : wordSize;
  jint min_object_size = oopDesc::header_size();

  // make an inclusive limit:
  uintptr_t max = (uintptr_t)high_boundary - min_object_size*wordSize;
  uintptr_t min = (uintptr_t)low_boundary;
  assert(min < max, "bad interval");
  uintptr_t diff = max ^ min;

  // throw away enough low-order bits to make the diff vanish
  uintptr_t mask = (uintptr_t)(-1);
  while ((mask & diff) != 0)
    mask <<= 1;
  uintptr_t bits = (min & mask);
  assert(bits == (max & mask), "correct mask");
  // check an intermediate value between min and max, just to make sure:
  assert(bits == ((min + (max-min)/2) & mask), "correct mask");

  // require address alignment, too:
  mask |= (alignSize - 1);

  if (!(verify_data[0] == 0 && verify_data[1] == -1)) {
    assert(verify_data[0] == (jint)mask && verify_data[1] == (jint)bits, "mask stability");
  }
  verify_data[0] = (jint)mask;
  verify_data[1] = (jint)bits;
}


// Oop verification (see MacroAssembler::verify_oop)
#ifndef PRODUCT

jint Universe::verify_oop_mask() {
  calculate_verify_data(_verify_oop_data,
			_new_gen->low_boundary,
			_perm_gen->high_boundary);
  return _verify_oop_data[0];
}


jint Universe::verify_oop_bits() {
  verify_oop_mask();
  return _verify_oop_data[1];
}


jint Universe::verify_klass_mask() {
  // A klass can never live in the new space.  Since the new and old
  // spaces can change size, we must settle for bounds-checking against
  // the bottom of the world, plus the smallest possible new and old
  // space sizes that may arise during execution.
  int min_new_size = Universe::new_size();   // in bytes
  int min_old_size = Universe::old_size();   // in bytes
  calculate_verify_data(_verify_klass_data,
	  (oop*)((uintptr_t)_new_gen->low_boundary + min_new_size + min_old_size),
	  _perm_gen->high_boundary);
  return _verify_klass_data[0];
}


jint Universe::verify_klass_bits() {
  verify_klass_mask();
  return _verify_klass_data[1];
}


jint Universe::verify_mark_mask() {
  return markOopDesc::    lock_mask_in_place;
}


jint Universe::verify_mark_bits() {
  jint mask = verify_mark_mask();
  jint bits = (jint)markOopDesc::prototype();
  assert((bits & ~mask) == 0, "no stray header bits");
  return bits;
}
#endif // PRODUCT


void Universe::compute_verify_oop_data() {
  verify_oop_mask();
  verify_oop_bits();
  verify_mark_mask();
  verify_mark_bits();
  verify_klass_mask();
  verify_klass_bits();
}


#ifndef PRODUCT
oop Universe::slow_object_start(oop* p) {
  if (_new_gen->contains(p))  return _new_gen->slow_object_start(p);
  if (_old_gen->contains(p))  return _old_gen->slow_object_start(p);
  if (_perm_gen->contains(p)) return _perm_gen->slow_object_start(p);
  return NULL;
}
#endif


void Universe::jvmpi_object_alloc(oop obj, int bytesize) {
  jvmpi::post_object_alloc_event(obj, bytesize, addr_to_arena_id(obj), 0);
}


void Universe::jvmpi_object_move(oop from, oop to) {
  jvmpi::post_object_move_event(from, addr_to_arena_id(from), to, addr_to_arena_id(to));
}


// TODO: make this more efficient by dispatching to space
int Universe::addr_to_arena_id(void* addr) {
  if (new_gen()->eden()->contains(addr)) {
    return 1;
  }
  if (new_gen()->from()->contains(addr)) {
    return (new_gen()->from()->bottom() < new_gen()->to()->bottom()) ? 2 : 3;
  }
  if (new_gen()->to()->contains(addr)) {
    return (new_gen()->from()->bottom() < new_gen()->to()->bottom()) ? 3 : 2;
  }
  if (tenured_gen()->the_space()->contains(addr)) {
    return 4;
  }
  if (perm_gen()->the_space()->contains(addr)) {
    return 5;
  }
  return 0;
}


#ifdef ASSERT
// Release dummy object(s) at bottom of heap
bool Universe::release_fullgc_alot_dummy() {
  if (_fullgc_alot_dummy_array != NULL) {
    if (_fullgc_alot_dummy_next == _fullgc_alot_dummy_array->length()) {
      // No more dummies to release, release entire array instead
      _fullgc_alot_dummy_array = NULL;
      return false;
    }
    if (!UseTrainGC) {
      // Release dummy at bottom of old generation
      _fullgc_alot_dummy_array->obj_at_put(_fullgc_alot_dummy_next++, NULL);
    }
    // Release dummy at bottom of permanent generation
    _fullgc_alot_dummy_array->obj_at_put(_fullgc_alot_dummy_next++, NULL);
  }
  return true;
}


void Universe::check_for_valid_allocation_state(Thread* t) {
  assert(!t->has_pending_exception(), "Should not have pending excepting when calling allocation");
  if (StrictSafepointChecks) {
    assert(t->allow_allocation(), "Allocation done by thread for which allocation is blocked by No_Allocation_Verifier!");
    // Allocation of an oop can always invoke a safepoint, hence, the true argument
    t->check_for_valid_safepoint_state(true);
  }
}


#endif // ASSERT


class BCIHistogramClosure : public ObjectClosure {
 // an abstract class to iterate over all the entries
 public:
  virtual void do_entry(methodOop m, int bci, int count) = 0;
  
  void do_object(oop obj) {
    if ( obj->is_method() ) {
      methodOop m = (methodOop) obj;
      int* p = m->bci_histogram();
      int  n = m->code_size();
      for ( int i = 0;  i < n;  ++i )
        do_entry(m, i, p[i]);
    }
  }
};


class MaxBCIHistogramClosure : public BCIHistogramClosure {
 private:
  int r;  
 public:
  MaxBCIHistogramClosure() : BCIHistogramClosure() { r = 0; }
  void do_entry(methodOop, int, int count) { 
    r = max(r, count); 
  }
  int maximum() { return r; }
};


class ComputeBCIHistogramClosure : public BCIHistogramClosure {
 private:
  int* _histogram;  
 public:
  ComputeBCIHistogramClosure(int* h) : BCIHistogramClosure() { _histogram = h; }
  void do_entry(methodOop, int, int count) { ++_histogram[count]; }
  int* histogram() { return _histogram; }
};


#ifndef PRODUCT
void Universe::print_bci_histogram() {
  const char* file_name = "bci_hist";
  tty->print_cr("Printing histogram to %s:\n", file_name);
  FILE* f = fopen(file_name, "w");
  if (f == NULL) {
    tty->print_cr("Could not open %s", file_name);
    return;
  }
  MaxBCIHistogramClosure m;

  _new_gen->object_iterate(&m);
  _old_gen->object_iterate(&m);
  _perm_gen->object_iterate(&m);

  int* histo = (int*) os::malloc(sizeof(int) * m.maximum());
  if (histo == NULL) {
    tty->print_cr("Could not print bci histogram; unable to allocate count array of %d words", m.maximum());
    return;
  }
  ComputeBCIHistogramClosure c(histo);

  _new_gen->object_iterate(&c);
  _old_gen->object_iterate(&c);
  _perm_gen->object_iterate(&c);

  for (int i = 0;  i < m.maximum();  ++i)
    if (histo[i])
      fprintf(f, "%d %d\n", i, histo[i]);
  fclose(f);
}
#endif // PRODUCT

