/*
 * @(#)vmSymbols.cpp	1.13 99/06/22 16:41:07
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

# include "incls/_precompiled.incl"
# include "incls/_vmSymbols.cpp.incl"


symbolOop vmSymbols::_symbols[vmSymbols::vm_symbols_terminating_enum];


#define VM_SYMBOL_INITIALIZE(name, string) { \
  symbolOop sym = oopFactory::new_symbol(string, CHECK);  \
  _symbols[VM_SYMBOL_ENUM_NAME(name)] = sym; }


void vmSymbols::initialize(TRAPS) {
  VM_SYMBOLS_DO(VM_SYMBOL_INITIALIZE)
}


void vmSymbols::follow_roots() {
  for (int index = 0; index < vm_symbols_terminating_enum; index++) {
    MarkSweep::follow_root((oop*) &_symbols[index]);
  }
}


void vmSymbols::adjust_roots() {
  for (int index = 0; index < vm_symbols_terminating_enum; index++) {
    MarkSweep::adjust_root_pointer((oop*) &_symbols[index]);
  }
}


void vmSymbols::oops_do(void f(oop*)) {
  for (int index = 0; index < vm_symbols_terminating_enum; index++) {
    f((oop*) &_symbols[index]);
  }
}
