/*
 * @(#)compiledICHolderKlass.hpp	1.12 01/02/09 14:45:22
 *
 * Copyright 1993-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// a compiledICHolderKlass is the klass of a compiledICHolderOop

class compiledICHolderKlass : public Klass {
  friend class VMStructs;
 private:
  juint    _alloc_size;        // allocation profiling support
 public:
  // Testing
  bool oop_is_compiledICHolder() const { return true; }

  // Allocation
  DEFINE_ALLOCATE_PERMANENT(compiledICHolderKlass);
  compiledICHolderOop allocate(TRAPS);
  static klassOop create_klass(TRAPS);

  // Sizing
  int oop_size(oop obj) const;
  int klass_oop_size() const     { return object_size(); }

  // Casting from klassOop
  static compiledICHolderKlass* cast(klassOop k) {
    assert(k->klass_part()->oop_is_compiledICHolder(), "cast to compiledICHolderKlass");
    return (compiledICHolderKlass*) k->klass_part(); 
  }

  // Sizing
  static int header_size()       { return oopDesc::header_size() + sizeof(compiledICHolderKlass)/wordSize; }
  int object_size() const        { return align_object_size(header_size()); }

  // Garbage collection
  void oop_follow_contents(oop obj);
  int  oop_scavenge_contents(oop obj);
  int  oop_scavenge_contents(oop obj, oop* bottom, oop* top);
  int  oop_adjust_pointers(oop obj);
  bool oop_being_unloaded(oop obj);

  // Allocation profiling support
  juint alloc_size() const              { return _alloc_size; }
  void set_alloc_size(juint n)          { _alloc_size = n; }

  // Iterators
  void oop_oop_iterate(oop obj, OopClosure* blk);

#ifndef PRODUCT
 public:
  // Printing
  void oop_print_on      (oop obj, outputStream* st);
  void oop_print_value_on(oop obj, outputStream* st);
  const char* internal_name() const;

  // Verification
  void oop_verify_on(oop obj, outputStream* st);
#endif
};

