/*
 * @(#)objArrayKlassKlass.hpp	1.25 00/05/08 23:08:55
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// The objArrayKlassKlass is klass for all objArrayKlass'

class objArrayKlassKlass : public arrayKlassKlass {
 public:
  // Testing
  virtual bool oop_is_objArrayKlass() const { return true; }

  // Dispatched operation
  int oop_size(oop obj) const { return objArrayKlass::cast(klassOop(obj))->object_size(); }
  int klass_oop_size() const  { return object_size(); }

  // Allocation
  DEFINE_ALLOCATE_PERMANENT(objArrayKlassKlass);
  static klassOop create_klass(TRAPS);
  klassOop allocate_objArray_klass(int n, KlassHandle element_klass, TRAPS);
  klassOop allocate_system_objArray_klass(TRAPS); // Used for bootstrapping in Universe::genesis

  // Casting from klassOop
  static objArrayKlassKlass* cast(klassOop k) {
    assert(k->klass_part()->oop_is_klass(), "cast to objArrayKlassKlass");
    return (objArrayKlassKlass*) k->klass_part(); 
  }

  // Sizing
  static int header_size()  { return oopDesc::header_size() + sizeof(objArrayKlassKlass)/wordSize; }
  int object_size() const   { return align_object_size(header_size()); }

  // Garbage collection
  void oop_follow_contents(oop obj);
  int oop_adjust_pointers(oop obj);

  // Iterators
  void oop_oop_iterate(oop obj, OopClosure* blk);

 private:
  // helpers
  static klassOop allocate_objArray_klass_impl(objArrayKlassKlassHandle this_oop, int n, KlassHandle element_klass, TRAPS);

#ifndef PRODUCT
 public:
  // Printing 
  void oop_print_on(oop obj, outputStream* st);
  void oop_print_value_on(oop obj, outputStream* st);
  const char* internal_name() const;

  // Verification
  void oop_verify_on(oop obj, outputStream* st);
#endif
};

