/*
 * @(#)objArrayOop.hpp	1.18 99/06/22 16:41:42
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// An objArrayOop is an array containing oops.
// Evaluating "String arg[10]" will create an objArrayOop.

class objArrayOopDesc : public arrayOopDesc {
 friend class objArrayKlass;
 private:
  oop* base() const                     { return (oop*) arrayOopDesc::base(T_OBJECT); }
 public:
  // Accessing
  oop obj_at(int index) const           { return *obj_at_addr(index);           }
  void obj_at_put(int index, oop value) { oop_store(obj_at_addr(index), value); }

  // Sizing
  static int header_size()              { return arrayOopDesc::header_size(T_OBJECT); }
  static int object_size(int length)    { return align_object_size(header_size() + length); }  

  // Returns the address of the index'th element
  oop* obj_at_addr(int index) const {
    assert(is_within_bounds(index), "index out of bounds");
    return &base()[index];
  }
};
