/*
 * @(#)c2_globals.hpp	1.22 01/02/09 14:45:52
 *
 * Copyright 1993-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2
//
// Defines all globals flags used by the server compiler.
//

#define C2_FLAGS(develop, develop_pd, product, product_pd)                  \
  develop(int, CompileZapFirst, 0,                                          \
          "If +ZapDeadCompiledLocals, "                                     \
          "skip this many before compiling in zap calls")                   \
                                                                            \
  develop(int, CompileZapLast, -1,                                          \
          "If +ZapDeadCompiledLocals, "                                     \
          "compile this many after skipping (incl. skip count, -1 = all)")  \
                                                                            \
  develop(int, ZapDeadCompiledLocalsFirst, 0,                               \
          "If +ZapDeadCompiledLocals, "                                     \
	  "skip this many before really doing it")                          \
                                                                            \
  develop(int, ZapDeadCompiledLocalsLast, -1,                               \
          "If +ZapDeadCompiledLocals, "                                     \
          "do this many after skipping (incl. skip count, -1 = all)")       \
                                                                            \
  develop(int, OptoPrologueNops, 0,                                         \
          "Insert this many extra nop instructions "                        \
          "in the prologue of every nmethod")                               \
                                                                            \
  develop_pd(int, InteriorEntryAlignment,                                   \
          "Code alignment for interior entry points "                       \
          "in generated code (in bytes)")                                   \
                                                                            \
  develop_pd(int, OptoLoopAlignment,                                        \
          "Align inner loops to zero relative to this modulus")             \
                                                                            \
  develop(int, IndexSetWatch, 0,                                            \
          "Trace all operations on this IndexSet (-1 means all, 0 none)")   \
                                                                            \
  develop(int, OptoNodeListSize, 4,                                         \
          "Starting allocation size of Node_List data structures")          \
                                                                            \
  develop(int, OptoBlockListSize, 8,                                        \
          "Starting allocation size of Block_List data structures")         \
                                                                            \
  develop(int, OptoPeepholeAt, -1,                                          \
          "Apply peephole optimizations to this peephole rule")             \
                                                                            \
  develop(bool, PrintOpto, false,                                           \
          "Print compiler2 attempts")                                       \
                                                                            \
  develop(bool, PrintOptoInlining, false,                                   \
          "Print compiler2 inlining decisions")                             \
                                                                            \
  develop(bool, VerifyOpto, false,                                          \
          "Apply more time consuming verification during compilation")      \
                                                                            \
  develop(bool, VerifyOptoOopOffsets, false,                                \
          "Check types of base addresses in field references")              \
                                                                            \
  develop(bool, IdealizedNumerics, false,                                   \
          "Check performance difference allowing FP "                       \
          "associativity and commutativity...")                             \
                                                                            \
  develop(bool, OptoBreakpoint, false,                                      \
          "insert breakpoint at method entry")                              \
                                                                            \
  develop(bool, OptoBreakpointOSR, false,                                   \
          "insert breakpoint at osr method entry")                          \
                                                                            \
  develop(bool, OptoBreakpointC2I, false,                                   \
          "insert breakpoint at C2IAdaptor entry")                          \
                                                                            \
  develop(bool, OptoBreakpointI2C, false,                                   \
          "insert breakpoint at I2CAdaptor entry")                          \
                                                                            \
  develop(bool, OptoBreakpointC2N, false,                                   \
          "insert breakpoint at native stub entry")                         \
                                                                            \
  develop(bool, OptoBreakpointC2R, false,                                   \
          "insert breakpoint at runtime stub entry")                        \
                                                                            \
  develop(bool, OptoNoExecute, false,                                       \
          "Attempt to parse and compile but do not execute generated code") \
                                                                            \
  develop(bool, PrintOptoBailouts, false,                                   \
          "Print compiler2 attempts that bailout to interpreter")           \
                                                                            \
  develop(bool, PrintOptoStatistics, false,                                 \
          "Print New compiler statistics")                                  \
                                                                            \
  develop(bool, PrintOptoAssembly, false,                                   \
          "Print New compiler assembly output")                             \
                                                                            \
  develop(bool, RoseOptoFixes, true,                                        \
          "Turn off John's OPTO changes, "                                  \
          "if they seem to have broken something.")                         \
                                                                            \
  develop(bool, OptoCompileNatives, true,                                   \
          "Allow compilation of natives")                                   \
                                                                            \
  develop(bool, OptoP6Instructions, true,                                   \
          "Allow matching to P6 instructions")                              \
                                                                            \
  develop(bool, OptoRuntimeCalleeSavedFloats, false,                        \
          "Runtime saves/restores callee-saved floats or doubles")          \
                                                                            \
  develop_pd(bool, OptoPeephole,                                            \
          "Apply peephole optimizations after register allocation")         \
                                                                            \
  develop(bool, PrintFrameConverterAssembly, false,                         \
          "Print New compiler assembly output for frame converters")        \
                                                                            \
  develop(bool, PrintOptoParseInfo, false,                                  \
          "Print New compiler parse info per method")                       \
                                                                            \
  develop(bool, PrintOptoPeephole, false,                                   \
          "Print New compiler peephole replacements")                       \
                                                                            \
  develop(bool, TraceOptoParse, false,                                      \
          "Trace bytecode parse and control-flow merge")                    \
                                                                            \
  develop(bool, OptoNoGC, false,                                            \
          "Skip GC for new compiler")                                       \
                                                                            \
  product_pd(int,  LoopUnrollLimit, 					    \
          "Unroll loop bodies with node count less than this")              \
                                                                            \
  develop(bool, OptoCoalesce, true,                                         \
          "Use Conservative Copy Coalescing in the Register Allocator")     \
                                                                            \
  develop(bool, OptoReorgOffsets, false,                                    \
          "Reorganize offsets to lower register pressure")                  \
                                                                            \
  develop_pd(int, RegisterCostAreaRatio,                                    \
          "Spill selection in reg allocator: scale area by (X/64K) before " \
          "adding cost")                                                    \
                                                                            \
  develop(bool, SplitLRGsAroundLoops, true,                                 \
	  "Split spanning live ranges around loops with spills")            \
                                                                            \
  develop_pd(bool, UseCISCSpill,                                            \
          "Use ADLC supplied cisc instructions during allocation")          \
                                                                            \
  develop_pd(int, FLOATPRESSURE,                                            \
          "Number of float LRG's that constitute high register pressure")   \
                                                                            \
  develop_pd(int, INTPRESSURE,                                              \
          "Number of integer LRG's that constitute high register pressure") \
                                                                            \
  develop(bool, TraceOptoPipelining, false,                                 \
          "Trace pipelining information")                                   \
                                                                            \
  develop(bool, TraceOptoOutput, false,                                     \
          "Trace pipelining information")                                   \
                                                                            \
  product_pd(bool, OptoScheduling,                                          \
          "Instruction Scheduling after register allocation")               \
                                                                            \
  product_pd(bool, OptoBundling,                                            \
          "Generate nops to fill i-cache lines")                            \
                                                                            \
  product_pd(int, ConditionalMoveLimit,                                     \
          "Limit of ops to make speculative when using CMOVE")              \
                                                                            \
  product(bool, BranchOnRegister, false,                                    \
          "Use Sparc V9 branch-on-register opcodes")                        \
                                                                            \
  develop(bool, SparcV9RegsHiBitsZero, true,                                \
          "Assume Sparc V9 I&L registers on V8+ systems are zero-extended") \
                                                                            \
  product(int,  AllocatePrefetchStyle, 0,                                   \
          "0=no prefetch, 1=dead load, 2=prefetch instruction")             \
                                                                            \
  product(int,  AllocatePrefetchDistance, 0,                                \
          "Distance to prefetch ahead of allocation pointer")               \
                                                                            \

C2_FLAGS(DECLARE_DEVELOPER_FLAG, DECLARE_PD_DEVELOPER_FLAG, DECLARE_PRODUCT_FLAG, DECLARE_PD_PRODUCT_FLAG)
