/*
 * @(#)c2compiler.cpp	1.7 01/02/09 14:45:53
 *
 * Copyright 1991-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

#include "incls/_precompiled.incl"
#include "incls/_c2compiler.cpp.incl"


void C2Compiler::initialize() {
  mark_initialized();
}

void C2Compiler::compile_method(ciEnv* env,
				ciScope* scope,
				ciMethod* target,
				int entry_bci,
                                bool reuse_env) {
  if (target->flags().is_native()) {
    Compile C(env, target);
  } else {
    bool subsume_loads = true;
    bool retry;
    do {
      // Attempt to compile while subsuming loads into machine instructions.
      Compile C(env, scope, target, entry_bci, subsume_loads, reuse_env);

      // Check result and retry if appropriate.
      switch (C.result()) {
      case Compile::Comp_subsumed_load_conflict:
	// Retry, without subsuming loads.
	assert(subsume_loads, "unexpected recompilation");
	retry = true;
	subsume_loads = false;
	break;
      default:
	retry = false;
	break;
      }
    } while (retry);
  }
}

void C2Compiler::compile_adapter(ciEnv* env,
				 ciMethod* callee,
				 int/*AdapterType*/ type,
                                 bool reuse_env) {
  Compile C(env, callee, type, reuse_env);
}

void C2Compiler::print_timers() {
  // do nothing
}
