/*
 * @(#)c2compiler.hpp	1.4 00/03/21 16:17:31
 *
 * Copyright 1991-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

class C2Compiler : public AbstractCompiler {
public:
  // Name
  const char *name() { return "opto"; }

  // Customization
  bool needs_preloaded_classes() { return false; }
  bool needs_inlining_scope   () { return true; }
  bool needs_adapters         () { return true; }
  bool needs_stubs            () { return true; }
  
  void initialize();

  // Compilation entry point for methods
  void compile_method(ciEnv* env,
		      ciScope* scope,
		      ciMethod* target,
		      int entry_bci,
                      bool reuse_env); 
  
  // Compilation entry point for adapters
  void compile_adapter(ciEnv* env,
		       ciMethod* callee,
		       int/*AdapterType*/ type,
                       bool reuse_env);

  // Print compilation timers and statistics
  void print_timers();
};







