/*
 * @(#)opcodes.hpp	1.21 01/02/09 14:46:46
 *
 * Copyright 1997-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// Build a big enum of class names to give them dense integer indices
#define macro(x) Op_##x,
enum Opcodes {
  Op_Node = 0,
  macro(Set)			// Instruction selection match rule
  macro(RegI)			// Machine integer register
  macro(RegP)			// Machine pointer register
  macro(RegF)			// Machine float   register
  macro(RegD)			// Machine double  register
  macro(RegL)			// Machine long    register
  macro(RegFlags)		// Machine flags   register
  _last_machine_leaf,		// Split between regular opcodes and machine
#include "classes.hpp"
  _last_opcode
};
#undef macro

// Table of names, indexed by Opcode
extern const char *NodeClassNames[];
