/*
 * @(#)privilegedStack.hpp	1.14 99/06/22 16:43:15
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

class PrivilegedElement VALUE_OBJ_CLASS_SPEC {
 private:  
  klassOop  _klass;                // klass for method 
  oop       _privileged_context;   // context for operation  
  jint*     _frame_id;             // location on stack
  PrivilegedElement* _next;        // Link to next one on stack
 public:
  void initialize(vframeStream* vf, oop context, PrivilegedElement* next, TRAPS);  
  void oops_do(void f(oop*));    
  jint* frame_id() const           { return _frame_id; }
  oop  privileged_context() const  { return _privileged_context; }  
  oop  class_loader() const        { return instanceKlass::cast(_klass)->class_loader(); }
  oop  protection_domain() const   { return instanceKlass::cast(_klass)->protection_domain(); }
  PrivilegedElement *next() const  { return _next; }

  // debugging (used for find)
  void print_on(outputStream* st) const   PRODUCT_RETURN;
  bool contains(address addr)             PRODUCT_RETURN0;
};

