// @(#)rawMonitor.hpp	1.3 01/02/09 14:47:28
// 
// Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road,
// Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
// 
// This software is the confidential and proprietary information of Sun
// Microsystems, Inc. ("Confidential Information").  You shall not
// disclose such Confidential Information and shall use it only in
// accordance with the terms of the license agreement you entered into
// with Sun.
// 
// CopyrightVersion 1.2
//
//
// class RawMonitor
// Used by all JVMPI RawMonitor methods: 
//   (CreateRawMonitor, EnterRawMonitor, etc.)
//
// Wrapper for ObjectMonitor class that saves the Monitor's name
// and links thread's owned raw monitors

class RawMonitor: public ObjectMonitor {
private:
  int           _magic;
  char *        _name;
  // maintaining list of locked raw monitors
  RawMonitor* _rmnext;    
  RawMonitor* _rmprev;

public:
  RawMonitor(const char *name, const int magic);
  ~RawMonitor();                             
  int       magic()                         { return _magic;  }
  void      print(outputStream& out)        { out.print(_name); }
  RawMonitor* next_raw() const              { return _rmnext; }
  const char *name() const                  { return _name; }
  void add_to_locked_list();
  void remove_from_locked_list();
  int       raw_destroy();
};


static int PROF_RM_MAGIC = (int)(('P' << 24) | ('I' << 16) | ('R' << 8) | 'M');
#define PROF_RM_CHECK(m)                                 \
    ((m) != NULL && (m)->magic() == PROF_RM_MAGIC) 
