/*
 * @(#)extendedPC.hpp	1.4 99/07/09 15:26:15
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// An ExtendedPC contains complete flow-of-control information for
// an architecture at any point of program execution.  For instance, on
// SPARC, this includes the PC as well as the nPC.  For IA, this is just
// Eip -- Thread::get_top_frame returns an ExtendedPC

class ExtendedPC VALUE_OBJ_CLASS_SPEC {
 private:
  address _pc;

 public:
  address pc() const { return _pc; }

  ExtendedPC adjust(address begin, address end, address new_begin);
  address contained_pc();
  bool is_contained_in(address begin, address end);

  // Machine dependent stuff
  #include "incls/_extendedPC_pd.hpp.incl"
};
