/*
 * @(#)icache.hpp	1.7 99/06/22 16:43:40
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// Interface for updating the instruction cache.  Whenever the VM modifies
// code, part of the processor instruction cache potentially has to be flushed.

// On the x86, this is a no-op -- the I-cache is guaranteed to be consistent
// after the next jump, and the VM never modifies instructions directly ahead
// of the instruction fetch path.

// Nevertheless, use this interface from all code that is not x86-specific.


// default implementations
class AbstractICache : AllStatic {
 public:
  static void invalidate_word (u_char* addr);    // for writes up to 4 bytes
  static void invalidate_range(u_char* start, int nBytes);

  static void initialize() {}
};

// overriden per platform, e.g.,
//
// 
//class ICache : public AbstractICache {
// public:
//  static void invalidate_word (u_char* addr);    // for writes up to 4 bytes
//  static void invalidate_range(u_char* start, int nBytes);
//
//  static void initialize();
//};
//
//
// The code must be in machine-specific file, i.e., icache_<arch>.hpp/.cpp

#include "incls/_icache_pd.hpp.incl"
