/*
 * @(#)methodTracer.hpp	1.7 00/03/21 16:17:57
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2


// Debugging Class for tracing method entry and exit.
//
// TODO: 
//   a. make it work with MT execution  
//   b. add hooks to x86 specific code


#ifndef PRODUCT
class MethodTracer : public CHeapObj {
 private:
  static bool                 _bUsage;
         bool                 _bDisplay;
         int                  _indent;
  const  int                  _MAX_INDENT;
  GrowableArray< methodOop >* _methodStack;

  void pushMethod(methodOop m);
  methodOop popMethod(methodOop m);

  void breakForMethod(const char *sEntry, char *sClass, char *sMethod);

  void doIndent(outputStream *out, bool addToIndent, int dindent);
  void describe(outputStream *out, int dindent, address pc, methodOop method);
  void write(
    outputStream *out, address pc, CodeBlob *cb,
    methodOop method, methodOop poppedMethod, 
	  char entry, int dindent
  );
  static MethodTracer *attachThread(JavaThread *thread);

 public:
  MethodTracer();
  static void entry(JavaThread *thread, methodOop method, address pc);
  static void exit (JavaThread *thread, methodOop method, address pc);
};
#endif
