/*
 * @(#)stackValue.hpp	1.21 99/06/22 16:44:12
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

class StackValue : public ResourceObj {
 private:
  BasicType _type;
  jint      _i;  
  Handle    _o;
 public:

  StackValue(jint value) {
    _type  = T_INT;
    _i     = value;
  }

  StackValue(Handle value) {
    _type    = T_OBJECT;
    _o       = value;
  }

  StackValue() {
    _type   = T_CONFLICT;
    _i      = 0;
  }

  Handle get_obj() const {
    assert(type() == T_OBJECT, "type check");
    return _o;
  }

  jint get_int() const {
    assert(type() == T_INT, "type check");
    return _i;
  }

  BasicType type() const { return  _type; }

  bool equal(StackValue *value) {
    if (_type != value->_type) return false;
    if (_type == T_OBJECT) 
      return (_o == value->_o);
    else {
      assert(_type == T_INT, "sanity check");
      return (_i == value->_i);    
    }
  }

#ifndef PRODUCT
 public:
  // Printing
  void print_on(outputStream* st) const;
#endif
};

