/*
 * @(#)stubRoutines.cpp	1.77 01/02/09 14:47:54
 *
 * Copyright 1993-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

#include "incls/_precompiled.incl"
#include "incls/_stubRoutines.cpp.incl"

// Implementation of StubRoutines - for a description
// of how to extend it, see the header file.


// Class Variables

bool    StubRoutines::_is_initialized_1 = false;
bool    StubRoutines::_is_initialized_2 = false;
u_char  StubRoutines::_code1[StubRoutines::code_size1];
u_char  StubRoutines::_code2[StubRoutines::code_size2];

address StubRoutines::_call_stub_return_address           = NULL;
address StubRoutines::_call_stub_entry                    = NULL;

address StubRoutines::_catch_exception_entry                    = NULL;
address StubRoutines::_forward_exception_entry                  = NULL;
address StubRoutines::_throw_null_exception_entry               = NULL;
#ifndef CORE
address StubRoutines::_lazy_i2c_adapter_entry                   = NULL;
#endif
address StubRoutines::_verify_oop_entry                         = NULL;
jint    StubRoutines::_verify_oop_count                         = 0;
address StubRoutines::_atomic_exchange_entry                    = NULL;
address StubRoutines::_atomic_store_entry                       = NULL;
address StubRoutines::_atomic_compare_and_exchange_entry        = NULL;
address StubRoutines::_atomic_increment_entry                   = NULL;

address StubRoutines::_d2i_wrapper                              = NULL;
address StubRoutines::_d2l_wrapper                              = NULL;
jint    StubRoutines::_fpu_cntrl_wrd_std                        = NULL;
jint    StubRoutines::_fpu_cntrl_wrd_24                         = NULL;
jint    StubRoutines::_fpu_cntrl_wrd_trunc                      = NULL;


// Initialization
//
// Note: to break cycle with universe initialization, stubs are generated in two phases.
// The first one generates stubs needed during universe init (e.g., _handle_must_compile_first_entry).
// The second phase includes all other stubs (which may depend on universe being initialized.)

extern void StubGenerator_generate(CodeBuffer* code, bool all); // only interface to generators


void StubRoutines::initialize1() {
  if (_is_initialized_1) return;
  { ResourceMark rm;
    TraceTime timer("StubRoutines generation 1", TraceStartupTime);
    CodeBuffer* code = new CodeBuffer(_code1, code_size1);
    StubGenerator_generate(code, false);
  }
  _is_initialized_1 = true;
}


void StubRoutines::initialize2() {
  if (_is_initialized_2) return;
  { ResourceMark rm;
    TraceTime timer("StubRoutines generation 2", TraceStartupTime);
    CodeBuffer* code = new CodeBuffer(_code2, code_size2);
    StubGenerator_generate(code, true);
  }
  _is_initialized_2 = true;
}


void stubRoutines_init1() { StubRoutines::initialize1(); }
void stubRoutines_init2() { StubRoutines::initialize2(); }
