/*
 * @(#)sweeper.hpp	1.12 99/06/22 16:44:15
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// An NmethodSweeper is an incremental cleaner for:
//    - cleanup inline caches
//    - reclamation of unreferences zombie nmethods
//

class NMethodSweeper : public AllStatic {  
  static CodeBlob* _current;      // Current nmethod
  static int       _seen;         // Nof. nmethod we have currently processed in current pass of CodeCache
  static int       _invocations;  // No. of invocations left until we are completed with this pass

  static long      _nof_zombies;       // No. of zombie methods in the CodeCache
  static long      _nof_not_entrants;  // No. of not_entrant methods in the CodeCache
  static long      _nof_unloaded;      // No. of not_entrant methods in the CodeCache

  static void process_nmethod(nmethod *nm);    
 public:      
  static void sweep();  // Invoked at the end of each safepoint

  static void notify(nmethod *nm); // Called by nmethod   
};
