/*
 * @(#)threadLocalStorage.hpp	1.29 99/06/29 18:31:37
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// Interface for thread local storage

// Fast variant of ThreadLocalStorage::get_thread_slow
extern "C" Thread* get_thread();

class ThreadLocalStorage : AllStatic {
 public:
  static void    set_thread(Thread* thread);
  static Thread* get_thread_slow();

  // Machine dependent stuff
  #include "incls/_threadLS_pd.hpp.incl"

  // Accessor
  static inline int  thread_index() { return _thread_index; }
  static inline void set_thread_index(int index) { _thread_index = index; }

  // Initialization
  // Called explicitly from VMThread::activate_system instead of init_globals.
  static void init();

 private:
  static void generate_code_for_get_thread();
  static int _thread_index;

  static Thread* _get_thread_cache[]; // index by [pd_sp_hash % _pd_cache_size]
  static Thread* get_thread_via_cache();
};

