/*
 * @(#)verifier.hpp	1.8 99/06/22 16:44:26
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// Interface to the external verifier

class Verifier : AllStatic {
 private:
  static bool should_verify_for(oop class_loader);

 public:
  // relax certain verifier checks to enable some broken 1.1 apps to run on 1.2.
  static bool relax_verify_for(oop class_loader);

  // Verifies the class file format
  static void verify_class_format(symbolHandle class_name, Handle class_loader, ClassFileStream* st, TRAPS);

  // Verifies the byte codes of the class
  static void verify_byte_codes(instanceKlassHandle klass, TRAPS);
};
