/*
 * @(#)vm_version_abs.cpp	1.23 01/02/09 14:48:08
 *
 * Copyright 1993-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

# include "incls/_precompiled.incl"
# include "incls/_vm_version_abs.cpp.incl"


const char* Abstract_VM_Version::vm_name() {
  CORE_ONLY(     return "Java HotSpot(TM) Core VM"  ;)
  COMPILER1_ONLY(return "Java HotSpot(TM) Client VM";)
  COMPILER2_ONLY(return "Java HotSpot(TM) Server VM";)
}


const char* Abstract_VM_Version::vm_vendor() {
#ifdef VENDOR
  return XSTR(VENDOR);
#else
  return "Sun Microsystems Inc.";
#endif
}


const char* Abstract_VM_Version::vm_info_string() {
  switch (Arguments::mode()) {
    case Arguments::_int:    return "interpreted mode";
    case Arguments::_mixed:  return "mixed mode";
    case Arguments::_comp:   return "compiled mode";
  };
  ShouldNotReachHere();
  return "";
}


const char* Abstract_VM_Version::vm_release() {
  stringStream st;
  #ifdef HOTSPOT_BUILD_VERSION
    st.print(HOTSPOT_BUILD_VERSION);
  #else
    st.print("1.3.1-internal");
  #endif
  #ifndef PRODUCT
    #ifdef ASSERT
      st.print("%s", "-debug");
    #else
      st.print("%s", "-release");
    #endif
  #endif
  return st.as_string();
}


const char* Abstract_VM_Version::internal_vm_info_string() {
  #ifndef HOTSPOT_BUILD_USER
    #define HOTSPOT_BUILD_USER unknown
  #endif

  #ifndef HOTSPOT_BUILD_COMPILER
    #ifdef _MSC_VER
      #if   _MSC_VER == 1100
        #define HOTSPOT_BUILD_COMPILER "MS VC++ 5.0"
      #elif _MSC_VER == 1200
        #define HOTSPOT_BUILD_COMPILER "MS VC++ 6.0"
      #else
        #define HOTSPOT_BUILD_COMPILER "unknown MS VC++:" XSTR(_MSC_VER)
      #endif
    #elif defined(__SUNPRO_CC)
      #if   __SUNPRO_CC == 0x500
        #define HOTSPOT_BUILD_COMPILER "Workshop 5.0 compat=" \
          XSTR(__SUNPRO_CC_COMPAT)
      #elif __SUNPRO_CC == 0x420
        #define HOTSPOT_BUILD_COMPILER "Workshop 4.2"
      #else
        #define HOTSPOT_BUILD_COMPILER "unknown Workshop:" XSTR(__SUNPRO_CC)
      #endif
    #else
      #define HOTSPOT_BUILD_COMPILER "unknown compiler"
    #endif
  #endif
  return "Built on " __DATE__ " " __TIME__ " by " XSTR(HOTSPOT_BUILD_USER)
    " with " HOTSPOT_BUILD_COMPILER;
}
