/*
 * @(#)macros.hpp	1.22 00/03/20 13:11:27
 *
 * Copyright 1993-1999 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

// CopyrightVersion 1.2

// Use this to mark code that needs to be cleaned up (for development only)
#define NEEDS_CLEANUP

// Makes a string of the argument (which is not macro-expanded)
#define STR(a)  #a

// Makes a string of the macro expansion of a
#define XSTR(a) STR(a)

// CORE variant
#ifdef CORE
  Error: CORE should not be defined explicitly
#endif

#if !defined(COMPILER1) && !defined(COMPILER2)
#define CORE
#define CORE_ONLY(code) code
#define NOT_CORE(code)
#define CORE_RETURN  {}
#define CORE_RETURN0 { return 0; }
#else // CORE
#define CORE_ONLY(code)
#define NOT_CORE(code) code
#define CORE_RETURN  /*next token must be ;*/
#define CORE_RETURN0 /*next token must be ;*/
#endif // CORE

// COMPILER1 variant
#ifdef COMPILER1
#ifdef COMPILER2
  Error: COMPILER1 and COMPILER2 should not be defined simultaneously
#endif
#define COMPILER1_ONLY(code) code
#define NOT_COMPILER1(code)
#else // COMPILER1
#define COMPILER1_ONLY(code)
#define NOT_COMPILER1(code) code
#endif // COMPILER1

// COMPILER2 variant
#ifdef COMPILER2
#ifdef COMPILER1
  Error: COMPILER1 and COMPILER2 should not be defined simultaneously
#endif
#define COMPILER2_ONLY(code) code
#define NOT_COMPILER2(code)
#else // COMPILER2
#define COMPILER2_ONLY(code)
#define NOT_COMPILER2(code) code
#endif // COMPILER2

// PRODUCT variant
#ifdef PRODUCT
#define PRODUCT_ONLY(code) code
#define NOT_PRODUCT(code)
#define PRODUCT_RETURN  {}
#define PRODUCT_RETURN0 { return 0; }
#define PRODUCT_RETURN_(code) { code }
#else // PRODUCT
#define PRODUCT_ONLY(code)
#define NOT_PRODUCT(code) code
#define PRODUCT_RETURN  /*next token must be ;*/
#define PRODUCT_RETURN0 /*next token must be ;*/
#define PRODUCT_RETURN_(code)  /*next token must be ;*/
#endif // PRODUCT

#define FIX_THIS(code) report_assertion_failure("FIX_THIS",__FILE__, __LINE__, "")

#define define_pd_global(type, name, value) const type pd_##name = value;

