/*
 * @(#)ByteToCharHKSCS.java	1.3 01/04/21
 *
 * Copyright (c) 2001 Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


package sun.io;

/**
 * Tables and data to convert HKSCS to Unicode
 *
 * @author  ConverterGenerator tool
 * @version >= JDK1.1.6
 */

class ByteToCharHKSCS extends ByteToCharDoubleByte {

    public String getCharacterEncoding() {
        return "HKSCS";
    }

    public ByteToCharHKSCS() {
        super.index1 = index1;
        super.index2 = index2;
        start = 0x40;
        end = 0xFE;
    }

    private final static String innerIndex0= 
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uF303"+
	"\uF304\uF305\uF306\uF307\uF308\uF309\uF30A\uF30B"+
	"\uF30C\uF30D\uF30E\uF30F\uF310\uF311\uF312\uF313"+
	"\uF314\uF315\uF316\uF317\uF318\u0100\u00C1\u01CD"+
	"\u00C0\u0112\u00C9\u011A\u00C8\u014C\u00D3\u01D1"+
	"\u00D2\uF325\u1EBE\uF327\u1EC0\u00CA\u0101\u00E1"+
	"\u01CE\u00E0\u0251\u0113\u00E9\u011B\u00E8\u012B"+
	"\u00ED\u01D0\u00EC\u014D\u00F3\u01D2\u00F2\u016B"+
	"\u00FA\u01D4\u00F9\u01D6\u01D8\u01DA\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\u01DC\u00FC\uF344\u1EBF\uF346\u1EC1\u00EA\u0261"+
	"\uF34A\uF34B\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uF3A0\uF3A1"+
	"\uFFFD\u650A\uFFFD\uFFFD\u4E3D\u6EDD\u9D4E\u91DF"+
	"\uFFFD\uFFFD\uF3AC\u6491\u4F1A\u4F28\u4FA8\u5156"+
	"\u5174\u519C\u51E4\u52A1\u52A8\u533B\u534E\u53D1"+
	"\u53D8\u56E2\u58F0\u5904\u5907\u5932\u5934\u5B66"+
	"\u5B9E\u5B9F\u5C9A\u5E86\u603B\u6589\u67FE\u6804"+
	"\u6865\u6D4E\u70BC\u7535\u7EA4\u7EAC\u7EBA\u7EC7"+
	"\u7ECF\u7EDF\u7F06\u7F37\u827A\u82CF\u836F\u89C6"+
	"\u8BBE\u8BE2\u8F66\u8F67\u8F6E\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u7411"+
	"\u7CFC\u7DCD\u6946\u7AC9\u5227\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\u918C\u78B8\u915E\u80BC\uFFFD\u8D0B\u80F6"+
	"\uF3F0\uFFFD\uFFFD\u809F\u9EC7\uF3F5\u9DC9\u9E0C"+
	"\uF3F8\uF3F9\uF3FA\u9E0A\uF3FC\uF3FD\uFFFD\u6E9A"+
	"\u823E\u7519\uFFFD\uF403\u9A6C\u9A8F\u9F99\u7987"+
	"\uF408\uF409\uF40A\uF40B\u4E24\u4E81\u4E80\u4E87"+
	"\u4EBF\u4EEB\u4F37\uF413\u4FBD\uF415\u5003\u5088"+
	"\uF418\uF419\uF41A\u5186\u5905\u51DB\u51FC\u5205"+
	"\u4E89\u5279\u5290\u5327\uF424\u53A9\uF426\u53B0"+
	"\uF428\u53C2\u5423\uF42B\uF42C\uF42D\u5493\u54A3"+
	"\u54B4\u54B9\u54D0\u54EF\u5518\u5523\u5528\uF437"+
	"\u553F\uF439\uF43A\u55D7\uF43C\uF43D\u5525\uFFFD"+
	"\uF440\uF441\uF442\u5590\uF444\uF445\uF446\u8E46"+
	"\uF448\uF449\uF44A\uF44B\u777A\uF44D\uF44E\uF44F"+
	"\uF450\uF451\uF452\u64DD\uF454\uF455\uF456\uF457"+
	"\u648D\u8E7E\uF45A\uF45B\uF45C\uF45D\uF45E\uF45F"+
	"\uFFFD\uF461\uF462\uF463\uF464\uF465\uF466\u9AB2"+
	"\uF468\uF469\uF46A\uF46B\uF46C\uF46D\uF46E\uF46F"+
	"\u9D6E\u9815\uFFFD\uF473\uF474\u64B4\u54E3\uF477"+
	"\uF478\uF479\uF47A\uF47B\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uF47C\uF47D"+
	"\uF47E\u64EA\uF480\uF481\u8E68\uF483\uF484\uF485"+
	"\uFFFD\uF487\uF488\uF489\u5873\uF48B\uFFFD\uF48D"+
	"\uF48E\uF48F\uF490\uF491\u5579\uF493\uF494\uFFFD"+
	"\uF496\uF497\uF498\u81AA\u98F5\uF49B\u6379\uF49D"+
	"\uF49E\u8DC0\u56A1\u647C\uF4A2\uFFFD\uF4A4\uF4A5"+
	"\uF4A6\uF4A7\uFFFD\uF4A9\uF4AA\uF4AB\uF4AC\uF4AD"+
	"\uF4AE\uF4AF\uF4B0\u5652\uF4B2\uF4B3\uF4B4\uF4B5"+
	"\u6C3D\uF4B7\uFFFD\uFFFD\uF4BA\uF4BB\uF4BC\uF4BD"+
	"\uF4BE\uF4BF\uF4C0\uF4C1\u7F93\uF4C3\uF4C4\uF4C5"+
	"\uF4C6\uF4C7\uF4C8\uF4C9\uF4CA\uF4CB\uF4CC\uF4CD"+
	"\uF4CE\uF4CF\uFFFD\uF4D1\uF4D2\uF4D3\uF4D4\uF4D5"+
	"\uF4D6\uF4D7\u6432\uF4D9\uF4DA\uF4DB\uF4DC\uF4DD"+
	"\uF4DE\uF4DF\uF4E0\uF4E1\uF4E2\uF4E3\uF4E4\uF4E5"+
	"\uF4E6\uF4E7\uF4E8\uF4E9\u95AA\u54CC\u82C4\u55B9"+
	"\uFFFD\uF4EF\u9C26\u9AB6\uF4F2\uF4F3\u7140\u816D"+
	"\u80EC\u5C1C\uF4F8\u8134\uF4FA\u535F\uF4FC\u91B6"+
	"\uF4FE\uF4FF\uF500\uF501\uF502\uF503\uF504\uF505"+
	"\u56AF\uF507\uF508\uF509\uF50A\uF50B\uF50C\uF50D"+
	"\uF50E\uF50F\uF510\uF511\u5A54\uF513\uF514\uF515"+
	"\uF516\u579C\uF518\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uF519\uF51A\uF51B"+
	"\uF51C\uF51D\uF51E\uF51F\uF520\uF521\uF522\uF523"+
	"\uF524\uF525\uF526\u5899\u5268\uF529\uF52A\u7BB2"+
	"\u5B68\uF52D\uF52E\u9F27\uF530\u9C1F\u9B8D\uF533"+
	"\uF534\u55FB\uF536\u5689\u4E28\u5902\uF53A\uF53B"+
	"\u9751\uF53D\u4E5B\u4EBB\uF540\u5C23\u5F51\u5FC4"+
	"\uF544\u624C\u6535\u6B7A\u6C35\u6C3A\u706C\u722B"+
	"\u4E2C\u72AD\uF54E\u7F52\u793B\u7CF9\u7F53\uF553"+
	"\uF554\uFFFD\uF556\u8002\u8080\uF559\uF55A\u535D"+
	"\u8864\u89C1\uF55E\u8BA0\u8D1D\u9485\u9578\u957F"+
	"\u95E8\uF565\u97E6\u9875\u98CE\u98DE\u9963\uF56B"+
	"\u9C7C\u9E1F\u9EC4\u6B6F\u9F9C\u4E37\uF572\u961D"+
	"\u6237\u94A2\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\u5D3E\u5D48\u5D56\uF637\uF638"+
	"\u5DA4\u5DB9\uF63B\uF63C\u5E42\u5EBD\u5F25\u5F83"+
	"\uF641\uF642\uF643\uF644\u60D7\u613D\u5CE5\uF648"+
	"\u61B7\u61B9\u61CF\uF64C\u622C\u6290\u62E5\u6318"+
	"\uF651\u56B1\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uF653\u63E2\u63FB\u6407"+
	"\u645A\uF658\u64C0\u5D15\u5621\u9F9F\uF65D\u6586"+
	"\uF65F\u65FF\u6653\uF662\u6692\uF664\u6716\uF666"+
	"\u67A4\u6800\uF669\u684A\u6884\uF66C\uF66D\uF66E"+
	"\u6909\u6943\u725C\u6964\u699F\u6985\uF675\u69D6"+
	"\uF677\u6A65\u6A74\u6A71\u6A82\uF67C\u6A99\uF67E"+
	"\u6AAB\u6AB5\u6AD4\u6AF6\u6B81\u6BC1\u6BEA\u6C75"+
	"\u6CAA\uF688\u6D02\u6D06\u6D26\u6D81\uF68D\u6DA4"+
	"\u6DB1\u6E15\u6E18\u6E29\u6E86\uF694\u6EBB\u6EE2"+
	"\u6EDA\u9F7F\u6EE8\u6EE9\u6F24\u6F34\uF69D\uF69E"+
	"\u6F81\u6FBE\uF6A1\uF6A2\u71B7\u5C99\uF6A5\u702C"+
	"\uF6A7\u7050\u7054\u706F\u707F\u7089\uF6AD\uF6AE"+
	"\uF6AF\uF6B0\uE311\u57BE\uE313\u713E\uE315\uE316"+
	"\u69A2\uE318\u5B74\u7A49\uE31B\uE31C\u7A65\u7A7D"+
	"\uE31F\u7ABB\u7AB0\u7AC2\u7AC3\u71D1\uE325\uE326"+
	"\u7ADA\u7ADD\u7AEA\uE32A\u54B2\uE32C\u7B0B\u7B55"+
	"\u7B29\uE330\uE331\u7BA2\u7B6F\u839C\uE335\uE336"+
	"\u7BD0\u8421\u7B92\uFFFD\uE33B\uE33C\uE33D\u8492"+
	"\u7BFA\uFFFD\u7C35\uE342\u7C44\u7C83\uE345\u7CA6"+
	"\u667D\uE348\u7CC9\u7CC7\u7CE6\u7C74\u7CF3\u7CF5"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\u7E67\uE351\uE352\u7D5D\uE354"+
	"\u748D\u7D89\u7DAB\u7135\u7DB3\uFFFD\uE35B\uE35C"+
	"\u7DE4\uE35E\u7DF5\uE360\u7DE5\uE362\uFFFD\uE364"+
	"\uE365\u7E6E\u7E92\uE368\u946C\u7E27\u7F40\u7F41"+
	"\u7F47\u7936\uE36F\u99E1\u7F97\uE372\u7FA3\uE374"+
	"\uE375\uE376\uE377\uE378\uE379\u7FFA\uE37B\uFFFD"+
	"\u8008\u801D\uFFFD\u802F\uE381\uE382\u803B\u803C"+
	"\u8061\uE386\uE387\uE388\uE389\uE38A\u6725\u80A7"+
	"\uE38D\u8107\u811A\u58B0\uE391\u6C7F\uE393\uE394"+
	"\u64E7\uE396\u8218\uE398\u6A53\uE39A\uE39B\uE39C"+
	"\u8229\uE39E\uE39F\uE3A0\u4FF9\uE3A2\u84E2\u8362"+
	"\uE3A5\uE3A6\uE3A7\uE3A8\uE3A9\u82AA\u691B\uE3AC"+
	"\uE3AD\u854B\u82D0\u831A\uE3B1\uE3B2\uE3B3\uE3B4"+
	"\uE3B5\u827B\u82E2\u8318\uE3B9\uE3BA\uE3BB\uE3BC"+
	"\uE3BD\uE3BE\u831D\u55EC\u8385\uE3C2\uE3C3\u83AC"+
	"\uFFFD\u83D3\uE3C7\uE3C8\u6A57\u855A\uE3CB\uE3CC"+
	"\uE3CD\u8458\uE3CF\u8471\uE3D1\uE3D2\u6AA7\u844A"+
	"\uE3D5\u7958\uFFFD\uE3D8\uE3D9\uE3DA\u84DE\uFFFD"+
	"\u8391\uE3DE\u8493\u84E4\uE3E1\uE3E2\uE3E3\uE3E4"+
	"\u8534\u5AF2\uE3E7\uE3E8\u8573\uE3EA\u67BF\u8616"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uE3ED\uE3EE\u85C1\uE3F0\u8602\uE3F2"+
	"\uE3F3\uE3F4\uE3F5\u8628\uE3F7\uE3F8\u53F7\uE3FA"+
	"\u867E\u8771\uE3FD\u87EE\uE3FF\u87B1\u87DA\u880F"+
	"\u5661\u866C\u6856\uE406\u8845\u8846\uE409\uE40A"+
	"\uE40B\u885E\u889C\uE40E\u88B4\u88B5\u63C1\u88C5"+
	"\u7777\uE414\u8987\u898A\uFFFD\uFFFD\u89A7\u89BC"+
	"\uE41B\u89E7\uE41D\uE41E\u8A9C\u7793\u91FE\u8A90"+
	"\uE423\u7AE9\uE425\uE426\uE427\uE428\u717C\u8B0C"+
	"\u8B1F\uE42C\uE42D\u8B3F\u8B4C\u8B4D\u8AA9\uE432"+
	"\u8B90\u8B9B\u8AAF\uE436\uE437\u884F\u8C9B\uE43A"+
	"\uE43B\uE43C\uE43D\uE43E\u8CD6\uE440\uE441\u8D12"+
	"\u8D03\uE444\u8CDB\u705C\u8D11\uE448\uE449\uFFFD"+
	"\u8DA9\uE44C\uE44D\uE44E\uE44F\uE450\uE451\u7AE7"+
	"\u8EAD\u8EB6\u8EC3\u92D4\u8F19\u8F2D\uE459\uE45A"+
	"\u8FA5\u9303\uE45D\uE45E\u8FB3\uE460\uE461\uE462"+
	"\uE463\u5EF8\uE465\u8FF9\uE467\uE468\uE469\uE46A"+
	"\uE46B\uE46C\u9037\uE46E\uE46F\u9061\uE471\uE472"+
	"\u90A8\uE474\u90C4\uE476\u90AE\uFFFD\u9167\uE47A"+
	"\u91A9\u91C4\u7CAC\uE47E\uE47F\u920E\u6C9F\u9241"+
	"\u9262\uE484\uFFFD\uE486\uE487\uE488\uE489\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uE48A\u932C\u936B\uE48D\uE48E\u708F\u5AC3"+
	"\uE491\uE492\uE493\u9244\uE495\uE496\uE497\u9373"+
	"\u945B\u8EBC\u9585\u95A6\u9426\u95A0\u6FF6\uE4A0"+
	"\uE4A1\uE4A2\uE4A3\uE4A4\uE4A5\u6C1C\u967B\u9696"+
	"\uE4A9\u96A3\uE4AB\u61DA\u96B6\u78F5\uE4AF\u96BD"+
	"\u53CC\uE4B2\uE4B3\uE4B4\uE4B5\uE4B6\uE4B7\uE4B8"+
	"\uE4B9\uE4BA\u9731\u8642\u9736\uE4BE\uE4BF\uE4C0"+
	"\uE4C1\u7075\u5B41\u971B\uFFFD\uE4C6\u9757\u5B4A"+
	"\uE4C9\u975F\u9425\u50D0\uE4CD\uE4CE\u9789\u979F"+
	"\u97B1\u97BE\u97C0\u97D2\u97E0\uE4D6\u97EE\u741C"+
	"\uE4D9\uFFFD\u97F5\uE4DC\uE4DD\uE4DE\u9834\u9833"+
	"\u984B\u9866\uE4E3\uE4E4\uE4E5\uE4E6\uE4E7\uE4E8"+
	"\u98CA\u98B7\u98C8\u98C7\uE4ED\uE4EE\uE4EF\u55B0"+
	"\u98E1\u98E6\u98EC\u9378\u9939\uE4F6\uE4F7\uE4F8"+
	"\uE4F9\u99F5\u9A0C\u9A3B\u9A10\u9A58\uE4FF\uE500"+
	"\uE501\uE502\u9AE0\u9AE2\uE505\u9AF4\uE507\u9B14"+
	"\u9B2D\uE50A\u5034\u9B34\uE50D\uE50E\uE50F\u9B50"+
	"\u9B40\uE512\u5A45\uE514\u9B8E\uE516\u9C02\u9BFF"+
	"\u9C0C\uE51A\u9DD4\uE51C\uE51D\uE51E\uE51F\uE520"+
	"\uE521\u9D7E\u9D83\uE524\u9E0E\u6888\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\u9DC4\uE528\uE529\uE52A\uE52B\uE52C\u9D39\uE52E"+
	"\uE52F\u9E90\u9E95\u9E9E\u9EA2\uE534\u9EAA\u9EAF"+
	"\uE537\u9EC1\uE539\uE53A\uE53B\u4F32\uE53D\uE53E"+
	"\u9F02\u9F08\uE541\u9424\uE543\u9F17\uFFFD\u9F39"+
	"\u569F\u568A\u9F45\u99B8\uE54B\u97F2\u847F\u9F62"+
	"\u9F69\u7ADC\u9F8E\u7216\uE553\uE554\uE555\u7177"+
	"\uE557\uE558\uE559\u739E\uE55B\uE55C\u799F\uE55E"+
	"\uE55F\u9369\u93F3\uE562\u92EC\u9381\u93CB\uE566"+
	"\uE567\u7217\uE569\u7772\u7A43\u70D0\uE56D\uE56E"+
	"\u717E\uE570\u70A3\uE572\uE573\uE574\uE575\uE576"+
	"\uE577\uE578\uE579\uE57A\uE57B\uE57C\uE57D\uE57E"+
	"\uE57F\uE580\u575B\uE582\uE583\uE584\uE585\uE586"+
	"\u8503\uE588\uFFFD\u8455\uE58B\uE58C\uE58D\uE58E"+
	"\uE58F\uE590\uE591\uE592\uE593\uE594\u67F9\uE596"+
	"\uE597\uE598\u586C\uE59A\u6810\uE59C\uE59D\uE59E"+
	"\uE59F\uE5A0\uE5A1\u54CB\u569E\uE5A4\u5692\uE5A6"+
	"\uE5A7\uE5A8\u93C6\uE5AA\u939C\u4EF8\u512B\uE5AE"+
	"\uE5AF\u4EBC\uE5B1\uE5B2\u4F4B\u4F8A\uE5B5\u5A68"+
	"\uE5B7\uE5B8\uE5B9\uE5BA\uE5BB\uE5BC\u4F29\uE5BE"+
	"\uE5BF\uE5C0\u8ADA\uE5C2\u4E98\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u50CD"+
	"\u510D\u4FA2\u4F03\uE5C8\uE5C9\u4F42\u502E\u506C"+
	"\u5081\u4FCC\u4FE5\u5058\u50FC\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\u6E76\uE5D7\uE5D8\uE5D9\u6D72\uE5DB\uE5DC"+
	"\u51A8\u51C3\uE5DF\uE5E0\uE5E1\uE5E2\uE5E3\u8D7A"+
	"\uE5E5\uE5E6\u5259\u52A4\uE5E9\u52E1\uFFFD\uE5EC"+
	"\u718C\uE5EE\uE5EF\uE5F0\uE5F1\u69D1\uE5F3\uFFFD"+
	"\uE5F5\u7499\u7414\u7456\u7398\uE5FA\uE5FB\uE5FC"+
	"\u53D0\uE5FE\u720F\uE600\u55B4\uE602\u54CD\uE604"+
	"\u571D\u925D\u96F4\u9366\u57DD\u578D\u577F\uE60C"+
	"\u58CB\u5A99\uE60F\uE610\uE611\uE612\u5A2C\u59B8"+
	"\u928F\u5A7E\u5ACF\u5A12\uE619\uE61A\uE61B\uE61C"+
	"\uE61D\u6D05\u7443\u5A21\uE621\u5A81\uE623\uE624"+
	"\u93E0\u748C\uE627\u7105\uE629\u9408\uE62B\u93BD"+
	"\uE62D\u5C1E\u5C9E\u5E5E\u5E48\uE632\uE633\uE634"+
	"\u5ECD\u5B4F\uE637\uE638\uE639\uE63A\uE63B\uE63C"+
	"\uE63D\u812A\uE63F\uE640\uE641\uE642\u5F0C\u5F0E"+
	"\uE645\uE646\u5A6B\uE648\u5B44\u8614\uE64B\u8860"+
	"\u607E\uE64E\uE64F\u5FDB\uE651\uE652\uE653\uE654"+
	"\uE655\u61C0\uE657\uE658\uE659\u6199\u6198\u6075"+
	"\uE65D\uE65E\uE65F\uE660\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u6471\uE662"+
	"\uE663\uE664\uE665\uE666\uE667\uE668\u6337\uE66A"+
	"\u64B6\u6331\u63D1\uE66E\uE66F\u62A4\uE671\u643B"+
	"\u656B\u6972\uE675\uE676\uE677\uE678\uE679\u550D"+
	"\uE67B\uE67C\uE67D\u66CE\uE67F\uE680\uE681\uE682"+
	"\uE683\uE684\uE685\uE686\uE687\uE688\u78EE\uE68A"+
	"\uE68B\uE68C\uE68D\uE68E\uE68F\uE690\u668E\uE692"+
	"\u666B\uE694\u6630\uE696\uE697\u6663\uE699\uE69A"+
	"\u661E\uE69C\uE69D\uE69E\uE69F\uE6A0\uE6A1\uE6A2"+
	"\u74D0\uE6A4\u678F\uE6A6\u68B6\u681E\uE6A9\u6ABE"+
	"\uE6AB\uE6AC\uE6AD\u6A33\u6A52\u6AC9\u6B05\uE6B2"+
	"\u6511\u6898\u6A4C\uE6B6\u6A7A\u6B57\uE6B9\uE6BA"+
	"\u93A0\u92F2\uE6BD\uE6BE\u9289\uE6C0\uE6C1\u9467"+
	"\u6DA5\u6F0B\uE6C5\uFFFD\uE6C7\uE6C8\u6E04\uE6CA"+
	"\u5A3D\u6E0A\u5847\u6D24\u7842\u713B\uE6D1\uE6D2"+
	"\u70F1\u7250\u7287\u7294\uE6D7\uE6D8\u5179\uE6DA"+
	"\uE6DB\u747A\uE6DD\uE6DE\uE6DF\uE6E0\uE6E1\uE6E2"+
	"\uE6E3\uE6E4\uE6E5\uE6E6\u60A7\uE6E8\u74CC\u743C"+
	"\u9387\u7437\uE6ED\uE6EE\uE6EF\u7583\uE6F1\uE6F2"+
	"\uE6F3\uE6F4\u7555\u7673\uE6F7\uE6F8\u7468\uE6FA"+
	"\uE6FB\uE6FC\uE6FD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uE6FE\uE6FF\uE700"+
	"\uE701\uE702\u91FA\u5732\u9342\uE706\uE707\u50DF"+
	"\uE709\uE70A\u7778\uE70C\u770E\u770F\u777B\uE710"+
	"\uE711\uE712\uE713\u7438\u749B\uE716\uE717\uE718"+
	"\uE719\uE71A\uE71B\u9307\uE71D\u781E\u788D\u7888"+
	"\u78D2\u73D0\u7959\uE724\uE725\uE726\uFFFD\u8496"+
	"\u79A5\u6A2D\uE72B\u7A3A\u79F4\uE72E\uE72F\uE730"+
	"\u9235\u79F1\uE733\uE734\uE735\uE736\uE737\uE738"+
	"\u556B\uE73A\uE73B\uE73C\uE73D\u7AE2\u5A59\uE740"+
	"\uE741\uE742\u5A0D\uE744\u78F0\u5A2A\uE747\u7AFE"+
	"\uE749\u7C5D\u7C6D\uE74C\uE74D\uE74E\uE74F\u7CCD"+
	"\uE751\uE752\u7C8E\u7C7C\u7CAE\u6AB2\u7DDC\u7E07"+
	"\u7DD3\u7F4E\uE75B\uE75C\uE75D\u7D97\uE75F\uE760"+
	"\uE761\uE762\u67D6\uE764\uE765\u57C4\uE767\uE768"+
	"\uE769\u7FDD\u7B27\uE76C\uE76D\uE76E\u7B0C\uE770"+
	"\u99E6\u8645\u9A63\u6A1C\uE775\uE776\uE777\uE778"+
	"\u9A1F\uE77A\u8480\uE77C\uE77D\uE77E\u8137\uE780"+
	"\u80C6\u8109\u8142\uE784\u98C3\uE786\u8262\u8265"+
	"\uE789\u8453\uE78B\u8610\uE78D\u5A86\uE78F\uE790"+
	"\u5B2B\uE792\u5AE4\uE794\u86A0\uE796\uE797\u882D"+
	"\uE799\u5A02\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\u886E\u4F45\u8887\u88BF"+
	"\u88E6\u8965\u894D\uE7A2\u8954\uE7A4\uE7A5\uE7A6"+
	"\uE7A7\uE7A8\uE7A9\uE7AA\u84A3\uE7AC\uE7AD\uE7AE"+
	"\u8A3D\u8A1C\uE7B1\u5F4D\u922B\uE7B4\u65D4\u7129"+
	"\u70C4\uE7B8\u9D6D\u8C9F\u8CE9\uE7BC\u599A\u77C3"+
	"\u59F0\uE7C0\uE7C1\u8E2A\u8EA7\uE7C4\u8F30\u8F4A"+
	"\uE7C7\u6C58\u6FBB\uE7CA\uE7CB\u6F79\u6E8B\uE7CE"+
	"\u9BE9\uE7D0\uE7D1\u90BB\uFFFD\u5571\uE7D5\u91BB"+
	"\u9404\uE7D8\uE7D9\uE7DA\u9427\uE7DC\uE7DD\u84E5"+
	"\u8A2B\u9599\u95A7\u9597\u9596\uE7E4\u7445\uE7E6"+
	"\uE7E7\uE7E8\uE7E9\uE7EA\uE7EB\u968F\uE7ED\uE7EE"+
	"\uE7EF\uE7F0\uE7F1\uE7F2\uE7F3\u7412\u746B\uE7F6"+
	"\u9741\uE7F8\u6847\uE7FA\uE7FB\uE7FC\uFFFD\u9368"+
	"\uE7FF\uE800\uE801\uE802\u92BA\u5B11\u8B69\uE806"+
	"\u73F9\uE808\u979B\u9771\u9938\uE80C\u5DC1\uE80E"+
	"\uE80F\u981F\uE811\u92F6\uE813\u91E5\uE815\uE816"+
	"\uE817\uE818\u98DC\uE81A\uE81B\u922A\uE81D\u8414"+
	"\u993B\u994D\uE821\uE822\u999B\uE824\u99AA\u9A5C"+
	"\uE827\uE828\u6A8F\u9A21\u5AFE\u9A2F\uE82D\uE82E"+
	"\uE82F\u99BC\uE831\uE832\u937D\u5872\uE835\u5822"+
	"\uE837\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uE838\u7844\uE83A\uE83B\u68C5"+
	"\uE83D\u9458\uE83F\u6150\uE841\uE842\u6107\u9C4F"+
	"\u9C53\u9C7B\u9C35\u9C10\u9B7F\u9BCF\uE84B\u9B9F"+
	"\uE84D\uE84E\u9D21\uE850\uE851\u9E18\uE853\u9D0C"+
	"\uE855\uE856\uE857\uE858\u9DA5\u84BD\uE85B\uE85C"+
	"\uE85D\u85FC\uE85F\uE860\uE861\uE862\u8420\u85EE"+
	"\uE865\uE866\uE867\u79E2\uE869\uE86A\uE86B\uE86C"+
	"\uE86D\u93DB\u92BE\u9348\uE871\u78B9\u9277\u944D"+
	"\u4FE4\uE876\u9064\uE878\u783D\u7854\u78B6\u784B"+
	"\uE87D\uE87E\uE87F\uE880\u4F72\u6FDA\u6FD9\uFFFD"+
	"\u701E\u5414\uE887\u57BB\u58F3\u578A\u9D16\u57D7"+
	"\u7134\uE88E\uE88F\u71EB\uE891\uE892\uFFFD\uE894"+
	"\uE895\u610C\u5ACE\u5A0B\uE899\uE89A\uE89B\uE89C"+
	"\uE89D\u93BB\u93B8\uE8A0\uE8A1\u8472\uE8A3\uE8A4"+
	"\uE8A5\uE8A6\uE8A7\u5994\uE8A9\uE8AA\u7DA8\uE8AC"+
	"\uE8AD\uE8AE\uE8AF\uE8B0\u92E5\u73E2\uE8B3\u74B4"+
	"\uE8B5\uE8B6\uE8B7\uE8B8\u6AD8\u73F3\u73FB\uE8BC"+
	"\uE8BD\uE8BE\uE8BF\uE8C0\uE8C1\uE8C2\uE8C3\u7448"+
	"\uE8C5\u70A5\uE8C7\u9284\u73E6\u935F\uE8CB\u9331"+
	"\uE8CD\uE8CE\u9386\uE8D0\uE8D1\uE8D2\uE8D3\u716B"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uE8D5\uE8D6\u56A4\uE8D8\uE8D9\uE8DA"+
	"\u5502\u79C4\uE8DD\u7DFE\uE8DF\uE8E0\uE8E1\uE8E2"+
	"\u9401\uE8E4\uE8E5\uE8E6\u59B0\uE8E8\uE8E9\uE8EA"+
	"\u5AA1\uE8EC\uE8ED\uE8EE\u925F\u5A79\uE8F1\uE8F2"+
	"\u9374\uE8F4\uE8F5\uE8F6\uE8F7\u50F4\uE8F9\uE8FA"+
	"\uE8FB\u7175\uE8FD\uE8FE\u6E0F\uE900\uE901\u6D57"+
	"\uE903\u7067\u6CAF\uE906\uE907\uE908\u6E02\u6F0C"+
	"\uE90B\uE90C\u7551\uE90E\uE90F\uE910\uE911\uE912"+
	"\u59C4\u926E\uE915\u8F41\uE917\uE918\u5812\u57C8"+
	"\uE91B\uE91C\u70FE\uE91E\uE91F\uE920\uE921\uE922"+
	"\u68B9\u6967\uE925\uE926\uE927\uE928\uE929\uE92A"+
	"\uE92B\uE92C\u6A1A\uE92E\uE92F\u843E\uE931\uE932";

    private final static String innerIndex1= 
	"\uE933\uE934\uE935\uE936\u6F17\uE938\u833D\uE93A"+
	"\u83ED\uE93C\uE93D\uE93E\u5989\u5A82\uE941\u5A61"+
	"\u5A71\uE944\uE945\uE946\u59EF\uE948\uE949\u718E"+
	"\u9390\u669A\uE94D\u5A6E\u5A2B\uE950\u6A2B\uE952"+
	"\uE953\uE954\uE955\u711D\uE957\uE958\u4FB0\uE95A"+
	"\u5CC2\uE95C\uE95D\uE95E\u6A0C\uE960\uE961\u70A6"+
	"\u7133\uE964\uE965\u6CDF\uE967\uE968\u7E65\u59EB"+
	"\u5D2F\uE96C\u5F5C\uE96E\uE96F\u7DA4\u8426\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\u5485\uE973\uE974\uE975\u577E\uE977\uE978"+
	"\uE979\uE97A\uE97B\u7003\uE97D\u5D70\u738F\u7CD3"+
	"\uE981\uE982\u4FC8\u7FE7\u72CD\u7310\uE987\u7338"+
	"\u7339\uE98A\u7341\u7348\uE98D\uE98E\u906C\u71F5"+
	"\uE991\u73E1\u81F6\uE994\u770C\uE996\u6CA2\u56FD"+
	"\u7419\u741E\u741F\uE99C\uE99D\uE99E\uE99F\u74D3"+
	"\uE9A1\uE9A2\u7542\u756D\u7572\u758D\uE9A7\u75C8"+
	"\u75DC\uE9AA\u764D\uE9AC\u7674\uE9AE\u767A\uE9B0"+
	"\u7188\u5623\u8980\u5869\uE9B5\u7743\uE9B7\u6761"+
	"\uE9B9\uE9BA\u7798\uE9BC\uE9BD\u5C5E\u77BE\u77CB"+
	"\u58F2\u7818\u70B9\u781C\uE9C5\u7839\u7847\u7851"+
	"\u7866\u8448\uE9CB\u7933\u6803\u7932\uE9CF\uE9D0"+
	"\u7991\u7999\u8FBB\u7A06\u8FBC\uE9D6\u7A91\uE9D8"+
	"\u7ABC\u8279\uE9DB\u7ACF\u7ADB\uE9DE\u4E21\u7B62"+
	"\u7B6C\u7B7B\u7C12\u7C1B\uE9E5\uE9E6\u7C7B\u7C9C"+
	"\uE9E9\u7CB8\uE9EB\u7CED\u8F93\u70C0\uE9EF\u7DCF"+
	"\u7DD4\u7DD0\u7DFD\u7FAE\u7FB4\u729F\uE9F7\u8020"+
	"\u8025\u7B39\u802E\u8031\u8054\uE9FE\u57B4\u70A0"+
	"\u80B7\u80E9\uEA03\u810C\u732A\u810E\u8112\u7560"+
	"\u8114\uEA0A\uEA0B\u8156\u8159\u815A\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uEA0F\u583A\u817C\u8184\uEA13\u8193\uEA15\u81A5"+
	"\u57EF\u81C1\u81E4\u8254\uEA1B\u82A6\u8276\u82CA"+
	"\u82D8\u82FF\uEA21\u8357\u9669\u698A\u8405\u70F5"+
	"\u8464\u60E3\u8488\uEA2A\u84BE\u84E1\u84F8\u8510"+
	"\u8538\u8552\uEA31\u856F\u8570\u85E0\uEA35\u8672"+
	"\u8692\u86B2\u86EF\u9645\u878B\uEA3C\uEA3D\u88AE"+
	"\u88FF\u8924\u8947\u8991\uEA43\u8A29\u8A38\u8A94"+
	"\u8AB4\u8C51\u8CD4\u8CF2\u8D1C\uEA4C\u585F\u8DC3"+
	"\uEA4F\u4EEE\u8E3A\u55D8\u5754\u8E71\u55F5\u8EB0"+
	"\uEA57\u8ECE\u8EE2\u8EE4\u8EED\u8EF2\u8FB7\u8FC1"+
	"\u8FCA\u8FCC\u9033\u99C4\uEA63\u98E0\u9213\uEA66"+
	"\u9228\u9258\u926B\u92B1\u92AE\u92BF\u92E3\u92EB"+
	"\u92F3\u92F4\u92FD\u9343\u9384\u93AD\uEA75\uEA76"+
	"\u9EBF\u9417\u5301\u941D\u942D\u943E\uEA7D\u9454"+
	"\u9479\u952D\u95A2\uEA82\u95F4\u9633\uEA85\u67A0"+
	"\uEA87\u9740\uEA89\u97B2\u97C2\u5654\uEA8D\u60E8"+
	"\u98B9\uEA90\u98F1\u5844\u990E\u9919\u51B4\u991C"+
	"\u9937\u9942\u995D\u9962\uEA9B\u99C5\uEA9D\u9A3C"+
	"\u9B0F\u7A83\u9B69\u9B81\u9BDD\u9BF1\u9BF4\uEAA6"+
	"\u9C20\uEAA8\uEAA9\u9D49\u9C3A\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u9EFE"+
	"\u5650\u9D93\u9DBD\u9DC0\u9DFC\u94F6\u8FB6\u9E7B"+
	"\u9EAC\u9EB1\u9EBD\u9EC6\u94DC\u9EE2\u9EF1\u9EF8"+
	"\u7AC8\u9F44\uEABF\uEAC0\uEAC1\u691A\u94C3\u59AC"+
	"\uEAC5\u5840\u94C1\uEAC8\uEAC9\uEACA\uEACB\uEACC"+
	"\u5757\u7173\uEACF\uEAD0\uEAD1\u546A\uEAD3\uEAD4"+
	"\u549E\uEAD6\uEAD7\uEAD8\uEAD9\uEADA\u60E7\uEADC"+
	"\u567A\uEADE\uEADF\uEAE0\uEAE1\uEAE2\uEAE3\u6955"+
	"\u9C2F\u87A5\uEAE7\uEAE8\uEAE9\uEAEA\uEAEB\uEAEC"+
	"\u5C20\uEAEE\u5E0B\uEAF0\uEAF1\uEAF2\u671E\uEAF4"+
	"\uEAF5\uEAF6\uEAF7\uEAF8\uEAF9\uEAFA\uEAFB\u5364"+
	"\u84AD\uEAFE\uEAFF\uEB00\u8B81\uEB02\uEB03\uEB04"+
	"\uEB05\u4E78\u70BB\uEB08\uEB09\uEB0A\uEB0B\uEB0C"+
	"\uEB0D\uEB0E\uEB0F\u62C3\uEB11\uEB12\u7198\u6855"+
	"\uEB15\u69E9\uEB17\uEB18\uEB19\uEB1A\uEB1B\uEB1C"+
	"\uEB1D\u82FD\uEB1F\uEB20\uEB21\u89A5\uEB23\u8FA0"+
	"\uEB25\u97B8\uEB27\u9847\u9ABD\uEB2A\uFFFD\uEB2C"+
	"\uEB2D\uEB2E\uEB2F\uEB30\uEB31\uEB32\uEB33\uEB34"+
	"\uEB35\uEB36\uEB37\uEB38\uEB39\u5FB1\u6648\u66BF"+
	"\uEB3D\uEB3E\uEB3F\uFFFD\uEB41\uFFFD\uEB43\uEB44"+
	"\uFFFD\uEB46\u58B5\u670E\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u6918\uEB4A"+
	"\uEB4B\uEB4C\uEB4D\uEB4E\uEB4F\uEB50\uEB51\uEB52"+
	"\uEB53\uEB54\uEB55\uEB56\uEB57\uEB58\uEB59\uEB5A"+
	"\uEB5B\u51D2\uEB5D\u599F\uEB5F\uEB60\uEB61\uEB62"+
	"\uEB63\u5788\uEB65\uEB66\uEB67\uEB68\uEB69\uEB6A"+
	"\uEB6B\u8B5E\uEB6D\uFFFD\uEB6F\uEB70\uEB71\u7209"+
	"\uEB73\uEB74\u5965\uEB76\uEB77\uEB78\u8EDA\uEB7A"+
	"\u528F\u573F\u7171\uEB7E\uEB7F\uEB80\uEB81\u55BC"+
	"\uEB83\uEB84\uEB85\uFFFD\uEB87\uEB88\uEB89\uEB8A"+
	"\uEB8B\uEB8C\uEB8D\uEB8E\uEB8F\uEB90\u5066\uEB92"+
	"\uEB93\uFFFD\uEB95\uEB96\uEB97\uEB98\uEB99\uEB9A"+
	"\uEB9B\u57A1\u7151\uFFFD\uEB9F\uEBA0\u9056\uEBA2"+
	"\uEBA3\u8B62\uEBA5\uEBA6\u5D5B\uEBA8\uFFFD\uEBAA"+
	"\uEBAB\u8AEA\uEBAD\uEBAE\uEBAF\uEBB0\uEBB1\uEBB2"+
	"\uEBB3\uEBB4\u9465\uEBB6\u6195\u5A27\uEBB9\uFFFD"+
	"\u56B9\uEBBC\uEBBD\u4E6A\uEBBF\u9656\u6D8F\uEBC2"+
	"\uEBC3\u8977\uEBC5\uEBC6\uEBC7\uEBC8\uFFFD\uEBCA"+
	"\u7B42\uEBCC\uEBCD\uEBCE\uFFFD\uEBD0\u7A45\uFFFD"+
	"\uEBD3\u9A26\uEBD5\uEBD6\uEBD7\uEBD8\u7983\uEBDA"+
	"\uEBDB\u5D2C\uEBDD\uFFFD\uEBDF\uEBE0\uEBE1\u753B"+
	"\u8865\uEBE4\u58B6\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uEBE6\uEBE7\uEBE8"+
	"\uEBE9\uEBEA\uEBEB\uEBEC\u9281\uEBEE\uEBEF\u9330"+
	"\uEBF1\uEBF2\u6C39\u949F\uEBF5\uEBF6\u8827\u88F5"+
	"\uEBF9\uEBFA\uEBFB\u6EB8\uEBFD\uEBFE\uEBFF\uEC00"+
	"\uFFFD\uFFFD\uEC03\u66B6\uEC05\uEC06\u8943\uEC08"+
	"\uEC09\u56D6\uEC0B\uEC0C\uEC0D\uEC0E\uEC0F\uEC10"+
	"\u71AD\u8366\uEC13\uEC14\uFFFD\uEC16\uEC17\uEC18"+
	"\uEC19\uEC1A\uEC1B\uEC1C\uEC1D\u7B43\u797E\uEC20"+
	"\u6FB5\uEC22\u6A03\uEC24\u53A2\uEC26\u93BF\u6836"+
	"\u975D\uEC2A\uEC2B\uEC2C\uEC2D\uEC2E\uEC2F\u5D85"+
	"\uEC31\uEC32\u5715\u9823\uEC35\u5DAB\uEC37\u65BE"+
	"\u69D5\u53D2\uEC3B\uEC3C\uEC3D\u6736\uEC3F\uEC40"+
	"\uEC41\uEC42\uEC43\uEC44\uEC45\uEC46\uEC47\uEC48"+
	"\uEC49\uEC4A\uEC4B\uEC4C\uEC4D\u63E6\uEC4F\u7808"+
	"\u9255\uEC52\uEC53\uEC54\uEC55\uEC56\uEC57\uEC58"+
	"\u59F8\uEC5A\uFFFD\uEC5C\uEC5D\uFFFD\uEC5F\uEC60"+
	"\uEC61\uEC62\uEC63\u8FD0\u728F\u568B\uEC67\uEC68"+
	"\uEC69\uEC6A\uEC6B\uEC6C\uEC6D\uEC6E\uEC6F\uEC70"+
	"\uEC71\uEC72\uEC73\u7E9F\uEC75\uEC76\uEC77\u9547"+
	"\uEC79\u71A2\uEC7B\uEC7C\u9012\uEC7E\uEC7F\uEC80"+
	"\u8FBE\u55C1\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\u8FBA\uEC84\u8FB9\uEC86"+
	"\uEC87\u7E7F\u6F56\u6AB1\u4EEA\uEC8C\uEC8D\uEC8E"+
	"\uEC8F\u8E80\uEC91\uEC92\uEC93\uEC94\uEC95\uEC96"+
	"\uEC97\uEC98\uEC99\uEC9A\uEC9B\u4E9A\uEC9D\uEC9E"+
	"\u56BF\uECA0\u8E0E\u5B6D\uECA3\uECA4\u63DE\uFFFD"+
	"\uECA7\uECA8\u6530\u562D\uECAB\u541A\uECAD\uECAE"+
	"\uECAF\uECB0\u5622\u561E\u7F49\uECB4\u5975\uECB6"+
	"\u8770\u4E1C\uECB9\uECBA\uECBB\u8117\u9D5E\u8D18"+
	"\u763B\u9C45\u764E\u77B9\u9345\u5432\u8148\u82F7"+
	"\u5625\u8132\u8418\u80BD\u55EA\u7962\u5643\u5416"+
	"\uECCF\uECD0\u5605\u55F1\u66F1\uECD4\uECD5\u7534"+
	"\u55F0\u55BA\u5497\u5572\uECDB\uECDC\u5ED0\uECDE"+
	"\uECDF\uECE0\uECE1\u9EAB\u7D5A\u55DE\uECE5\u629D"+
	"\u976D\u5494\u8CCD\u71F6\u9176\u63FC\u63B9\u63FE"+
	"\u5569\uECF0\u9C72\uECF2\u519A\uECF4\uECF5\u51A7"+
	"\u544D\u551E\u5513\u7666\u8E2D\uECFC\u75B1\u80B6"+
	"\u8804\u8786\u88C7\u81B6\u841C\uED04\uED05\u7304"+
	"\uED07\u5B90\u830B\uED0A\u567B\uED0C\uED0D\uED0E"+
	"\uED0F\uED10\uED11\u9170\uED13\u9208\uED15\uED16"+
	"\uED17\uED18\u7266\uED1A\uED1B\uED1C\uED1D\uED1E"+
	"\uED1F\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\u9C5D\u651F\uED22\uED23\uED24"+
	"\uED25\uED26\uED27\uFFFD\uED29\uED2A\uFFFD\uED2C"+
	"\uED2D\u71A3\u7E8E\u9D50\u4E1A\u4E04\uED33\u5B0D"+
	"\u6CB2\u5367\uED37\uED38\u537D\uED3A\uED3B\u589A"+
	"\uED3D\u822D\u544B\u57AA\uED41\uED42\uFFFD\uED44"+
	"\uED45\u7374\uED47\uED48\u9BED\uED4A\uED4B\uED4C"+
	"\uED4D\uED4E\uED4F\u845C\uED51\uED52\uED53\uED54"+
	"\u632E\u7D25\uED57\uED58\uED59\u9008\u52CC\uED5C"+
	"\uED5D\uED5E\uED5F\u7640\u5AF0\uED62\u787A\uED64"+
	"\u58A7\uED66\u567C\u9B8B\u5D74\u7654\uED6B\u9E85"+
	"\uED6D\uFFFD\uED6F\u6119\uED71\uED72\uFFFD\u565D"+
	"\uED75\u57A7\uED77\uED78\u5234\uED7A\uED7B\uFFFD"+
	"\u9D7C\u7C56\u9B39\u57DE\uED81\u5C53\u64D3\uED84"+
	"\uED85\uED86\u86AD\uED88\uED89\uED8A\uED8B\uFFFD"+
	"\u51FE\uED8E\u5D8E\u9703\uED91\u9E81\u904C\u7B1F"+
	"\u9B02\u5CD1\u7BA3\u6268\u6335\u9AFF\u7BCF\u9B2A"+
	"\u7C7E\uFFFD\u7C42\u7C86\u9C15\u7BFC\u9B09\uFFFD"+
	"\u9C1B\uEDA6\u9F5A\u5573\u5BC3\u4FFD\u9E98\u4FF2"+
	"\u5260\uEDAE\u52D1\u5767\u5056\u59B7\u5E12\u97C8"+
	"\u9DAB\u8F5C\u5469\u97B4\u9940\u97BA\u532C\u6130"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\u692C\u53DA\u9C0A\u9D02\uEDC1\u9641"+
	"\u6980\u50A6\u7546\uEDC6\u99DA\u5273\uFFFD\u9159"+
	"\u9681\u915C\uFFFD\u9151\uEDCF\u637F\uEDD1\u6ACA"+
	"\u5611\u918E\u757A\u6285\uEDD7\u734F\u7C70\uEDDA"+
	"\uEDDB\uFFFD\uEDDD\u76D6\u9B9D\u4E2A\uEDE1\u83BE"+
	"\u8842\uFFFD\u5C4A\u69C0\uFFFD\u577A\u521F\u5DF5"+
	"\u4ECE\u6C31\uEDED\u4F39\u549C\u54DA\u529A\u8D82"+
	"\uEDF3\uFFFD\uEDF5\uFFFD\u6B52\u917C\u9FA5\u9B97"+
	"\u982E\u98B4\u9ABA\u9EA8\u9E84\u717A\u7B14\uFFFD"+
	"\u6BFA\u8818\u7F78\uFFFD\u5620\uEE08\u8E77\u9F53"+
	"\uFFFD\u8DD4\u8E4F\u9E1C\u8E01\u6282\uEE11\u8E28"+
	"\u8E75\u7AD3\uEE15\u7A3E\u78D8\u6CEA\u8A67\u7607"+
	"\uEE1B\u9F26\u6CCE\u87D6\u75C3\uEE20\u7853\uEE22"+
	"\u8D0C\u72E2\u7371\u8B2D\u7302\u74F1\u8CEB\uEE2A"+
	"\u862F\u5FBA\u88A0\uEE2E\uFFFD\uEE30\uEE31\uFFFD"+
	"\u8A7E\uEE34\uFFFD\u60FD\u7667\u9AD7\u9D44\u936E"+
	"\u9B8F\u87F5\uFFFD\uFFFD\u8CF7\u732C\u9721\u9BB0"+
	"\uEE43\u72B2\uEE45\u7C51\u994A\uEE48\u6159\uEE4A"+
	"\u9E96\u617D\uFFFD\u575F\u616F\u62A6\u6239\uFFFD"+
	"\uEE53\u61E2\u53AA\uEE56\u6364\u6802\uEE59\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\u5D57\uEE5B\u8FDA\uEE5D\uFFFD\u50D9\uEE60"+
	"\u7906\u5332\u9638\uEE64\uEE65\uFFFD\u77FE\uFFFD"+
	"\u7CC2\uEE6A\u7CDA\u7A2D\u8066\u8063\u7D4D\u7505"+
	"\u74F2\u8994\u821A\u670C\u8062\uEE76\u805B\u74F0"+
	"\u8103\u7724\u8989\uEE7C\u7553\uEE7E\u87A9\u87CE"+
	"\u81C8\u878C\u8A49\u8CAD\u8B43\u772B\u74F8\u84DA"+
	"\u3635\u69B2\u8DA6\uFFFD\u89A9\uFFFD\u6DB9\u87C1"+
	"\uEE91\u74E7\uEE93\u7176\u60A4\u619C\uEE97\uFFFD"+
	"\u6077\uFFFD\u7F71\uEE9C\uFFFD\u60E9\uEE9F\u5220"+
	"\uEEA1\uEEA2\uEEA3\uEEA4\uEEA5\uEEA6\uEEA7\uEEA8"+
	"\uEEA9\uEEAA\u5CC1\uEEAC\uEEAD\uEEAE\uEEAF\uEEB0"+
	"\uEEB1\u4562\u5B1F\uEEB4\u9F50\u9EA6\uEEB7\u8B96"+
	"\u8277\u8D1B\u91C0\u946A\u9742\u9748\u9744\u97C6"+
	"\u9870\u9A5F\u9B22\u9B58\u9C5F\u9DF9\u9DFA\u9E7C"+
	"\u9E7D\u9F07\u9F77\u9F72\u5EF3\u6B16\u7063\u7C6C"+
	"\u7C6E\u883B\u89C0\u8EA1\u91C1\u9472\u9470\u9871"+
	"\u995E\u9AD6\u9B23\u9ECC\u7064\u77DA\u8B9A\u9477"+
	"\u97C9\u9A62\u9A65\u7E9C\u8B9C\u8EAA\u91C5\u947D"+
	"\u947E\u947C\u9C77\u9C78\u9EF7\u8C54\u947F\u9E1A"+
	"\u7228\u9A6A\u9B31\u9E1B\u9E1E\u7C72\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\u2460\u2461\u2462\u2463\u2464\u2465\u2466\u2467"+
	"\u2468\u2469\u2474\u2475\u2476\u2477\u2478\u2479"+
	"\u247A\u247B\u247C\u247D\u2170\u2171\u2172\u2173"+
	"\u2174\u2175\u2176\u2177\u2178\u2179\u4E36\u4E3F"+
	"\u4E85\u4EA0\u5182\u5196\u51AB\u52F9\u5338\u5369"+
	"\u53B6\u590A\u5B80\u5DDB\u2F33\u5E7F\uFFFD\u5F50"+
	"\u5F61\u6534\uFFFD\u7592\uFFFD\u8FB5\uFFFD\u00A8"+
	"\u02C6\u30FD\u30FE\u309D\u309E\uFFFD\uFFFD\u3005"+
	"\u3006\u3007\u30FC\uFF3B\uFF3D\u273D\u3041\u3042"+
	"\u3043\u3044\u3045\u3046\u3047\u3048\u3049\u304A"+
	"\u304B\u304C\u304D\u304E\u304F\u3050\u3051\u3052"+
	"\u3053\u3054\u3055\u3056\u3057\u3058\u3059\u305A"+
	"\u305B\u305C\u305D\u305E\u305F\u3060\u3061\u3062"+
	"\u3063\u3064\u3065\u3066\u3067\u3068\u3069\u306A"+
	"\u306B\u306C\u306D\u306E\u306F\u3070\u3071\u3072"+
	"\u3073\u3074\u3075\u3076\u3077\u3078\u3079\u307A"+
	"\u307B\u307C\u307D\u307E\u307F\u3080\u3081\u3082"+
	"\u3083\u3084\u3085\u3086\u3087\u3088\u3089\u308A"+
	"\u308B\u308C\u308D\u308E\u308F\u3090\u3091\u3092"+
	"\u3093\u30A1\u30A2\u30A3\u30A4\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u30A5"+
	"\u30A6\u30A7\u30A8\u30A9\u30AA\u30AB\u30AC\u30AD"+
	"\u30AE\u30AF\u30B0\u30B1\u30B2\u30B3\u30B4\u30B5"+
	"\u30B6\u30B7\u30B8\u30B9\u30BA\u30BB\u30BC\u30BD"+
	"\u30BE\u30BF\u30C0\u30C1\u30C2\u30C3\u30C4\u30C5"+
	"\u30C6\u30C7\u30C8\u30C9\u30CA\u30CB\u30CC\u30CD"+
	"\u30CE\u30CF\u30D0\u30D1\u30D2\u30D3\u30D4\u30D5"+
	"\u30D6\u30D7\u30D8\u30D9\u30DA\u30DB\u30DC\u30DD"+
	"\u30DE\u30DF\u30E0\u30E1\u30E2\u30E3\u30E4\u30E5"+
	"\u30E6\u30E7\u30E8\u30E9\u30EA\u30EB\u30EC\u30ED"+
	"\u30EE\u30EF\u30F0\u30F1\u30F2\u30F3\u30F4\u30F5"+
	"\u30F6\u0410\u0411\u0412\u0413\u0414\u0415\u0401"+
	"\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D"+
	"\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425"+
	"\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D"+
	"\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435"+
	"\u0451\u0436\u0437\u0438\u0439\u043A\u043B\u043C"+
	"\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444"+
	"\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C"+
	"\u044D\u044E\u044F\u21E7\u21B8\u21B9\uF7E5\uF7E6"+
	"\u4E5A\uF7E8\u5202\uF7EA\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uF7EB\u5188"+
	"\uF7ED\uF7EE\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFE2\uFFE4\uFF07\uFF02\u3231\u2116"+
	"\u2121\u309B\u309C\uF820\uF821\uF822\uF823\uF824"+
	"\uF825\uF826\uF827\uF828\uF829\uF82A\uF82B\uF82C"+
	"\uF82D\uF82E\uF82F\uF830\uF831\uF832\uF833\uF834"+
	"\uF835\uF836\uF837\uF838\uF839\uF83A\uF83B\uFFFD"+
	"\uFFFD\uFFFD\u0283\u0250\u025B\u0254\u0275\u0153"+
	"\u00F8\u014B\u028A\u026A\uE000\u92DB\uE002\uE003"+
	"\u854C\uE005\u73EF\u51B5\uE008\uE009\uE00A\u9344"+
	"\uE00C\u82EE\uE00E\u783C\u6744\u62DF\uE012\uE013"+
	"\uE014\uE015\uE016\u4FAB\uE018\u5008\uE01A\uE01B"+
	"\uE01C\uE01D\uE01E\uFFFD\uE020\u5FA4\uE022\uE023"+
	"\u6EDB\uE025\uFFFD\u5101\uE028\u510E\u986C\uE02B"+
	"\u8416\uE02D\uE02E\u5160\uE030\u516A\uE032\uE033"+
	"\uE034\uE035\uE036\uE037\uE038\u5B82\u877D\uE03B"+
	"\uE03C\u51B2\u51B8\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u9D34\u51C9\u51CF"+
	"\u51D1\uE043\u51D3\uE045\u51B3\u51E2\u5342\u51ED"+
	"\u83CD\u693E\uE04C\u5F7B\u520B\u5226\u523C\u52B5"+
	"\u5257\u5294\u52B9\u52C5\u7C15\u8542\u52E0\u860D"+
	"\uE05A\uFFFD\uE05C\u5549\u6ED9\uE05F\uE060\uE061"+
	"\u5333\uFFFD\uE064\u6CCB\uE066\u681B\u73D5\u604A"+
	"\uE06A\uE06B\uE06C\u71DD\uE06E\u536D\u5374\uE071"+
	"\u537E\uFFFD\uE074\uE075\u77E6\u5393\uE078\u53A0"+
	"\u53AB\u53AE\u73A7\uE07D\uE07E\u739C\u53C1\u53C5"+
	"\u6C49\u4E49\u57FE\u53D9\uE086\uE087\u53E0\uE089"+
	"\uE08A\u53F6\uE08C\u5413\u7079\u552B\u6657\u6D5B"+
	"\u546D\uE093\uE094\u555D\u548F\u54A4\uE098\uE099"+
	"\uE09A\uE09B\uE09C\uE09D\uE09E\u5547\uE0A0\u542F"+
	"\u7417\u5586\u55A9\uFFFD\uE0A6\uE0A7\uE0A8\uE0A9"+
	"\u66B3\uE0AB\u5637\u66CD\uE0AE\u66A4\u66AD\u564D"+
	"\u564F\u78F1\u56F1\u9787\u53FE\u5700\u56EF\u56ED"+
	"\uE0BA\uE0BB\uE0BC\u5746\uE0BE\u6C6E\u708B\u5742"+
	"\uE0C2\uE0C3\u57E6\uE0C5\u5803\uE0C7\uE0C8\u5826"+
	"\uE0CA\u585C\u58AA\uE0CD\u58E0\u58DC\uE0D0\u58FB"+
	"\u5BFF\u5743\uE0D4\uE0D5\u93D3\uE0D7\u591F\u68A6"+
	"\uE0DA\u6E59\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uE0DC\u5A24\u5553\uE0DF"+
	"\u8505\u59C9\uE0E2\uE0E3\uE0E4\uE0E5\u59D9\uE0E7"+
	"\uE0E8\uE0E9\u6D71\uE0EB\uE0EC\u59F9\uE0EE\u5AAB"+
	"\u5A63\uE0F1\uE0F2\uFFFD\uE0F4\u5A96\u7465\u5AD3"+
	"\uE0F8\uE0F9\u3D85\uE0FB\uE0FC\uE0FD\u5E83\u52D0"+
	"\u5B76\u6588\u5B7C\uE103\uE104\uE105\uE106\u5BD5"+
	"\u6160\uE109\uE10A\uE10B\u5BF3\u5B9D\uE10E\u5C05"+
	"\uE110\u5C13\u73CE\u5C14\uE114\uE115\u5C49\uE117"+
	"\u5C85\u5CE9\u5CEF\u5D8B\uE11C\uE11D\u5D10\u5D18"+
	"\u5D46\uE121\u5CBA\u5DD7\u82FC\uE125\uE126\uE127"+
	"\uE128\u8287\uE12A\uE12B\u5E2E\u6A8A\uFFFD\u5E7A"+
	"\uE130\uE131\u53A6\u4EB7\uFFFD\u53A8\uE136\u5E09"+
	"\u5EF4\uE139\u5EF9\u5EFB\uE13C\u5EFC\u683E\u941B"+
	"\u5F0D\uE141\uE142\uE143\u48AE\uE145\u5F3A\uE147"+
	"\uE148\uFFFD\uE14A\u5F63\u97BD\uE14D\u5F72\u9340"+
	"\uE150\u5FA7\u5DB6\uE153\uE154\uE155\uE156\uE157"+
	"\u91D6\uE159\uE15A\u6031\u6685\uE15D\uE15E\uE15F"+
	"\uE160\u5790\uE162\u7971\uE164\u609E\uFFFD\u60B3"+
	"\uE168\uE169\uE16A\u74A4\u50E1\u5AA0\u6164\u8424"+
	"\u6142\uE171\uE172\u6181\u51F4\uE175\u6187\u5BAA"+
	"\uE178\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uE179\u61D3\uE17B\uE17C\u61D0"+
	"\uE17E\uE17F\uE180\u6023\u615C\u651E\u638B\uE185"+
	"\u62C5\uE187\u62D5\uE189\u636C\uE18B\uE18C\u6438"+
	"\u63F8\uE18F\uE190\uFFFD\u6F8A\uE193\u9814\uE195"+
	"\uE196\u64E1\u64E5\u947B\uE19A\u643A\uE19C\u654D"+
	"\u6F16\uE19F\uE1A0\u6585\u656D\u655F\uE1A4\u65B5"+
	"\uE1A6\uE1A7\u65D1\uE1A9\uE1AA\u65E0\u65E3\u5FDF"+
	"\uE1AE\u6618\uE1B0\uE1B1\u6644\uE1B3\uE1B4\u664B"+
	"\uE1B6\u6667\uE1B8\u6673\uFFFD\uE1BB\uE1BC\uE1BD"+
	"\uE1BE\uE1BF\u77C5\uE1C1\u99A4\u6702\uE1C4\uE1C5"+
	"\u3B2B\u69FA\uE1C8\uFFFD\u6767\u6762\uE1CC\uE1CD"+
	"\u67D7\uE1CF\u6822\u6E50\u923C\u6801\uE1D4\uE1D5"+
	"\u685D\uE1D7\u69E1\u6A0B\uE1DA\u6973\u68C3\uE1DD"+
	"\u6901\u6900\u3D32\uE1E1\uE1E2\uE1E3\u67AC\u6961"+
	"\uE1E6\uE1E7\u6936\u6998\uE1EA\uE1EB\u8363\u5090"+
	"\u69F9\uE1EF\uE1F0\u6A45\uE1F2\u6A9D\uE1F4\u67B1"+
	"\u6AC8\uE1F7\uE1F8\u6B1D\uE1FA\u60DE\u6B35\u6B74"+
	"\uE1FE\u6EB5\uE200\uE201\uE202\uE203\u5421\uE205"+
	"\u6BE1\uE207\u6BDC\u6C37\uE20A\uE20B\uE20C\u6C5A"+
	"\u8226\u6C79\uE210\uE211\uE212\uE213\uE214\uE215"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uE216\uE217\uE218\uE219\u9B83\uE21B"+
	"\uE21C\u7F8F\u6837\uE21F\uE220\uE221\u6D96\u6D5C"+
	"\u6E7C\u6F04\uE226\uE227\uE228\u8533\uE22A\u51C7"+
	"\uFFFD\uFFFD\u842E\uE22F\uFFFD\uE231\u7453\uE233"+
	"\u79CC\u6E4F\u5A91\uE237\u6FF8\uE239\u6F9D\uE23B"+
	"\u6EFA\uE23D\uE23E\uE23F\u93F0\u6F44\u6F5C\uE243"+
	"\u6F74\uE245\uE246\u6F9F\uE248\u6FD3\uE24A\uE24B"+
	"\uE24C\uE24D\uE24E\uE24F\u51DF\uE251\uE252\uE253"+
	"\uE254\u704B\u707E\u70A7\u7081\u70CC\u70D5\u70D6"+
	"\u70DF\uE25D\uE25E\u71B4\u7196\uE261\u712B\u7145"+
	"\u5A88\u714A\uFFFD\u5C9C\uE268\u714F\u9362\uE26B"+
	"\u712C\uE26D\uE26E\uE26F\u71BA\uE271\u70BD\u720E";

    private final static String innerIndex2= 
	"\u9442\u7215\u5911\u9443\u7224\u9341\uE27A\u722E"+
	"\u7240\uE27D\u68BD\u7255\u7257\uE281\uE282\u680D"+
	"\u6F3D\u7282\uFFFD\u732B\uE288\uE289\uE28A\uE28B"+
	"\u7328\u732E\u73CF\u73AA\uE290\uE291\u73C9\u7449"+
	"\uE294\uE295\uE296\u6623\uE298\uE299\uE29A\uE29B"+
	"\u73F7\u7415\u6903\uE29F\u7439\uE2A1\uE2A2\uFFFD"+
	"\uE2A4\u7460\uE2A6\u7447\u73E4\u7476\u83B9\u746C"+
	"\u3730\u7474\u93F1\u6A2C\u7482\uE2B1\uE2B2\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"+
	"\uFFFD\uE2B3\uE2B4\uE2B5\u5B46\uE2B7\uE2B8\u74C8"+
	"\uE2BA\u750E\uFFFD\u751E\uE2BE\uE2BF\u5BD7\uE2C1"+
	"\u9385\u754D\u754A\u7567\u756E\uE2C7\uE2C8\uE2C9"+
	"\u758E\u745D\u759E\u75B4\u7602\u762C\u7651\u764F"+
	"\u766F\u7676\uE2D4\u7690\u81EF\uE2D7\uE2D8\uE2D9"+
	"\u76A1\u76A5\u76B7\u76CC\uE2DE\u8462\uE2E0\uE2E1"+
	"\uE2E2\u771E\u7726\u7740\u64AF\uE2E7\u7758\uE2E9"+
	"\u77AF\uE2EB\uE2EC\uE2ED\u77F4\uFFFD\uE2F0\uE2F1"+
	"\u68CA\u78AF\u78C7\u78D3\u96A5\u792E\uE2F8\u78D7"+
	"\u7934\u78B1\uE2FC\u8FB8\u8884\uE2FF\uE300\uE301"+
	"\u7986\u8900\u6902\u7980\uE306\u799D\uE308\u793C"+
	"\u79A9\u6E2A\uE30C\uE30D\u79C6\uE30F\u79D4";

    private final static short index1[] = {
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 3, 4, 0, 5, 6, 7, 
        8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 
        24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 25, 26, 27, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 29, 30, 31, 32, 0
    };

    String index2[] = {
        innerIndex0,
        innerIndex1,
        innerIndex2
    };
}
