/*
 * @(#)CharToByteX11CNS11643P2.java	1.8 00/02/28
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.awt.motif;
import sun.io.CharToByteEUC_TW;

public class CharToByteX11CNS11643P2 extends CharToByteEUC_TW {
    public String toString(){
	return "X11CNS11643P2";
    }
    
    public boolean canConvert(char ch){
	int cns = getNative(ch);

        if (((0xFF00 & ch) != 0) && (cns & 0xF0000) == 0x20000) {
            return true;
        }
        return false;
    }

    public int convert(char[] input, int inOff, int inEnd,
                       byte[] output, int outOff, int outEnd) {

	for (int i = inOff; i < inEnd; i++) {
            int cns = getNative(input[i]);

	    if ((cns & 0xF0000) == 0x20000) {      // Plane 2
		output[outOff++] = (byte) ((cns >> 8) & 0x7f);
		output[outOff++] = (byte) (cns & 0x7f);
	    }
	    else {
		output[outOff++] = subBytes.length > 0 ? subBytes[0] : 0;
		output[outOff++] = subBytes.length > 1 ? subBytes[1] : 0;
	    }
	}

        return (inEnd - inOff) * 2;
    }
}

