/*
 * @(#)inStream.h	1.9 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
#ifndef INSTREAM_H
#define INSTREAM_H

#include <jni.h>
#include <jvmdi.h>
#include "transport.h"

struct bag;

typedef struct PacketInputStream {
    jbyte *current;
    struct PacketData *segment;
    jint left;
    jint error;
    struct Packet packet;
    struct bag *refs;
} PacketInputStream;

void inStream_init(PacketInputStream *stream, struct Packet packet);

jint inStream_id(PacketInputStream *stream);
jbyte inStream_command(PacketInputStream *stream);

jboolean inStream_readBoolean(PacketInputStream *stream);
jbyte inStream_readByte(PacketInputStream *stream);
jchar inStream_readChar(PacketInputStream *stream);
jshort inStream_readShort(PacketInputStream *stream);
jint inStream_readInt(PacketInputStream *stream);
jlong inStream_readLong(PacketInputStream *stream);
jfloat inStream_readFloat(PacketInputStream *stream);
jdouble inStream_readDouble(PacketInputStream *stream);
jlong inStream_readObjectID(PacketInputStream *stream);
jframeID inStream_readFrameID(PacketInputStream *stream);
jmethodID inStream_readMethodID(PacketInputStream *stream);
jfieldID inStream_readFieldID(PacketInputStream *stream);
jlocation inStream_readLocation(PacketInputStream *stream);

jobject inStream_readObjectRef(PacketInputStream *stream);
jclass inStream_readClassRef(PacketInputStream *stream);
jthread inStream_readThreadRef(PacketInputStream *stream);
jthreadGroup inStream_readThreadGroupRef(PacketInputStream *stream);
jobject inStream_readClassLoaderRef(PacketInputStream *stream);
jstring inStream_readStringRef(PacketInputStream *stream);
jarray inStream_readArrayRef(PacketInputStream *stream);

char *inStream_readString(PacketInputStream *stream);
jvalue inStream_readValue(struct PacketInputStream *in, jbyte *typeKeyPtr);

jint inStream_skipBytes(PacketInputStream *stream, jint count);

jboolean inStream_endOfInput(PacketInputStream *stream);
jint inStream_error(PacketInputStream *stream);

void inStream_destroy(PacketInputStream *stream);

#endif /* INSTREAM_H */
