/*
 * @(#)stepControl.h	1.17 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
#include <jni.h>
#include <jvmdi.h>

#ifndef STEP_CONTROL_H
#define STEP_CONTROL_H

struct HandlerNode_;

typedef struct {
    /* Parameters */
    jint granularity;
    jint depth;

    /* State */
    jboolean pending;
    jboolean frameExited;    /* for depth == STEP_OVER or STEP_OUT */
    jboolean fromNative;
    jint fromStackDepth;     /* for all but STEP_INTO STEP_INSTRUCTION */
    jint fromLine;           /* for granularity == STEP_LINE */
    JVMDI_line_number_entry *lineEntries;       /* STEP_LINE */
    jint lineEntryCount;     /* for granularity == STEP_LINE */

    struct HandlerNode_ *stepHandlerNode;
    struct HandlerNode_ *catchHandlerNode;
    struct HandlerNode_ *framePopHandlerNode;
    struct HandlerNode_ *methodEnterHandlerNode;
} StepRequest;


void stepControl_initialize(void);
void stepControl_reset(void);
void stepControl_OnHook(void);

jboolean stepControl_handleStep(JNIEnv *env, JVMDI_Event *event);

jint stepControl_beginStep(jthread thread, jint size, jint depth,
                           struct HandlerNode_ *node);
jint stepControl_endStep(jthread thread);

void stepControl_clearRequest(jthread thread, StepRequest *step);

void stepControl_lock(void);
void stepControl_unlock(void);

#endif

