/*
 * @(#)Bootstrap.java	1.5 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.jdi;

/**
 * Initial class that provides access to the default implementation 
 * of JDI interfaces. A debugger application uses this class to access the 
 * single instance of the {@link VirtualMachineManager} interface.
 *
 * @author Gordon Hirsch
 * @since  1.3
 */
public class Bootstrap extends Object {

    static private VirtualMachineManager virtualMachineManager = null;

    static public synchronized VirtualMachineManager virtualMachineManager() {
        if (virtualMachineManager == null) {
            virtualMachineManager = new com.sun.tools.jdi.VirtualMachineManagerImpl();
        }
        return virtualMachineManager;
    }
}
