/*
 * @(#)ByteValue.java	1.9 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.jdi;

/**
 * Provides access to a primitive <code>byte</code> value in the target VM.
 *
 * @author Robert Field
 * @author Gordon Hirsch
 * @author James McIlree
 * @since  1.3
 */
public interface ByteValue extends PrimitiveValue, Comparable
{
    /**
     * Returns this ByteValue as a boolean.
     * 
     * @return the byte mirrored by this object.
     */
    byte value();

    /**
     * Compares the specified Object with this ByteValue for equality.
     *
     * @return true if the Object is a ByteValue and if applying "=="
     * to the two mirrored primitives would evaluate to true; false
     * otherwise.
     */
    boolean equals(Object obj);

    /**
     * Returns the hash code value for this BooleanValue.
     *
     * @return the integer hash code
     */
    int hashCode();
}

