/*
 * @(#)InternalException.java	1.4 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.jdi;

/**
 * Thrown to indicate that an unexpected internal error has 
 * occurred.
 *
 * @author Gordon Hirsch
 * @since  1.3
 */
public class InternalException extends RuntimeException {
     private int errorCode;

     public InternalException() {
         super();
         this.errorCode = 0;
     }
 
     public InternalException(String s) {
         super(s);
         this.errorCode = 0;
     }

    public InternalException(int errorCode) {
	super();
        this.errorCode = errorCode;
    }

    public InternalException(String s, int errorCode) {
	super(s);
        this.errorCode = errorCode;
    }

    public int errorCode() {
        return errorCode;
    }
}
