/*
 * @(#)Locatable.java	1.11 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.jdi;

/**
 * A mirror that has a {@link Location}. 
 *
 * @author Robert Field
 * @author Gordon Hirsch
 * @author James McIlree
 * @since  1.3
 */
public interface Locatable {
    /**
     * Returns the {@link Location} of this mirror, if there
     * is executable Java language code associated with it. 
     * 
     * @return the {@link Location} of this mirror, or null if 
     * there is no executable code associated with it. 
     * For example, abstract and native {@link Method Methods}
     * will return null when their <code>location</code> method is
     * called.
     */
    Location location();
}
