/*
 * @(#)Value.java	1.9 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.jdi;

/**
 * The value assigned to a field or variable at some point during
 * the execution of the target VM. This interface is the root of a 
 * value hierarchy encompassing primitive and object values. 
 *
 * @author Robert Field
 * @author Gordon Hirsch
 * @author James McIlree
 * @since  1.3
 */

public interface Value extends Mirror
{
    /*
     * Returns the run-time type of this value. This value may be 
     * assigned to a field or variable whose declared type is a 
     * superclass, superinterface, or implemented interface
     * of the returned type.
     *
     * @return a {@link Type} which mirrors the value's type in the 
     * target VM.
     */
    Type type();
}

