/*
 * @(#)IllegalConnectorArgumentsException.java	1.5 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.jdi.connect;

import java.util.List;
import java.util.ArrayList;
import java.util.Collections;

/**
 * Thrown to indicate an invalid argument or 
 * inconsistent passed to a {@link Connector}.
 *
 * @author Gordon Hirsch
 * @since  1.3
 */
public class IllegalConnectorArgumentsException extends Exception
{
    List names;
    
    public IllegalConnectorArgumentsException(String s,
                                              String name) {
        super(s);
        names = new ArrayList(1);
        names.add(name);
    }

    public IllegalConnectorArgumentsException(String s, List names) {
        super(s);

        this.names = new ArrayList(names);
    }

    public List argumentNames() {
        return Collections.unmodifiableList(names);
    }
}
