/*
 * @(#)MethodExitEvent.java	1.7 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.jdi.event;

import com.sun.jdi.*;

/**
 * Notification of a method return in the target VM. This event
 * is generated after all code in the method has executed, but the 
 * location of this event is the last executed location in the method. 
 * Method exit events are generated for both native and non-native 
 * methods. Method exit events are not generated if the method terminates
 * with a thrown exception. 
 *
 * @see EventQueue
 *
 * @author Robert Field
 * @since  1.3
 */
public interface MethodExitEvent extends LocatableEvent {

    /**
     * Returns the method that was exited.
     *
     * @return a {@link Method} which mirrors the method that was exited.
     */
    public Method method();
}

