/*
 * @(#)VMDisconnectEvent.java	1.8 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.jdi.event;

import com.sun.jdi.*;

/**
 * Notification of disconnection from target VM.
 * May be caused by debugger action (
 * {@link VirtualMachine#dispose} or 
 * {@link VirtualMachine#exit}) or by external events
 * (for example, target process termination by the
 * operating system, transport termination, etc).
 * <p>
 * If the target VM terminates before the disconnection, this event 
 * will be preceded by a {@link VMDeathEvent}.
 *
 * @see VMDeathEvent
 * @see EventQueue
 * @see VirtualMachine
 *
 * @author Robert Field
 * @since  1.3
 */
public interface VMDisconnectEvent extends Event {
}

