/*
 * @(#)WatchpointEvent.java	1.10 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.jdi.event;

import com.sun.jdi.*;

/**
 * Notification of a field triggered event encountered by a thread in the 
 * target VM.
 *
 * @see EventQueue
 * @see VirtualMachine
 *
 * @author Robert Field
 * @since  1.3
 */
public interface WatchpointEvent extends LocatableEvent {

    /**
     * Returns the field that is about to be accessed/modified. 
     *
     * @return a {@link Field} which mirrors the field
     * in the target VM.
     */
    Field field();

    /**
     * Returns the object whose field is about to be accessed/modified. 
     * Return null is the access is to a static field.
     *
     * @return a {@link ObjectReference} which mirrors the event's 
     * object in the target VM.
     */
    ObjectReference object();

    /**
     * Current value of the field.
     */
    Value valueCurrent();
}
    

