/*
 * @(#)JVMDINode.java	1.6 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.tools.jdwpgen;

import java.util.*;
import java.io.*;

/**
 * Will get converted to Constant nodes during prune.
 */
class JVMDINode extends AbstractNamedNode {

    private String prettyIt(String lead, String underscored) {
        boolean upIt = false;
        StringBuffer sb = new StringBuffer(underscored.length());
        for (int i = lead.length(); i < underscored.length(); ++i) {
            char ch = underscored.charAt(i);
            if (ch == '_') {
                upIt = true;
            } else {
                if (upIt) {
                    upIt = false;
                } else {
                    ch = Character.toLowerCase(ch);
                }
                sb.append(ch);
            }
        }
        return sb.toString();
    }
            
    void addConstants(List addons) {
        int prefixLength = name.length();
        for (Iterator it = Main.nameMap.entrySet().iterator(); it.hasNext();) {
            Map.Entry entry = (Map.Entry)it.next();
            String nm = (String)entry.getKey();
            if (nm.startsWith(name)) {
                NameValueNode val = (NameValueNode)entry.getValue();
                val.name = nm.substring(prefixLength);
                List constName = new ArrayList();
                constName.add(val);
                ConstantNode cn = new ConstantNode(constName);
                it.remove(); // was: prevent ConcurrentModificationException
                addons.add(cn);
            }
        }
    }        
}
