/*
 * @(#)ActivatorAppletAudioClipRef.java	1.5 01/02/09
 *
 *  Copyright (c) 1996-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1
 *
 */

package sun.applet;


/*
 * Helper class that make the AudioClip useable in 1.2 
 *
 * @version 	1.1
 * @author	Stanley Man-Kit Ho
 */
import java.applet.AudioClip;
import java.net.URL;
import java.security.*;


public class ActivatorAppletAudioClipRef extends sun.misc.Ref 
{
    URL url;
    boolean doDownload = true;

    /**
     * Create the Ref
     */
    public ActivatorAppletAudioClipRef(URL url) {
	this.url = url;
    }

    public void flush() 
    {
	super.flush();
    }

    /**
     * Reconsitute the image.  Only called when the ref has been flushed.
     */
    public Object reconstitute() 
    {
	if ( doDownload )
	{
	    AudioClip clip = (AudioClip) AccessController.doPrivileged(
				     new PrivilegedAction() 
				     {
					 public Object run() 
					 {
					      return new AppletAudioClip(url);
				         }
				     });

	    if (clip != null)
		return new PluginAudioClip(clip);
	    else
		return null;
	}
	else
	    return null;
    }


    //
    // TODO: This is a hack to accomodate ActivatorAppletContext.stopAudioClips().
    // When trying to stop all audioclips, a download is being triggered,
    // which causes a deadlock.  We will revisit this when we have more time.
    //
    public void setDoDownload(boolean doDownload) {
	this.doDownload = doDownload;
    }
}


class PluginAudioClip implements AudioClip
{
    private AudioClip clip = null;

    public PluginAudioClip(AudioClip clip)
    {
	this.clip = clip;
    }

    public void loop()
    {
	if (clip != null)
	    clip.loop();
    }

    public void play()
    {
	if (clip != null)
	    clip.play();
    }

    public void stop()
    {
	if (clip != null)
	    clip.stop();
    }

    public void finalize()
    {
	// Make sure audio clip is stopped before GC,
	// this is to avoid locking up the audio system.
	if (clip != null)
	{
	    clip.stop();
	    clip = null;
	}
    }
}

