/*
 * @(#)OleBeanInfo.java	0.01 96/12/08
 *
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.0
 *
 */

/**
 * Take a generic component Editor and wrap it in a Dialog box.
 * this includes adding the Frame and the "ok" and "cancel" buttons.
 */

package sun.beans.ole;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;


public class CustomizerDialog extends Dialog implements ActionListener {

  public CustomizerDialog(Frame frame, Customizer customizer, Object target) {

	super(frame, customizer.getClass().getName(), false);

        this.customizerComponent = (Component)customizer;

        setLayout(null);

	add(customizerComponent);
	doneButton = new Button("Done");
	doneButton.addActionListener(this);
	add(doneButton);

	Dimension d = customizerComponent.getPreferredSize();
	int width = d.width;
	int height = vpad + d.height + 35;
	if (width < 150) {
	    width = 150;
	}

        int x = frame.getLocation().x + 30;
        int y = frame.getLocation().y + 100;
        setBounds(x, y, width, height);
	show();
  }

    public void doLayout() {
	int width = getSize().width;
	int height = getSize().height;
	customizerComponent.setBounds(0, vpad, width, height-(vpad+35));
	doneButton.setBounds((width-140)/2, height-30, 140, 25);
    }

    public void actionPerformed(ActionEvent evt) {
	// Our "done" button got pushed.
	dispose();
    }

    private Component customizerComponent;
    private Button doneButton;
    private static int vpad = 25;
 
}
