/*
 * @(#)ExceptionReporter.java	1.0 17/1/97
 *
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.0 
 *
 */

package sun.beans.ole;

/*
 * Display an exception in a frame window, wait for user to click OK before
 * proceeding
 */

import java.awt.*;
import java.awt.event.*;

public class ExceptionReporter extends Frame
                implements ActionListener {

    public ExceptionReporter(Throwable e, String msg) {

        textArea = new TextArea(17,80);
        textArea.setEditable(false);
        add(textArea, "Center");
        Button button = new Button(OleBeanInterface.getMessage("ok.label"));
        button.addActionListener(this);
        Panel panel = new Panel();
        panel.add(button);
        add(panel, "South");

        setTitle(OleBeanInterface.getMessage("status.exception")+ msg);

        java.io.ByteArrayOutputStream trace = 
	    new java.io.ByteArrayOutputStream();
        java.io.PrintStream printStream = new java.io.PrintStream(trace);
        if (e==null) {
	    return;
        }
        e.printStackTrace(printStream);
        textArea.setText(trace.toString());
        pack();
        show();

    }

    public void actionPerformed(ActionEvent e) {
        dispose();
    }

    private TextArea  textArea;

}
