/*
 * @(#)ModalityListenerImpl.java	
 *
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.2.2
 *
 */
package sun.beans.ole;

/*
 * The ModalityListener interface could not be implemented in OleEmbeddedFrame
 * directly since this interface has been added in 1.1.8 and 1.2.2 or superior.
 * We still need to run in previous jre/jdk version.
 *
 * @version 1.2.2
 * @date 1/21/98
 * @author Jerome Dochez
 */

import sun.awt.windows.*;

class ModalityListenerImpl implements ModalityListener, 
			      ModalityListenerRegistration {

    /*
     * <p>
     * Register a frame to receive the modality event notification
     * <p>
     *
     * @param frame which needs notification
     */
    public void register(OleEmbeddedFrame frame) {
	WToolkit.getWToolkit().addModalityListener(this);
	this.frame=frame;
    }

    /*
     * <p>
     * Unregister a frame 
     * <p>
     *
     * @param frame that does not require notification anymore
     */
    public void unregister(OleEmbeddedFrame frame) {
	WToolkit.getWToolkit().removeModalityListener(this);
	this.frame=null;
    }

   /**
    * Called by AWT when it enters a new level of modality
    */
    public void modalityPushed(ModalityEvent ev) {
	frame.modalityPushed();
    }
    
   /**
    * Called by AWT when it exits a level of modality
    */
    public void modalityPopped(ModalityEvent ev) {
	frame.modalityPopped();
    }
    
    private OleEmbeddedFrame frame;
}

 
