/*
 * @(#)ModalityListener.java	
 *
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.2.2
 *
 */
package sun.beans.ole;

import sun.awt.windows.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.Beans;
import java.applet.Applet;

/*
 * This interface register and unregister a modality event listener frame
 *
 * @version 1.2.2
 * @date 1/21/98
 * @author Jerome Dochez
 */

interface ModalityListenerRegistration {

   /**
    * <p>
    * Register the sender to listen to the modality events
    * </p>
    *
    * @param frame to listen
    */
    public void register(OleEmbeddedFrame frame);

    /*
     * <p>
     * Unregister a frame 
     * <p>
     *
     * @param frame that does not require notification anymore
     */
    public void unregister(OleEmbeddedFrame frame);
}

 
