/*
 * @(#)OleBeanInfo.java	0.01 96/12/08
 *
 *  Copyright (c) 1996-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.2
 *
 */

 package sun.beans.ole;

 import sun.plugin.AppletViewer;
 import sun.plugin.ocx.ActiveXAppletViewer;

 class OleAppletViewerInterface extends OleBeanInterface {


    /*
     * <p>
     * Construct a new interface between an applet viewer and the 
     * native ActiveX implementation
     * </p>
     *
     * @param appletViewer the new applet viewer responsible for 
     * displaying the Applet.
     * @param handle	    native COM Object instance
     */
    protected OleAppletViewerInterface(AppletViewer appletViewer, int handle) {
	super(appletViewer.getViewedObject(), handle);
	this.appletViewer = appletViewer;
    }

    /*
     * <p>
     * Return the AWT component responsible for hosting a Java Applet
     * Can be overriden by subclasses to provide customization
     * </p>
     *
     * @return the class reference
     *
     */
    private static Class getAppletViewerClass() {
	return sun.plugin.ocx.ActiveXAppletViewer.class;	
    }

    /*
     * <p>
     * Return the AWT component responsible for hosting a Java Beans
     * Can be overriden by subclasses to provide customization
     * </p>
     *
     * @return the class reference
     *
     */
    private static Class getBeansViewerClass() {
	return sun.plugin.ocx.ActiveXBeansViewer.class;
    }

    /*
     * <p>
     * Register all source event interfaces with the bridge run-time
     * handlers
     * </p>
     *
     * @param interfaceDesc the list of interfaces and registration/
     * deregistration methods
     *
     * @param connectionPoint OLE interface pointer
     *
     * @param propertyNotify OLE property notification mechanism
     *
     * @return success or failure
     */
    public boolean addCustomEventListeners(String interfacesDesc,
					   int connectionPoint,
					   int propertyNotify) {

	if (appletViewer instanceof ActiveXAppletViewer)
	    if (((ActiveXAppletViewer) appletViewer).bridgeEvents()==false)
		return true;

	return super.addCustomEventListeners(interfacesDesc, connectionPoint, propertyNotify);
    }

    /*
     * <p>
     * Register the bridge to the source interfaces produced by the
     * targeted JavaBean component. 
     * </p>
     *
     * @parm interfacesDesc      String describing the source interfaces. 
     * Each source interface is defined by the interface name and the 
     * registration/unregistration method.
     * 
     * @param connectionPoint	Ole interface pointer for custom event
     *
     * @param propertyNotify	Ole Interface pointer for property events firing
     *
     * @return true if success
     */
    public boolean addPropertyEventListener(String interfacesDesc, 
					    int connectionPoint,
					    int propertyNotify) {
	return true;
    }

    /*
     * <p>
     * Called by the save framework to prepare the object for saving
     * </p>
     */
    protected void beforeSave() {

	// Stop the applet
	appletViewer.getApplet().stop();
    }

    /*
     * @return the AppletViewer
     */			     
    public sun.plugin.AppletViewer getViewerObject() {
	return appletViewer;
    }

    /*
     * @return the instance of the automated object
     */			     
    public Object getInterfacedObject() {
	return appletViewer.getViewedObject();
    }


    public void release() {
	appletViewer = null;
	super.release();
    }

    private AppletViewer appletViewer;
 }
