/*
 * @(#)OleBeanInfo.java	0.01 96/12/08
 *
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.2
 *
 */

package sun.beans.ole;


import java.lang.*;

/*
 * OleEventListener
 *
 * This class is responsible for allocating, storing and retrieal of java
 * values into OLE automation DISPARAMS structure and translating between
 * java values and C values. Mainly implemented in C++, in the ActiveX
 * implementation
 *
 * 
 * @author Jerome Dochez
 * @version 1.2
 */

abstract public class OleEventListener extends OleDispatchInterface{

    /* 
     * Construct a new OleEventListener object responsible for 
     * catching events published by the bean. This class will marshall
     * the parameters for the OLE layer.
     * @parm connectionPoint	IConnectionPoint interface pointer
     * @return OLE structure pointer
     */ 
    public OleEventListener(int connectionPoint) {
	m_connectionPoint = connectionPoint;
    }

    /*
     * Fire a particular event to the native code
     */
    protected native void fireEvent(int connectionPoint, 
				    int dispID,
				    int disparams);

    protected int	m_connectionPoint;

}

