/*
 * @(#)UserFeedback.java	0.1 97/4/15
 *
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.0 
 *
 */



/*
 * <p>
 * sun.beans.ole.UserFeedback
 * </p>
 *
 * Author :
 *   Jerome Dochez
 *   version 1.0 
 */

package sun.beans.ole;
/**
 * <p>
 * Interface defining methods for giving feeback to the user
 * </p>
 */
public interface UserFeedback { 

    /**
     * <p>
     * Display some text to the user
     * <p>
     * @param string to display
     */
    public void printText(String text);

    /**
     * <p>
     * Display a warning message to the user, may ask for confirmation
     * </p>
     * @param title the warning title
     * @param message the warning text
     */
    public void warn(String title, String message);

    /**
     * <p>
     * Display a warning message to the user, may ask for confirmation
     * </p>
     * @param title the warning title
     * @param messages the warning text
     */
    public void warn(String title, String messages[]);

}
    
