/*
 * @(#)VisualFeedback.java	1.0 97/8/7
 *
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.0
 *
 */


/*
 * <p>
 * sun.beans.ole.VisualFeeback
 * </p>
 *
 * @version 1.0
 * @author Jerome Dochez
 */

package sun.beans.ole;

/**
 * <p>
 * The VisualFeedback class implement the UserFeeback interface for
 * notifying visually the user of the packaging step events
 * </p>
 * @see sun.beans.ole.Feeback
 */

public class VisualFeedback implements UserFeedback {


    /**
     * <p>
     * Construct a new VisualFeeback
     * </p>
     * @param java.awt.Frame f the frame parenting all UI display
     * @param java.awt.TextField t the textfield used to display user 
     * messages
     */
    public VisualFeedback(java.awt.Frame f, java.awt.TextField t) {
	parent = f;
	textField = t;
    }

    /**
     * <p>
     * print the text to the user
     * </p>
     * @param s the string to be printed
     */
    public void printText(String s) {
	textField.setText(s);
    }

        /**
     * <p>
     * warn the user with a specific title and message
     * @param java.lang.String title warning title
     * @param java.lang.String message warning message
     */
    public void warn(String title, String message) {
	new InformationDialog(parent, title, message);
    }

     /**
     * <p>
     * warn the user with a specific title and message
     * @param java.lang.String title warning title
     * @param java.lang.String message[] warning messages
     */
    public void warn(String title, String messages[]) {
	new InformationDialog(parent, title, messages);
    }

    private java.awt.Frame parent;
    private java.awt.TextField textField;
}
