/*
 * @(#)AppletCheckConnectForJDK12.java	1.2 98/9/8
 *
 *  Copyright (c) 1996-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.2
 *
 */

package sun.plugin;

import java.net.*;

/*
 * <p>
 * JDK 1.2 nterface implementation responsible for checking that a particular
 * applet can connect to requested hosts
 * </p>
 *
 */
class AppletCheckConnectForJDK12 implements AppletCheckConnect {

    /*
     * <p>
     * Check applet connection rights.
     * </p>
     * @param sourceHostName host originating the applet
     * @param targetHostName host the applet requested a connection to
     * 
     * @return true if the applet originating from sourceHostName can make
     * a connection to targetHostName
     *
     */
    public boolean checkConnect(String sourceHostName, String targetHostName) throws Exception {
	    
	SocketPermission panelSp = 
	    new SocketPermission(sourceHostName,
		       		 "connect");
	SocketPermission sp =
	    new SocketPermission(targetHostName,
	       			 "connect");
	if (panelSp.implies(sp)) {
	    return true;
	}	
	return false;
    }
}
