/*
 * @(#)BeansViewer.java	1.00 97/10/7
 *
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1
 *
 */

package sun.plugin;

/*
 * A recipient to show a Java Beans in.
 * This class implements the AppletContext used by all applets loaded
 * within a running instance of the bridge.
 *
 * @version 	1.0
 * @author	Stanley Man-Kit Ho
 */

import java.beans.*; 
import java.util.*;
import java.applet.*;
import java.awt.*;
import java.net.*;
import java.io.*;
import sun.applet.*;
                       
public class BeansViewer {
 
    public final static int APPLET_DISPOSE = 0;
    public final static int APPLET_ERROR = 7;

    static public Applet createJavaBeanComponent(AppletViewer appletViewer, AppletClassLoader loader) throws ClassNotFoundException,
	IllegalAccessException, IOException, InstantiationException, InterruptedException {

	Applet applet;
	String serName = appletViewer.getSerializedObject();
	String code = appletViewer.getCode();

	if (code != null && serName != null) {
            System.err.println(AppletViewer.getMessage("bean_code_and_ser"));
	    return null;
	}
	if (code == null && serName == null) {
            String msg = "nocode";
	    appletViewer.setStatus(APPLET_ERROR);
	    appletViewer.showActivatorAppletStatus(msg);
	    appletViewer.showActivatorAppletLog(msg);
	    appletViewer.repaint();
	}
	if (code != null) {
	    Component bean = (Component)Beans.instantiate(loader, code);
            applet = new BeansApplet(bean);
	    appletViewer.setDoInit(true);
	} else {
	    // serName is not null;
	    Component bean = (Component) Beans.instantiate(loader, serName);
            applet = new BeansApplet(bean);
	    appletViewer.setDoInit(false); // skip over the first init
	}
	if (Thread.interrupted()) {
	    try {
		appletViewer.setStatus(APPLET_DISPOSE); // APPLET_ERROR?
		applet = null;
		// REMIND: This may not be exactly the right thing: the
		// status is set by the stop button and not necessarily
		// here.
		appletViewer.showActivatorAppletStatus("death");
	    } finally {
		Thread.currentThread().interrupt(); // resignal interrupt
		return null;
	    }
	}

	return applet;
    }


}
