/*
 * @(#)CacheHandler.java	1.14 01/02/09
 *
 * Copyright (c) 1995-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1
 *
 * Java Plug-in 
 *
 * @author Robert Szewczyk
 */

package sun.plugin;

import java.net.URL;
import sun.plugin.usability.Trace;

public class CacheHandler {
    public static String getCacheFile(URL u) {
	try {
	    /* unix. If this fails, exception will be caught below */
	    String ret = getCacheFilename(null, u.toString());

	    if (ret == null || ret.equals(""))
		return null;

	    Trace.netPrintln("Cache filename: " + ret);

	    return ret;
	} catch (Throwable e) {
	    // Ignore exception
	    return null;
	}
    }

    private static native String getCacheFilename(CacheReceiver cr, String url);
}
