/*
 * @(#)BookmarkManager.java	1.5 01/02/09
 *
 * Copyright (c) 1995-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.3
 *
 * Java Plug-in 
 *
 * @author Stanley Man-Kit Ho
 */

package sun.plugin.cachescheme;

import sun.plugin.usability.Trace;
import sun.plugin.usability.TraceFilter;


/**
 * HTMLGenerator is used for generating installed HTML page for applet 
 * installation.
 */ 
public class BookmarkManager 
{
    /**
     * Add bookmark.
     *
     * @param name Bookmark name
     * @param file File name
     */
    public void addBookmark(String name, String file)
    {
	Trace.println("Add bookmark \"" + name + "\" as " + file, TraceFilter.JAVA_CONSOLE_ONLY);

	nativeAddBookmark(name, file);
    }

    public void removeBookmark(String name, String file)
    {
	Trace.println("Remove bookmark \"" + name + "\" as " + file, TraceFilter.JAVA_CONSOLE_ONLY);
    }

    public static void removeAllBookmark()
    {
	Trace.println("Remove all bookmarks", TraceFilter.JAVA_CONSOLE_ONLY);
	nativeRemoveAllBookmark();
    }

    /**
     * Add bookmark in the native platform.
     *
     * @param name Bookmark name
     * @param file File name
     */
    private native void nativeAddBookmark(String name, String file);
    private static native void nativeRemoveAllBookmark();
}


