/*
 * @(#)JarCacheManager.java	1.3 01/02/09
 *
 * Copyright (c) 1995-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.3
 *
 * Java Plug-in 
 *
 * @author Devananda J. 
 */

package sun.plugin.cachescheme;

import java.util.*;
import sun.plugin.usability.Trace;

public class JarCacheManager{

    ArrayList handlers = null;

    public JarCacheManager()
    {
        handlers = new ArrayList();
	handlers.add(new PluginJarCacheHandler());
	handlers.add(new DefaultJarCacheHandler());
    }

    public JarCacheInterface selectHandler(String jarCacheOption)
			     throws InvalidCacheParameterException
    {
	Object obj=null;
	for (int i=0; i<handlers.size();i++) 
	{
	    obj = handlers.get(i);
	    if( ((JarCacheInterface)obj).isValidHandler(jarCacheOption) == true )
	    {
		return (JarCacheInterface)obj;	
	    }
	}

	throw new InvalidCacheParameterException("Unable to find handler to support \"" 
						 + jarCacheOption + "\" as \'cache_option\'");
    }
}




