/*
 * @(#)PluginJarCacheTable.java	1.3 01/02/09
 *
 * Copyright (c) 1995-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.3
 *
 * Java Plug-in 
 *
 * @author Devananda J. based on stanley's HTMLVersionTable.java
 */

package sun.plugin.cachescheme;
import java.io.File;

/* 
 * Version table for storing installed HTML page information.
 */
public class PluginJarCacheTable extends PluginCacheTable{
    PluginJarCacheTable()
    {
	super("jar", "cache.table");
    }

    static String getCacheHomeDir(){return jarCacheHome;}

    static String jarCacheHome = cacheHome + File.separator + "jar";

    /**
     * Add version information into version table file.
     * @param key -key
     * @param entry  -value
     */    
    public void add(String key, PluginJarCacheTableEntry entry)
    {
	m_cacheTable.put(key, entry.toString());
    }

     /**
     * Get version entry from version table.
     * @param key -key
     * @return entry for the key
     */    
    public PluginJarCacheTableEntry getEntry(String key)
				    throws CacheTableEntryException
    {
	String entry = super.getTableEntry(key);

	if(entry != null)
	    return new PluginJarCacheTableEntry(entry);
	else 
	    return null;
    }
}
  

