/*
 * @(#)ExtensionInstaller.java	1.7 01/02/09
 *
 * Copyright 1997-2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 *
 * @author Stanley Man-Kit Ho
 */

package sun.plugin.extension;

import java.io.IOException;
import java.util.jar.JarFile;
import sun.misc.ExtensionInstallationException;


/**
 * Interface that represents the Java standard extension installer.
 */
public interface ExtensionInstaller
{
    /**
     * Install extension to the destination directory.
     *
     * @param url URL of where the extension was downloaded from.
     * @param jarFileName Jar file that might contains the extensions.
     * @param destDir Destination directory to install the extension.
     * @param true if extension is installed successfully.
     */
    public boolean install(String url, String jarFileName, String destDir)
		    throws ExtensionInstallationException, 
			   IOException, InterruptedException;
}
