/*
 * @(#)JSContext.java	1.11 98/05/18
 *
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1_beta
 *
 * Java Plug-in 1.2
 *
 * @author Stanley Man-Kit Ho
 */

package sun.plugin.javascript;

/** 
 * <p> JSContext is an interface that the AppletContext object must implement 
 * in order to support netscape.javascript.JSObject in Java Plug-in. The idea 
 * is that netscape.javascript.JSObject.getWindow is called to obtain a 
 * JSObject which represents the Window object in the document object model.
 * Since the AppletContext is provided by the Java Plug-in, it also contains 
 * information about the corresponding native instance handle info. 
 * The implementor of this interface is therefore required to return the right
 * implementation of the JSObject for the current browser
 * </p>
 */
public interface JSContext {

    /** 
     * <p> Return the JSObject implementation for this applet window
     * </p>
     *
     * @param JSObject implementation
     */
    netscape.javascript.JSObject getJSObject();
}
