/*
 * @(#)History.java	1.11 98/05/19
 *
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1_beta
 *
 * Java Plug-in 1.2
 *
 * @author Stanley Man-Kit Ho
 */


package sun.plugin.javascript.navig;

import java.util.Hashtable;
import netscape.javascript.JSObject;
import netscape.javascript.JSException;



/** 
 * <p> Emulate the History object in the JavaScript Document Object Model.
 * </p>
 */
class History extends sun.plugin.javascript.navig.JSObject {

   /**
    * <p> Method table contains all method info in the History object. </p>
    */
   private static Hashtable methodTable = new Hashtable();

   /**
    * <p> Field table contains all properties info in the History object. </p>
    */
   private static Hashtable fieldTable = new Hashtable();

   static {

	// Initialize all method and field info in the History object.
	//
	methodTable.put("back",	    new Boolean(false));
	methodTable.put("forward",  new Boolean(false));
	methodTable.put("go",	    new Boolean(false));
	methodTable.put("toString", new Boolean(true));

	fieldTable.put("current",	new Boolean(false));
	fieldTable.put("length",	new Boolean(false));
	fieldTable.put("next",		new Boolean(false));
	fieldTable.put("previous",	new Boolean(false));
    }

    
    /**
     * <p> Construct a new History object. 
     * </p>
     * 
     * @param instance Native plugin instance.
     * @param context Evaluation context.
     */
    History(int instance, String context)  {
	super(instance, context);
	addObjectTable(fieldTable, methodTable);
    }
}
