/*
 * @(#)Image.java	1.11 98/05/19
 *
 * Copyright (c) 1995-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1_beta
 *
 * Java Plug-in 1.2
 *
 * @author Stanley Man-Kit Ho
 */

package sun.plugin.javascript.navig;

import java.util.Hashtable;
import netscape.javascript.JSObject;
import netscape.javascript.JSException;



/** 
 * <p> Emulate the Image object in the JavaScript Document Object Model.
 * </p>
 */
public class Image extends sun.plugin.javascript.navig.JSObject {

    /**
     * <p> Field table contains all properties info in the Image object. </p>
     */
    private static Hashtable fieldTable = new Hashtable();

    static {

	// Initialize all method and field info in the Image object.
	//
	fieldTable.put("border",   new Boolean(false));
	fieldTable.put("complete", new Boolean(false));
	fieldTable.put("height",   new Boolean(false));
	fieldTable.put("hspace",   new Boolean(false));
	fieldTable.put("lowsrc",   new Boolean(true));
	fieldTable.put("name",     new Boolean(false));
	fieldTable.put("src",	   new Boolean(true));
	fieldTable.put("vspace",   new Boolean(false));
	fieldTable.put("width",	   new Boolean(false));
    }

    
    /**
     * <p> Construct a new Image object. 
     * </p>
     * 
     * @param instance Native plugin instance.
     */
    protected Image(int instance, String context) {
	super(instance, context);
	addObjectTable(fieldTable, null);
    }
}
