/*
 * @(#)Option.java	1.11 98/05/20
 *
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1_beta
 *
 * Java Plug-in 1.2
 *
 * @author Stanley Man-Kit Ho
 */

package sun.plugin.javascript.navig;

import java.util.Hashtable;
import netscape.javascript.JSObject;
import netscape.javascript.JSException;



/** 
 * <p> Emulate the Option object in the JavaScript Document Object Model.
 * </p>
 */
class Option extends sun.plugin.javascript.navig.JSObject {

    /**
     * <p> Field table contains all properties info in the Option object. </p>
     */
    private static Hashtable fieldTable = new Hashtable();

    static {

	// Initialize all field info in the Option object.
	//
	fieldTable.put("defaultSelected", new Boolean(false));
	fieldTable.put("index",		  new Boolean(false));
	fieldTable.put("selected",	  new Boolean(true));
	fieldTable.put("text",		  new Boolean(true));
	fieldTable.put("value",		  new Boolean(true));
    }

    
    /**
     * <p> Construct a new Option object. 
     * </p>
     * 
     * @param instance Native plugin instance.
     * @param context Evaluation context.
     */
    Option(int instance, String context) {
	super(instance, context);
	addObjectTable(fieldTable, null);
    }
}
