/*
 * @(#)URL.java	1.11 98/05/19
 *
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1_beta
 *
 * Java Plug-in 1.2
 *
 * @author Stanley Man-Kit Ho
 */


package sun.plugin.javascript.navig;

import java.util.Hashtable;
import netscape.javascript.JSObject;
import netscape.javascript.JSException;


/** 
 * <p> Emulate the URL object in the JavaScript Document Object Model.
 * </p>
 */
class URL extends sun.plugin.javascript.navig.JSObject {

    private static Hashtable fieldTable = new Hashtable();

   /**
    * <p> Field table contains all properties info in the URL object. </p>
    */
    
    static {
	fieldTable.put("hash",	    new Boolean(true));
	fieldTable.put("host",	    new Boolean(true));
	fieldTable.put("hostname",  new Boolean(true));
	fieldTable.put("href",	    new Boolean(true));
	fieldTable.put("pathname",  new Boolean(true));
	fieldTable.put("port",	    new Boolean(true));
	fieldTable.put("protocol",  new Boolean(true));
	fieldTable.put("search",    new Boolean(true));
    }


    /**
     * <p> Construct a new URL object. 
     * </p>
     * 
     * @param instance Native plugin instance.
     * @param context Evaluation context.
     */
    URL(int instance, String context) {
	super(instance, context);
	addObjectTable(fieldTable, null);
    }
}
