/*
 * @(#)JavaScriptPermission.java	1.00 98/09/22
 *
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1 
 *
 */

package sun.plugin.liveconnect;

import java.security.BasicPermission;

/**
 * <P> JavaScriptPermission is for encapsulating a JavaScript 
 * permission which is passed through LiveConnect.
 * </P>
 *
 * @version 	1.1 
 * @author	Stanley Man-Kit Ho
 */


public final class JavaScriptPermission extends BasicPermission {

    /**
     * Creates a new JavaScriptPermission with the specified name.
     * The name is the symbolic name of the JavaScriptPermission. An asterisk
     * may appear at the end of the name, following a ".", or by itself, to
     * signify a wildcard match.
     *
     * @param name the name of the JavaScriptPermission
     */

    public JavaScriptPermission(String name)
    {
	super(name);
    }

    /**
     * Creates a new JavaScriptPermission object with the specified name.
     * The name is the symbolic name of the JavaScriptPermission, and the
     * actions String is currently unused and should be null.  This
     * constructor exists for use by the <code>Policy</code> object
     * to instantiate new Permission objects.
     *
     * @param name the name of the JavaScriptPermission
     * @param actions should be null.
     */

    public JavaScriptPermission(String name, String actions)
    {
	super(name, actions);
    }
}
