/*
 * @(#)MotifAppletContext.java	1.12 98/06/03
 * 
 * Copyright 1998 Sun Microsystems, Inc. 901 San Antonio Road, 
 * Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * CopyrightVersion 1.2
 * 
 */


package sun.plugin.navig.motif;

/*
 * AppletContext for Applets running within the UNix plugin version
 * of the javaplugin.
 *
 * @version 	1.1
 * @author	Graham Hamilton
 */

import sun.plugin.ActivatorAppletContext;
import java.net.URL;
import sun.plugin.javascript.JSContext;
public class MotifAppletContext extends ActivatorAppletContext implements
JSContext {

    private int pluginIndex;

    MotifAppletContext(int pluginIndex) {
	this.pluginIndex = pluginIndex;
    }

    /**
     * Replaces the Web page currently being viewed with the given URL. 
     */
    public void showDocument(URL url) {
	showDocument(url, "_top");
    }

    /**
     * Requests that the browser or applet viewer show a Web page 
     */
    public void showDocument(URL url, String target) {
	// Tell our parent plugin to redirect navigator to this page.
	Worker.showDocument(pluginIndex, url, target);
    }

    /**
     * Show a status message
     */
    public void showStatus(String status) {
	Worker.showStatus(pluginIndex, status);
    }

    void setMayScript(boolean mayScript) {
	this.mayScript=mayScript;
    }

    private boolean mayScript = false;

    /* Determine the right implementation of the JS object given the
     * browser version. Version 5+ will have proper OJI support.
     * Version 4 allows JS evals. Versions below 4 don't allow for much
     */
    public netscape.javascript.JSObject getJSObject() {
        int version = Plugin.getNavigVersion();
	if (mayScript) {
	    if (version > 4) {
	      return new sun.plugin.javascript.navig5.JSObject(pluginIndex);
	    } else if (version < 4) {
		return new sun.plugin.javascript.navig.Window(pluginIndex);
	    } else {
		return new sun.plugin.javascript.navig4.Window(pluginIndex);
	    }
	} else {
	    return null;
	}
    }
}



