/*
 * @(#)SecureInvocation.java	1.00 98/09/22
 *
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1 
 *
 */

package sun.plugin.navig.motif;

/**
 * <P> SecurityContextHelper is for evaluating whether an AccessControlContext
 * implies a particular LiveConnect permission.
 * </P>
 *
 * @version 	1.1 
 * @author	Stanley Man-Kit Ho
 */


public class SecureJNITester {
 
    public boolean 		m_i_boolean = true;
    public Boolean 		m_i_Boolean = new Boolean(true);
    public byte		m_i_byte = 10;
    public Byte		m_i_Byte = new Byte((byte)20);
    public char		m_i_char = 'f';
    public Character		m_i_Character = new Character('w');
    public short		m_i_short = 68;
    public Short		m_i_Short = new Short((short)101);
    public int			m_i_int = 999;
    public Integer		m_i_Integer = new Integer(1056);
    public Integer		m_i_Integer2 = new Integer(1057);
    public long		m_i_long = 1000001;
    public Long		m_i_Long = new Long(4000005);
    public float		m_i_float = (float) 8.23423;
    public Float		m_i_Float = new Float((float) 56.29873);
    public double		m_i_double = 3452.234234232;
    public Double		m_i_Double = new Double(6432.34507897);
    public String		m_i_String = "Hello";

    public static boolean	m_s_boolean = false;
    public static Boolean	m_s_Boolean = new Boolean(true);
    public static byte		m_s_byte = -10;
    public static Byte		m_s_Byte = new Byte((byte)-20);
    public static char		m_s_char = 't';
    public static Character	m_s_Character = new Character('q');
    public static short	m_s_short = -68;
    public static Short	m_s_Short = new Short((short)-101);
    public static int		m_s_int = -999;
    public static Integer	m_s_Integer = new Integer(-1056);
    public static long		m_s_long = -1000001L;
    public static Long		m_s_Long = new Long(-4000005);
    public static float	m_s_float = (float) -8.23423;
    public static Float	m_s_Float = new Float((float) -56.29873);
    public static double	m_s_double = -3452.234234232;
    public static Double	m_s_Double = new Double(-6432.34507897);
    public static String	m_s_String = "olleH";

    public SecureJNITester() {
    	System.err.println(" Creating a new SecureJNITester. \n");
    	// m_i_Boolean = new Boolean(true);
	i_print();
    }

    public void i_print(String msg) {
	System.out.println("i_print message " + msg);
	i_print();
    }

    public void i_print()
    {
	System.out.println("Result: ");
	System.out.println("===============================================");
	System.out.println("m_i_boolean = "	+ m_i_boolean);
	System.out.println("m_i_Boolean = "	+ m_i_Boolean);
	System.out.println("m_i_byte = "	+ m_i_byte);
	System.out.println("m_i_Byte = "	+ m_i_Byte);
	System.out.println("m_i_char = "	+ m_i_char);
	System.out.println("m_i_Character = "	+ m_i_Character);
	System.out.println("m_i_short =	"	+ m_i_short);
	System.out.println("m_i_Short = "	+ m_i_Short);
	System.out.println("m_i_int = "		+ m_i_int);
	System.out.println("m_i_Integer = "	+ m_i_Integer);
	System.out.println("m_i_long = "	+ m_i_long);
	System.out.println("m_i_Long = "	+ m_i_Long);
	System.out.println("m_i_float = "	+ m_i_float);
	System.out.println("m_i_Float = "	+ m_i_Float);
	System.out.println("m_i_double = "	+ m_i_double);
	System.out.println("m_i_Double = "	+ m_i_Double);
	System.out.println("m_i_String = "	+ m_i_String);
	System.out.println("-----------------------------------------------");
	System.out.println("m_s_boolean = "	+ m_s_boolean);
	System.out.println("m_s_Boolean = "	+ m_s_Boolean);
	System.out.println("m_s_byte = "	+ m_s_byte);
	System.out.println("m_s_Byte = "	+ m_s_Byte);
	System.out.println("m_s_char = "	+ m_s_char);
	System.out.println("m_s_Character = "	+ m_s_Character);
	System.out.println("m_s_short =	"	+ m_s_short);
	System.out.println("m_s_Short = "	+ m_s_Short);
	System.out.println("m_s_int = "		+ m_s_int);
	System.out.println("m_s_Integer = "	+ m_s_Integer);
	System.out.println("m_s_long = "	+ m_s_long);
	System.out.println("m_s_Long = "	+ m_s_Long);
	System.out.println("m_s_float = "	+ m_s_float);
	System.out.println("m_s_Float = "	+ m_s_Float);
	System.out.println("m_s_double = "	+ m_s_double);
	System.out.println("m_s_Double = "	+ m_s_Double);
	System.out.println("m_s_String = "	+ m_s_String);
	System.out.println("===============================================");
    }

    public static void s_print(String message) {
	System.out.println("Static Result:" + message);
	s_print();
    }

    public static void s_print()
    {
	System.out.println("===============================================");
	System.out.println("m_s_boolean = "	+ m_s_boolean);
	System.out.println("m_s_Boolean = "	+ m_s_Boolean);
	System.out.println("m_s_byte = "	+ m_s_byte);
	System.out.println("m_s_Byte = "	+ m_s_Byte);
	System.out.println("m_s_char = "	+ m_s_char);
	System.out.println("m_s_Character = "	+ m_s_Character);
	System.out.println("m_s_short =	"	+ m_s_short);
	System.out.println("m_s_Short = "	+ m_s_Short);
	System.out.println("m_s_int = "		+ m_s_int);
	System.out.println("m_s_Integer = "	+ m_s_Integer);
	System.out.println("m_s_long = "	+ m_s_long);
	System.out.println("m_s_Long = "	+ m_s_Long);
	System.out.println("m_s_float = "	+ m_s_float);
	System.out.println("m_s_Float = "	+ m_s_Float);
	System.out.println("m_s_double = "	+ m_s_double);
	System.out.println("m_s_Double = "	+ m_s_Double);
	System.out.println("m_s_String = "	+ m_s_String);
	System.out.println("===============================================");
    }

    public void i_call_1(boolean z, byte b, char c, short s, int i, long j, float f, double d)
    {
	m_i_boolean = z;
	m_i_byte = b;
	m_i_char = c;
	m_i_short = s;
	m_i_int = i;
	m_i_long = j;
	m_i_float = f;
	m_i_double = d;

	i_print("i_call_1");
    }

    public void i_call_2(Boolean z, Byte b, Character c, Short s, Integer i, Long j, Float f, Double d, String str)
    {
	m_i_Boolean = z;
	m_i_Byte = b;
	m_i_Character = c;
	m_i_Short = s;
	m_i_Integer = i;
	m_i_Long = j;
	m_i_Float = f;
	m_i_Double = d;
	m_i_String = str;

	i_print("i_call_2");
    }

    public boolean i_get_boolean() { return m_i_boolean; }
    public byte    i_get_byte()    { return m_i_byte; }
    public char    i_get_char()    { return m_i_char; }
    public short   i_get_short()   { return m_i_short; }
    public int	    i_get_int()	    { return m_i_int; }
    public long    i_get_long()    { return m_i_long; }
    public float   i_get_float()   { return m_i_float; }
    public double  i_get_double()  { return m_i_double; }
    public String  i_get_String()  { return m_i_String; }

    public static void s_call_1(boolean z, byte b, char c, short s, int i, long j, float f, double d)
    {
	m_s_boolean = z;
	m_s_byte = b;
	m_s_char = c;
	m_s_short = s;
	m_s_int = i;
	m_s_long = j;
	m_s_float = f;
	m_s_double = d;

	s_print("s_call_1");
    }

    public static void s_call_2(Boolean z, Byte b, Character c, Short s, Integer i, Long j, Float f, Double d, String str)
    {
	m_s_Boolean = z;
	m_s_Byte = b;
	m_s_Character = c;
	m_s_Short = s;
	m_s_Integer = i;
	m_s_Long = j;
	m_s_Float = f;
	m_s_Double = d;
	m_s_String = str;

	s_print("s_call_2");
    }

    public static boolean s_get_boolean() { return m_s_boolean; }
    public static byte    s_get_byte()    { return m_s_byte; }
    public static char    s_get_char()    { return m_s_char; }
    public static short   s_get_short()   { return m_s_short; }
    public static int	   s_get_int()	    { return m_s_int; }
    public static long    s_get_long()    { return m_s_long; }
    public static float   s_get_float()   { return m_s_float; }
    public static double  s_get_double()  { return m_s_double; }
    public static String  s_get_String()  { return m_s_String; }

    public static void dummy() {
	System.err.println("Dummy output");
	sun.misc.MessageUtils.toStderr("DummyOutput\n");
    }
}
