/*
 * @(#)SynchronizedCounter.java	1.1 98/09/23
 * 
 * Copyright 1998 Sun Microsystems, Inc. 901 San Antonio Road, 
 * Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * CopyrightVersion 1.2
 * 
 * @author Benedict Gomes
 */

package sun.plugin.navig.motif;

// A trivial synchronized counter to prevent races in incrementing/decrementing
// an integer (necessary even if ++ and -- are atomic).
public class SynchronizedCounter {

    private int counter;
    
    SynchronizedCounter(int initialval) {
	counter = initialval;
    }

    public synchronized void increment() { 
	counter++; 
    }

    public synchronized void decrement() {
	counter--;
    }
	
    public synchronized int getValue() {
	return counter;
    }

}

