/*
 * @(#)ActiveXAppletContext.java	1.1 97/12/27
 *
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1
 *
 */

package sun.plugin.ocx;

/*
 * AppletContext for Applets running within the ActiveX version
 * of the javaplugin, All methods are implemented in the native layers
 *
 * @version 	1.1
 * @author	Jerome Dochez
 */

import sun.plugin.ActivatorAppletContext;
import sun.plugin.javascript.JSContext;
import java.net.URL;
import sun.plugin.javascript.ocx.JSObject;

public class ActiveXAppletContext extends ActivatorAppletContext
                           implements JSContext
{

    /*
     * <p>
     * Construct a new AppletViewer. This can be invoked from native
     * code only for security reasons
     * </p>
     * 
     * @param handle native ActiveX handle 
     *
     * @param parms is the delegate object responsible for retrieving the 
     * applet properties
     *
     */
    protected ActiveXAppletContext(int handle) {
	this.handle = handle;
    }

    /*
     * <p>
     * Allow/Disallow the usage of the document object model from this
     * Applet
     * </p>
     */
    public void setMayScriptFlag(boolean b) {
	mayScript = b;
    }

    /*
     * Pass to the native bridge implementation
     */
    public native void showDocument(URL url);

    /*
     * Pass to the native bridge implementation
     */
    public native void showDocument(URL url, String target);

    /**
     * Show status.
     */
    public native void showStatus(String status);

    /*
     * <p>
     * Notification of being closed, we have to release all JSObject 
     * that this particular applet has opened
     * </p>
     */
    public void onClose() {
	handle=0;
	if (exported==null)
	    return;
	for (java.util.Enumeration e= exported.elements();e.hasMoreElements();) {
	    Object o = e.nextElement();
	    if (o instanceof sun.plugin.javascript.ocx.JSObject)
		((sun.plugin.javascript.ocx.JSObject) o).cleanup();
	}
    }

    /*
     * <p>
     * Plublic acessor for the JSObject implementation
     * @return the JSObject implementation for the current browser
     * </p>
     */ 
    public netscape.javascript.JSObject getJSObject() {
	if (mayScript)
	    return nativeGetJSObject();
	else
	    return null;
    }

    /* 
     * <p>
     * JSContext implementation
     * @return the JSObject implementation for the current browser 
     * <p>
     */
    private native netscape.javascript.JSObject nativeGetJSObject();	

    /*
     * <p>
     * Add a JSObject to the list of exported JSObjects so it gets properly
     * released upon applet destruction
     * </p>
     * @param JSObject instance to add
     */
    public void addJSObjectToExportedList(netscape.javascript.JSObject jso) {
	if (exported==null) 
	    exported = new java.util.Vector();
        exported.addElement(jso);
    }

    /*
     * <p>
     * Native object reference
     * </p>
     */
    private int handle;

    /*
     * <p>
     * List of exported JSObject to be finalized upon closing the applet
     * </p>
     */
    private java.util.Vector exported;

    /*
     * <p>
     * true if this applet is authorized to use the document object model
     * </p>
     */
    private boolean mayScript = false;
}
