/*
 * @(#)ActiveXBeansViewer.java	1.6 00/04/21
 *
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1 
 *
 */

package sun.plugin.ocx;

/*
 * A recipient to show a JavaBeans component in.
 * This class implements all platform dependent code to show an JavaBeans
 * running in the Activator for Internet Explorer 3 and 4.
 *
 * @version 	1.1 
 * @author	Jerome Dochez
 */

import sun.plugin.*;
import sun.applet.*;
import java.awt.*;
import java.io.*;
import java.applet.Applet;
import java.beans.Beans;
import java.util.Hashtable;

public class ActiveXBeansViewer extends ActiveXAppletViewer {

    /*
     * <p>
     * Construct a new ActiveXBeansViewer. This can be invoked from native
     * code only for security reasons
     * </p>
     *
     * @param handle native ActiveX handle
     *
     */
    private ActiveXBeansViewer(Hashtable attr, int handle){
        super(attr, new ActiveXBeansContext(handle), handle);
    }

    protected Applet createApplet(AppletClassLoader loader) throws ClassNotFoundException,
    IllegalAccessException, IOException, InstantiationException, InterruptedException {
	return BeansViewer.createJavaBeanComponent(this, loader);
    }

    /*
     * <p>
     * @return the java component displayed by this viewer class
     * </p>
     */
    protected String getHandledType() {
	return "JavaBeans";
    }

    /* 
     * <p>
     * @return true if the bridge can safely bridge events to the 
     * ActiveX world
     * </p>
     */
    public boolean bridgeEvents() {
	// we always return true...
	return true;
    }
}

