/*
 * @(#)ProxyInfo.java	1.2 98/08/20
 *
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.2
 *
 * Java Plug-in
 *
 * @author Jerome Dochez
 */


package sun.plugin.protocol;

/*
 * This class holds a reference to the default proxy handler.
 */
public class PluginProxyHandler {

    // The current default proxy handler
    private static ProxyHandler handler; 

    /*
     * <p>
     * @return the default proxy handler installed
     * </p>
     *
     */
    public static ProxyHandler getDefaultProxyHandler() {
	return handler;
    }

    /**
     * <p>
     * Set the default proxy handler reference
     * <p>
     * 
     * @paran newDefault new default proxy handler
     */
    public static void setDefaultProxyHandler(ProxyHandler newDefault) {
	handler = newDefault;
    }
}
