/*
 * @(#)Handler.java	1.10 96/11/23
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 *
 * Java Plug-in
 *
 * @author Jerome Dochez
 * @author Stanley Man-Kit Ho
 */

package sun.plugin.protocol.jdk12.gopher;

import java.net.URL;
import java.io.IOException;
import sun.plugin.protocol.jdk12.http.HttpURLConnection;
import sun.plugin.protocol.*;

/**
 * A class to handle the gopher protocol.
 */

public class Handler extends sun.net.www.protocol.gopher.Handler {

    public java.net.URLConnection openConnection(URL u) throws IOException {
	/* if set for proxy usage then go through the gopher code to get
	 * the url connection.
         */
	ProxyHandler handler = PluginProxyHandler.getDefaultProxyHandler();
        ProxyInfo pinfo = null;

        if (handler != null)
           pinfo = handler.getProxyInfo(u);

	try  {
	    if (pinfo != null && pinfo.isProxyUsed())
	    {
		return new sun.plugin.protocol.jdk12.http.HttpURLConnection(u, pinfo.getProxy(), pinfo.getPort());
	    }
	    else 
	    {
  		/* make a direct gopher connection */
		return super.openConnection(u);
	    }
        } catch(IOException e)  {
	    return super.openConnection(u);
	}
    }
}


