/*
 * @(#)BrowserHttpsURLConnection.java	1.8 97/12/10
 * 
 * Copyright (c) 1996-1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.0
 */

package sun.plugin.protocol.jdk12.https;

import java.net.*;
import java.io.IOException;
import java.security.Permission;
import java.net.SocketPermission;
import sun.plugin.protocol.*;


/**
 * HTTPS URL connection support.  These URL connection classes are
 * not always made public, but this one needs to be public in order
 * to expose SSL-related information which must needs to be presented
 * to users.
 *
 * @author Stanley Man-Kit Ho
 */
public
class BrowserHttpsURLConnection extends sun.plugin.protocol.https.BrowserHttpsURLConnection
{
    public Permission getPermission() throws IOException {
	int port = url.getPort();
	port = port < 0 ? 80 : port;
	String host = url.getHost() + ":" + port;
	Permission permission = new SocketPermission(host, "connect");
	return permission;
    }

    /*
     * Initialize an HTTPS URLConnection ... could check that the URL
     * is an "https" URL, and that the handler is also an HTTPS one,
     * but that's established by other code in this package.
     */
    public BrowserHttpsURLConnection (URL url) throws IOException {
	super (url);
    }
}
