/*
 * @(#)JavaScriptURLConnection.java	1.1 00/08/26
 *
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.3 
 *
 */

package sun.plugin.protocol.jdk12.javascript;

import java.io.IOException;
import java.net.URL;
import java.net.ProtocolException;
import java.net.InetAddress;
import java.net.UnknownHostException;
import sun.plugin.usability.Trace;
import sun.plugin.usability.TraceFilter;


/**
 * A class to represent an JavaScript connection.
 *
 * @author  Stanley Man-Kit Ho
 */

public class JavaScriptURLConnection extends java.net.URLConnection
{
    URL url = null;

    /**
     * Construct a JavaScriptURLConnection object.
     */
    public JavaScriptURLConnection(URL u) throws IOException 
    {
	super(u);
	url = u;
    }


    public void connect() throws IOException 
    {
	// Cannot connect to a JavaScript
	throw new IOException("Cannot connect to " + url);
    }
}


