/*
 * @(#)Activator.java	1.31 01/02/09 Sun Microsystems
 *
 * Copyright (c) 1998-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.3 
 *
 */

package sun.plugin.resources;

import java.util.ListResourceBundle;

/**
 * US English verison of Activator strings.
 *
 * @author Graham Hamilton
 */

public class Activator extends ListResourceBundle {

    public Object[][] getContents() {
	return contents;
    }

    static final Object[][] contents = {
	{ "welcome_message", "Java(TM) Plug-in Control Panel" }, 
	{ "product_name", "Java(TM) Plug-in" },
	{ "version", "Version" },
	{ "default_vm_version", "Default Virtual Machine Version " },
	{ "using_jre_version", "Using JRE version" },
	{ "user_home_dir", "User home directory" },
	{ "user_overriden_browser", "User has overriden browser's proxy settings." },
	{ "proxy_configuration", "Proxy Configuration: " },
	{ "browser_config", "Browser Proxy Configuration" },
	{ "auto_config", "Automatic Proxy Configuration" },
	{ "manual_config", "Manual Configuration" },
	{ "no_proxy", "No proxy" },
	{ "proxy_is", "Proxy: " },
	{ "proxy_override_is", "Proxy Overrides: " },
	{ "loading", "Loading " },
	{ "java_applet", "Java Applet" },
	{ "java_bean", "JavaBeans" },
	{ "java_not_enabled", "Java is not enabled" },
    { "java_cache_enabled", "JAR cache enabled." },
    { "java_cache_disabled", "JAR cache disabled." },
	{ "opening_url", "Opening " },
	{ "no_proxy", "no proxy" },
	{ "proxy_equals", "proxy=" },
	{ "bean_code_and_ser", "Bean cannot have both CODE and JAVA_OBJECT defined " },
	{ "proxy_defaulted_direct", "Proxy is defaulted to DIRECT." },
	{ "status", "" },
	{ "status_applet", "Applet " },
	{ "status_bean", "JavaBeans " },
	{ "status_exception", "Exception: " },
	{ "jsobject_method", "Method "},
	{ "not_found", " not found"},
	{ "jsobject_getslot", "getSlot method not supported by this object"},
	{ "jsobject_setslot", "setSlot method not supported by this object"},
	{ "ok.label", "Ok" },
	{ "protocol_handler_error", "Error while installing the protocol handlers, some protocols may not be available" },

	// Resources associated with SecurityManager print Dialog:
	{ "print.title", "Warning" },
	{ "print.message", new String[]{
		"An applet would like to print.",
		"Is this OK?"}},
	{ "print.yes", "Yes" },
	{ "print.no", "No" },

	{ "security_dialog.caption", "Java Plug-in Security Warning" },
	{ "security_dialog.text0", "Do you want to install and run signed applet distributed by \n" },
	{ "security_dialog.text1", "\n\nPublisher authenticity verified by " },
	{ "security_dialog.text2", "\n\nCaution: " },
	{ "security_dialog.text3", " asserts that this content is\nsafe. You should only install/view this content if you trust\n" },
	{ "security_dialog.text4", " to make that assertion.\n\n" },
	{ "security_dialog.buttonAlways", "Grant always" },
	{ "security_dialog.buttonYes", "Grant this session" },
	{ "security_dialog.buttonNo", "Deny" },
	{ "security_dialog.buttonInfo", "More Info" },	

	{ "cert_dialog.caption", "Certificate Properties" },
	{ "cert_dialog.field.Version", "Version" },
	{ "cert_dialog.field.SerialNumber", "Serial Number" },
	{ "cert_dialog.field.SignatureAlg", "Signature Algorithm" },
	{ "cert_dialog.field.Issuer", "Issuer" },
	{ "cert_dialog.field.EffectiveDate", "Effective Date" },
	{ "cert_dialog.field.ExpirationDate", "Expiration Date" },
	{ "cert_dialog.field.Subject", "Subject" },
	{ "cert_dialog.field.Signature", "Signature" },

	{ "cert_dialog.field", "Field" },
	{ "cert_dialog.value", "Value" },

	{ "cert_dialog.issuerButton", "Issuer" },
	{ "cert_dialog.okButton",  "Ok" },
	{ "net.authenticate.title", "Enter Network Password"},
	{ "net.authenticate.label", "Please type your username and password."},
	{ "net.authenticate.resource", "Resource:" },
	{ "net.authenticate.username", "User name:" },
	{ "net.authenticate.password", "Password:" },
	{ "net.authenticate.firewall", "Firewall:" },
	{ "net.authenticate.realm", "Realm:" },
	{ "net.authenticate.scheme", "Scheme:" },


    { "console.clear", "Clear" },
    { "console.close", "Close" },
    { "console.copy", "Copy" },

	{ "html.wrong_param", "Unable to determine all the necessary HTML parameters - abort HTML installation.\n" },
	{ "html.cache_error", "Unable to access version table of HTML cache - abort HTML installation.\n" },
	{ "html.general_error", "Unable to finish HTML installation.\n" },
	{ "html.caption", "Java Plug-in HTML Installation Warning" },
	{ "html.prompt_user", "This applet requests to install the HTML page in your local machine,"
			      + " and create a shortcut on your desktop. Do you want to continue?"},

	{ "optpkg.cert_expired", "The certificate is expired - abort optional package installation.\n" },
	{ "optpkg.cert_notyieldvalid", "The certificate is not yet valid - abort optional package installation.\n" },
	{ "optpkg.cert_notverify", "Unable to verify the certificate - abort optional package installation.\n" },
	{ "optpkg.general_error", "Unable to install optional package.\n" },
	{ "optpkg.caption", "Java Plug-in Optional Package Installation Warning" },
	{ "optpkg.wait_for_installer", "Please click OK to continue applet loading after optional package installer has exited." },
	{ "optpkg.launch_installer", "Launching Optional Package Installer"},
	{ "optpkg.prompt_user.new_spec.text0", "The applet requires a newer version (specification "},
	{ "optpkg.prompt_user.new_spec.text1", ") of optional package \""},
	{ "optpkg.prompt_user.new_impl.text0", "The applet requires a newer version (implementation "},
	{ "optpkg.prompt_user.new_impl.text1", ") of optional package \""},
	{ "optpkg.prompt_user.new_vendor.text0", "The applet requires the ("},
	{ "optpkg.prompt_user.new_vendor.text1", ") of optional package \""},
	{ "optpkg.prompt_user.default.text", "The applet requires the installation of optional package \""},
	{ "optpkg.prompt_user.end", "\"\nfrom "},

	{ "rsa.cert_expired", "The certificate is expired - code will be treated as unsigned.\n" },
	{ "rsa.cert_notyieldvalid", "The certificate is not yet valid - code will be treated as unsigned.\n" },
	{ "rsa.general_error", "Unable to verify the certificate - code will be treated as unsigned.\n" },
	{ "rsa.cert_expired_prompt_user", "The certificate is expired. Do you want to ignore this warning and proceed?\n" },
	{ "rsa.cert_notyieldvalid_prompt_user", "The certificate is not yet valid. Do you want to ignore this warning and proceed?\n" },

	{ "usability.confirmDialogTitle", "Java Plug-in Confirmation Dialog" },
	{ "usability.inputDialogTitle", "Java Plug-in Input Dialog" },
	{ "usability.messageDialogTitle", "Java Plug-in Message Dialog" },
	{ "usability.exceptionDialogTitle", "Java Plug-in Exception Dialog" },
	{ "usability.optionDialogTitle", "Java Plug-in Option Dialog" },
	{ "usability.aboutDialogTitle", "About Java Plug-in" },
	{ "usability.confirm.yes", "Yes" },
	{ "usability.confirm.no", "No" },

	{ "usability.general_error", "General Exception.\n" },
	{ "usability.net_error", "Networking Exception.\n" },
	{ "usability.security_error", "Security Exception.\n" },
	{ "usability.ext_error", "Optional Package Installation Exception.\n" },

	{ "usability.menu.show_console", "Show Java Console" },
	{ "usability.menu.hide_console", "Hide Java Console" },
	{ "usability.menu.about", "About Java Plug-in" },
	{ "usability.menu.copy", "Copy" },

	{ "proxy.auto_config.download_error", "Unable to download auto proxy configuration file - fallback.\n" },
	{ "proxy.error_caption", "Proxy Configuration Error" },
	{ "proxy.prefsfile.nsreg_error", "Unable to obtain proxy configuration settings - fallback\n" },

	{ "applet_install.wrong_param", "Invalid applet parameters - abort Applet installation.\n" },
	{ "applet_install.mutex_error", "Unable to obtain locks on cache table - abort Applet installation.\n" },
	{ "applet_install.io_error", "I/O Exception - abort Applet installation.\n" },
	{ "applet_install.jar_cache_error", "Applet Installation Exception.\n" },
	{ "applet_install.general_error", "Unable to finish Applet installation.\n" },
	{ "applet_install.caption", "Java Plug-in Applet Installation Warning" },
    };
}

  
