/* 
 *  @(#)ControlPanel.java	1.27 01/02/09
 *
 *  Copyright (c) 1998-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.3 
 *
 */

package sun.plugin.resources;

import java.util.ListResourceBundle;

/**
 * US English verison of ControlPanel strings.
 *
 * @author Graham Hamilton
 */

public class ControlPanel extends ListResourceBundle {

    public Object[][] getContents() {
	return contents;
    }

    static final Object[][] contents = {
	{ "advanced.jre_format", "JRE {0} in {1}" },
	{ "advanced.jdk_format", "JDK {0} in {1}" },
	{ "panel.about", "About" }, 
	{ "panel.basic", "Basic" },
	{ "panel.advanced", "Advanced" },
	{ "panel.proxies", "Proxies" },
	{ "panel.cert", "Certificates" },
	{ "panel.apply", "Apply" },
	{ "panel.cancel", "Reset" },
	{ "panel.apply_failed", "Failed to write property file" },
	{ "panel.apply_failed_title", "Apply Failed" },

	{ "basic.enable_java", "Enable Java Plug-in" },
	{ "basic.show_console", "Show Java Console" },
	{ "basic.cache_jars", "Cache JARs in memory" },
	{ "basic.java_parms", "Java Runtime Parameters" },
	{ "basic.show_exception", "Show Exception Dialog Box" },
	{ "basic.recycle_classloader", "Recycle Classloader" },

	{ "advanced.jre_name", "Java Runtime Environment" },
	{ "advanced.path", "Path :" },
	{ "advanced.enable_jit", "Enable Just In Time Compiler" },
	{ "advanced.jit_path", "JIT path" },
	{ "advanced.enable_debug", "Enable Debug" },
	{ "advanced.debug_settings", "Debug Settings" },
	{ "advanced.debug_port", "Connection Address :" },
	{ "advanced.other_jdk", "Other..." },
	{ "advanced.default_jdk", "Use Java Plug-in Default" },
	{ "advanced.jre_selection_warning.info", "Selecting a Java Runtime other than \"Default\" is not recommended."},

	{ "proxy.use_browser", "Use browser settings" },
	{ "proxy.proxy_settings", "Proxy Settings" },
	{ "proxy.protocol_type", "Type" },
	{ "proxy.proxy_address", "Proxy Address" },
	{ "proxy.proxy_port", "Port" },
	{ "proxy.http", "HTTP" },
	{ "proxy.ftp", "FTP" },
	{ "proxy.gopher", "Gopher" },
	{ "proxy.https", "Secure" },
	{ "proxy.socks", "Socks" },
	{ "proxy.same_for_all_protocols", "Same proxy server for all protocols" },

	{ "cert.netscape_object_signing", "Netscape Object Signing Certificates" },
	{ "cert.description", "The following certificates are trusted by Java Plug-in:"},
	{ "cert.remove_button", "Remove" },

	{ "main.control_panel_title", "Java(TM) Plug-in Properties" },
	{ "main.control_panel_caption", "Java(TM) Plug-in Control Panel" },

	// Each line in the property_file_header must start with "#"
	{ "config.property_file_header", "# Java(TM) Plug-in Properties\n"
			+ "# DO NOT EDIT THIS FILE.  It is machine generated.\n"
			+ "# Use the Activator Control Panel to edit properties." },

	{ "panel.cache", "Cache" },
	{ "cache.html_cache", "HTML Cache" },
	{ "cache.jar_cache", " JAR Cache" },
	//{ "cache.html_cache_details", 
	//"HTML pages are stored in a special folder in order to run the applets offline" },
	//{ "cache.jar_cache_details", 
	//"Jar files are stored in a special folder in order to avoid reload" },
	{ "cache.clear_html_cache", "Clear HTML Cache" },
	{ "cache.clear_jar_cache", "Clear JAR Cache" },
	{ "cache.clear_html_cache_from", "Cleared HTML Cache from " },
	{ "cache.clear_jar_cache_from", "Cleared JAR Cache from " },
	{ "cache.caption", "Clear cache" },

    };
}

