/*
 * @(#)ControlPanel_zh_CN.java	1.18 01/03/08
 *
 *  Copyright (c) 1998-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.3 
 *
 */

package sun.plugin.resources;

import java.util.ListResourceBundle;

/**
 * Simplified Chinese version of ControlPanel strings.
 * from
 * US English version of ControlPanel strings.
 *
 * @author Graham Hamilton
 */

public class ControlPanel_zh_CN extends ListResourceBundle {

    public Object[][] getContents() {
	return contents;
    }

    static final Object[][] contents = {
	{ "advanced.jre_format", "JRE {0} \u5728 {1} \u4e2d" },
	{ "advanced.jdk_format", "JDK {0} \u5728 {1} \u4e2d" },
	{ "panel.about", "\u5173\u4e8e" },
	{ "panel.basic", "\u57fa\u672c" },
	{ "panel.advanced", "\u9ad8\u7ea7" },
	{ "panel.proxies", "\u4ee3\u7406" },
	{ "panel.cert", "\u8bc1\u4e66" },
	{ "panel.apply", "\u5e94\u7528" },
	{ "panel.cancel", "\u91cd\u8bbe" },
	{ "panel.apply_failed", "\u5199\u5c5e\u6027\u6587\u4ef6\u5931\u8d25" },
	{ "panel.apply_failed_title", "\u5e94\u7528\u5931\u8d25" },
	
	{ "basic.enable_java", "\u542f\u7528 Java Plug-in" },
	{ "basic.show_console", "\u663e\u793a Java Console" },
	{ "basic.cache_jars", "\u5c06 JAR \u9ad8\u901f\u7f13\u5b58\u4e8e\u5185\u5b58\u4e2d" },
	{ "basic.java_parms", "Java Runtime \u53c2\u6570" },
	{ "basic.show_exception", "\u663e\u793a\u5f02\u5e38\u5bf9\u8bdd\u6846" },
	{ "basic.recycle_classloader", "\u56de\u6536 Classloader" },
	
	{ "advanced.jre_name", "Java Runtime Environment" },
	{ "advanced.path", "\u8def\u5f84\uff1a" },
	{ "advanced.enable_jit", "\u542f\u7528\u201c\u9002\u65f6\u201d\u7f16\u8bd1\u5668" },
	{ "advanced.jit_path", "JIT \u8def\u5f84" },
	{ "advanced.enable_debug", "\u542f\u7528\u8c03\u8bd5" },
	{ "advanced.debug_settings", "\u8c03\u8bd5\u8bbe\u7f6e" },
	{ "advanced.debug_port", "\u8fde\u63a5\u5730\u5740:" },
	{ "advanced.debug_port", "\u8c03\u8bd5\u7aef\u53e3\uff1a" },
	{ "advanced.other_jdk", "\u5176\u5b83..." },
	{ "advanced.default_jdk", "\u4f7f\u7528 Java Plug-in \u9ed8\u8ba4" },
	{ "advanced.jre_selection_warning.info", "\u9009\u62e9\u9664\u4e0d\u53d7\u652f\u6301\u7684 \"Default\" \u5916\u7684 Java Runtime\u3002" },

	{ "proxy.use_browser", "\u4f7f\u7528\u6d4f\u89c8\u5668\u8bbe\u7f6e" },
	{ "proxy.proxy_settings", "\u4ee3\u7406\u8bbe\u7f6e" },
	{ "proxy.protocol_type", "\u7c7b\u578b" },
	{ "proxy.proxy_address", "\u4ee3\u7406\u5730\u5740" },
	{ "proxy.proxy_port", "\u7aef\u53e3" },
	{ "proxy.http", "HTTP" },
	{ "proxy.ftp", "FTP" },
	{ "proxy.gopher", "Gopher" },
	{ "proxy.https", "Secure" },
	{ "proxy.socks", "Socks" },
	{ "proxy.same_for_all_protocols", "\u6240\u6709\u534f\u8bae\u4f7f\u7528\u540c\u4e00\u4ee3\u7406\u670d\u52a1\u5668" },

	{ "cert.netscape_object_signing", "Netscape \u5bf9\u8c61\u7b7e\u7f72\u8bc1\u4e66" },
	{ "cert.description", "\u4ee5\u4e0b\u8bc1\u4e66\u88ab Java Plug-in \u8ba4\u53ef:"},
	{ "cert.remove_button", "\u5220\u9664" },

	{ "main.control_panel_title", "Java(TM) Plug-in \u5c5e\u6027" },
	{ "main.control_panel_caption", "Java(TM) Plug-in \u63a7\u5236\u9762\u677f" },

	// Each line in the property_file_header must start with "#"
	{ "config.property_file_header", "# Java(TM) Plug-in \u5c5e\u6027newline"
			+ "# \u4e0d\u8981\u7f16\u8f91\u672c\u6587\u4ef6\u3002\u8fd9\u662f\u7531\u673a\u5668\u751f\u6210\u7684\u3002newline"
			+ "# \u4f7f\u7528\u201c\u6fc0\u6d3b\u7a0b\u5e8f\u201d\u63a7\u5236\u9762\u677f\u6765\u7f16\u8f91\u5c5e\u6027\u3002" },

	
	{ "panel.cache", "\u9ad8\u901f\u7f13\u5b58" },
	{ "cache.html_cache", "HTML \u9ad8\u901f\u7f13\u5b58" },
	{ "cache.jar_cache", " JAR \u9ad8\u901f\u7f13\u5b58" },
	//{ "cache.html_cache_details", 
	//"HTML \u9875\u50a8\u5b58\u5728\u7279\u6b8a\u7684\u6587\u4ef6\u5939\uff0c\u4ee5\u4fbf applet \u5c0f\u7a0b\u5e8f\u8131\u7ebf\u8fd0\u884c" },
	//{ "cache.jar_cache_details", 
	//"Jar \u6587\u4ef6\u5b58\u5728\u7279\u6b8a\u7684\u6587\u4ef6\u5939\uff0c\u4ee5\u9632\u518d\u6b21\u52a0\u8f7d" },
	{ "cache.clear_html_cache", "\u6e05\u9664 HTML \u9ad8\u901f\u7f13\u5b58" },
	{ "cache.clear_jar_cache", "\u6e05\u9664 JAR \u9ad8\u901f\u7f13\u5b58" },
	{ "cache.clear_html_cache_from", "\u5df2\u6e05\u9664 HTML \u9ad8\u901f\u7f13\u5b58\u81ea " },
	{ "cache.clear_jar_cache_from", "\u5df2\u6e05\u9664 JAR \u9ad8\u901f\u7f13\u5b58\u81ea " },
	{ "cache.caption", "\u6e05\u9664\u9ad8\u901f\u7f13\u5b58" },
    };
}


	
	

