/*
 * @(#)ResourceHandler.java	1.1 00/07/29
 *
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1 
 *
 */

package sun.plugin.resources;

/*
 * A singleton object which deals with I18N resources handling.
 *
 * @version 	1.3
 * @author	Stanley Man-Kit Ho
 */

import java.util.*;


public class ResourceHandler
{
    // Localization strings.
    private static ResourceBundle rb;

    static
    {
	// Get our internationalization resources.  (Make sure this is
        // done before calling showConsoleWindow.)
        rb = ResourceBundle.getBundle("sun.plugin.resources.Activator");
    }


    /**
     * Method to get an internationalized string from the Activator resource.
     */
    public static String getMessage(String key) {
        try {
	    return rb.getString(key);
        } catch (java.util.MissingResourceException ex) {
	    return key;
	}
    }


    /**
     * Method to get an internationalized string from the Activator resource.
     */
    public static String[] getMessageArray(String key) {
        try {
	    return rb.getStringArray(key);
        } catch (java.util.MissingResourceException ex) {
	    return new String[] { key };
	}
    }
}



