/*
 * @(#)TraceFilter.java	1.1 00/07/29
 *
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 *
 * Java Plug-in 
 *
 * @author Stanley Man-Kit Ho
 */

package sun.plugin.usability;


/**
 * TraceFilter is an interface which contains all the possible trace
 * filters.
 */
public interface TraceFilter 
{
    /**
     * STATUS_BAR. Trace message can be output to browser's status bar.
     */
    public final int STATUS_BAR_ONLY = 0x0001;


    /**
     * JAVA_CONSOLE. Trace message can be output to Java Console.
     */
    public final int JAVA_CONSOLE_ONLY = 0x0002;


    /**
     * GRAY_BOX. Trace message can be output to applet's gray box.
     */
    public final int GRAY_BOX_ONLY = 0x0004;


    /**
     * DEFAULT. Trace message can be output to the default display.
     */
    public final int DEFAULT = JAVA_CONSOLE_ONLY | GRAY_BOX_ONLY;
}

