/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIBufferInputStream.idl
 */

#ifndef __gen_nsIBufferInputStream_h__
#define __gen_nsIBufferInputStream_h__

#include "nsISupports.h"
#include "nsIInputStream.h"
#include "nsIBaseStream.h"
#include "nsrootidl.h"
class nsIBuffer; /* forward decl */
/**
 * The signature of the writer function passed to ReadSegments. This
 * specifies where the data should go that gets read from the buffer.
 * Implementers should return the following:
 * @return NS_OK and writeCount - if successfully wrote something
 * @return NS_BASE_STREAM_CLOSED - if no more can be written
 * @return NS_BASE_STREAM_WOULD_BLOCK - if there is currently space to write (in
 *   a non-blocking mode)
 * @return <other-error> - on failure
 */
typedef NS_CALLBACK(nsWriteSegmentFun)(void* closure,
                                       const char* fromRawSegment,
                                       PRUint32 toOffset,
                                       PRUint32 count,
                                       PRUint32 *writeCount);

/* starting interface:    nsIBufferInputStream */

#define NS_IBUFFERINPUTSTREAM_IID_STR "93e9a230-1955-11d3-933b-000064657374"

#define NS_IBUFFERINPUTSTREAM_IID \
  {0x93e9a230, 0x1955, 0x11d3, \
    { 0x93, 0x3b, 0x00, 0x00, 0x64, 0x65, 0x73, 0x74 }}

class nsIBufferInputStream : public nsIInputStream {
 public: 
  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IBUFFERINPUTSTREAM_IID)

  /* readonly attribute nsIBuffer Buffer; */
  NS_IMETHOD GetBuffer(nsIBuffer * *aBuffer) = 0;

  /* [noscript] unsigned long ReadSegments (in nsWriteSegmentFun writer, in voidStar closure, in unsigned long count); */
  NS_IMETHOD ReadSegments(nsWriteSegmentFun writer, void * closure, PRUint32 count, PRUint32 *_retval) = 0;

  /* void Search (in string forString, in boolean ignoreCase, out boolean found, out unsigned long offsetSearchedTo); */
  NS_IMETHOD Search(const char *forString, PRBool ignoreCase, PRBool *found, PRUint32 *offsetSearchedTo) = 0;

  /* attribute boolean NonBlocking; */
  NS_IMETHOD GetNonBlocking(PRBool *aNonBlocking) = 0;
  NS_IMETHOD SetNonBlocking(PRBool aNonBlocking) = 0;
};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIBUFFERINPUTSTREAM \
  NS_IMETHOD GetBuffer(nsIBuffer * *aBuffer); \
  NS_IMETHOD ReadSegments(nsWriteSegmentFun writer, void * closure, PRUint32 count, PRUint32 *_retval); \
  NS_IMETHOD Search(const char *forString, PRBool ignoreCase, PRBool *found, PRUint32 *offsetSearchedTo); \
  NS_IMETHOD GetNonBlocking(PRBool *aNonBlocking); \
  NS_IMETHOD SetNonBlocking(PRBool aNonBlocking); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIBUFFERINPUTSTREAM(_to) \
  NS_IMETHOD GetBuffer(nsIBuffer * *aBuffer) { return _to ## GetBuffer(aBuffer); } \
  NS_IMETHOD ReadSegments(nsWriteSegmentFun writer, void * closure, PRUint32 count, PRUint32 *_retval) { return _to ## ReadSegments(writer, closure, count, _retval); } \
  NS_IMETHOD Search(const char *forString, PRBool ignoreCase, PRBool *found, PRUint32 *offsetSearchedTo) { return _to ## Search(forString, ignoreCase, found, offsetSearchedTo); } \
  NS_IMETHOD GetNonBlocking(PRBool *aNonBlocking) { return _to ## GetNonBlocking(aNonBlocking); } \
  NS_IMETHOD SetNonBlocking(PRBool aNonBlocking) { return _to ## SetNonBlocking(aNonBlocking); } 


#endif /* __gen_nsIBufferInputStream_h__ */
