/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIBufferOutputStream.idl
 */

#ifndef __gen_nsIBufferOutputStream_h__
#define __gen_nsIBufferOutputStream_h__

#include "nsISupports.h"
#include "nsIOutputStream.h"
#include "nsIInputStream.h"
#include "nsIBaseStream.h"
#include "nsrootidl.h"
class nsIBuffer; /* forward decl */
/**
 * The signature for the reader function passed to WriteSegment. This 
 * specifies where the data should come from that gets written into the buffer.
 * Implementers should return the following:
 * @return NS_OK and readCount > 0 - if successfully read something
 * @return NS_OK and readCount == 0 - if no more to read (EOF)
 * @return NS_BASE_STREAM_WOULD_BLOCK - if there is currently no data (in
 *   a non-blocking mode)
 * @return <other-error> - on failure
 */
typedef NS_CALLBACK(nsReadSegmentFun)(void* closure,
                                      char* toRawSegment,
                                      PRUint32 fromOffset,
                                      PRUint32 count,
                                      PRUint32 *readCount);

/* starting interface:    nsIBufferOutputStream */

#define NS_IBUFFEROUTPUTSTREAM_IID_STR "d2aaae66-1ab0-11d3-8ccd-0060b0fc14a3"

#define NS_IBUFFEROUTPUTSTREAM_IID \
  {0xd2aaae66, 0x1ab0, 0x11d3, \
    { 0x8c, 0xcd, 0x00, 0x60, 0xb0, 0xfc, 0x14, 0xa3 }}

class nsIBufferOutputStream : public nsIOutputStream {
 public: 
  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IBUFFEROUTPUTSTREAM_IID)

  /* readonly attribute nsIBuffer Buffer; */
  NS_IMETHOD GetBuffer(nsIBuffer * *aBuffer) = 0;

  /* [noscript] unsigned long WriteSegments (in nsReadSegmentFun reader, in voidStar closure, in unsigned long count); */
  NS_IMETHOD WriteSegments(nsReadSegmentFun reader, void * closure, PRUint32 count, PRUint32 *_retval) = 0;

  /* unsigned long WriteFrom (in nsIInputStream inStr, in unsigned long count); */
  NS_IMETHOD WriteFrom(nsIInputStream *inStr, PRUint32 count, PRUint32 *_retval) = 0;

  /* attribute boolean NonBlocking; */
  NS_IMETHOD GetNonBlocking(PRBool *aNonBlocking) = 0;
  NS_IMETHOD SetNonBlocking(PRBool aNonBlocking) = 0;
};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIBUFFEROUTPUTSTREAM \
  NS_IMETHOD GetBuffer(nsIBuffer * *aBuffer); \
  NS_IMETHOD WriteSegments(nsReadSegmentFun reader, void * closure, PRUint32 count, PRUint32 *_retval); \
  NS_IMETHOD WriteFrom(nsIInputStream *inStr, PRUint32 count, PRUint32 *_retval); \
  NS_IMETHOD GetNonBlocking(PRBool *aNonBlocking); \
  NS_IMETHOD SetNonBlocking(PRBool aNonBlocking); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIBUFFEROUTPUTSTREAM(_to) \
  NS_IMETHOD GetBuffer(nsIBuffer * *aBuffer) { return _to ## GetBuffer(aBuffer); } \
  NS_IMETHOD WriteSegments(nsReadSegmentFun reader, void * closure, PRUint32 count, PRUint32 *_retval) { return _to ## WriteSegments(reader, closure, count, _retval); } \
  NS_IMETHOD WriteFrom(nsIInputStream *inStr, PRUint32 count, PRUint32 *_retval) { return _to ## WriteFrom(inStr, count, _retval); } \
  NS_IMETHOD GetNonBlocking(PRBool *aNonBlocking) { return _to ## GetNonBlocking(aNonBlocking); } \
  NS_IMETHOD SetNonBlocking(PRBool aNonBlocking) { return _to ## SetNonBlocking(aNonBlocking); } 


#endif /* __gen_nsIBufferOutputStream_h__ */
