/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIScriptSecurityManager.idl
 */

#ifndef __gen_nsIScriptSecurityManager_h__
#define __gen_nsIScriptSecurityManager_h__

#include "nsISupports.h"
#include "nsIPrincipal.h"
#include "nsrootidl.h"
class nsIScriptContext; /* forward decl */
class nsIURI; /* forward decl */

/* starting interface:    nsIScriptSecurityManager */

#define NS_ISCRIPTSECURITYMANAGER_IID_STR "58df5780-8006-11d2-bd91-00805f8ae3f4"

#define NS_ISCRIPTSECURITYMANAGER_IID \
  {0x58df5780, 0x8006, 0x11d2, \
    { 0xbd, 0x91, 0x00, 0x80, 0x5f, 0x8a, 0xe3, 0xf4 }}

class nsIScriptSecurityManager : public nsISupports {
 public: 
  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ISCRIPTSECURITYMANAGER_IID)

  /* boolean CheckScriptAccess (in nsIScriptContext cx, in voidStar obj, in long prop, in boolean isWrite); */
  NS_IMETHOD CheckScriptAccess(nsIScriptContext *cx, void * obj, PRInt32 prop, PRBool isWrite, PRBool *_retval) = 0;

  /* void CheckLoadURIFromScript (in nsIScriptContext cx, in nsIURI uri); */
  NS_IMETHOD CheckLoadURIFromScript(nsIScriptContext *cx, nsIURI *uri) = 0;

  /* void CheckLoadURI (in nsIURI from, in nsIURI uri); */
  NS_IMETHOD CheckLoadURI(nsIURI *from, nsIURI *uri) = 0;

  /* nsIPrincipal GetSubjectPrincipal (); */
  NS_IMETHOD GetSubjectPrincipal(nsIPrincipal **_retval) = 0;

  /* nsIPrincipal GetSystemPrincipal (); */
  NS_IMETHOD GetSystemPrincipal(nsIPrincipal **_retval) = 0;

  /* nsIPrincipal GetCodebasePrincipal (in nsIURI aURI); */
  NS_IMETHOD GetCodebasePrincipal(nsIURI *aURI, nsIPrincipal **_retval) = 0;

  /* boolean CanExecuteScripts (in nsIPrincipal principal); */
  NS_IMETHOD CanExecuteScripts(nsIPrincipal *principal, PRBool *_retval) = 0;

  /* boolean CanExecuteFunction (in voidStar jsFunction); */
  NS_IMETHOD CanExecuteFunction(void * jsFunction, PRBool *_retval) = 0;

  /* boolean IsCapabilityEnabled (in string capability); */
  NS_IMETHOD IsCapabilityEnabled(const char *capability, PRBool *_retval) = 0;

  /* void EnableCapability (in string capability); */
  NS_IMETHOD EnableCapability(const char *capability) = 0;

  /* void RevertCapability (in string capability); */
  NS_IMETHOD RevertCapability(const char *capability) = 0;

  /* void DisableCapability (in string capability); */
  NS_IMETHOD DisableCapability(const char *capability) = 0;
};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISCRIPTSECURITYMANAGER \
  NS_IMETHOD CheckScriptAccess(nsIScriptContext *cx, void * obj, PRInt32 prop, PRBool isWrite, PRBool *_retval); \
  NS_IMETHOD CheckLoadURIFromScript(nsIScriptContext *cx, nsIURI *uri); \
  NS_IMETHOD CheckLoadURI(nsIURI *from, nsIURI *uri); \
  NS_IMETHOD GetSubjectPrincipal(nsIPrincipal **_retval); \
  NS_IMETHOD GetSystemPrincipal(nsIPrincipal **_retval); \
  NS_IMETHOD GetCodebasePrincipal(nsIURI *aURI, nsIPrincipal **_retval); \
  NS_IMETHOD CanExecuteScripts(nsIPrincipal *principal, PRBool *_retval); \
  NS_IMETHOD CanExecuteFunction(void * jsFunction, PRBool *_retval); \
  NS_IMETHOD IsCapabilityEnabled(const char *capability, PRBool *_retval); \
  NS_IMETHOD EnableCapability(const char *capability); \
  NS_IMETHOD RevertCapability(const char *capability); \
  NS_IMETHOD DisableCapability(const char *capability); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISCRIPTSECURITYMANAGER(_to) \
  NS_IMETHOD CheckScriptAccess(nsIScriptContext *cx, void * obj, PRInt32 prop, PRBool isWrite, PRBool *_retval) { return _to ## CheckScriptAccess(cx, obj, prop, isWrite, _retval); } \
  NS_IMETHOD CheckLoadURIFromScript(nsIScriptContext *cx, nsIURI *uri) { return _to ## CheckLoadURIFromScript(cx, uri); } \
  NS_IMETHOD CheckLoadURI(nsIURI *from, nsIURI *uri) { return _to ## CheckLoadURI(from, uri); } \
  NS_IMETHOD GetSubjectPrincipal(nsIPrincipal **_retval) { return _to ## GetSubjectPrincipal(_retval); } \
  NS_IMETHOD GetSystemPrincipal(nsIPrincipal **_retval) { return _to ## GetSystemPrincipal(_retval); } \
  NS_IMETHOD GetCodebasePrincipal(nsIURI *aURI, nsIPrincipal **_retval) { return _to ## GetCodebasePrincipal(aURI, _retval); } \
  NS_IMETHOD CanExecuteScripts(nsIPrincipal *principal, PRBool *_retval) { return _to ## CanExecuteScripts(principal, _retval); } \
  NS_IMETHOD CanExecuteFunction(void * jsFunction, PRBool *_retval) { return _to ## CanExecuteFunction(jsFunction, _retval); } \
  NS_IMETHOD IsCapabilityEnabled(const char *capability, PRBool *_retval) { return _to ## IsCapabilityEnabled(capability, _retval); } \
  NS_IMETHOD EnableCapability(const char *capability) { return _to ## EnableCapability(capability); } \
  NS_IMETHOD RevertCapability(const char *capability) { return _to ## RevertCapability(capability); } \
  NS_IMETHOD DisableCapability(const char *capability) { return _to ## DisableCapability(capability); } 

#define NS_SCRIPTSECURITYMANAGER_PROGID "component://netscape/scriptsecuritymanager"
#define NS_SCRIPTSECURITYMANAGER_CLASSNAME "scriptsecuritymanager"

#endif /* __gen_nsIScriptSecurityManager_h__ */
