/*
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "COPYRIGHT"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  SUN
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 */

///=--------------------------------------------------------------------------=
//
// nsIBwAdapterPluginStreamListener.h  by Stanley Man-Kit Ho
//
///=--------------------------------------------------------------------------=

#ifndef nsIBwAdapterPluginStreamListener_h__
#define nsIBwAdapterPluginStreamListener_h__

#include "nsplugindefs.h"

////////////////////////////////////////////////////////////////////////////////
// Plugin Stream Listener Interface for Navigator 3/4

/**
 *
 * The nsIBwAdapterPluginStreamListener interface provides a fallback to one of
 * the hack that we did in URLNotify to obtain the document base URL. Only the
 * document base stream listener should actually use it.
 *
 */
class nsIBwAdapterPluginStreamListener : public nsISupports {
public:
    NS_IMETHOD
    OnNotify(const char* url, nsresult status) = 0;
};


// {66677840-D1B4-11d2-BA21-00105A1F1DAB}
#define NS_IBWADAPTERPLUGINSTREAMLISTENER_IID			\
{	0x66677840,						\
	0xd1b4,							\
	0x11d2,							\
	{ 0xba, 0x21, 0x0, 0x10, 0x5a, 0x1f, 0x1d, 0xab } };	\

////////////////////////////////////////////////////////////////////////////////

#endif /* nsIBwAdapterPluginStreamListener_h__ */
