/*
 To exercise the jvm-plugin interface without actually running the plugin
 */
#ifdef XP_UNIX
#define _UINT32
#define _INT32
#else // XP_UNIX

#endif
extern "C" {
#include "DummyUtil.h"
#include <unistd.h>
}


#include "nsIFactory.h"		/* NS_IMETHOD etc. */
#include "nsRepository.h"	/* nsFactoryProc, nsGetFactory */
#include "nsIPlugin.h"	       /* NS_IJVMPLUGIN_IID  nsIJVMPlugin, */
#include "npupp.h"		/* NPNetscapeFuncs */
#include <dlfcn.h>


extern void dummySetupPlugin(nsIPlugin *userPlugin);

/* NPX_PlugIn in plugin.cpp */
NPError(*load)(NPNetscapeFuncs *, NPPluginFuncs *);
NPError(*shutdown)();
NPError(*getvalue)(void *, NPPVariable variable, void *value); 


int main(){
				/* nsJVMMgr::GetJVMPlugin(void) */
				/* FE_LoadPlugin */
    nsIPlugin *userPlugin;	/* plugin.cpp FE_LoadPlugin */
    NPError err;
			/* PR_link stuff, but called by FE_LoadPlugin */
    check_not_null((void *)1, "Starting up");
    void *javaplugin_so;
    javaplugin_so = dlopen("javaplugin.so", RTLD_LAZY);
    check_not_null(javaplugin_so,"Checking load javaplugin.so");

    // Mozilla changes: Need to call NSGetFactoryStub instead of NSGetFactory
    nsFactoryProc nsGetFactory =
	(nsFactoryProc) dlsym(javaplugin_so, "NSGetFactory");
    check_not_null(nsGetFactory, "Checking find NSGetFactoryStub symbol");
    load = (NPError (*)(NPNetscapeFuncs *, NPPluginFuncs *)) 
	dlsym(javaplugin_so,"NP_Initialize");
    check_not_null(load, "Could not find NP_Initialize");
    shutdown = (NPError (*)(void))dlsym(javaplugin_so,"NP_Shutdown");
    check_not_null(shutdown, "Checking find NP_Shutdown");

    static NS_DEFINE_IID(kIPluginIID, NS_IPLUGIN_IID);
    nsGetFactory(NULL, kIPluginIID, NULL, NULL, (nsIFactory **)&userPlugin);
    
    /* 
       nsPluginManager::Create(Null,kIPluginManagerIID, 
       (void*)&thePluginManager);
			    This can't work, since nsPluginManager is private
			    to netscape;
       check_not_null(thePluginManager, "Creating the plugin manager");
       err = userPlugin->initialize((nsIPluginManager *)thePluginManager);
       check_ok(err, "Initializing plugin with plugin manager");
    */
	/* userPlugin is actually a CJavaPluginFactory */

    dummySetupPlugin(userPlugin);
    while(1) {
	sleep(1);
	fprintf(stderr,"Sleeping...");
    }
    return 1;
}

