extern "C" {
#include "DummyUtil.h"
#include <unistd.h>
}
 

#include "nsIFactory.h"		/* NS_IMETHOD etc. */
#include "nsRepository.h"	/* nsFactoryProc, nsGetFactory */
#include "nsIJVMPlugin.h"	

/* jvmmgr.cpp */
static NS_DEFINE_IID(kIJVMPluginIID, NS_IJVMPLUGIN_IID); 
/* jvmmgr.h */
static nsIJVMPlugin* fJVMFactory;	

void doTests(void);

void dummySetupPlugin(nsIPlugin *userPlugin) {
    /* jvmmgr.cpp GetJVMPlugin */
    nsresult res = userPlugin->QueryInterface(kIJVMPluginIID, 
					    (void **)&fJVMFactory);
    if (res != NS_OK) err_terminate("fJVMFactory Java plugin query failed");
    check_not_null(fJVMFactory, "Checking initialize fJVMFactory");

    /* jvmmgr.cpp StartupJVM jvm = fJVMFactory*/
    {
	nsJVMInitArgs initargs;
	char* classpathAdditions = NULL;
	initargs.version = nsJVMInitArgs_Version;
	initargs.classpathAdditions = "/usr/local/lib/netscape/plugins:/home/bgomes/.netscape/plugins";

	nsresult err = fJVMFactory->StartupJVM(&initargs);
				/* This calls  */
	if (err != NS_OK) err_terminate("fJVMFactory->StartupJVM failed");
	/* assume the JVM is running. */
	doTests();
	fJVMFactory->Release();
	fprintf(stderr,"Not yet status ");
    }

}

void doTests(void) {
    /* Try attaching a thread and calling various JNI functions*/
    JNIEnv *env;
    int res;
    res = fJVMFactory->GetJNIEnv(&env);
    check_not_null((res != -1), "Getting the environment res for this thread");
    check_not_null(env, "Getting the environment for this thread");
    jclass clz = env->FindClass("java/lang/System");
    fprintf(stderr, "clz"); 
    jfieldID fid = env->GetStaticFieldID(clz, "out", "Ljava/io/PrintStream;");
    fprintf(stderr, "fid");
    jobject o = env->GetStaticObjectField(clz, fid);
    fprintf(stderr, "field");
    clz = env->FindClass("java/io/PrintStream");
    fprintf(stderr, "clz");                
    jmethodID print_method = env->GetMethodID(clz, "println",
					      "(Ljava/lang/String;)V");
    fprintf(stderr, "mid");
    jstring str = env->NewStringUTF("Tickling the VM!!!");
    while(1){
	fprintf(stderr,"foo");
	sleep(1);
    }
}

