/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-*/
/*
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "COPYRIGHT"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  SUN
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 */

//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//
// CNetscapeStream.h  by Stanley Man-Kit Ho
//
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//
// Contains declaration of the CNetscapeStream
//

#ifndef CNETSCAPESTREAM_H
#define CNETSCAPESTREAM_H


class CNetscapeStream : public nsIPluginStream
{
public:
    CNetscapeStream(nsIPluginStreamPeer* peer);
    virtual	~CNetscapeStream();
		
    //================================================================
    // nsISupport
    //================================================================
    NS_DECL_ISUPPORTS		

    //================================================================
    // nsIStream
    //================================================================

    NS_METHOD Close(void);

    // (Corresponds to nsP_Write and nsN_Write.)
    NS_IMETHOD Write(const char* buffer, PRInt32 offset, PRInt32 len, PRInt32 *bytesWritten);

    //================================================================
    // nsIPluginStream
    //================================================================

    // (Corresponds to nsP_NewStream's stype return parameter.)
    NS_IMETHOD GetStreamType(nsPluginStreamType *result);

    // (Corresponds to nsP_StreamAsFile.)
    NS_IMETHOD AsFile(const char* fname);		
protected:
    static const long	 kMaxBufSize;

    nsIPluginStreamPeer* mStreamPeer;
};

#endif
