/*
 *  Copyright (c) 1996-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "COPYRIGHT"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  SUN
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 */

//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//
// CNetscapeStreamListener.cpp  by Stanley Man-Kit Ho
//
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//
// Contains implementation of the CNetscapeStreamListener
//


//#include "nsPlugin.h"
//#include "nsAgg.h"
#include <stdlib.h>
#include <stdio.h>
#include "remotejni.h"
#include "nsIPluginInstance.h"
#include "nsIJVMPluginInstance.h"
#include "nsIEventHandler.h"
#include "nsplugin.h"
#include "Navig5.h"
#include "nsIPluginStreamListener.h"
#include "JavaPluginInstance5.h"
#include "CNetscapeStreamListener.h"


// Interface IDs we'll need:
static NS_DEFINE_IID(kIPluginStreamListenerIID, NS_IPLUGINSTREAMLISTENER_IID);


////////////////////////////////////////////////////////////////////////////////
// CNetscapeStreamListener Methods
////////////////////////////////////////////////////////////////////////////////


//------------------------------------------------------------------------------------
// CNetscapeStreamListener::CNetscapeStreamListener
//------------------------------------------------------------------------------------
CNetscapeStreamListener::CNetscapeStreamListener(JavaPluginInstance5* inst,
                                                 const char* msgName)
    : fInst(inst), fMessageName(msgName)
{
    NS_INIT_REFCNT();
    
    if (fInst)
        fInst->AddRef();
}


//------------------------------------------------------------------------------------
// CNetscapeStreamListener::~CNetscapeStreamListener
//------------------------------------------------------------------------------------
CNetscapeStreamListener::~CNetscapeStreamListener(void)
{

    if (fInst)
    {
        fInst->Release();
        fInst = NULL;
    }
}

// This macro produces a simple version of QueryInterface, AddRef and Release.
// See the nsISupports.h header file for details.

NS_IMPL_ISUPPORTS(CNetscapeStreamListener, kIPluginStreamListenerIID);


//------------------------------------------------------------------------------------
// CNetscapeStreamListener::GetStreamType
//------------------------------------------------------------------------------------
NS_METHOD CNetscapeStreamListener::GetStreamType(nsPluginStreamType* streamType)
{
    if (streamType == NULL)
        return NS_ERROR_NULL_POINTER;

    *streamType = nsPluginStreamType_Normal;

    return NS_OK;
}

    
//------------------------------------------------------------------------------------
// CNetscapeStreamListener::OnStartBinding
//------------------------------------------------------------------------------------
NS_METHOD CNetscapeStreamListener::OnStartBinding(nsIPluginStreamInfo* info)
{
    return NS_OK;
}


//------------------------------------------------------------------------------------
// CNetscapeStreamListener::OnDataAvailable
//------------------------------------------------------------------------------------
NS_METHOD CNetscapeStreamListener::OnDataAvailable(nsIPluginStreamInfo* pluginInfo, 
                                                   nsIInputStream* input,
                                                   PRUint32 length)
{

    return NS_OK;
}

//------------------------------------------------------------------------------------
// CNetscapeStreamListener::OnFileAvailable
//------------------------------------------------------------------------------------
NS_METHOD CNetscapeStreamListener::OnFileAvailable(nsIPluginStreamInfo* pluginInfo, 
						   const char* fileName)
{
    return NS_OK;
}

//------------------------------------------------------------------------------------
// CNetscapeStreamListener::OnStopBinding
//------------------------------------------------------------------------------------
NS_METHOD CNetscapeStreamListener::OnStopBinding(nsIPluginStreamInfo* pluginInfo, 
						 nsresult status)
{
    return NS_OK;
}



