/*
 * Copyright (c) 2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "COPYRIGHT"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  SUN
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 */

//=--------------------------------------------------------------------------=
//
// NSRegistry.h  by Stanley Man-Kit Ho
//
//=--------------------------------------------------------------------------=

#ifndef _NSREGISTRY_H_
#define _NSREGISTRY_H_

#include "NSReg.h"

class NSRegistry
{
public:
    NSRegistry();

    BOOL getUserPreferenceFilePath(/*[in, out]*/char* lpszPrefsPath);

private:

    // Extract registry value from Netscape registry
    BOOL getValue(/*[in]*/const REGDESC* parentRecord, 
		  /*[in]*/const char* lpszPathElts, 
		  /*[in, out]*/char* lpszValue);
    
    // Read registry record		 
    BOOL readRecord(/*[in]*/REGOFF offset, 
		    /*[in, out]*/REGDESC* regDesc);

    // Read registry file		 
    BOOL readHeader(/*[in, out]*/REGHDR* regHdr);

    // Read registry root record		 
    BOOL readRootRecord(/*[in, out]*/REGDESC* regDesc);

    // Read string from registry
    BOOL readString(/*[in]*/REGOFF offset, 
		    /*[in]*/uint32 length, 
		    /*[in, out]*/char* lpszValue);

    FILE*   m_file;
};

#endif  /* _NSREGISTRY_H_ */


