/*
 * @(#)Converter.java	1.4 01/04/21
 *
 * Copyright (c) 1995-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 *  @version 1.0
 *
 */

package sun.plugin.converter.engine;

import sun.plugin.converter.util.*;
import java.util.Vector;
import java.io.*;


public interface Converter {

	
    /*
      Do we show progress in Stdout
      */
    public void setShowProgressStdOut(boolean b);
    public boolean isShowProgressStdOut();
	
    /*
      Name of template file to be used
      */
    public void setTemplateFilePath(String fileName) throws FileNotFoundException;
    public String getTemplateFilePath();

    /*
      Do we process into subdirectories
      */
    public void setRecurse(boolean b);
    public boolean isRecurse();

    /*
      Stream to direct log information
      */
    public void setLogFile(java.io.File f);
    public java.io.File getLogFile();
	
    /*
      Do we create a log?
      */
    public void setCreateLog(boolean b);
    public boolean isCreateLog();


    /*
      Progress can be posted out via the ConverterProgressEvent object
      */
    public void addConverterProgressListener(ConverterProgressListener l);
    public void removedConverterProgressListener(ConverterProgressListener l);
	
}
