/*
 * @(#)Converter.java	1.20 01/03/16
 *
 * Copyright (c) 1998-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1 
 *
 */

package sun.plugin.converter.resources;

import java.util.ListResourceBundle;

/**
 * US English version of Java Plug-in HTML Converter strings.
 *
 * @author Stanley Man-Kit Ho
 */

public class Converter extends ListResourceBundle {

    private static String newline = System.getProperty("line.separator");
    private static String fileSeparator = System.getProperty("file.separator");

    public Object[][] getContents() {
	return contents;
    }

    static final Object[][] contents = {
	{ "caption.error", "Error" },
	{ "caption.warning", "Warning" },
	{ "caption.propnotfound", "Properties File not Found" },
	{ "caption.tempnotfound", "Template File not Found" },
	{ "caption.absdirnotfound", "Absolute Directory not Found" },
	{ "caption.reldirnotfound", "Relative Directory not Found" },
        { "about_dialog.info", "Java(tm) Plug-in HTML Converter v" },
	{ "about_dialog.info2", "\nCopyright 2001 Sun Microsystems, Inc." },
        { "about_dialog.caption", "About Java(tm) Plug-in HTML Converter" },
	{ "nottemplatefile_dialog.caption", "Not a Template File"},
	{ "nottemplatefile_dialog.info0", "The file specified in the \"Template File:\" field" + newline +
					  "is not a valid template file.  The file must end" + newline +
					  "with the extention .tpl" + newline + newline +
					  "Would you like the template file reset to the" + newline +
					  "default ("},
	{ "nottemplatefile_dialog.info1", ")?"},
	{ "nottemplatefile_dialog.info2", "Using default template file.  Specified template file does not exist"},
	{ "nopluginurl_dialog.info0", "The required URLs for the Java Plug-in are not available."},
	{ "nopluginurl_dialog.info1", "The required URLs for the converter are not available." + newline +
	                              "(converter.props missing from classpath.)"},
	{ "nopluginurl_dialog.info2", "The required backup URLs for the Java Plug-in are not available." + newline +
	                              "(default.props missing from classpath.)"},
	{ "warning_dialog.info", "The backup folder and the destination folder cannot" + newline +
	                         "have the same path.  Would you like the backup" + newline +
	                         "folder path changed to the following:"},
	{ "notemplate_dialog.caption", "Template File Not Found"},
	{ "notemplate_dialog.info0", "The default template file ("},
	{ "notemplate_dialog.info1", ") could" + newline + "not be found. Either it is not in the classpath" + newline +
				     "or it is not in the working directory."},
	{ "file_unwritable.info", "File is not writable: "},
	{ "file_notexists.info", "File does not exist: "},
	{ "illegal_source_and_backup.info", "Destination and backup directories cannot be the same!"},
	{ "button.reset", "Reset to Defaults"},
	{ "button.okay", "OK"},
	{ "button.cancel", "Cancel"},
	{ "button.about", "About"},
	{ "button.print", "Print"},
	{ "button.done", "Done"},
	{ "button.browse", "Browse..."},
	{ "button.quit", "Quit"},
	{ "button.advanced", "Advanced Options..."},
	{ "button.help", "Help"},
	{ "button.convert", "Convert..."},

	{ "advanced_dialog.caption", "Advanced Options"},
	{ "advanced_dialog.cab", "Specify Source Location for ActiveX CAB File:"},
	{ "advanced_dialog.plugin", "Specify Source Location for Netscape Plug-In:"},
	{ "advanced_dialog.smartupdate", "Specify Source Location for Netscape SmartUpdate:"},
	{ "advanced_dialog.mimetype", "Specify MIME type for Java Plug-In HTML Conversion:"},
	{ "advanced_dialog.log", "Specify Location for Log File:"},
	{ "advanced_dialog.generate", "Generate Log File"},

	{ "progress_dialog.caption", "Progress..."},
	{ "progress_dialog.processing", "Processing..."},
	{ "progress_dialog.folder", "Folder:"},
	{ "progress_dialog.file", "File:"},
	{ "progress_dialog.totalfile", "Total Files Processed:"},
	{ "progress_dialog.totalapplet", "Total Applets Found:"},
	{ "progress_dialog.totalerror", "Total Errors:"},

	{ "notdirectory_dialog.caption0", "Not a Valid File"},
	{ "notdirectory_dialog.caption1", "Not a Valid Folder"},
	{ "notdirectory_dialog.info0", "The following folder does not exist" + newline},
	{ "notdirectory_dialog.info1", "The following file does not exist" + newline},
	{ "notdirectory_dialog.info2", "(in the \"All Files in Folder\" text field):" + newline},
	{ "notdirectory_dialog.info3", "(in the \"One File\" text field):" + newline},
	{ "notdirectory_dialog.info4", "(in the \"Template File\" text field):" + newline},
	{ "notdirectory_dialog.info5", "<empty>"},

	{ "converter_gui.lablel0", "Specify a file or a directory path:"},
	{ "converter_gui.lablel1", "Matching File Names:"},
	{ "converter_gui.lablel2", "*.html, *.htm, *.asp"},
	{ "converter_gui.lablel3", "Include Subfolders"},
	{ "converter_gui.lablel4", "One File:"},
	{ "converter_gui.lablel5", "Backup Files to Folder:"},
	{ "converter_gui.lablel7", "Template File:"},


	{ "template.default", "Standard (IE & Navigator) for Windows & Solaris Only"},
	{ "template.extend",  "Extended (Standard + All Browsers/Platforms)"},
	{ "template.ieonly",  "Internet Explorer for Windows & Solaris Only"},
	{ "template.nsonly",  "Navigator for Windows Only"},
	{ "template.other",   "Other Template..."},

	{ "help_dialog.caption", "Help"},

	{ "menu.file", "File"},
	{ "menu.exit", "Exit"},
	{ "menu.edit", "Edit"},
	{ "menu.option", "Options"},
	{ "menu.help", "Help"},
	{ "menu.about", "About"},

	{ "progress_event.preparing", "Preparing"},
	{ "progress_event.converting", "Converting"},
	{ "progress_event.copying", "Copying"},
	{ "progress_event.done", "Done"},
	{ "progress_event.destdirnotcreated", "Could not create destination directory."},
	{ "progress_event.error", "Error"},
	
	{ "plugin_converter.propnotfound2", "Property files not found. Default properties are used."},
	{ "plugin_converter.propnotfound", "converter.props is not found.  This is necessary to load the Java Plug-in download locations"},
	{ "plugin_converter.logerror", "Log file output could not be established"},
	{ "plugin_converter.saveerror", "Could not save properties file:  "},
	{ "plugin_converter.appletconv", "Applet Conversion "},
	{ "plugin_converter.failure", "Unable to convert the file "},
	{ "plugin_converter.overwrite1", "A backup copy already exists for..." + newline + newline },
	{ "plugin_converter.overwrite2", newline + newline + "Do you want to overwrite this backup copy?"},
	{ "plugin_converter.done", "All Done  Files Processed:  "},
	{ "plugin_converter.appletfound", "  Applets Found:  "},
	{ "plugin_converter.processing", "  Processing..."},
	{ "plugin_converter.cancel", "Conversion Cancelled"},
	{ "plugin_converter.files", "Files to be converted: "},
	{ "plugin_converter.converted", "File previously converted, no conversion is necessary. "},
	{ "plugin_converter.donefound", "Done  Applets Found:  "},
	{ "plugin_converter.seetrace", "Error on file - see trace below"},
	{ "plugin_converter.noapplet", "No applets in file "},
	{ "plugin_converter.nofiles", "No files to be processed "},
	{ "plugin_converter.nobackuppath", "Didn't create the backup path"},
	{ "plugin_converter.writelog", "Writing over log file with same name"},
	{ "plugin_converter.backup_path", "Backup Path"},
	{ "plugin_converter.log_path", "Log Path"},
	{ "plugin_converter.template_file", "Template File"},
	{ "plugin_converter.process_subdirs", "Process Subdirectories"},
	{ "plugin_converter.show_progress", "Show progress"},
	{ "plugin_converter.help_message", newline + 
	                                  "Usage: HtmlConverter [-option1 value1 [-option2 value2 [...]]] [-simulate]  [filespecs]" + newline + newline +
	                                  "where options include:" + newline + newline +
	                                  "    -source:    Path to get original files.  Default: <userdir>" + newline +
	                                  "    -dest:      Path to write converted files.  Default: <userdir>" + newline +
	                                  "    -backup:    Path to write backup files.  Default: <dirname>_BAK" + newline +
	                                  "    -subdirs:   Should files in subdirectories be processed." + newline +
	                                  "    -template:  Path to template file.  Use default if unsure." + newline +
	                                  "    -log:       Path to write log.  If not provided, no log is written." + newline +
	                                  "    -progress:  Display progress while converting.  Default: true" + newline +
	                                  "    -simulate:  Display the specifics to the conversion without converting." + newline + 
                                          "    -gui:       Display the graphical user interface for the converter." + newline + newline +
	                                  "    filespecs:  Space delimited list of files specs.  Default: \"*.html *.htm\" (quotes required)" + newline},
	
	{ "product_name", "Java(TM) Plug-in HTML Converter" },
    };
}

