/*
 * @(#)Converter_de.java    1.19 01/03/08
 *
 * Copyright (c) 1998-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1 
 *
 */

package sun.plugin.converter.resources;

import java.util.ListResourceBundle;

/**
 * US English version of Java Plug-in HTML Converter strings.
 *
 * @author Stanley Man-Kit Ho
 */

public class Converter_de extends ListResourceBundle {

    private static String newline = System.getProperty("line.separator");
    private static String fileSeparator = System.getProperty("file.separator");

    public Object[][] getContents() {
    return contents;
    }

    static final Object[][] contents = {
    { "caption.error", "Fehler" },
    { "caption.warning", "Warnung" },
    { "caption.propnotfound", "Eigenschaftendatei nicht gefunden" },
    { "caption.tempnotfound", "Schablonendatei nicht gefunden" },
        { "caption.absdirnotfound", "Absolutes Verzeichnis nicht gefunden" },
        { "caption.reldirnotfound", "Relatives Verzeichnis nicht gefunden" },
        { "about_dialog.info", "Java(tm) Plug-in HTML-Konverter v" },
        { "about_dialog.info2", "\nCopyright 2001 Sun Microsystems, Inc." },
        { "about_dialog.caption", "Info zu Java(tm) Plug-in HTML-Konverter" },
    { "nottemplatefile_dialog.caption", "Keine Schablonendatei"},
    { "nottemplatefile_dialog.info0", "Bei der Datei, die im Feld \"Schablonendatei:\" angegeben" + newline +
                      "ist, handelt es sich nicht um eine g\u00fcltige Schablonendatei." + newline +
                      "Die Datei muss die Erweiterung .tpl haben." + newline + newline +
                      "Soll die Schablonendatei auf die Standardeinstellung zur\u00fcckgesetzt" + newline +
                      "werden ("},
    { "nottemplatefile_dialog.info1", ")?"},
    { "nottemplatefile_dialog.info2", "Es wird die Standardschablonendatei verwendet. Die angegebene Schablonendatei ist nicht vorhanden."},
    { "nopluginurl_dialog.info0", "Die erforderlichen URLs f\u00fcr das Java Plug-In sind nicht verf\u00fcgbar."},
    { "nopluginurl_dialog.info1", "Die erforderlichen URLs f\u00fcr den Konverter sind nicht verf\u00fcgbar." + newline +
                      "(converter.props fehlt im Klassenpfad.)"},
    { "nopluginurl_dialog.info2", "Die erforderlichen Sicherungs-URLs f\u00fcr das Java Plug-in sind nicht verf\u00fcgbar." + newline +
                      "(default.props fehlt im Klassenpfad.)"},
    { "warning_dialog.info", "Der Pfad des Sicherungsordners und der Pfad des Zielordners d\u00fcrfen nicht" + newline +
                             "identisch sein. Soll der Pfad des" + newline +
                             "Sicherungsordners auf folgenden Pfad ge\u00e4ndert werden:"},
    { "notemplate_dialog.caption", "Schablonendatei nicht gefunden"},
    { "notemplate_dialog.info0", "Die standardm\u00e4\u00dfige Schablonendatei ("},
    { "notemplate_dialog.info1", ") wurde" + newline +"nicht gefunden. Sie befindet sich entweder nicht im Klassenpfad" + newline +
                     "oder nicht im Arbeitsverzeichnis."},
    { "file_unwritable.info", "In die Datei kann nicht geschrieben werden: "},
    { "file_notexists.info", "Die Datei ist nicht vorhanden: "},
    { "illegal_source_and_backup.info", "Ziel- und Sicherungsverzeichnisse d\u00fcrfen nicht identisch sein!"},
    { "button.reset", "Auf Standardwerte zur\u00fccksetzen"},
    { "button.okay", "OK"},
    { "button.cancel", "Abbrechen"},
    { "button.about", "Info zu"},
    { "button.print", "Drucken"},
    { "button.done", "Fertig"},
    { "button.browse", "Durchsuchen..."},
    { "button.quit", "Beenden"},
    { "button.advanced", "Erweiterte Optionen..."},
    { "button.help", "Hilfe"},
    { "button.convert", "Konvertieren..."},

    { "advanced_dialog.caption", "Erweiterte Optionen"},
    { "advanced_dialog.cab", "Geben Sie den Quellspeicherort f\u00fcr die ActiveX CAB-Datei an:"},
    { "advanced_dialog.plugin", "Geben Sie den Quellspeicherort f\u00fcr das Netscape Plug-in an:"},
        { "advanced_dialog.smartupdate", "Geben Sie das Quellverzeichnis f\u00fcr das Netscape-SmartUpdate an:"},    
        { "advanced_dialog.mimetype", "Geben Sie den MIME-Typ f\u00fcr die Java Plug-in HTML-Konvertierung an:"},    
    { "advanced_dialog.log", "Geben Sie den Speicherort f\u00fcr die Protokolldatei an:"},
    { "advanced_dialog.generate", "Erzeugen der Protokolldatei"},

    { "progress_dialog.caption", "Fortschritt..."},
    { "progress_dialog.processing", "Verarbeitung l\u00e4uft..."},
    { "progress_dialog.folder", "Ordner:"},
    { "progress_dialog.file", "Datei:"},
    { "progress_dialog.totalfile", "Gesamtzahl der verarbeiteten Dateien:"},
    { "progress_dialog.totalapplet", "Gesamtzahl der gefundenen Applets:"},
    { "progress_dialog.totalerror", "Gesamtzahl der Fehler:"},

    { "notdirectory_dialog.caption0", "Keine g\u00fcltige Datei"},
    { "notdirectory_dialog.caption1", "Kein g\u00fcltiger Ordner"},
    { "notdirectory_dialog.info0", "Folgender Ordner ist nicht vorhanden" + newline},
    { "notdirectory_dialog.info1", "Folgende Datei ist nicht vorhanden" + newline},
    { "notdirectory_dialog.info2", "(im Textfeld \"Alle Dateien im Ordner\"):" + newline},
    { "notdirectory_dialog.info3", "(im Textfeld \"Eine Datei\"):" + newline},
    { "notdirectory_dialog.info4", "(im Textfeld \"Schablonendatei\"):" + newline},
    { "notdirectory_dialog.info5", "<leer>"},

        { "converter_gui.lablel0", "Geben Sie eine Datei oder einen Verzeichnispfad an:"},
        { "converter_gui.lablel1", "\u00dcbereinstimmende Dateinamen:"},
        { "converter_gui.lablel2", "*.html, *.htm, *.asp"},
        { "converter_gui.lablel3", "Untergeordnete Ordner aufnehmen"},
        { "converter_gui.lablel4", "Eine Datei:"},
        { "converter_gui.lablel5", "Sicherungsdateien in Ordner:"},
        { "converter_gui.lablel7", "Schablonendatei:"},


    { "template.default", "Standard (IE & Navigator) nur f\u00fcr Windows u. Solaris"},
    { "template.extend",  "Erweitert (Standard + s\u00e4mtliche Browser/Plattformen)"},
    { "template.ieonly",  "Internet Explorer nur f\u00fcr Windows & Solaris"},
    { "template.nsonly",  "Navigator nur f\u00fcr Windows"},
    { "template.other",   "Andere Schablone..."},

    { "help_dialog.caption", "Hilfe"},

    { "menu.file", "Datei"},
    { "menu.exit", "Beenden"},
    { "menu.edit", "Bearbeiten"},
    { "menu.option", "Optionen"},
    { "menu.help", "Hilfe"},
    { "menu.about", "Info zu"},

    { "progress_event.preparing", "Vorbereitung"},
    { "progress_event.converting", "Konvertierung"},
    { "progress_event.copying", "Kopiervorgang"},
    { "progress_event.done", "Fertig"},
    { "progress_event.destdirnotcreated", "Das Zielverzeichnis konnte nicht erstellt werden."},
    { "progress_event.error", "Fehler"},

        { "plugin_converter.propnotfound2", "Eigenschaftendateien nicht gefunden. Es werden Standardeigenschaften verwendet."},     
    { "plugin_converter.propnotfound", "converter.props wurde nicht gefunden. Die Datei ist f\u00fcr das Laden der Download-Speicherorte f\u00fcr das Java Plug-in erforderlich."},
    { "plugin_converter.logerror", "Ausgabe der Protokolldatei nicht m\u00f6glich"},
    { "plugin_converter.saveerror", "Eigenschaftendatei konnte nicht gespeichert werden:"},
    { "plugin_converter.appletconv", "Applet-Konvertierung"},
    { "plugin_converter.done", "Alle verarbeiteten Dateien:"},
        { "plugin_converter.failure", "Die Datei konnte nicht konvertiert werden "},
    { "plugin_converter.overwrite1", "Es existiert bereits eine Sicherungskopie f\u00FCr..." + newline + newline },
    { "plugin_converter.overwrite2", newline + newline + "M\u00F6chten Sie diese Sicherungskopie \u00FCberschreiben?"},
        { "plugin_converter.appletfound", "Gefundene Applets:"},
        { "plugin_converter.processing", "Verarbeitung l\u00e4uft..."},
        { "plugin_converter.cancel", "Konvertierung abgebrochen"},
        { "plugin_converter.files", "Zu konvertierende Dateien: "},
        { "plugin_converter.converted", "Datei wurde bereits konvertiert, Konvertierung nicht erforderlich."},
        { "plugin_converter.donefound", "Gefundene fertiggestellte Applets:"},
        { "plugin_converter.seetrace", "Dateifehler - siehe nachstehende Ablaufverfolgung"},
        { "plugin_converter.noapplet", "Keine Applets in der Datei vorhanden"},
        { "plugin_converter.nofiles", "Es sind keine zu verarbeitende Dateien vorhanden. "},
        { "plugin_converter.nobackuppath", "Sicherungspfad wurde nicht erstellt."},
        { "plugin_converter.writelog", "Protokolldatei mit identischem Namen wird \u00fcberschrieben."},
        { "plugin_converter.backup_path", "Sicherungspfad"},
        { "plugin_converter.log_path", "Protokollpfad"},
        { "plugin_converter.template_file", "Schablonendatei"},
        { "plugin_converter.process_subdirs", "Verarbeitungsunterverzeichnisse"},
        { "plugin_converter.show_progress", "Fortschrittsanzeige"},
        { "plugin_converter.help_message", newline + 
                                      "Syntax: HtmlConverter [-Option1 Wert1 [-Option2 Wert2 [...]]] [-simulate] [filespecs]" + newline + newline +
                                      "wobei folgende Optionen m\u00F6glich sind:" + newline + newline +
                                      "    -source:    Pfad zum Verzeichnis, aus dem die Ausgangsdateien gelesen werden sollen Standardvorgabe: <Benutzerverzeichnis>" + newline +
                                      "    -dest:      Pfad zum Verzeichnis, in das die konvertierten Dateien geschrieben werden sollen Standardvorgabe: <Benutzerverzeichnis>" + newline +
                                      "    -backup:    Pfad zum Verzeichnis, in das die Sicherungsdateien geschrieben werden sollen Standardvorgabe: <Verzeichnisname>_BAK" + newline +
                                      "    -subdirs:   Falls Dateien in Unterverzeichnissen verarbeitet werden sollen" + newline +
                                      "    -template:  Pfad zur Schablonendatei. Verwenden Sie die Standardvorgabe, wenn Sie sich unsicher sind." + newline +
                                      "    -log:       Pfad zum Verzeichnis, in das die Protokolldatei geschrieben werden soll. Wenn hier keine Angabe erfolgt, wird keine Protokolldatei erstellt." + newline +
                                      "    -progress:  Fortschrittsanzeige w\u00E4hrend der Umwandlung. Standardvorgabe: true" + newline +
                                      "    -simulate:  Anzeige der Umwandlungseinzelheiten ohne Umwandlung" + newline + 
                                          "    -gui:       Anzeige der grafischen Benutzeroberfl\u00E4che f\u00FCr das Umwandlungsprogramm" + newline + newline +
                                      "    filespecs:  Leerzeichenbegrenzte Dateiliste Standardvorgabe: \"*.html *.htm\" (Anf\u00FChrungszeichen m\u00FCssen angegeben werden)" + newline},

    { "product_name", "Java(TM) Plug-in HTML Converter" },
    };
}

