/*
 * @(#)Converter_es.java    1.19 01/03/08
 *
 * Copyright (c) 1998-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1
 *
 */

package sun.plugin.converter.resources;

import java.util.ListResourceBundle;

/**
 * Spanish version of Java Plug-in HTML Converter strings.
 *
 * @author Stanley Man-Kit Ho
 */

public class Converter_es extends ListResourceBundle {

    private static String newline = System.getProperty("line.separator");
    private static String fileSeparator = System.getProperty("file.separator");

    public Object[][] getContents() {
        return contents;
    }

    static final Object[][] contents = {
        { "caption.error", "Error" },
        { "caption.warning", "Aviso" },
        { "caption.propnotfound", "Archivo de propiedades no encontrado" },
        { "caption.tempnotfound", "Archivo de plantillas no encontrado" },
    { "caption.absdirnotfound", "Directorio absoluto no encontrado" },
    { "caption.reldirnotfound", "Directorio relativo no encontrado" },
         { "about_dialog.info", "Convertidor HTML para Java(tm) Plug-in" },
   { "about_dialog.info2", "\nCopyright 2001 Sun Microsystems, Inc." },

        { "about_dialog.caption", "Acerca del Convertidor HTML de Java(tm) Plug-in" },
        { "nottemplatefile_dialog.caption", "No es un archivo de plantillas"},
        { "nottemplatefile_dialog.info0", "El archivo especificado en el campo \"Archivo de plantillas:\"" + newline +
                                          "no es un archivo de plantillas v\u00e1lido.  El archivo debe terminar" + newline +
                                          "con una extensi\u00f3n.tpl" + newline + newline +
                                          "\u00bfDesea restablecer el archivo de plantillas" + newline +
                                          "por omisi\u00f3n ("},
        { "nottemplatefile_dialog.info1", ")?"},
    { "nottemplatefile_dialog.info2", "Usando archivo de plantillas predeterminado. El archivo de plantillas especificado no existe"},
        { "nopluginurl_dialog.info0", "Los URL necesarios para el Java Plug-in no est\u00e1n disponibles."},
        { "nopluginurl_dialog.info1", "Los URL necesarios para el convertidor no est\u00e1n disponibles." + newline +
                                      "(falta converter.props en la ruta de clase.)"},
        { "nopluginurl_dialog.info2", "Los URL necesarios de copia de seguridad para el Java Plug-in no est\u00e1n disponibles. " + newline +
                                      "(falta default.props en la ruta de clase.)"},
    { "warning_dialog.info", "La carpeta de copia de seguridad y la carpeta de destino no pueden" + newline +
                             "tener la misma ruta de acceso. \u00bfDesea cambiar la ruta de acceso de la" + newline +
                             "carpeta de copia de seguridad por la siguiente:"},
        { "notemplate_dialog.caption", "Archivo de plantillas no encontrado"},
        { "notemplate_dialog.info0", "El archivo de plantillas por omisi\u00f3n ("},
        { "notemplate_dialog.info1", ") no" + newline +"pudo encontrarse. No es una ruta de clase" + newline +
                                     "o no est\u00e1 en el directorio de trabajo."},
    { "file_unwritable.info", "No es posible escribir en el archivo: "},
    { "file_notexists.info", "El archivo no existe: "},
    { "illegal_source_and_backup.info", "Los directorios de destino y de copia de seguridad no pueden ser el mismo."},
        { "button.reset", "Restablecer a valores por omisi\u00f3n"},
        { "button.okay", "Aceptar"},
        { "button.cancel", "Cancelar"},
        { "button.about", "Acerca de"},
        { "button.print", "Imprimir"},
        { "button.done", "Realizado"},
        { "button.browse", "Examinar..."},
        { "button.quit", "Salir"},
        { "button.advanced", "Opciones avanzadas..."},
        { "button.help", "Ayuda"},
        { "advanced_dialog.smartupdate", "Especifique la ubicaci\u00f3n de origen para SmartUpdate de Netscape:"}, 
        { "advanced_dialog.mimetype", "Especifique el tipo MIME para la conversi\u00f3n de HTML de Java Plug-In:"},{ "button.convert", "Convertir..."},
        { "advanced_dialog.caption", "Opciones avanzadas"},
        { "advanced_dialog.cab", "Especificar ubicaci\u00f3n de origen para archivo CAB ActiveX:"},
        { "advanced_dialog.plugin", "Especificar ubicaci\u00f3n de origen para Netscape Plug-in:"},
        { "advanced_dialog.smartupdate", "Especificar ubicaci\u00f3n de origen para Netscape SmartUpdate:"},


        { "advanced_dialog.log", "Especificar ubicaci\u00f3n para archivo de registro:"},
        { "advanced_dialog.generate", "Generar archivo de registro"},

        { "progress_dialog.caption", "En curso..."},
        { "progress_dialog.processing", "Procesando..."},
        { "progress_dialog.folder", "Carpeta:"},
        { "progress_dialog.file", "Archivo:"},
        { "progress_dialog.totalfile", "Total archivos procesados:"},
        { "progress_dialog.totalapplet", "Total subprogramas encontrados:"},
        { "progress_dialog.totalerror", "Total errores:"},

        { "notdirectory_dialog.caption0", "No es un archivo v\u00e1lido"},
        { "notdirectory_dialog.caption1", "No es una carpeta v\u00e1lida"},
        { "notdirectory_dialog.info0", "La carpeta siguiente no existe" + newline},
        { "notdirectory_dialog.info1", "El archivo siguiente no existe" + newline},
        { "notdirectory_dialog.info2", "(en el campo de texto \"Todos los archivo de la carpeta\":" + newline},
        { "notdirectory_dialog.info3", "(en el campo de texto \"Un archivo\"):\n"},
        { "notdirectory_dialog.info4", "(en el campo de texto \"Archivo de plantillas\" ):" + newline},
        { "notdirectory_dialog.info5", "<vac\u00edo>"},

        { "converter_gui.lablel0", "Especifique un archivo o una ruta de acceso a un directorio:"},
        { "converter_gui.lablel1", "Correspondencia de nombres de archivo:"},
        { "converter_gui.lablel2", "*.html, *.htm, *.asp"},
        { "converter_gui.lablel3", "Incluir subcarpetas"},
        { "converter_gui.lablel4", "Un archivo:"},
        { "converter_gui.lablel5", "Archivos de copia de seguridad en carpeta:"},
        { "converter_gui.lablel7", "Archivo de plantillas:"},


        { "template.default", "Est\u00e1ndar (IE y Navigator) s\u00f3lo para Windows y Solaris"},
        { "template.extend",  "Ampliado (Est\u00e1ndar + Todos los exploradores/plataformas)"},
        { "template.ieonly",  "Internet Explorer s\u00f3lo para Windows y Solaris"},
        { "template.nsonly",  "Navigator s\u00f3lo para Windows"},
        { "template.other",   "Otra plantilla..."},

        { "help_dialog.caption", "Ayuda"},

        { "menu.file", "Archivo"},
        { "menu.exit", "Salir"},
        { "menu.edit", "Editar"},
    { "menu.option", "Opciones"},
        { "menu.help", "Ayuda"},
        { "menu.about", "Acerca de"},

        { "progress_event.preparing", "Preparar"},
        { "progress_event.converting", "Convertir"},
        { "progress_event.copying", "Copiar"},
        { "progress_event.done", "Realizado"},
        { "progress_event.destdirnotcreated", "No se ha podido crear el directorio de destino."},
        { "progress_event.error", "Error"},
            
        { "plugin_converter.propnotfound2", "No se encontraron los archivos de propiedades. Se utilizan las propiedades predeterminadas."},     
        { "plugin_converter.propnotfound", "converter.props no encontrado. Es necesario para cargar las ubicaciones descargadas del Java Plug-in"},
        { "plugin_converter.logerror", "La salida del archivo de registro no pudo establecerse"},
        { "plugin_converter.saveerror", "No se pudo guardar el archivo de propiedades:  "},
        { "plugin_converter.appletconv", "Conversi\u00f3n de subprograma"},
        { "plugin_converter.done", "Se han procesado todos los archivos realizados:  "},
        { "plugin_converter.failure", "Imposible convertir el archivo "},
    { "plugin_converter.overwrite1", "Ya hay una copia de seguridad de..." + newline + newline },
    { "plugin_converter.overwrite2", newline + newline + "\u00BFDesea sobrescribir dicha copia de seguridad?"},
        { "plugin_converter.appletfound", "Subprogramas encontrados:  "},
        { "plugin_converter.processing", "  Procesando..."},
        { "plugin_converter.cancel", "Conversi\u00f3n cancelada"},
    { "plugin_converter.files", "Archivos que se deben convertir: "},
        { "plugin_converter.converted", "Archivo convertido previamente, no es necesaria la conversi\u00f3n. "},
        { "plugin_converter.donefound", "Subprogramas realizados encontrados:  "},
        { "plugin_converter.seetrace", "Error en archivo - v\u00e9ase rastreo a continuaci\u00f3n"},
        { "plugin_converter.noapplet", "No hay subprogramas en este archivo"},
    { "plugin_converter.nofiles", "No hay archivos que procesar "},
        { "plugin_converter.nobackuppath", "No se pudo crear la ruta de la copia de seguridad"},
        { "plugin_converter.writelog", "Sobrescribir el archivo de registro con el mismo nombre"},
    { "plugin_converter.backup_path", "Ruta de copia de seguridad"},
    { "plugin_converter.log_path", "Ruta de registro"},
    { "plugin_converter.template_file", "Archivo de plantillas"},
    { "plugin_converter.process_subdirs", "Procesar subdirectorios"},
    { "plugin_converter.show_progress", "Mostrar progreso"},
    { "plugin_converter.help_message", newline +
                                      "Sintaxis: HtmlConverter [-opci\u00F3n1 valor1 [-opci\u00F3n2 valor2 [...]]] [-simulate]  [especificaciones_de_archivo]" + newline + newline +
                                      "donde las opciones son:" + newline + newline +
                                      "    -source:    Ruta de acceso de los archivos originales. Predeterminada: <dirdeusuario>" + newline +
                                      "    -dest:      Ruta de acceso para escribir los archivos convertidos. Predeterminada: <dirdeusuario>" + newline +
                                      "    -backup:    Ruta de escritura de los archivos de copia de seguridad. Predeterminada: <nombre_directorio>_BAK" + newline +
                                      "    -subdirs:   Si hay que procesar los archivos de los subdirectorios." + newline +
                                      "    -template:  Ruta al archivo de plantillas. Use la predeterminada en caso de duda." + newline +
                                      "    -log:       Ruta de escritura del registro. Si no se indica, no se crear\u00E1 ning\u00FAn registro." + newline +
                                      "    -progress:  Muestra el progreso durante la conversi\u00F3n. Predeterminada: true" + newline +
                                      "    -simulate:  Muestra detalles de la conversi\u00F3n, sin realizarla." + newline + 
                                          "    -gui:       Muestra la interfaz gr\u00E1fica de usuario del conversor." + newline + newline +
                                      "    filespecs:  Lista de especificaciones de los archivos delimitada por espacios. Predeterminada: \"*.html *.htm\" (se requieren comillas)" + newline},

        { "product_name", "Java(TM) Plug-in HTML Converter" },
    };
}

