/*
 * @(#)Converter_fr.java    1.19 01/03/08
 *
 * Copyright (c) 1998-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1 
 *
 */

package sun.plugin.converter.resources;

import java.util.ListResourceBundle;

/**
 * US English version of Java Plug-in HTML Converter strings.
 *
 * @author Stanley Man-Kit Ho
 */

public class Converter_fr extends ListResourceBundle {

    private static String newline = System.getProperty("line.separator");
    private static String fileSeparator = System.getProperty("file.separator");

    public Object[][] getContents() {
    return contents;
    }

    static final Object[][] contents = {
    { "caption.error", "Erreur" },
    { "caption.warning", "Avertissement" },
    { "caption.propnotfound", "Fichier de propri\u00e9t\u00e9s introuvable" },
    { "caption.tempnotfound", "Fichier mod\u00e8le introuvable" },
        { "caption.absdirnotfound", "R\u00e9pertoire absolu introuvable" },
        { "caption.reldirnotfound", "R\u00e9pertoire relatif introuvable" },
        { "about_dialog.info", "Convertisseur HTML du plug-in Java(tm) version" },
        { "about_dialog.info2", "\nCopyright 2001 Sun Microsystems, Inc." },
        { "about_dialog.caption", "A propos du Convertisseur HTML du plug-in Java(tm) " },
    { "nottemplatefile_dialog.caption", "Ce n'est pas un fichier mod\u00e8le"},
    { "nottemplatefile_dialog.info0", "Le fichier sp\u00e9cifi\u00e9 dans le champ \"Fichier mod\u00e8le :\" " + newline +
                      "n'est pas un fichier mod\u00e8le valide. Le fichier doit avoir" + newline +
                      "une extension .tpl." + newline + newline +
                      "Voulez-vous utiliser le fichier mod\u00e8le" + newline +
                      "par d\u00e9faut ("},
    { "nottemplatefile_dialog.info1", ") ?"},
    { "nottemplatefile_dialog.info2", "Utilisation du fichier mod\u00e8le par d\u00e9faut.  Le fichier mod\u00e8le sp\u00e9cifi\u00e9 n'existe pas."},
    { "nopluginurl_dialog.info0", "Les URL n\u00e9cessaires pour le plug-in Java ne sont pas disponibles."},
    { "nopluginurl_dialog.info1", "Les URL n\u00e9cessaires pour le convertisseur ne sont pas disponibles." + newline +
                      "(converter.props ne se trouve pas dans le chemin des classes.)"},
    { "nopluginurl_dialog.info2", "Les URL de sauvegarde n\u00e9cessaires pour le plug-in Java ne sont pas disponibles." + newline +
                      "(default.props ne se trouve pas dans le chemin des classes.)"},
    { "warning_dialog.info", "Le chemin des dossiers de sauvegarde et de destination doit" + newline +
                             "u00eatre diff\u00e9rent. Souhaitez-vous   remplacer le chemin" + newline +
                             "du dossier de sauvegarde par :"},
    { "notemplate_dialog.caption", "Fichier mod\u00e8le introuvable"},
    { "notemplate_dialog.info0", "Le fichier mod\u00e8le par d\u00e9faut ("},
    { "notemplate_dialog.info1", ") est" + newline +"introuvable. Soit il ne se trouve pas dans le chemin des classes," + newline +
                     "soit il ne se trouve pas dans le r\u00e9pertoire de travail."},
    { "file_unwritable.info", "Impossible d'\u00e9crire dans le fichier : "},
    { "file_notexists.info", "Le fichier n'existe pas : "},
    { "illegal_source_and_backup.info", "Les r\u00e9pertoires de destination et de sauvegarde doivent u00eatre diff\u00e9rents !"},
    { "button.reset", "Restaurer les valeurs par d\u00e9faut"},
    { "button.okay", "OK"},
    { "button.cancel", "Annuler"},
    { "button.about", "A propos de"},
    { "button.print", "Imprimer"},
    { "button.done", "Termin\u00e9"},
    { "button.browse", "Parcourir..."},
    { "button.quit", "Quitter"},
    { "button.advanced", "Options avanc\u00e9es..."},
    { "button.help", "Aide"},
    { "button.convert", "Convertir..."},

    { "advanced_dialog.caption", "Options avanc\u00e9es"},
    { "advanced_dialog.cab", "Sp\u00e9cifier l'emplacement source du fichier ActiveX CAB :"},
    { "advanced_dialog.plugin", "Sp\u00e9cifier l'emplacement source du plug-in Netscape :"},
        { "advanced_dialog.smartupdate", "Sp\u00e9cifier l'emplacement source de Netscape SmartUpdate :"},    
        { "advanced_dialog.mimetype", "Sp\u00e9cifier le type MIME pour la conversion HTML du plug-in Java :"}, 
    { "advanced_dialog.log", " Sp\u00e9cifier l'emplacement du fichier journal :"},
    { "advanced_dialog.generate", "G\u00e9n\u00e9rer le fichier journal"},

    { "progress_dialog.caption", "Progression..."},
    { "progress_dialog.processing", "Traitement en cours..."},
    { "progress_dialog.folder", "Dossier :"},
    { "progress_dialog.file", "Fichier :"},
    { "progress_dialog.totalfile", "Nombre de fichiers trait\u00e9s :"},
    { "progress_dialog.totalapplet", "Nombre d'applets trouv\u00e9s :"},
    { "progress_dialog.totalerror", "Nombre total d'erreurs :"},

    { "notdirectory_dialog.caption0", "Fichier non valide"},
    { "notdirectory_dialog.caption1", "Dossier non valide"},
    { "notdirectory_dialog.info0", "Le dossier suivant n'existe pas" + newline},
    { "notdirectory_dialog.info1", " Le fichier suivant n'existe pas " + newline},
    { "notdirectory_dialog.info2", "(dans la zone de texte \"Tous les fichiers du dossier\") :" + newline},
    { "notdirectory_dialog.info3", "(dans la zone de texte \"Un fichier\") :" + newline},
    { "notdirectory_dialog.info4", "(dans la zone de texte \"Fichier mod\u00e8le\") :" + newline},
    { "notdirectory_dialog.info5", "<vide>"},

        { "converter_gui.lablel0", "Sp\u00e9cifiez un fichier ou un chemin de r\u00e9pertoire :"},
        { "converter_gui.lablel1", "Noms de fichiers correspondants :"},
        { "converter_gui.lablel2", "*.html, *.htm, *.asp"},
        { "converter_gui.lablel3", "Inclure les sous-dossiers"},
        { "converter_gui.lablel4", "Un fichier :"},
        { "converter_gui.lablel5", "Sauvegarder les fichiers dans le dossier :"},
        { "converter_gui.lablel7", "Fichier mod\u00e8le :"},


    { "template.default", "Standard (IE & Netscape Navigator) pour Windows & Solaris uniquement"},
    { "template.extend",  "Etendu (standard + tous les navigateurs et toutes les plates-formes)"},
    { "template.ieonly",  "Internet Explorer pour Windows & Solaris uniquement"},
    { "template.nsonly",  "Netscape Navigator pour Windows uniquement"},
    { "template.other",   "Autre mod\u00e8le..."},

    { "help_dialog.caption", "Aide"},

    { "menu.file", "Fichier"},
    { "menu.exit", "Quitter"},
    { "menu.edit", "Edition"},
    { "menu.option", "Options"},
    { "menu.help", "Aide"},
    { "menu.about", "A propos de"},

        { "progress_event.preparing", "Pr\u00e9paration en cours"},
        { "progress_event.converting", "Conversion en cours"},
        { "progress_event.copying", "Copie en cours"},
        { "progress_event.done", "Termin\u00e9"},
        { "progress_event.destdirnotcreated", "Impossible de cr\u00e9er un r\u00e9pertoire de destination."},
        { "progress_event.error", "Erreur"},
        { "plugin_converter.propnotfound2", "Fichiers de propri\u00e9t\u00e9s introuvables. Propri\u00e9t\u00e9s par d\u00e9faut utilis\u00e9es."},    
    { "plugin_converter.propnotfound", "converter.props introuvable. Il est n\u00e9cessaire pour charger les emplacements de t\u00e9l\u00e9chargement du plug-in Java"},
    { "plugin_converter.logerror", "La sortie du fichier journal n'a pas pu \u00eatre \u00e9tablie"},
    { "plugin_converter.saveerror", "Impossible d'enregistrer le fichier de propri\u00e9t\u00e9s :  "},
    { "plugin_converter.appletconv", "Conversion d'applet "},
    { "plugin_converter.done", "Termin\u00e9. Fichiers trait\u00e9s :  "},
        { "plugin_converter.failure", "Impossible de convertir le fichier "},
    { "plugin_converter.overwrite1", "Une copie de sauvegarde existe d\u00E9j\u00E0 pour..." + newline + newline },
    { "plugin_converter.overwrite2", newline + newline + "Voulez-vous remplacer cette copie de sauvegarde ?"},
        { "plugin_converter.appletfound", "  Applets trouv\u00e9s :  "},
        { "plugin_converter.processing", "  Traitement en cours..."},
        { "plugin_converter.cancel", "Conversion annul\u00e9e"},
        { "plugin_converter.files", "Fichiers \u00e0 convertir : "},
        { "plugin_converter.converted", "Fichier d\u00e9j\u00e0 converti, aucune conversion n\u00e9cessaire. "},
        { "plugin_converter.donefound", "Termin\u00e9. Applets trouv\u00e9s :  "},
        { "plugin_converter.seetrace", "Erreur dans le fichier : voir le suivi ci-dessous"},
        { "plugin_converter.noapplet", "Aucun applet dans le fichier "},
        { "plugin_converter.nofiles", "Aucun fichier \u00e0 traiter "},
        { "plugin_converter.nobackuppath", "Le chemin de sauvegarde n'a pas \u00e9t\u00e9 cr\u00e9\u00e9"},
        { "plugin_converter.writelog", "Ecriture dans un fichier journal du m\u00eame nom"},
        { "plugin_converter.backup_path", "Chemin de sauvegarde"},
        { "plugin_converter.log_path", "Chemin d'acc\u00e8s aux journaux"},
        { "plugin_converter.template_file", "Fichier mod\u00e8le"},
        { "plugin_converter.process_subdirs", "Sous-r\u00e9pertoires de traitement"},
        { "plugin_converter.show_progress", "Afficher la progression"},
        { "plugin_converter.help_message", newline + 
                                      "Syntaxe : HtmlConverter [-option1 valeur1 [-option2 valeur2 [...]]] [-simulate]  [specsfichier]" + newline + newline +
                                      "o\u00F9 les options sont :" + newline + newline +
                                      "    -source:    Chemin d'acc\u00E8s aux fichiers originaux.  Par d\u00E9faut : <reputil>" + newline +
                                      "    -dest:      Chemin d'acc\u00E8s aux fichiers convertis.  Par d\u00E9faut : <reputil>" + newline +
                                      "    -backup:    Chemin d'acc\u00E8s aux fichiers de sauvegarde.  Par d\u00E9faut : <nomrep>_BAK" + newline +
                                      "    -subdirs:   Si les fichiers situ\u00E9s dans les sous-r\u00E9pertoires doivent \u00EAtre trait\u00E9s." + newline +
                                      "    -template:  Chemin d'acc\u00E8s aux fichier de mod\u00E8le.  En cas de doute, utilisez la valeur par d\u00E9faut." + newline +
                                      "    -log:       Chemin d'acc\u00E8s au journal d'\u00E9criture.  Doit \u00EAtre sp\u00E9cifi\u00E9 pour que le journal soit cr\u00E9\u00E9." + newline +
                                      "    -progress:  Indique la progression de la conversion.  Par d\u00E9faut : true" + newline +
                                      "    -simulate:  D\u00E9crit la conversion sans l'ex\u00E9cuter." + newline + 
                                          "    -gui:       Affiche l'interface graphique utilisateur du convertisseur." + newline + newline +
                                      "    filespecs:  Liste de sp\u00E9cifications de fichiers s\u00E9par\u00E9es par des espaces.  Par d\u00E9faut : \"*.html *.htm\" (guillemets obligatoires)" + newline},

    { "product_name", "Java(TM) Plug-in HTML Converter" },
    };
}






