/*
 * @(#)Converter_it.java    1.19 01/03/08
 *
 * Copyright (c) 1998-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1 
 *
 */

package sun.plugin.converter.resources;

import java.util.ListResourceBundle;

/**
 * US English version of Java Plug-in HTML Converter strings.
 *
 * @author Stanley Man-Kit Ho
 */

public class Converter_it extends ListResourceBundle {

    private static String newline = System.getProperty("line.separator");
    private static String fileSeparator = System.getProperty("file.separator");

    public Object[][] getContents() {
    return contents;
    }

    static final Object[][] contents = {
    { "caption.error", "Errore" },
    { "caption.warning", "Avviso" },
    { "caption.propnotfound", "File delle propriet\u00e0 non trovato" },
    { "caption.tempnotfound", "File modello non trovato" },
        { "caption.absdirnotfound", "Impossibile trovare la cartella assoluta" },
        { "caption.reldirnotfound", "Impossibile trovare la cartella relativa" },
        { "about_dialog.info", "Convertitore HTML Java(TM) Plug-in v" },
        { "about_dialog.info2", "\nCopyright 2001 Sun Microsystems, Inc." },
        { "about_dialog.caption", "Informazioni sul convertitore HTML Java(TM) Plug-in" },
    { "nottemplatefile_dialog.caption", "File modello non valido"},
    { "nottemplatefile_dialog.info0", "Il file specificato nel campo \"File modello:\"" + newline +
                      "non \u00e8 un file modello valido. Il file deve avere" + newline +
                      "l'estensione .tpl" + newline + newline +
                      "Ripristinare il file modello" + newline +
                      "predefinito ("},
    { "nottemplatefile_dialog.info1", ")?"},
    { "nottemplatefile_dialog.info2", "Verr\u00e0 utilizzato il file modello predefinito. Il file modello specificato non esiste."},
    { "nopluginurl_dialog.info0", "Gli URL necessari per Java Plug-in non sono disponibili."},
    { "nopluginurl_dialog.info1", "Gli URL necessari per il convertitore non sono disponibili." + newline +
                      "(converter.props mancante in classpath.)"},
    { "nopluginurl_dialog.info2", "Gli URL di backup necessari per Java Plug-in non sono disponibili." + newline +
                      "(default.props mancante in classpath.)"},
    { "warning_dialog.info", "La cartella di backup e la cartella di destinazione" + newline +
                             "non possono avere lo stesso percorso. Si desidera" + newline +
                             "cambiare il percorso della cartella di backup in:"},
    { "notemplate_dialog.caption", "File modello non trovato"},
    { "notemplate_dialog.info0", "Il file modello predefinito ("},
    { "notemplate_dialog.info1", ") non \u00e8" + newline + "stato trovato. Non \u00e8 presente nel classpath" + newline +
                     "o nella directory di lavoro."},
    { "file_unwritable.info", "Impossibile scrivere sul file: "},
    { "file_notexists.info", "File inesistente: "},
    { "illegal_source_and_backup.info", "La directory di destinazione e quella di backup non possono coincidere!"},
    { "button.reset", "Ripristina valori predefiniti"},
    { "button.okay", "OK"},
    { "button.cancel", "Annulla"},
    { "button.about", "Informazioni su"},
    { "button.print", "Stampa"},
    { "button.done", "Chiudi"},
    { "button.browse", "Sfoglia..."},
    { "button.quit", "Esci"},
    { "button.advanced", "Opzioni avanzate..."},
    { "button.help", "?"},
    { "button.convert", "Converti..."},

    { "advanced_dialog.caption", "Opzioni avanzate"},
    { "advanced_dialog.cab", "Specifica posizione di origine per file CAB ActiveX:"},
    { "advanced_dialog.plugin", "Specifica posizione di origine per Netscape Plug-in:"},
        { "advanced_dialog.smartupdate", "Specificare la posizione di origine di Netscape SmartUpdate:"}, 
        { "advanced_dialog.mimetype", "Specificare il tipo MIME per la conversione HTML di Java Plug-In:"},   
    { "advanced_dialog.log", "Specifica posizione per file di log:"},
    { "advanced_dialog.generate", "Genera file di log"},

    { "progress_dialog.caption", "Avanzamento..."},
    { "progress_dialog.processing", "Elaborazione in corso..."},
    { "progress_dialog.folder", "Cartella:"},
    { "progress_dialog.file", "File:"},
    { "progress_dialog.totalfile", "Totale file elaborati:"},
    { "progress_dialog.totalapplet", "Totale applet trovati:"},
    { "progress_dialog.totalerror", "Totale errori:"},

    { "notdirectory_dialog.caption0", "File non valido"},
    { "notdirectory_dialog.caption1", "Cartella non valida"},
    { "notdirectory_dialog.info0", "La cartella seguente non esiste" + newline},
    { "notdirectory_dialog.info1", "Il file seguente non esiste" + newline},
    { "notdirectory_dialog.info2", "(nel campo di testo \"Tutti i file nella cartella\"):" + newline},
    { "notdirectory_dialog.info3", "(nel campo di testo \"File singolo\"):" + newline},
    { "notdirectory_dialog.info4", "(nel campo di testo \"File modello\"):" + newline},
    { "notdirectory_dialog.info5", "<vuoto>"},

        { "converter_gui.lablel0", "Specificare un file o una directory:"},
        { "converter_gui.lablel1", "Nomi file corrispondenti:"},
        { "converter_gui.lablel2", "*.html, *.htm, *.asp"},
        { "converter_gui.lablel3", "Includi sottocartelle"},
        { "converter_gui.lablel4", "File singolo:"},
        { "converter_gui.lablel5", "Backup dei file nella cartella:"},
        { "converter_gui.lablel7", "File modello:"},


    { "template.default", "Standard (IE e Navigator) solo per Windows e Solaris"},
    { "template.extend",  "Esteso (Standard + tutti i browser/piattaforme)"},
    { "template.ieonly",  "Internet Explorer solo per Windows e Solaris"},
    { "template.nsonly",  "Solo Navigator per Windows"},
    { "template.other",   "Altri modelli..."},

    { "help_dialog.caption", "?"},

    { "menu.file", "File"},
    { "menu.exit", "Esci"},
    { "menu.edit", "Modifica"},
    { "menu.option", "Opzioni"},
    { "menu.help", "?"},
    { "menu.about", "Informazioni su"},

        { "progress_event.preparing", "Preparazione"},
        { "progress_event.converting", "Conversione"},
        { "progress_event.copying", "Copia"},
        { "progress_event.done", "Chiudi"},
        { "progress_event.destdirnotcreated", "Impossibile creare la directory di destinazione"},
        { "progress_event.error", "Errore"},

        { "plugin_converter.propnotfound2", "File di propriet\u00e0 non trovati. Saranno utilizzate le propriet\u00e0 predefinite."},   
 
    { "plugin_converter.propnotfound", "converter.props non trovato. Richiesto per caricare i percorsi di scaricamento di Java Plug-in"},
    { "plugin_converter.logerror", "Impossibile eseguire l'output del file di log"},
    { "plugin_converter.saveerror", "Impossibile salvare il file delle propriet\u00e0:  "},
    { "plugin_converter.appletconv", "Conversione dell'applet "},
    { "plugin_converter.done", "Operazione eseguita. File elaborati:  "},
        { "plugin_converter.failure", "Impossibile convertire il file "},
    { "plugin_converter.overwrite1", "Esiste gi\u00E0 una copia di backup per..." + newline + newline },
    { "plugin_converter.overwrite2", newline + newline + "Sovrascriverla?"},
        { "plugin_converter.appletfound", "  Applet trovati:  "},
        { "plugin_converter.processing", "  Elaborazione in corso..."},
        { "plugin_converter.cancel", "Conversione annullata"},
        { "plugin_converter.files", "File da convertire: "},
        { "plugin_converter.converted", "File gi\u00e0 convertito. Conversione non necessaria. "},
        { "plugin_converter.donefound", "Operazione eseguita. Applet trovati:  "},
        { "plugin_converter.seetrace", "Errore nel file - vedere il file traccia riportato di seguito"},
        { "plugin_converter.noapplet", "Nessun applet nel file "},
        { "plugin_converter.nofiles", "Nessun file da elaborare "},
        { "plugin_converter.nobackuppath", "Percorso di backup non creato"},
        { "plugin_converter.writelog", "Scrittura su un file di log con lo stesso nome"},
        { "plugin_converter.backup_path", "Percorso di backup"},
        { "plugin_converter.log_path", "Percorso del file di log"},
        { "plugin_converter.template_file", "File modello"},
        { "plugin_converter.process_subdirs", "Elabora sottocartelle"},
        { "plugin_converter.show_progress", "Mostra avanzamento"},
        { "plugin_converter.help_message", newline + 
                                      "Utilizzo: HtmlConverter [-opzione1 valore1 [-opzione2 valore2 [...]]] [-simulate]  [specfile]" + newline + newline +
                                      "dove le opzioni includono:" + newline + newline +
                                      "    -source:    percorso da cui leggere i file originari.  Default: <dirutente>" + newline +
                                      "    -dest:      percorso in cui scrivere i file convertiti.  Default: <dirutente>" + newline +
                                      "    -backup:    percorso in cui scrivere i file di backup.  Default: <nomedir>_BAK" + newline +
                                      "    -subdirs:   elabora i file nelle sottocartelle." + newline +
                                      "    -template:  percorso del file modello.  In caso di dubbio utilizzare il percorso di default." + newline +
                                      "    -log:       percorso in cui scrivere il file di log.  Se non specificato, il file non verr\u00E0 scritto." + newline +
                                      "    -progress:  visualizza l'avanzamento durante la conversione.  Default: true" + newline +
                                      "    -simulate:  visualizza le specifiche della conversione senza effettuarla." + newline + 
                                          "    -gui:       visualizza l'interfaccia utente grafica per il converter." + newline + newline +
                                      "    filespecs:  Elenco delimitato da spazi delle specifiche dei file.  Default: \"*.html *.htm\" (virgolette richieste)" + newline},

    { "product_name", "Java(TM) Plug-in HTML Converter" },
    };
}



