/*
 * @(#)Converter_sv.java    1.19 01/03/08
 *
 * Copyright (c) 1998-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1 
 *
 */

package sun.plugin.converter.resources;

import java.util.ListResourceBundle;

/**
 * US English version of Java Plug-in HTML Converter strings.
 *
 * @author Stanley Man-Kit Ho
 */

public class Converter_sv extends ListResourceBundle {

    private static String newline = System.getProperty("line.separator");
    private static String fileSeparator = System.getProperty("file.separator");

    public Object[][] getContents() {
    return contents;
    }

    static final Object[][] contents = {
    { "caption.error", "Fel" },
    { "caption.warning", "Varning" },
    { "caption.propnotfound", "Hittar inte egenskapsfilen" },
    { "caption.tempnotfound", "Hittar inte mallfilen" },
        { "caption.absdirnotfound", "Hittar inte absolut katalog" },
        { "caption.reldirnotfound", "Hittar inte relativ katalog" },
        { "about_dialog.info", "Java(tm) Plug-in HTML Converter v" },
        { "about_dialog.info2", "\nCopyright 2001 Sun Microsystems, Inc." },
        { "about_dialog.caption", "Om Java(tm) Plug-in HTML Converter" },
    { "nottemplatefile_dialog.caption", "Ingen mallfil"},
    { "nottemplatefile_dialog.info0", "Filen i f\u00e4ltet \"Mallfil:\"" + newline +
                      "\u00e4r ingen giltig mallfil. Filen m\u00e5ste ha" + newline +
                      "filtypen .tpl" + newline + newline +
                      "Vill du \u00e5terst\u00e4lla mallfilen till" + newline +
                      "standardfilen ("},
    { "nottemplatefile_dialog.info1", ")?"},
    { "nottemplatefile_dialog.info2", "Anv\u00e4nder standardinst\u00e4lld mallfil. Angiven mallfil \u00e4r inte tillg\u00e4nglig."},
    { "nopluginurl_dialog.info0", "De URLer som beh\u00f6vs f\u00f6r Java Plug-in \u00e4r inte tillg\u00e4ngliga."},
    { "nopluginurl_dialog.info1", "De URLer som beh\u00f6vs f\u00f6r konverteraren \u00e4r inte tillg\u00e4ngliga." + newline +
                      "(converter.props saknas i classpath.)"},
    { "nopluginurl_dialog.info2", "De backup-URLer som beh\u00f6vs f\u00f6r Java Plug-in \u00e4r inte tillg\u00e4ngliga." + newline +
                      "(default.props saknas i classpath.)"},
    { "warning_dialog.info", "Mappen f\u00F6r s\u00E4kerhetskopior och destinationsmappen kan inte" + newline +
                             "ha samma s\u00F6kv\u00E4g. Vill du att s\u00E4kerhetskopian" + newline +
                             "ska sparas till f\u00F6ljande s\u00F6kv\u00E4g:"},
    { "notemplate_dialog.caption", "Hittar inte mallfil"},
    { "notemplate_dialog.info0", "Standardmallfilen ("},
    { "notemplate_dialog.info1", ") finns" + newline + "inte. Antingen finns den inte i classpath" + newline +
                     "eller ocks\u00e5 finns den inte i arbetskatalogen."},
    { "file_unwritable.info", "Kan inte skriva till filen: "},
    { "file_notexists.info", "Filen finns inte: "},
    { "illegal_source_and_backup.info", "Destinationsmappen och mappen f\u00F6r s\u00E4kerhetskopior kan inte vara samma!"},
    { "button.reset", "\u00c5terst\u00e4ll standardv\u00e4rden"},
    { "button.okay", "OK"},
    { "button.cancel", "Avbryt"},
    { "button.about", "Om"},
    { "button.print", "Skriv ut"},
    { "button.done", "Klar"},
    { "button.browse", "Bl\u00e4ddra..."},
    { "button.quit", "Avsluta"},
    { "button.advanced", "Avancerade alternativ..."},
    { "button.help", "Hj\u00e4lp"},
    { "button.convert", "Konvertera..."},

    { "advanced_dialog.caption", "Avancerade alternativ"},
    { "advanced_dialog.cab", "Ange k\u00e4llplats f\u00f6r ActiveX CAB-fil:"},
    { "advanced_dialog.plugin", "Ange k\u00e4llplats f\u00f6r Netscape Plug-In:"},
        { "advanced_dialog.smartupdate", "Ange k\u00e4llplats f\u00f6r Netscape SmartUpdate:"},     
        { "advanced_dialog.mimetype", "Ange MIME-typ f\u00f6r Java Plug-In HTML-konvertering:"},
    { "advanced_dialog.log", "Ange plats f\u00f6r logfil:"},
    { "advanced_dialog.generate", "Generera loggfil"},

    { "progress_dialog.caption", "Status..."},
    { "progress_dialog.processing", "Bearbetar..."},
    { "progress_dialog.folder", "Mapp:"},
    { "progress_dialog.file", "Fil:"},
    { "progress_dialog.totalfile", "Antal bearbetade filer:"},
    { "progress_dialog.totalapplet", "Antal funna appletar:"},
    { "progress_dialog.totalerror", "Totalt antal fel:"},

    { "notdirectory_dialog.caption0", "Ogiltig fil"},
    { "notdirectory_dialog.caption1", "Ogiltig mapp"},
    { "notdirectory_dialog.info0", "Den h\u00e4r mappen finns inte" + newline},
    { "notdirectory_dialog.info1", "Den h\u00e4r filen finns inte" + newline},
    { "notdirectory_dialog.info2", "(i f\u00e4ltet \"Alla filer i mappen\"):" + newline},
    { "notdirectory_dialog.info3", "(i f\u00e4ltet \"En fil\"):" + newline},
    { "notdirectory_dialog.info4", "(i f\u00e4ltet \"Mallfil\"):" + newline},
    { "notdirectory_dialog.info5", "<tom>"},

        { "converter_gui.lablel0", "Ange fil eller s\u00f6kv\u00e4g:"},
        { "converter_gui.lablel1", "\u00d6verensst\u00e4mmande filnamn:"},
        { "converter_gui.lablel2", "*.html, *.htm, *.asp"},
        { "converter_gui.lablel3", "Ta med underliggande mappar"},
        { "converter_gui.lablel4", "En fil:"},
        { "converter_gui.lablel5", "S\u00e4kerhetskopiera filer till mapp:"},
        { "converter_gui.lablel7", "Mappfil:"},


    { "template.default", "Endast standard (IE & Navigator) f\u00f6r Windows & Solaris"},
    { "template.extend",  "Ut\u00f6kad (Standard + Alla webbl\u00e4sare/plattformar)"},
    { "template.ieonly",  "Endast Internet Explorer f\u00f6r Windows & Solaris"},
    { "template.nsonly",  "Endast Navigator f\u00f6r Windows"},
    { "template.other",   "Annan mall..."},

    { "help_dialog.caption", "Hj\u00e4lp"},

    { "menu.file", "Arkiv"},
    { "menu.exit", "Avsluta"},
    { "menu.edit", "Redigera"},
    { "menu.option", "Alternativ"},
    { "menu.help", "Hj\u00e4lp"},
    { "menu.about", "Om"},

        { "progress_event.preparing", "F\u00f6rbereder"},
        { "progress_event.converting", "Konverterar"},
        { "progress_event.copying", "Kopierar"},
        { "progress_event.done", "Klar"},
        { "progress_event.destdirnotcreated", "Kunde inte skapa m\u00e5lkatalog."},
        { "progress_event.error", "Fel"},

        { "plugin_converter.propnotfound2", "Det gick inte att hitta egenskapsfilerna. Standardegenskaper anv\u00e4nds."},      
    { "plugin_converter.propnotfound", "Hittar inte converter.props. Beh\u00f6vs f\u00f6r att l\u00e4sa in nedl\u00e4sningsplatser f\u00f6r Java Plug-in"},
    { "plugin_converter.logerror", "Loggfilsutdata kunde inte fastst\u00e4llas"},
    { "plugin_converter.saveerror", "Kunde inte spara egenskapsfilen: "},
    { "plugin_converter.appletconv", "Konvertering av appletar"},
    { "plugin_converter.done", "Alla klara  Bearbetade filer: "},
        { "plugin_converter.failure", "Kunde inte konvertera filen "},
    { "plugin_converter.overwrite1", "Det finns redan en s\u00E4kerhetskopia f\u00F6r..." + newline + newline },
    { "plugin_converter.overwrite2", newline + newline + "Vill du skriva \u00F6ver den h\u00E4r s\u00E4kerhetskopian?"},
        { "plugin_converter.appletfound", "  Antal funna appletar: "},
        { "plugin_converter.processing", "  Bearbetar..."},
        { "plugin_converter.cancel", "Konverteringen avbr\u00f6ts"},
        { "plugin_converter.files", "Filer som ska konverteras: "},
        { "plugin_converter.converted", "Filen redan konverterad. Ingen konvertering beh\u00f6vs. "},
        { "plugin_converter.donefound", "Klart  Antal funna appletar: "},
        { "plugin_converter.seetrace", "Fel i fil - se sp\u00e5rning nedan"},
        { "plugin_converter.noapplet", "Inga appletar i filen "},
        { "plugin_converter.nofiles", "Finns inga filer att bearbeta "},
        { "plugin_converter.nobackuppath", "Skapade inte backups\u00f6kv\u00e4g"},
        { "plugin_converter.writelog", "Skriver \u00f6ver loggfilen med samma namn"},
        { "plugin_converter.backup_path", "Backups\u00f6kv\u00e4g"},
        { "plugin_converter.log_path", "Loggs\u00f6kv\u00e4g"},
        { "plugin_converter.template_file", "Mallfil"},
        { "plugin_converter.process_subdirs", "Underordnade kataloger som ska behandlas"},
        { "plugin_converter.show_progress", "Visa f\u00f6rlopp"},
        { "plugin_converter.help_message", newline + 
                                      "G\u00F6r s\u00E5 h\u00E4r: HtmlConverter [-alternativ1 v\u00E4rde1 [-alternativ2 v\u00E4rde2 [...]]] [-simulate]  [filspecifikation]" + newline + newline +
                                      "d\u00E4r alternativen omfattar:" + newline + newline +
                                      "    -source:    S\u00F6kv\u00E4g till originalfiler.  Standard: <anv\u00E4ndarkatalog>" + newline +
                                      "    -dest:      S\u00F6kv\u00E4g f\u00F6r att spara konverterade filer.  Standard: <anv\u00E4ndarkatalog>" + newline +
                                      "    -backup:    S\u00F6kv\u00E4g f\u00F6r att spara backupfiler.  Standard: <katalognamn>_BAK" + newline +
                                      "    -subdirs:   Ska filer i underordnade kataloger behandlas." + newline +
                                      "    -template:  S\u00F6kv\u00E4g till mallfil.  Anv\u00E4nd standard vid tveksamheter." + newline +
                                      "    -log:       S\u00F6kv\u00E4g till logg.  Om den inte anges, skrivs ingen logg." + newline +
                                      "    -progress:  Visa f\u00F6rlopp under konvertering.  Standard: true" + newline +
                                      "    -simulate:  Visa detaljerna i konverteringen utan att konvertera." + newline + 
                                          "    -gui:       Visa det grafiska anv\u00E4ndargr\u00E4nssnittet f\u00F6r konverteringen." + newline + newline +
                                      "    filespecs:  Blankstegsformaterad lista \u00F6ver filspecifikationer.  Standard: \"*.html *.htm\" (citattecken kr\u00E4vs)" + newline},

    { "product_name", "Java(TM) Plug-in HTML Converter" },
    };
}



