/*
 * @(#)Converter_zh_CN.java	1.22 01/04/04
 *
 *  Copyright (c) 1998-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.1 
 *
 */

package sun.plugin.converter.resources;

import java.util.ListResourceBundle;

/**
 * Simplified Chinese version of Java Plug-in HTML Converter strings.
 * from
 * US English version of Java Plug-in HTML Converter strings.
 *
 * @author Stanley Man-Kit Ho
 */

public class Converter_zh_CN extends ListResourceBundle {

    private static String newline = System.getProperty("line.separator");
    private static String fileSeparator = System.getProperty("file.separator");

    public Object[][] getContents() {
	return contents;
    }

    static final Object[][] contents = {
	{ "caption.error", "\u9519\u8bef" },
	{ "caption.warning", "\u8b66\u544a" },
	{ "caption.propnotfound", "\u6ca1\u6709\u627e\u5230\u5c5e\u6027\u6587\u4ef6" },
	{ "caption.tempnotfound", "\u6ca1\u6709\u627e\u5230\u6a21\u677f\u6587\u4ef6" },
	{ "caption.absdirnotfound", "\u6ca1\u6709\u627e\u5230\u7edd\u5bf9\u8def\u5f84" },
	{ "caption.reldirnotfound", "\u6ca1\u6709\u627e\u5230\u76f8\u5bf9\u8def\u5f84" },
        { "about_dialog.info", "Java(tm) Plug-in HTML \u8f6c\u6362\u7a0b\u5e8f\u7248\u672c" },
	{ "about_dialog.info2", "\nCopyright 2001 Sun Microsystems, Inc." },
        { "about_dialog.caption", "\u5173\u4e8e Java(tm) Plug-in HTML \u8f6c\u6362\u7a0b\u5e8f" },
	{ "nottemplatefile_dialog.caption", "\u4e0d\u662f\u6a21\u677f\u6587\u4ef6"},
	{ "nottemplatefile_dialog.info0", "\u4e0b\u9762\u6240\u6307\u5b9a\u7684\u6587\u4ef6\u201c\u6a21\u677f\u6587\u4ef6\uff1a\u201d\u57df" + newline
					+ "\u4e0d\u662f\u4e00\u4e2a\u6709\u6548\u7684\u6a21\u677f\u6587\u4ef6\u3002\u8be5\u6587\u4ef6\u7684\u7ed3\u5c3e\u5fc5\u987b" + newline
					+ "\u662f .tpl \u6269\u5c55\u540d" + newline + newline
					+ "\u60a8\u613f\u610f\u5c06\u6a21\u677f\u6587\u4ef6\u91cd\u8bbe\u6210" + newline
					+ "\u9ed8\u8ba4\u503c\u5417\uff08"},
	{ "nottemplatefile_dialog.info1", "\uff09\uff1f"},
	{ "nottemplatefile_dialog.info2", "\u4f7f\u7528\u9ed8\u8ba4\u6a21\u677f\u6587\u4ef6\u3002  \u6307\u5b9a\u7684\u6a21\u677f\u6587\u4ef6\u4e0d\u5b58\u5728\u3002"},
	{ "nopluginurl_dialog.info0", "Java Plug-in \u6240\u9700\u7684 URL \u4e0d\u53ef\u7528\u3002 "},
	{ "nopluginurl_dialog.info1", "\u8f6c\u6362\u7a0b\u5e8f\u6240\u9700\u7684 URL \u4e0d\u53ef\u7528\u3002" + newline
				    + "\uff08classpath \u4e2d\u7f3a\u5c11 converter.props\u3002\uff09"},
	{ "nopluginurl_dialog.info2", "Java Plug-in \u6240\u9700\u7684\u5907\u4efd URL \u4e0d\u53ef\u7528\u3002" + newline
				    + "\uff08classpath \u4e2d\u7f3a\u5c11 default.props\u3002\uff09"},
	{ "warning_dialog.info", "\u5907\u4efd\u76ee\u5f55\u548c\u76ee\u6807\u76ee\u5f55\u4e0d\u53ef" + newline
				+"\u62e5\u6709\u540c\u4e00\u8def\u5f84\u3002\u60a8\u613f\u610f\u5c06\u5907\u4efd" + newline
				+"\u76ee\u5f55\u8def\u5f84\u53d8\u4e3a\u5982\u4e0b\u5417\uff1a"},
	{ "notemplate_dialog.caption", "\u6ca1\u6709\u627e\u5230\u6a21\u677f\u6587\u4ef6"},
	{ "notemplate_dialog.info0", "\u9ed8\u8ba4\u7684\u6a21\u677f\u6587\u4ef6\uff08"},
	{ "notemplate_dialog.info1", "\uff09\u65e0\u6cd5\u627e\u5230\u3002\u5b83\u6216\u8005\u4e0d\u5728 classpath" + newline
				    +"\u4e2d\uff0c\u6216\u8005\u4e0d\u5728\u5de5\u4f5c\u76ee\u5f55\u4e2d\u3002"},
	{ "file_unwritable.info", "\u6587\u4ef6\u65e0\u6cd5\u5199\u5165: "},
	{ "file_notexists.info", "\u6587\u4ef6\u4e0d\u5b58\u5728: "},
	{ "illegal_source_and_backup.info", "\u76ee\u6807\u76ee\u5f55\u548c\u5907\u4efd\u76ee\u5f55\u4e0d\u80fd\u76f8\u540c!"},
	{ "button.reset", "\u91cd\u8bbe\u4e3a\u9ed8\u8ba4\u503c"},
	{ "button.okay", "\u786e\u5b9a"},
	{ "button.cancel", "\u53d6\u6d88"},
	{ "button.about", "\u5173\u4e8e"},
	{ "button.print", "\u6253\u5370"},
	{ "button.done", "\u5b8c\u6210"},
	{ "button.browse", "\u6d4f\u89c8..."},
	{ "button.quit", "\u9000\u51fa"},
	{ "button.advanced", "\u9ad8\u7ea7\u9009\u9879..."},
	{ "button.help", "\u5e2e\u52a9"},
	{ "button.convert", "\u8f6c\u6362..."},

	{ "advanced_dialog.caption", "\u9ad8\u7ea7\u9009\u9879"},
	{ "advanced_dialog.cab", "\u6307\u5b9a ActiveX CAB \u6587\u4ef6\u7684\u6e90\u4f4d\u7f6e\uff1a"},
	{ "advanced_dialog.plugin", "\u6307\u5b9a Netscape Plug-in \u7684\u6e90\u4f4d\u7f6e\uff1a"},
	{ "advanced_dialog.smartupdate", "\u6307\u5b9a Netscape SmartUpdate \u7684\u6e90\u4f4d\u7f6e:"},
	{ "advanced_dialog.mimetype", "\u6307\u5b9a Java Plug-in HTML \u8f6c\u6362\u7684 MIME \u7c7b\u578b:"},
	{ "advanced_dialog.log", "\u6307\u5b9a\u65e5\u5fd7\u6587\u4ef6\uff1a"},
	{ "advanced_dialog.generate", "\u751f\u6210\u65e5\u5fd7\u6587\u4ef6"},

	{ "progress_dialog.caption", "\u8fdb\u5ea6..."},
	{ "progress_dialog.processing", "\u6b63\u5728\u5904\u7406..."},
	{ "progress_dialog.folder", "\u76ee\u5f55\uff1a"},
	{ "progress_dialog.file", "\u6587\u4ef6\uff1a"},
	{ "progress_dialog.totalfile", "\u5904\u7406\u8fc7\u7684\u6587\u4ef6\u603b\u8ba1\uff1a"},
	{ "progress_dialog.totalapplet", "\u627e\u5230\u7684\u5c0f\u5e94\u7528\u7a0b\u5e8f\u603b\u8ba1\uff1a"},
	{ "progress_dialog.totalerror", "\u9519\u8bef\u603b\u8ba1\uff1a"},

	{ "notdirectory_dialog.caption0", "\u4e0d\u662f\u4e00\u4e2a\u6709\u6548\u7684\u6587\u4ef6"},
	{ "notdirectory_dialog.caption1", "\u4e0d\u662f\u4e00\u4e2a\u6709\u6548\u7684\u76ee\u5f55"},
	{ "notdirectory_dialog.info0", "\u4e0b\u5217\u76ee\u5f55\u4e0d\u5b58\u5728\uff1a" + newline},
	{ "notdirectory_dialog.info1", "\u4e0b\u5217\u6587\u4ef6\u4e0d\u5b58\u5728\uff1a" + newline},
	{ "notdirectory_dialog.info2", "\uff08\u5728\u201c\u76ee\u5f55\u4e2d\u7684\u6240\u6709\u6587\u4ef6\u201d\u6587\u672c\u57df\u4e2d\uff09\uff1a" + newline},
	{ "notdirectory_dialog.info3", "\uff08\u5728\u201c\u4e00\u4e2a\u6587\u4ef6\u201d\u6587\u672c\u57df\u4e2d\uff09\uff1a" + newline},
	{ "notdirectory_dialog.info4", "\uff08\u5728\u201c\u6a21\u677f\u6587\u4ef6\u201d\u6587\u672c\u57df\u4e2d\uff09\uff1a" + newline},
	{ "notdirectory_dialog.info5", "<\u7a7a>"},

	{ "converter_gui.lablel0", "\u6307\u5b9a\u6587\u4ef6\u6216\u76ee\u5f55\u8def\u5f84\uff1a"},
	{ "converter_gui.lablel1", "\u9009\u53d6\u76f8\u7b26\u7684\u6587\u4ef6\u540d\u79f0\uff1a"},
	{ "converter_gui.lablel2", "*.html, *.htm, *.asp"},
	{ "converter_gui.lablel3", "\u52a0\u5165\u5b50\u76ee\u5f55"},
	{ "converter_gui.lablel4", "\u4e00\u4e2a\u6587\u4ef6\uff1a"},
	{ "converter_gui.lablel5", "\u5c06\u6587\u4ef6\u5907\u4efd\u5230\u4ee5\u4e0b\u76ee\u5f55\uff1a"},
	{ "converter_gui.lablel7", "\u6a21\u677f\u6587\u4ef6\uff1a"},


	{ "template.default", "\u6807\u51c6\u578b\uff08\u9002\u7528\u4e8e Windows \u548c Solaris \u5e73\u53f0\u4e0b\u7684 IE \u53ca Navigator\uff09"},
	{ "template.extend",  "\u6269\u5c55\u578b\uff08\u6807\u51c6\u578b\uff0b\u6240\u6709\u7684\u6d4f\u89c8\u5668/\u5e73\u53f0\u652f\u6301\u3015"},
	{ "template.ieonly",  "\u53ea\u9002\u7528\u4e8e Windows \u548c Solaris \u5e73\u53f0\u4e0b\u7684 IE"},
	{ "template.nsonly",  "\u53ea\u9002\u7528\u4e8e Windows \u5e73\u53f0\u4e0b\u7684 Navigator"},
	{ "template.other",   "\u5176\u5b83\u6a21\u677f..."},

	{ "help_dialog.caption", "\u5e2e\u52a9"},

	{ "menu.file", "\u6587\u4ef6"},
	{ "menu.exit", "\u9000\u51fa"},
	{ "menu.edit", "\u7f16\u8f91"},
	{ "menu.option", "\u9009\u9879"},
	{ "menu.help", "\u5e2e\u52a9"},
	{ "menu.about", "\u5173\u4e8e"},

	{ "progress_event.preparing", "\u6b63\u5728\u51c6\u5907"},
	{ "progress_event.converting", "\u6b63\u5728\u8f6c\u6362"},
	{ "progress_event.copying", "\u6b63\u5728\u590d\u5236"},
	{ "progress_event.done", "\u5b8c\u6210"},
	{ "progress_event.destdirnotcreated", "\u65e0\u6cd5\u521b\u5efa\u76ee\u6807\u76ee\u5f55"},
	{ "progress_event.error", "\u9519\u8bef"},
	
	{ "plugin_converter.propnotfound2", "\u5c5e\u6027\u6587\u4ef6\u672a\u627e\u5230\u3002\u9ed8\u8ba4\u5c5e\u6027\u88ab\u4f7f\u7528\u3002"},
	{ "plugin_converter.propnotfound", "\u6ca1\u6709\u627e\u5230 converter.props\u3002\u8fd9\u662f\u8f7d\u5165 Java Plug-in \u4e0b\u8f7d\u4f4d\u7f6e\u6240\u5fc5\u9700\u7684"},
	{ "plugin_converter.logerror", "\u65e0\u6cd5\u5efa\u7acb\u65e5\u5fd7\u6587\u4ef6\u8f93\u51fa"},
	{ "plugin_converter.saveerror", "\u65e0\u6cd5\u4fdd\u5b58\u5c5e\u6027\u6587\u4ef6"},
        { "plugin_converter.appletconv", "\u5c0f\u5e94\u7528\u7a0b\u5e8f\u8f6c\u6362"},
	{ "plugin_converter.failure", "\u65e0\u6cd5\u8f6c\u6362\u6587\u4ef6"},
	{ "plugin_converter.overwrite1", "\u5907\u4efd\u526f\u672c\u5df2\u5b58\u5728..." + newline + newline },
        { "plugin_converter.overwrite2", newline + newline + "\u662f\u5426\u5e0c\u671b\u8986\u76d6\u6b64\u5907\u4efd\u526f\u672c?"},
	{ "plugin_converter.done", "\u5168\u90e8\u5b8c\u6210\u5904\u7406\u7684\u6587\u4ef6\uff1a"},
	{ "plugin_converter.appletfound", "  \u627e\u5230\u5c0f\u5e94\u7528\u7a0b\u5e8f\uff1a"},
	{ "plugin_converter.processing", "  \u6b63\u5728\u5904\u7406..."},
	{ "plugin_converter.cancel", "\u8f6c\u6362\u88ab\u53d6\u6d88"},
	{ "plugin_converter.files", "\u8981\u8f6c\u6362\u7684\u6587\u4ef6: "},
	{ "plugin_converter.converted", "\u4ee5\u524d\u8f6c\u6362\u8fc7\u7684\u6587\u4ef6\uff0c\u65e0\u987b\u518d\u8fdb\u884c\u8f6c\u6362\u3002"},
	{ "plugin_converter.donefound", "\u5b8c\u6210   \u627e\u5230\u5c0f\u5e94\u7528\u7a0b\u5e8f\uff1a"},
	{ "plugin_converter.seetrace", "\u6587\u4ef6\u4e0a\u51fa\u73b0\u9519\u8bef - \u53c2\u89c1\u4e0b\u9762\u7684\u8ddf\u8e2a"},
	{ "plugin_converter.noapplet", "\u6587\u4ef6\u4e2d\u6ca1\u6709\u5c0f\u5e94\u7528\u7a0b\u5e8f"},
	{ "plugin_converter.nofiles", "\u6ca1\u6709\u8981\u5904\u7406\u7684\u6587\u4ef6 "},
	{ "plugin_converter.nobackuppath", "\u6ca1\u6709\u521b\u5efa\u5907\u4efd\u8def\u5f84"},
	{ "plugin_converter.writelog", "\u8986\u5199\u540c\u4e00\u540d\u79f0\u7684\u65e5\u5fd7\u6587\u4ef6"},
	{ "plugin_converter.backup_path", "\u540e\u5907\u8def\u5f84"},
	{ "plugin_converter.log_path", "\u8bb0\u5f55\u8def\u5f84"},
	{ "plugin_converter.template_file", "\u6a21\u677f\u6587\u4ef6"},
	{ "plugin_converter.process_subdirs", "\u7a0b\u5e8f\u5b50\u76ee\u5f55"},
	{ "plugin_converter.show_progress", "\u663e\u793a\u8fdb\u7a0b"},
	{ "plugin_converter.help_message", newline + 
  	                                  "\u7528\u6cd5\uff1aHtmlConverter [-option1 value1 [-option2 value2 [...]]] [-simulate]  [filespecs]" + newline + newline +
 	                                  "\u5176\u4e2d\u9009\u9879\u5305\u62ec\uff1a" + newline + newline +
 	                                  "    -source:    \u6e90\u6587\u4ef6\u8def\u5f84\u3002\u9ed8\u8ba4\uff1a<userdir>" + newline +
 	                                  "    -dest:      \u5199\u5165\u8f6c\u6362\u6587\u4ef6\u7684\u8def\u5f84\u3002\u9ed8\u8ba4\uff1a<userdir>" + newline +
 	                                  "    -backup:    \u5199\u5165\u5907\u4efd\u6587\u4ef6\u7684\u8def\u5f84\u3002\u9ed8\u8ba4\uff1a<dirname>_BAK" + newline +
 	                                  "    -subdirs:   \u5982\u679c\u5b50\u76ee\u5f55\u4e0b\u7684\u6587\u4ef6\u9700\u8981\u5904\u7406\u3002" + newline +
 	                                  "    -template:  \u6a21\u677f\u6587\u4ef6\u8def\u5f84\u3002\u5982\u679c\u4e0d\u786e\u5b9a\uff0c\u8bf7\u4f7f\u7528\u9ed8\u8ba4\u503c\u3002" + newline +
 	                                  "    -log:       \u5199\u5165\u65e5\u5fd7\u7684\u8def\u5f84\u3002\u82e5\u672a\u63d0\u4f9b\uff0c\u5219\u4e0d\u4f1a\u5199\u5165\u65e5\u5fd7\u3002" + newline +
 	                                  "    -progress:  \u5728\u8f6c\u6362\u65f6\u663e\u793a\u8fdb\u5ea6\u3002\u9ed8\u8ba4\uff1atrue" + newline +
 	                                  "    -simulate:  \u6ca1\u6709\u7ecf\u8fc7\u8f6c\u6362\u53ea\u662f\u663e\u793a\u8f6c\u6362\u7ec6\u8282\u3002" + newline + 
                                          "    -gui:       \u663e\u793a\u8f6c\u6362\u7a0b\u5e8f\u7684\u56fe\u5f62\u7528\u6237\u754c\u9762\u3002" + newline + newline +
 	                                  "    filespecs:  \u4ee5\u7a7a\u683c\u5206\u9694\u7684\u6587\u4ef6\u89c4\u8303\u5217\u8868\u3002\u9ed8\u8ba4\uff1a\"*.html *.htm\"\uff08\u9700\u8981\u5f15\u53f7\uff09" + newline},
	
	{ "product_name", "Java(TM) Plug-in HTML Converter" },
    };
}

