/*
 * @(#)PrintManyPlaces.java	1.2 01/04/21
 * Copyright (c) 1995-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 *  @version 1.0
 *
 */

package sun.plugin.converter.util;

import java.io.*;
import java.util.*;

public class PrintManyPlaces extends OutputStream {

    private Vector places = new Vector();

    public void addPlace(OutputStream o) {
	places.addElement(o);
    }
		
    public void removePlace(OutputStream o ) {
	places.removeElement(o);
    }

    public void write(int b) throws IOException {

	OutputStream o ;
	for(int i = 0;i<places.size();i++) {
	    o = (OutputStream)places.elementAt(i);
	    o.write(b);
	    o.flush();
	}
    }
    public synchronized void closeAll() {
	try {
	    OutputStream o ;
	    for(int i = 0;i<places.size();i++) {
		o = (OutputStream)places.elementAt(i);
		if(o != System.out)
		    o.close();
	    }
	}
	catch(IOException e) {
	    e.printStackTrace();
	}
    }
		
    public int countPlaces() {
	return places.size();
    }
}
