# Usage:
#   perl rmlinks.pl serialized-form.html

# This program removes from the specified file all the links from the file that point to javadoc files.
# It keeps links in the navigation bar.


while (<>) {
	if ($ARGV ne $oldargv) {
		rename($ARGV, $ARGV . '.bak');
		open(ARGVOUT, ">$ARGV");
		select(ARGVOUT);
		$oldargv = $ARGV;
	}
# Delete all anchors starting with "java" or "org" but keep the visible text.

#   FROM:  <A HREF="java"...>text</A>    TO:  text
	s|(<A HREF="java[^>]*>)([^<]*)(</A>)|$2|g;

#   FROM:  <A HREF="java"...><CODE>text</CODE></A>    TO:  <CODE>text</CODE>
	s|(<A HREF="java[^>]*><CODE>)([^<]*)(</CODE></A>)|<CODE>$2</CODE>|g;

#   FROM:  <A HREF="org"...>text</A>    TO:  text
	s|(<A HREF="org[^>]*>)([^<]*)(</A>)|$2|g;

#   FROM:  <A HREF="org"...><CODE>text</CODE></A>     TO:  <CODE>text</CODE>
	s|(<A HREF="org[^>]*><CODE>)([^<]*)(</CODE></A>)|<CODE>$2</CODE>|g;
}
continue {
	print;     # this prints to original filename
}
select(STDOUT);

