/*
 * @(#)SyntheticAttribute.java	1.5 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.tools.crunch;

/**
 * Describes an empty "synthetic" attribute
 *
 * @author Graham Hamilton
 */

import java.io.*;

public class SyntheticAttribute extends Attribute {
    private ClassFile cfile;
    private static int count;

    public static Attribute read(ClassFile cf, DataInputStream din) throws IOException {
	return new SyntheticAttribute(cf, din);
    }

    private SyntheticAttribute(ClassFile cf, DataInputStream din) throws IOException {
	cfile = cf;
	int length = din.readInt();
	if (length != 0) {
	    throw new Error("Unexpected length in Synthetic attribute");
	}
	count++;
    }

    public void write(DataOutputStream out) throws IOException {
	out.writeByte(GlobalTables.syntheticAttribute);
    }

    public static void summarize() {
	System.out.println("    " + count + " Synthetic attributes, written length = "
			+ (count * 1) + " bytes");
    }
}
