#
# @(#)Depend.mak	1.2 99/07/21
#
# This makefile must be executed on a system with makedepend, such as Solaris.
# In my copious amount of spare time, I hope to write a Java-based makedepend
# to eliminate this dependency (no pun intended). TB

BUILD_DIR = ../..
TOPDIR   = ../../../..

STUBDIR = WindowsSystemHeaderStubs

SHARE_SRC = $(TOPDIR)/src/share
SUN_SRC = $(SHARE_SRC)/native/sun
COMP_SRC = $(SUN_SRC)/awt/alphacomposite
DEBUG_SRC = $(SUN_SRC)/awt/debug
IMG_SRC = $(SUN_SRC)/awt/image
MEDIA_SRC = $(SUN_SRC)/awt/medialib
LOOP_SRC = $(SUN_SRC)/java2d/loops
PIPE_SRC = $(SUN_SRC)/java2d/pipe
WIN32_SRC = $(TOPDIR)/src/win32
SRC = $(WIN32_SRC)/native/sun/windows

INCLUDES = -I. \
	   -I$(STUBDIR) \
	   -ICClassHeaders \
	   -I$(SHARE_SRC)/hpi/export \
	   -I$(SHARE_SRC)/javavm/export \
	   -I$(WIN32_SRC)/javavm/export \
	   -I$(SHARE_SRC)/native/common \
	   -I$(WIN32_SRC)/native/common \
	   -I$(SUN_SRC)/dc/doe \
	   -I$(SUN_SRC)/dc/path \
	   -I$(SUN_SRC)/dc/pr \
	   -I$(SUN_SRC)/dc/util \
	   -I$(COMP_SRC) \
	   -I$(DEBUG_SRC) \
	   -I$(IMG_SRC) \
	   -I$(IMG_SRC)/cvutils \
	   -I$(IMG_SRC)/gif \
	   -I$(MEDIA_SRC) \
	   -I$(LOOP_SRC) \
	   -I$(PIPE_SRC) \
	   -I$(SRC)

FILES_cpp = \
	$(SRC)/jawt.cpp

STUBFILES = \
	$(STUBDIR)/Ole2.h \
	$(STUBDIR)/cderr.h \
	$(STUBDIR)/commdlg.h \
	$(STUBDIR)/direct.h \
	$(STUBDIR)/imm.h \
	$(STUBDIR)/ime.h \
	$(STUBDIR)/io.h \
	$(STUBDIR)/mmsystem.h \
	$(STUBDIR)/new.h \
	$(STUBDIR)/new \
	$(STUBDIR)/shellapi.h \
	$(STUBDIR)/shlobj.h \
	$(STUBDIR)/tchar.h \
	$(STUBDIR)/winbase.h \
	$(STUBDIR)/windef.h \
	$(STUBDIR)/windows.h \
	$(STUBDIR)/winspool.h \
	$(STUBDIR)/winuser.h \
	$(STUBDIR)/wtypes.h

default:
	rm -rf make.depend make.tmp make.tmp2 $(STUBDIR)
	touch make.tmp
	mkdir $(STUBDIR)
	touch $(STUBFILES)
	makedepend -DWIN32 -D_X86X -Dx86 -DDEBUG -f make.tmp -o.obj $(INCLUDES) \
		$(FILES_cpp)
	fgrep .obj make.tmp | sed -f Depend.sed > make.depend
	rm -rf $(STUBDIR)
