/*
 * @(#)TypeCodeImpl.java	1.66 01/02/09
 *
 * Copyright 1996-2001 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.corba.se.internal.corba;

import org.omg.CORBA.*;
import org.omg.CORBA.TypeCodePackage.*;

import org.omg.CORBA_2_3.portable.InputStream;
import org.omg.CORBA_2_3.portable.OutputStream;

import com.sun.corba.se.internal.core.*;
import com.sun.corba.se.internal.iiop.CDRInputStream;
import com.sun.corba.se.internal.iiop.CDROutputStream;

import java.util.Hashtable;
import java.io.IOException;
/*
// WrapperInputStream is moved to a separate file, This is because of
// a compilation problem in Ladybird.
class WrapperInputStream extends org.omg.CORBA_2_3.portable.InputStream implements TypeCodeReader
{
    private CDRInputStream stream;
    private Hashtable typeMap = null;
    private InputStream enclosure = null;

    public WrapperInputStream(CDRInputStream s) {
        super();
        stream = s;
    }

    public int read() throws IOException { return stream.read(); }
    public int read(byte b[]) throws IOException { return stream.read(b); }
    public int read(byte b[], int off, int len) throws IOException {
	return stream.read(b, off, len);
    }
    public long skip(long n) throws IOException { return stream.skip(n); }
    public int available() throws IOException { return stream.available(); }
    public void close() throws IOException { stream.close(); }
    public void mark(int readlimit) { stream.mark(readlimit); }
    public void reset() throws IOException { stream.reset(); }
    public boolean markSupported() { return stream.markSupported(); }
    public void consumeEndian() { stream.consumeEndian(); }
    public int  mark() { return stream.mark(); }
    public void reset(int mark) { stream.reset(mark); }

    public boolean read_boolean() { return stream.read_boolean(); }
    public char read_char() { return stream.read_char(); }
    public char read_wchar() { return stream.read_wchar(); }
    public byte read_octet() { return stream.read_octet(); }
    public short read_short() { return stream.read_short(); }
    public short read_ushort() { return stream.read_ushort(); }
    public int read_long() { return stream.read_long(); }
    public int read_ulong() { return stream.read_ulong(); }
    public long read_longlong() { return stream.read_longlong(); }
    public long read_ulonglong() { return stream.read_ulonglong(); }
    public float read_float() { return stream.read_float(); }
    public double read_double() { return stream.read_double(); }
    public String read_string() { return stream.read_string(); }
    public String read_wstring() { return stream.read_wstring(); }

    public void read_boolean_array(boolean[] value, int offset, int length) {
	stream.read_boolean_array(value, offset, length);
    }
    public void read_char_array(char[] value, int offset, int length) {
	stream.read_char_array(value, offset, length);
    }
    public void read_wchar_array(char[] value, int offset, int length) {
	stream.read_wchar_array(value, offset, length);
    }
    public void read_octet_array(byte[] value, int offset, int length) {
	stream.read_octet_array(value, offset, length);
    }
    public void read_short_array(short[] value, int offset, int length) {
	stream.read_short_array(value, offset, length);
    }
    public void read_ushort_array(short[] value, int offset, int length) {
	stream.read_ushort_array(value, offset, length);
    }
    public void read_long_array(int[] value, int offset, int length) {
	stream.read_long_array(value, offset, length);
    }
    public void read_ulong_array(int[] value, int offset, int length) {
	stream.read_ulong_array(value, offset, length);
    }
    public void read_longlong_array(long[] value, int offset, int length) {
	stream.read_longlong_array(value, offset, length);
    }
    public void read_ulonglong_array(long[] value, int offset, int length) {
	stream.read_ulonglong_array(value, offset, length);
    }
    public void read_float_array(float[] value, int offset, int length) {
	stream.read_float_array(value, offset, length);
    }
    public void read_double_array(double[] value, int offset, int length) {
	stream.read_double_array(value, offset, length);
    }

    public org.omg.CORBA.Object read_Object() { return stream.read_Object(); }
    public java.io.Serializable read_value() {return stream.read_value();}
    public TypeCode read_TypeCode() { return stream.read_TypeCode(); }
    public Any read_any() { return stream.read_any(); }
    public Principal read_Principal() { return stream.read_Principal(); }
    public java.math.BigDecimal read_fixed() { return stream.read_fixed(); }
    public org.omg.CORBA.Context read_Context() { return stream.read_Context(); }

    public org.omg.CORBA.ORB orb() { return stream.orb(); }

    public void addTypeAtPosition(TypeCodeImpl typeCode, int position) {
        if (typeMap == null)
            typeMap = new Hashtable(16);
        typeMap.put(new Integer(position), typeCode);
    }

    public TypeCodeImpl getTypeAtPosition(int position) {
        return (TypeCodeImpl)typeMap.get(new Integer(position));
    }

    public void setEnclosingInputStream(InputStream enclosure) {
        this.enclosure = enclosure;
    }

    public TypeCodeReader getTopLevelStream() {
        if (enclosure == null)
            return this;
        if (enclosure instanceof TypeCodeReader)
            return ((TypeCodeReader)enclosure).getTopLevelStream();
        // Recursion ends at top level TypeCodeReader.
        //return enclosure;
        return this;
    }

    public int getTopLevelPosition() {
        if (enclosure == null)
            return mark();
        if (enclosure instanceof TypeCodeReader) {
            return ((TypeCodeReader)enclosure).getTopLevelPosition()
		- 4 + mark();
        }
        // Recursion ends at top level TypeCodeReader.
        //return enclosure.getSize();
        return mark();
    }

    public TypeCodeInputStream read_encapsulation(org.omg.CORBA.ORB _orb) {
	// _REVISIT_ Would be nice if we didn't have to copy the buffer!
	TypeCodeInputStream _encap;
	// pop off the encapsulation length
	int encapLength = this.read_long();

	// read off part of the buffer corresponding to the encapsulation
	byte[] encapBuffer = new byte[encapLength];
	this.read_octet_array(encapBuffer, 0, encapBuffer.length);

	// create an encapsulation using the marshal buffer
	// _REVISIT_ We have no information about the endianess!
	_encap = new TypeCodeInputStream(_orb, encapBuffer, encapBuffer.length);
	_encap.setEnclosingInputStream(this);

	// read and set the endianness of the encapsulation
	_encap.consumeEndian();
	return _encap;
    }
}
*/
interface TypeCodeReader extends MarshalInputStream {
    public void addTypeAtPosition(TypeCodeImpl typeCode, int position);
    public TypeCodeImpl getTypeAtPosition(int position);
    public void setEnclosingInputStream(InputStream enclosure);
    public TypeCodeReader getTopLevelStream();
    public int getTopLevelPosition();
    public TypeCodeInputStream read_encapsulation(org.omg.CORBA.ORB _orb);
}

class TypeCodeInputStream extends CDRInputStream implements TypeCodeReader
{
    private Hashtable typeMap = null;
    private InputStream enclosure = null;

    public TypeCodeInputStream() {
	super();
    }

    public TypeCodeInputStream(org.omg.CORBA.ORB orb, byte[] data, int size) {
        super(orb, data, size);
    }

    public TypeCodeInputStream(org.omg.CORBA.ORB orb, byte[] data, int size,
                               boolean littleEndian) {
        super(orb, data, size, littleEndian);
    }

    public void addTypeAtPosition(TypeCodeImpl typeCode, int position) {
        if (typeMap == null)
            typeMap = new Hashtable(16);
        typeMap.put(new Integer(position), typeCode);
    }

    public TypeCodeImpl getTypeAtPosition(int position) {
        return (TypeCodeImpl)typeMap.get(new Integer(position));
    }

    public void setEnclosingInputStream(InputStream enclosure) {
        this.enclosure = enclosure;
    }

    public TypeCodeReader getTopLevelStream() {
        if (enclosure == null)
            return this;
        if (enclosure instanceof TypeCodeInputStream)
            return ((TypeCodeInputStream)enclosure).getTopLevelStream();
        // Recursion ends at top level TypeCodeInputStream.
        //return enclosure;
        return this;
    }

    public int getTopLevelPosition() {
        if (enclosure == null)
            return mark();
        if (enclosure instanceof TypeCodeInputStream) {
            // The enclosed stream has to consider that the enclosing stream
            // had to read the enclosed stream completely when creating it.
            // This is why the size of the enclosed stream needs to be substracted.
            return ((TypeCodeInputStream)enclosure).getTopLevelPosition()
		- 4 - size + mark();
        }
        // Recursion ends at top level TypeCodeInputStream.
        //return enclosure.getSize();
        return mark();
    }

    public TypeCodeInputStream read_encapsulation(org.omg.CORBA.ORB _orb) {
	// _REVISIT_ Would be nice if we didn't have to copy the buffer!
	TypeCodeInputStream _encap;
	// pop off the encapsulation length
	int encapLength = this.read_long();

	// read off part of the buffer corresponding to the encapsulation
	byte[] encapBuffer = new byte[encapLength];
	this.read_octet_array(encapBuffer, 0, encapBuffer.length);

	// create an encapsulation using the marshal buffer
	_encap = new TypeCodeInputStream(_orb, encapBuffer, encapBuffer.length, littleEndian);
	_encap.setEnclosingInputStream(this);

	// read and set the endianness of the encapsulation
	_encap.consumeEndian();
	return _encap;
    }
}

final class TypeCodeOutputStream extends CDROutputStream {

    private OutputStream enclosure = null;

    public TypeCodeOutputStream(org.omg.CORBA.ORB orb) {
        super(orb, false);
    }

    public TypeCodeOutputStream(org.omg.CORBA.ORB orb, boolean littleEndian) {
        super(orb, littleEndian);
    }

    public org.omg.CORBA.portable.InputStream create_input_stream()
    {
        return new TypeCodeInputStream(orb, buf, size, littleEndian);
    }

    public void setEnclosingOutputStream(OutputStream enclosure) {
        this.enclosure = enclosure;
    }

    /*
      public boolean isEncapsulatedIn(TypeCodeOutputStream outerEnclosure) {
      if (outerEnclosure == this)
      return true;
      if (enclosure == null)
      return false;
      if (enclosure instanceof TypeCodeOutputStream)
      return ((TypeCodeOutputStream)enclosure).isEncapsulatedIn(outerEnclosure);
      // Last chance! Recursion ends with first non TypeCodeOutputStream.
      return (enclosure == outerEnclosure);
      }
    */

    public TypeCodeOutputStream getTopLevelStream() {
        if (enclosure == null)
            return this;
        if (enclosure instanceof TypeCodeOutputStream)
            return ((TypeCodeOutputStream)enclosure).getTopLevelStream();
        // Recursion ends at top level TypeCodeOutputStream.
        //return enclosure;
        return this;
    }

    public int getTopLevelPosition() {
        if (enclosure == null)
            return getSize();
        if (enclosure instanceof TypeCodeOutputStream) {
            return ((TypeCodeOutputStream)enclosure).getTopLevelPosition() + getSize();
        }
        // Recursion ends at top level TypeCodeOutputStream.
        //return enclosure.getSize();
        return getSize();
    }

    public void writeOctetSequenceNoLengthTo(org.omg.CORBA.portable.OutputStream s) {
        // Make sure to align s to 4 byte boundaries.
        // Unfortunately we can't do just this:
        // s.alignAndReserve(4, 4);
        // So we have to take the first four bytes off this stream and write them
        // with a call to write_long which will trigger the alignment.
        // Then write the rest of the byte array.
        org.omg.CORBA_2_3.portable.InputStream in =
	    (org.omg.CORBA_2_3.portable.InputStream)this.create_input_stream();
        s.write_long(in.read_long());
        s.write_octet_array(buf, 4, size - 4);
    }

    public TypeCodeOutputStream init_encapsulation(org.omg.CORBA.ORB _orb) {
	TypeCodeOutputStream _encap = new TypeCodeOutputStream(_orb, littleEndian);
	_encap.setEnclosingOutputStream(this);
	// stick the endianness of the encapsulation
	_encap.putEndian();
	return _encap;
    }
}

// no chance of subclasses, so no problems with runtime helper lookup
public final class TypeCodeImpl extends TypeCode 
{
  
    // the predefined typecode constants

    private static final TypeCodeImpl primitiveConstants[] = {
	new TypeCodeImpl(TCKind._tk_null),			// tk_null      
	new TypeCodeImpl(TCKind._tk_void),			// tk_void      
	new TypeCodeImpl(TCKind._tk_short),			// tk_short     
	new TypeCodeImpl(TCKind._tk_long),			// tk_long      
	new TypeCodeImpl(TCKind._tk_ushort),		// tk_ushort    
	new TypeCodeImpl(TCKind._tk_ulong),			// tk_ulong     
	new TypeCodeImpl(TCKind._tk_float),			// tk_float     
	new TypeCodeImpl(TCKind._tk_double),		// tk_double    
	new TypeCodeImpl(TCKind._tk_boolean),		// tk_boolean   
	new TypeCodeImpl(TCKind._tk_char),			// tk_char      
	new TypeCodeImpl(TCKind._tk_octet),			// tk_octet     
	new TypeCodeImpl(TCKind._tk_any),			// tk_any       
	new TypeCodeImpl(TCKind._tk_TypeCode),		// tk_typecode  
	new TypeCodeImpl(TCKind._tk_Principal),		// tk_principal 
	new TypeCodeImpl(TCKind._tk_objref),		// tk_objref    
	null,						// tk_struct    
	null,						// tk_union     
	null,						// tk_enum      
	new TypeCodeImpl(TCKind._tk_string),		// tk_string    
	null,						// tk_sequence  
	null,						// tk_array     
	null,						// tk_alias     
	null,						// tk_except    
	new TypeCodeImpl(TCKind._tk_longlong),		// tk_longlong  
	new TypeCodeImpl(TCKind._tk_ulonglong),		// tk_ulonglong 
	new TypeCodeImpl(TCKind._tk_longdouble),		// tk_longdouble
	new TypeCodeImpl(TCKind._tk_wchar),			// tk_wchar     
	new TypeCodeImpl(TCKind._tk_wstring),		// tk_wstring
	new TypeCodeImpl(TCKind._tk_fixed),         // tk_fixed
	new TypeCodeImpl(TCKind._tk_value),			// tk_value
	new TypeCodeImpl(TCKind._tk_value_box),		// tk_value_box
	new TypeCodeImpl(TCKind._tk_native),		// tk_native
	new TypeCodeImpl(TCKind._tk_abstract_interface)	// tk_abstract_interface   
    };

    // the indirection TCKind, needed for recursive typecodes. 
    protected static final int tk_indirect = 0xFFFFFFFF;
  
    // typecode encodings have three different categories that determine
    // how the encoding should be done.
  
    private static final int EMPTY = 0;	// no parameters
    private static final int SIMPLE = 1;	// simple parameters.
    private static final int COMPLEX = 2; // complex parameters. need to
    // use CDR encapsulation for
    // parameters 
  
    // a table storing the encoding category for the various typecodes.
  
    private static final int typeTable[] = {
	EMPTY,	// tk_null      
	EMPTY,	// tk_void      
	EMPTY,	// tk_short     
	EMPTY,	// tk_long      
	EMPTY,	// tk_ushort    
	EMPTY,	// tk_ulong     
	EMPTY,	// tk_float     
	EMPTY,	// tk_double    
	EMPTY,	// tk_boolean   
	EMPTY,	// tk_char      
	EMPTY,	// tk_octet     
	EMPTY,	// tk_any       
	EMPTY,	// tk_typecode  
	EMPTY,	// tk_principal 
	COMPLEX,	// tk_objref    
	COMPLEX,	// tk_struct    
	COMPLEX,	// tk_union     
	COMPLEX,	// tk_enum      
	SIMPLE,	// tk_string    
	COMPLEX,	// tk_sequence  
	COMPLEX,	// tk_array     
	COMPLEX,	// tk_alias     
	COMPLEX,	// tk_except    
	EMPTY,	// tk_longlong  
	EMPTY,	// tk_ulonglong 
	EMPTY,	// tk_longdouble
	EMPTY,	// tk_wchar     
	SIMPLE,	// tk_wstring
	SIMPLE,	// tk_fixed
	COMPLEX,	// tk_value
	COMPLEX,	// tk_value_box
	COMPLEX,	// tk_native
	COMPLEX	// tk_abstract_interface
    };

private int 		_kind		= 0;	// the typecode kind

// data members for representing the various kinds of typecodes. 

    private String 	_id		= "";	// the typecode repository id
private String 	_name		= "";	// the typecode name
private int		_memberCount    = 0;    // member count
private String 	_memberNames[]  = null; // names of members
private TypeCodeImpl 	_memberTypes[]  = null; // types of members
private AnyImpl 	_unionLabels[]  = null; // values of union labels
private TypeCodeImpl  _discriminator  = null; // union discriminator type
private int		_defaultIndex   = -1;	// union default index
private int		_length		= 0;	// string/seq/array length
private TypeCodeImpl	_contentType	= null;	// seq/array/alias type
// fixed
private short		_digits		= 0;
private short		_scale		= 0;
// value type
// _REVISIT_ We might want to keep references to the ValueMember classes
// passed in at initialization instead of copying the relevant data.
// Is the data immutable? What about StructMember, UnionMember etc.?
private short		_type_modifier	= -1;	// VM_NONE, VM_CUSTOM,
// VM_ABSTRACT, VM_TRUNCATABLE
private TypeCodeImpl	_concrete_base	= null;	// concrete base type
private short		_memberAccess[] = null; // visibility of ValueMember
// recursive sequence support
private TypeCodeImpl	_parent		= null;	// the enclosing type code
private int		_parentOffset	= 0;	// the level of enclosure
// recursive type codes support
private TypeCodeImpl	_indirectType	= null;
private TypeCodeOutputStream
    _lastOutStream	= null;	// remember the stream we last wrote to
private int		_outStreamPosition = 0;	// remember the position in that stream
private TypeCodeReader
    _lastInStream	= null;	// remember the stream we last read from
private int		_inStreamPosition  = 0;	// remember the position in that stream

// the ORB instance: may be instanceof ORBSingleton or ORB
private org.omg.CORBA.ORB _orb; 		

///////////////////////////////////////////////////////////////////////////
// Constructors...

public TypeCodeImpl(org.omg.CORBA.ORB orb) 
{
    // initialized to tk_null
    _orb = orb;
}
  
public TypeCodeImpl(org.omg.CORBA.ORB orb, TypeCode tc)
// to handle conversion of "remote" typecodes into "native" style.
// also see the 'convertToNative(ORB orb, TypeCode tc)' function
{
    // the orb object
    _orb = orb;

    // This is a protection against misuse of this constructor.
    // Should only be used if tc is not an instance of this class!
    // Otherwise we run into problems with recursive/indirect type codes.
    // _REVISIT_ We should make this constructor private
    if (tc instanceof TypeCodeImpl) {
	TypeCodeImpl tci = (TypeCodeImpl)tc;
	if (tci._kind == tk_indirect)
	    throw new BAD_TYPECODE();
	if (tci._kind == TCKind._tk_sequence && tci._contentType == null)
	    throw new BAD_TYPECODE();
    }

    // set up kind
    _kind 	= tc.kind().value();

    try {
	// set up parameters
	switch (_kind) {
	case TCKind._tk_value:
	    _type_modifier = tc.type_modifier();
	    _concrete_base = convertToNative(_orb, tc.concrete_base_type());
	    //_memberAccess = tc._memberAccess;
	    // Need to reconstruct _memberAccess using member_count() and member_visibility()
	    _memberAccess = new short[tc.member_count()];
	    for (int i=0; i < tc.member_count(); i++) {
		_memberAccess[i] = tc.member_visibility(i);
	    }
	case TCKind._tk_except:
	case TCKind._tk_struct:
	case TCKind._tk_union:
	    // set up member types
	    _memberTypes = new TypeCodeImpl[tc.member_count()];
	    for (int i=0; i < tc.member_count(); i++) {
	        _memberTypes[i] = convertToNative(_orb, tc.member_type(i));
		_memberTypes[i].setParent(this);
	    }
	case TCKind._tk_enum:
	    // set up member names
	    _memberNames = new String[tc.member_count()];
	    for (int i=0; i < tc.member_count(); i++) {
	        _memberNames[i] = tc.member_name(i);
	    }
	    // set up member count
	    _memberCount = tc.member_count();
	case TCKind._tk_objref:
	case TCKind._tk_alias:
	case TCKind._tk_value_box:
	case TCKind._tk_native:
	case TCKind._tk_abstract_interface:
	    setId(tc.id());
	    _name = tc.name();
	    break;
	}
      
	// set up stuff for unions
	switch (_kind) {
	case TCKind._tk_union:
	    _discriminator = convertToNative(_orb, tc.discriminator_type());
	    _defaultIndex  = tc.default_index();
	    _unionLabels = new AnyImpl[_memberCount];
	    for (int i=0; i < _memberCount; i++)
		_unionLabels[i] = new AnyImpl(_orb, tc.member_label(i));
	    break;
	}
      
	// set up length
	switch (_kind) {
	case TCKind._tk_string:
	case TCKind._tk_wstring:
	case TCKind._tk_sequence:
	case TCKind._tk_array:
	    _length = tc.length();
	}
      
	// set up content type
	switch (_kind) {
	case TCKind._tk_sequence:
	case TCKind._tk_array:
	case TCKind._tk_alias:
	case TCKind._tk_value_box:
	    _contentType = convertToNative(_orb, tc.content_type());
	}
    } catch (org.omg.CORBA.TypeCodePackage.Bounds e) {} catch (BadKind e) {}
    // dont have to worry about these since code ensures we dont step
    // out of bounds.
}
    
public TypeCodeImpl(int creationKind)
// for primitive types
{
    // the orb object
    _orb = null;

    // private API. dont bother checking that
    //     (creationKind < 0 || creationKind > typeTable.length)

    _kind = creationKind;

    // do initialization for special cases
    switch (_kind) {
    case TCKind._tk_objref:
	{
	    // this is being used to create typecode for CORBA::Object
	    setId("IDL:omg.org/CORBA/Object:1.0");
	    _name = "Object";
	    break;
	}

    case TCKind._tk_string:
    case TCKind._tk_wstring:
	{
	    _length =0;
	    break;
	}

    case TCKind._tk_value:
	{
	    _concrete_base = new TypeCodeImpl (TCKind._tk_null);
	    break;
	}
    }
}

public TypeCodeImpl(org.omg.CORBA.ORB orb,
		    int creationKind,
		    String id,
		    String name,
		    StructMember[] members)
		    // for structs and exceptions
{
    // the orb object
    _orb = orb;

    if ((creationKind == TCKind._tk_struct) || (creationKind == TCKind._tk_except))
	{
	
	    _kind		= creationKind;
	    setId(id);
	    _name		= name;
	    _memberCount	= members.length;
	
	    _memberNames = new String[_memberCount];
	    _memberTypes = new TypeCodeImpl[_memberCount];

	    for (int i = 0 ; i < _memberCount ; i++) {
		_memberNames[i] = members[i].name;
		_memberTypes[i] = convertToNative(_orb, members[i].type);
		_memberTypes[i].setParent(this);
	    }
	} // else initializes to null
}

public TypeCodeImpl(org.omg.CORBA.ORB orb, 
		    int creationKind,
		    String id,
		    String name,
		    TypeCode discriminator_type,
		    UnionMember[] members)
		    // for unions
{
    // the orb object
    _orb = orb;

    if (creationKind == TCKind._tk_union)
	{
	    _kind		= creationKind;
	    setId(id);
	    _name		= name;
	    _memberCount	= members.length;
	    _discriminator	= convertToNative(_orb, discriminator_type);

	    _memberNames = new String[_memberCount];
	    _memberTypes = new TypeCodeImpl[_memberCount];
	    _unionLabels = new AnyImpl[_memberCount];

	    for (int i = 0 ; i < _memberCount ; i++) {
		_memberNames[i] = members[i].name;
		_memberTypes[i] = convertToNative(_orb, members[i].type);
		_memberTypes[i].setParent(this);
		_unionLabels[i] = new AnyImpl(_orb, members[i].label);
		if (_unionLabels[i].type().kind() == TCKind.tk_octet)
		    { 
			// check whether this is the default branch.
			// strictly speaking, should also check that the value
			// of the octet is zero. 
			_defaultIndex = i;
		    }
	    }
	} // else initializes to null
}

public TypeCodeImpl(org.omg.CORBA.ORB orb,
		    int creationKind,
		    String id,
		    String name,
		    short type_modifier,
		    TypeCode concrete_base,
		    ValueMember[] members)
		    // for value types
{
    // the orb object
    _orb = orb;

    if (creationKind == TCKind._tk_value) {
        _kind		= creationKind;
        setId(id);
        _name		= name;
        _type_modifier	= type_modifier;
        _concrete_base	= convertToNative(_orb, concrete_base);
        _memberCount	= members.length;

        _memberNames = new String[_memberCount];
        _memberTypes = new TypeCodeImpl[_memberCount];
        _memberAccess = new short[_memberCount];

        for (int i = 0 ; i < _memberCount ; i++) {
	    _memberNames[i] = members[i].name;
	    _memberTypes[i] = convertToNative(_orb, members[i].type);
	    _memberTypes[i].setParent(this);
	    _memberAccess[i] = members[i].access;
        }
    } // else initializes to null
}


public TypeCodeImpl(org.omg.CORBA.ORB orb,
		    int creationKind,
		    String id,
		    String name,
		    String[] members)
		    // for enums
{
    // the orb object
    _orb = orb;

    if (creationKind == TCKind._tk_enum)
	{
	    _kind		= creationKind;
	    setId(id);
	    _name		= name;
	    _memberCount	= members.length;

	    _memberNames = new String[_memberCount];

	    for (int i = 0 ; i < _memberCount ; i++)
		_memberNames[i] = members[i];
	} // else initializes to null
}

public TypeCodeImpl(org.omg.CORBA.ORB orb, 
		    int creationKind,
		    String id,
		    String name,
		    TypeCode original_type)
		    // for aliases and value boxes
{
    // the orb object
    _orb = orb;

    if ( creationKind == TCKind._tk_alias || creationKind == TCKind._tk_value_box )
	{
	    _kind		= creationKind;
	    setId(id);
	    _name		= name;
	    _contentType	= convertToNative(_orb, original_type);
	}
    // else initializes to null

}

public TypeCodeImpl(org.omg.CORBA.ORB orb, 
		    int creationKind,
		    String id,
		    String name)
{
    // the orb object
    _orb = orb;

    if (creationKind == TCKind._tk_objref ||
        creationKind == TCKind._tk_native ||
        creationKind == TCKind._tk_abstract_interface)
	{
	    _kind		= creationKind;
	    setId(id);
	    _name		= name;
	} // else initializes to null
}

  
public TypeCodeImpl(org.omg.CORBA.ORB orb, 
		    int creationKind,
		    int bound)
		    // for strings
{
    // the orb object
    _orb = orb;

    if ((creationKind == TCKind._tk_string) || (creationKind == TCKind._tk_wstring))
	{
	    _kind		= creationKind;
	    _length		= bound;
	} // else initializes to null
}

public TypeCodeImpl(org.omg.CORBA.ORB orb, 
		    int creationKind,
		    int bound,
		    TypeCode element_type)
		    // for sequences and arrays
{
    // the orb object
    _orb = orb;

    if ( creationKind == TCKind._tk_sequence || creationKind == TCKind._tk_array )
	{
	    _kind		= creationKind;
	    _length		= bound;
	    _contentType	= convertToNative(_orb, element_type);
	} // else initializes to null
}
  
public TypeCodeImpl(org.omg.CORBA.ORB orb,
		    int creationKind,
		    int bound,
		    int offset)
		    // for recursive sequences
{
    // the orb object
    _orb = orb;

    if (creationKind == TCKind._tk_sequence) {
        _kind		= creationKind;
        _length		= bound;
        _parentOffset	= offset;
    } // else initializes to null
}

public TypeCodeImpl(org.omg.CORBA.ORB orb,
		    String id)
		    // for recursive type codes
{
    // the orb object
    _orb = orb;

    _kind	= tk_indirect;
    // This is the type code of the type we stand in for, not our own.
    _id		= id;
    // Try to resolve it now. May return null in which case
    // we try again later (see indirectType()).
    tryIndirectType();
}

public TypeCodeImpl(org.omg.CORBA.ORB orb,
		    int creationKind,
		    short digits,
		    short scale)
		    // for fixed
{
    // the orb object
    _orb = orb;

    //if (digits < 1 || digits > 31)
    //throw new BAD_TYPECODE();

    if (creationKind == TCKind._tk_fixed) {
        _kind		= creationKind;
        _digits		= digits;
        _scale		= scale;
    } // else initializes to null
}

///////////////////////////////////////////////////////////////////////////
// Other creation functions...

public static TypeCodeImpl get_primitive_tc(TCKind tcKind)
{
    try {
	return primitiveConstants[tcKind.value()];
    } catch (Throwable t) {
	throw new BAD_OPERATION("Invalid or unavailable typecode for kind = "+tcKind.value());
    }
}

public static TypeCodeImpl get_primitive_tc(int val)
{
    try {
	return primitiveConstants[val];
    } catch (Throwable t) {
	throw new BAD_OPERATION("Invalid or unavailable typecode for kind = "+val);
    }
}

// Optimization:
// If we checked for and returned constant primitive typecodes
// here we could reduce object creation and also enable more
// efficient typecode comparisons for primitive typecodes.
//
protected static TypeCodeImpl convertToNative(org.omg.CORBA.ORB orb,
					      TypeCode tc) 
{
    if (tc instanceof TypeCodeImpl)
	return (TypeCodeImpl) tc;
    else
	return new TypeCodeImpl(orb, tc);
}

public static CDROutputStream newOutputStream(org.omg.CORBA.ORB orb) {
    return new TypeCodeOutputStream(orb);
}

// Support for indirect/recursive type codes

private TypeCodeImpl indirectType() {
    _indirectType = tryIndirectType();
    if (_indirectType == null) {
        // Nothing we can do about that.
        throw new BAD_TYPECODE("Invoked operation on unresolved recursive type code!");
    }
    return _indirectType;
}

private TypeCodeImpl tryIndirectType() {
    // Assert that _kind == tk_indirect
    if (_indirectType != null)
        return _indirectType;

    if (_orb instanceof TypeCodeFactory) {
        setIndirectType(((TypeCodeFactory)_orb).getTypeCode(_id));
    } else {
        throw new BAD_TYPECODE("ORB not supporting recursive type codes!");
    }
    return _indirectType;
}

private void setIndirectType(TypeCodeImpl newType) {
    _indirectType = newType;
    if (_indirectType != null) {
	try {
	    _id = _indirectType.id();
	} catch (BadKind e) {} // can't happen
    }
}

private void setId(String newID) {
    _id = newID;
    if (_orb instanceof TypeCodeFactory) {
        ((TypeCodeFactory)_orb).setTypeCode(_id, this);
    }
    // check whether return value != this which would indicate that the
    // repository id isn't unique.
}

private void setParent(TypeCodeImpl parent) {
    _parent = parent;
}

private TypeCodeImpl getParentAtLevel(int level) {
    if (level == 0)
        return this;
    if (_parent == null)
        throw new BAD_TYPECODE("Invoked operation on unresolved recursive type code!");
    return _parent.getParentAtLevel(level - 1);
}

private TypeCodeImpl lazy_content_type() {
    if (_contentType == null) {
        if (_kind == TCKind._tk_sequence && _parentOffset > 0 && _parent != null) {
	    // This is an unresolved recursive sequence tc.
	    // Try to resolve it now if the hierarchy is complete.
	    TypeCodeImpl realParent = getParentAtLevel(_parentOffset);
	    if (realParent != null && realParent._id != null) {
		// Create a recursive type code object as the content type.
		// This is when the recursive sequence typecode morphes
		// into a sequence typecode containing a recursive typecode.
		_contentType = new TypeCodeImpl(_orb, realParent._id);
	    }
        }
    }
    return _contentType;
}

///////////////////////////////////////////////////////////////////////////
// TypeCode operations

public final boolean equal(TypeCode tc)
// _REVISIT_ for all optional names/ids, we might want to check that
// they are equal in case both are non-nil.
{
    if (tc == this)
        return true;

    try {

	if (_kind == tk_indirect) {
	    //return indirectType().equal(tc);
	    if (_id != null && tc.id() != null)
		return _id.equals(tc.id());
	    return (_id == null && tc.id() == null);
	}

	// make sure kinds are identical.
	if (_kind != tc.kind().value()) {
	    return false;
	}

	switch (typeTable[_kind]) {
	case EMPTY:
	    // no parameters to check.
	    return true;
      
	case SIMPLE:
	    switch (_kind) {
	    case TCKind._tk_string:
	    case TCKind._tk_wstring:
		// check for bound.
		return (_length == tc.length());

	    case TCKind._tk_fixed:
		return (_digits == tc.fixed_digits() && _scale == tc.fixed_scale());
	    default:
		return false;
	    }
      
	case COMPLEX:

	    switch(_kind) {

	    case TCKind._tk_objref:
		{
		    // check for logical id.
		    if (_id.compareTo(tc.id()) == 0) {
			return true;
		    }

		    if (_id.compareTo(get_primitive_tc(_kind).id()) == 0) {
			return true;
		    }

		    if (tc.id().compareTo(get_primitive_tc(_kind).id()) == 0) {
			return true;
		    }

		    return false;
		}

	    case TCKind._tk_native:
	    case TCKind._tk_abstract_interface:
		{
		    // check for logical id.
		    if (_id.compareTo(tc.id()) != 0) {
			return false;

		    }
		    // ignore name since its optional.
		    return true;
		}

	    case TCKind._tk_struct:
	    case TCKind._tk_except:
		{
		    // check for member count
		    if (_memberCount != tc.member_count())
			return false;
		    // check for repository id
		    if (_id.compareTo(tc.id()) != 0)
			return false;
		    // check for member types.
		    for (int i = 0 ; i < _memberCount ; i++)
			if (! _memberTypes[i].equal(tc.member_type(i)))
			    return false;
		    // ignore id and names since those are optional.
		    return true;
		}

	    case TCKind._tk_union:
		{
		    // check for member count
		    if (_memberCount != tc.member_count())
			return false;
		    // check for repository id
		    if (_id.compareTo(tc.id()) != 0)
			return false;
		    // check for default index
		    if (_defaultIndex != tc.default_index())
			return false;
		    // check for discriminator type
		    if (!_discriminator.equal(tc.discriminator_type()))
			return false;
		    // check for label types and values
		    for (int i = 0 ; i < _memberCount ; i++)
			if (! _unionLabels[i].equal(tc.member_label(i)))
			    return false;
		    // check for branch types
		    for (int i = 0 ; i < _memberCount ; i++)
			if (! _memberTypes[i].equal(tc.member_type(i)))
			    return false;
		    // ignore id and names since those are optional.
		    return true;
		}

	    case TCKind._tk_enum:
		{
		    // check for repository id
		    if (_id.compareTo(tc.id()) != 0)
			return false;
		    // check member count
		    if (_memberCount != tc.member_count())
			return false;
		    // ignore names since those are optional.
		    return true;
		}

	    case TCKind._tk_sequence:
	    case TCKind._tk_array:
		{
		    // check bound/length
		    if (_length != tc.length()) {
			return false;
		    }
		    // check content type
		    if (! lazy_content_type().equal(tc.content_type())) {
			return false;
		    }
		    // ignore id and name since those are optional.
		    return true;
		}

	    case TCKind._tk_value:
		{
		    // check for member count
		    if (_memberCount != tc.member_count())
			return false;
		    // check for repository id
		    if (_id.compareTo(tc.id()) != 0)
			return false;
		    // check for member types.
		    for (int i = 0 ; i < _memberCount ; i++)
			if (_memberAccess[i] != tc.member_visibility(i) ||
			    ! _memberTypes[i].equal(tc.member_type(i)))
			    return false;
		    if (_type_modifier == tc.type_modifier())
			return false;
		    if (! _concrete_base.equal(tc.concrete_base_type()))
			return false;
		    // ignore id and names since those are optional.
		    return true;
		}

	    case TCKind._tk_alias:
	    case TCKind._tk_value_box:
		{
		    // check for repository id
		    if (_id.compareTo(tc.id()) != 0) {
			return false;
		    }
		    // check for equality with the true type
		    return _contentType.equal(tc.content_type());
		}
	    }
	}
    } catch (org.omg.CORBA.TypeCodePackage.Bounds e) {} catch (BadKind e) {}
    // dont have to worry about these since the code ensures these dont
    // arise.
    return false;
}

public boolean equivalent(TypeCode tc) {
    throw new org.omg.CORBA.NO_IMPLEMENT();
}


public TCKind kind() 
{
    if (_kind == tk_indirect)
        return indirectType().kind();
    return TCKind.from_int(_kind);
}
  
public String id()
    throws BadKind
{
    switch (_kind) {
    case tk_indirect:
	//return indirectType().id(); // same as _id
    case TCKind._tk_except:
    case TCKind._tk_objref:
    case TCKind._tk_struct:
    case TCKind._tk_union:
    case TCKind._tk_enum:
    case TCKind._tk_alias:
    case TCKind._tk_value:
    case TCKind._tk_value_box:
    case TCKind._tk_native:
    case TCKind._tk_abstract_interface:
	// exception and objref typecodes must have a repository id.
	// structs, unions, enums, and aliases may or may not.
	return _id;
    default:
	// all other typecodes throw the BadKind exception.
	throw new BadKind();
    }
}

public String name()
    throws BadKind
{
    switch (_kind) {
    case tk_indirect:
	return indirectType().name();
    case TCKind._tk_except:
    case TCKind._tk_objref:
    case TCKind._tk_struct:
    case TCKind._tk_union:
    case TCKind._tk_enum:
    case TCKind._tk_alias:
    case TCKind._tk_value:
    case TCKind._tk_value_box:
    case TCKind._tk_native:
    case TCKind._tk_abstract_interface:
	return _name;
    default:
	throw new BadKind();
    }
}

public int member_count()
    throws BadKind
{
    switch (_kind) {
    case tk_indirect:
	return indirectType().member_count();
    case TCKind._tk_except:
    case TCKind._tk_struct:
    case TCKind._tk_union:
    case TCKind._tk_enum:
    case TCKind._tk_value:
	return _memberCount;
    default:
	throw new BadKind();
    }
}

public String member_name(int index)
    throws BadKind, org.omg.CORBA.TypeCodePackage.Bounds
{
    switch (_kind) {
    case tk_indirect:
	return indirectType().member_name(index);
    case TCKind._tk_except:
    case TCKind._tk_struct:
    case TCKind._tk_union:
    case TCKind._tk_enum:
    case TCKind._tk_value:
	try {
	    return _memberNames[index];
	} catch (ArrayIndexOutOfBoundsException e) {
	    throw new org.omg.CORBA.TypeCodePackage.Bounds();
	};
    default:
	throw new BadKind();
    }
}

public TypeCode member_type(int index)
    throws BadKind, org.omg.CORBA.TypeCodePackage.Bounds
{
    switch (_kind) {
    case tk_indirect:
	return indirectType().member_type(index);
    case TCKind._tk_except:
    case TCKind._tk_struct:
    case TCKind._tk_union:
    case TCKind._tk_value:
	try {
	    return _memberTypes[index];
	} catch (ArrayIndexOutOfBoundsException e) {
	    throw new org.omg.CORBA.TypeCodePackage.Bounds();
	};
    default:
	throw new BadKind();
    }
}
  
public Any member_label(int index)
    throws BadKind, org.omg.CORBA.TypeCodePackage.Bounds
{
    switch (_kind) {
    case tk_indirect:
	return indirectType().member_label(index);
    case TCKind._tk_union:
	try {
	    return new AnyImpl(_orb, _unionLabels[index]);
	} catch (ArrayIndexOutOfBoundsException e) {
	    throw new org.omg.CORBA.TypeCodePackage.Bounds();
	};
    default:
	throw new BadKind();
    }
}

public TypeCode discriminator_type()
    throws BadKind
{
    switch (_kind) {
    case tk_indirect:
	return indirectType().discriminator_type();
    case TCKind._tk_union:
	return _discriminator;
    default:
	throw new BadKind();
    }
}

public int default_index()
    throws BadKind
{
    switch (_kind) {
    case tk_indirect:
	return indirectType().default_index();
    case TCKind._tk_union:
	return _defaultIndex;
    default:
	throw new BadKind();
    }
}

public int length()
    throws BadKind
{
    switch (_kind) {
    case tk_indirect:
	return indirectType().length();
    case TCKind._tk_string:
    case TCKind._tk_wstring:
    case TCKind._tk_sequence:
    case TCKind._tk_array:
	return _length;
    default:
	throw new BadKind();
    }
}
  
public TypeCode content_type()
    throws BadKind
{
    switch (_kind) {
    case tk_indirect:
	return indirectType().content_type();
    case TCKind._tk_sequence:
	return lazy_content_type();
    case TCKind._tk_array:
    case TCKind._tk_alias:
    case TCKind._tk_value_box:
	return _contentType;
    default:
	throw new BadKind();
    }
}

public short fixed_digits() throws BadKind {
    switch (_kind) {
    case TCKind._tk_fixed:
	return _digits;
    default:
	throw new BadKind();
    }
}

public short fixed_scale() throws BadKind {
    switch (_kind) {
    case TCKind._tk_fixed:
	return _scale;
    default:
	throw new BadKind();
    }
}

public short member_visibility(int index) throws BadKind, org.omg.CORBA.TypeCodePackage.Bounds {
    switch (_kind) {
    case tk_indirect:
        return indirectType().member_visibility(index);
    case TCKind._tk_value:
        try {
            return _memberAccess[index];
        } catch (ArrayIndexOutOfBoundsException e) {
            throw new org.omg.CORBA.TypeCodePackage.Bounds();
        };
    default:
        throw new BadKind();
    }
}

public short type_modifier() throws BadKind {
    switch (_kind) {
    case tk_indirect:
        return indirectType().type_modifier();
    case TCKind._tk_value:
        return _type_modifier;
    default:
        throw new BadKind();
    }
}

public TypeCode concrete_base_type() throws BadKind {
    switch (_kind) {
    case tk_indirect:
        return indirectType().concrete_base_type();
    case TCKind._tk_value:
        return _concrete_base;
    default:
        throw new BadKind();
    }
}

public void read_value(InputStream is) {
    if (is instanceof TypeCodeReader) {
	// hardly possible unless caller knows our "private" stream classes.
	if (read_value_kind((TypeCodeReader)is))
	    read_value_body(is);
    } else if (is instanceof CDRInputStream) {
	WrapperInputStream wrapper = new WrapperInputStream((CDRInputStream)is);
	if (read_value_kind((TypeCodeReader)wrapper))
	    read_value_body(wrapper);
    } else {
	read_value_kind(is);
	read_value_body(is);
    }
}

void read_value_recursive(InputStream is) {
    // don't wrap a CDRInputStream reading "inner" TypeCodes.
    if (is instanceof TypeCodeReader) {
	if (read_value_kind((TypeCodeReader)is))
	    read_value_body(is);
    } else {
	read_value_kind(is);
	read_value_body(is);
    }
}

boolean read_value_kind(TypeCodeReader tcis) {
    int startPos = tcis.mark();
    // unmarshal the kind
    _kind = tcis.read_long();
    // Depending on alignment this could be more than 4 bytes.
    int correction = tcis.mark() - startPos;

    // check validity of kind
    if ((_kind < 0 || _kind > typeTable.length) && _kind != tk_indirect) {
	throw new MARSHAL();
    }
    // Don't do any work if this is native
    if (_kind == TCKind._tk_native)
	throw new MARSHAL();

    // We have to remember the stream and position for EVERY type code
    // in case some recursive or indirect type code references it.
    _lastInStream = tcis.getTopLevelStream();
    // calculate position resetting to where it was before we read the _kind
    _inStreamPosition = tcis.getTopLevelPosition() - correction;
    _lastInStream.addTypeAtPosition(this, _inStreamPosition);

    if (_kind == tk_indirect) {
	int streamOffset = tcis.read_long();
	if (streamOffset > -4)
	    throw new MARSHAL();
	// The encoding used for indirection is the same as that used for recursive TypeCodes,
	// i.e., a 0xffffffff indirection marker followed by a long offset
	// (in units of octets) from the beginning of the long offset.
	// _REVISIT_ The constant 4 for the long value of the indirection marker.
	int indirectTypePosition = (_inStreamPosition + 4) + streamOffset;

	// Now we have to find the referenced type
	// by its indirectTypePosition within _lastInStream.
	setIndirectType(_lastInStream.getTypeAtPosition(indirectTypePosition));
	return false;
    }
    return true;
}

void read_value_kind(InputStream is) {
    // unmarshal the kind
    _kind = is.read_long();

    // check validity of kind
    if ((_kind < 0 || _kind > typeTable.length) && _kind != tk_indirect) {
	throw new MARSHAL();
    }
    // Don't do any work if this is native
    if (_kind == TCKind._tk_native)
	throw new MARSHAL();

    if (_kind == tk_indirect) {
	throw new MARSHAL("InputStream subtype not supporting recursive type codes!");
    }
}

void read_value_body(InputStream is) {
    // start unmarshaling the rest of the typecode, based on the
    // encoding (empty, simple or complex).

    switch (typeTable[_kind]) {
    case EMPTY:
	// nothing to unmarshal
	break;

    case SIMPLE:
	switch (_kind) {
	case TCKind._tk_string:
	case TCKind._tk_wstring:
	    _length = is.read_long();
	    break;
	case TCKind._tk_fixed:
	    _digits = is.read_ushort();
	    _scale = is.read_short();
	    break;
	default:
	    throw new MARSHAL();
	}
	break;

    case COMPLEX:
	{
	    InputStream _encap;
	    if (is instanceof TypeCodeReader)
		_encap = ((TypeCodeReader)is).read_encapsulation(_orb);
	    else {
		// pop off the encapsulation length
		int encapLength = is.read_long();

		// read off part of the buffer corresponding to the encapsulation
		byte[] encapBuffer = new byte[encapLength];
		is.read_octet_array(encapBuffer, 0, encapBuffer.length);

		// create an encapsulation using the marshal buffer
		// _REVISIT_ We have no information about the endianess!
		_encap = new CDRInputStream(_orb, encapBuffer, encapBuffer.length);

		// read and set the endianness of the encapsulation
		((CDRInputStream)_encap).consumeEndian();
	    }

	    switch(_kind) {

	    case TCKind._tk_objref:
	    case TCKind._tk_abstract_interface:
		{
		    // get the repository id
		    setId(_encap.read_string());
		    // get the name
		    _name = _encap.read_string();
		}
		break;

	    case TCKind._tk_union:
		{
		    // get the repository id
		    setId(_encap.read_string());

		    // get the name
		    _name = _encap.read_string();

		    // discriminant typecode
		    _discriminator = new TypeCodeImpl(_orb);
		    _discriminator.read_value_recursive(_encap);

		    // default index
		    _defaultIndex = _encap.read_long();

		    // get the number of members
		    _memberCount = _encap.read_long();

		    // create arrays for the label values, names and types of members
		    _unionLabels = new AnyImpl[_memberCount];
		    _memberNames = new String[_memberCount];
		    _memberTypes = new TypeCodeImpl[_memberCount];

		    // read off label values, names and types
		    for (int i=0; i < _memberCount; i++) {
			_unionLabels[i] = new AnyImpl(_orb);
			if (i == _defaultIndex) 
			    // for the default case, read off the zero octet
			    _unionLabels[i].insert_octet(_encap.read_octet());
			else {
			    switch (_discriminator.kind().value()) {
			    case TCKind._tk_short:
				_unionLabels[i].insert_short(_encap.read_short());
				break;
			    case TCKind._tk_long:
				_unionLabels[i].insert_long(_encap.read_long());
				break;
			    case TCKind._tk_ushort:
				_unionLabels[i].insert_ushort(_encap.read_short());
				break;
			    case TCKind._tk_ulong:
				_unionLabels[i].insert_ulong(_encap.read_long());
				break;
			    case TCKind._tk_float:
				_unionLabels[i].insert_float(_encap.read_float());
				break;
			    case TCKind._tk_double:
				_unionLabels[i].insert_double(_encap.read_double());
				break;
			    case TCKind._tk_boolean:
				_unionLabels[i].insert_boolean(_encap.read_boolean());
				break;
			    case TCKind._tk_char:
				_unionLabels[i].insert_char(_encap.read_char());
				break;
			    case TCKind._tk_enum:
				int value = _encap.read_long();
				org.omg.CORBA.portable.OutputStream out = 
				    _unionLabels[i].create_output_stream();
				out.write_long(value);
				_unionLabels[i].read_value(out.create_input_stream(),
							   _discriminator);
				break;
			    case TCKind._tk_longlong:
				_unionLabels[i].insert_longlong(_encap.read_longlong());
				break;
			    case TCKind._tk_ulonglong:
				_unionLabels[i].insert_ulonglong(_encap.read_longlong());
				break;
				// _REVISIT_ figure out long double mapping
				// case TCKind.tk_longdouble:
				// _unionLabels[i].insert_longdouble(_encap.getDouble());
				// break;
				//		case TCKind._tk_wchar:
				//		  _unionLabels[i].insert_wchar(_encap.read_char());
				//		  break;
			    default:
				throw new MARSHAL();
			    }
			}
			_memberNames[i] = _encap.read_string();
			_memberTypes[i] = new TypeCodeImpl(_orb);
			_memberTypes[i].read_value_recursive(_encap);
			_memberTypes[i].setParent(this);
		    }
		}
		break;

	    case TCKind._tk_enum:
		{
		    // get the repository id
		    setId(_encap.read_string());

		    // get the name
		    _name = _encap.read_string();

		    // get the number of members
		    _memberCount = _encap.read_long();

		    // create arrays for the identifier names
		    _memberNames = new String[_memberCount];

		    // read off identifier names
		    for (int i=0; i < _memberCount; i++)
			_memberNames[i] = _encap.read_string();
		}
		break;

	    case TCKind._tk_sequence:
		{
		    // get the type of the sequence
		    _contentType = new TypeCodeImpl(_orb);
		    _contentType.read_value_recursive(_encap);
	    
		    // get the bound on the length of the sequence
		    _length = _encap.read_long();
		}
		break;

	    case TCKind._tk_array:
		{
		    // get the type of the array
		    _contentType = new TypeCodeImpl(_orb);
		    _contentType.read_value_recursive(_encap);

		    // get the length of the array
		    _length = _encap.read_long();
		}
		break;

	    case TCKind._tk_alias:
	    case TCKind._tk_value_box:
		{
		    // get the repository id
		    setId(_encap.read_string());

		    // get the name
		    _name = _encap.read_string();

		    // get the type aliased
		    _contentType = new TypeCodeImpl(_orb);
		    _contentType.read_value_recursive(_encap);
		}
		break;

	    case TCKind._tk_except:
	    case TCKind._tk_struct:
		{
		    // get the repository id
		    setId(_encap.read_string());

		    // get the name
		    _name = _encap.read_string();

		    // get the number of members
		    _memberCount = _encap.read_long();

		    // create arrays for the names and types of members
		    _memberNames = new String[_memberCount];
		    _memberTypes = new TypeCodeImpl[_memberCount];

		    // read off member names and types
		    for (int i=0; i < _memberCount; i++) {
			_memberNames[i] = _encap.read_string();
			_memberTypes[i] = new TypeCodeImpl(_orb);
			_memberTypes[i].read_value_recursive(_encap);
			_memberTypes[i].setParent(this);
		    }
		}
		break;

	    case TCKind._tk_value:
		{
		    // get the repository id
		    setId(_encap.read_string());

		    // get the name
		    _name = _encap.read_string();

		    // get the type modifier
		    _type_modifier = _encap.read_short();

		    // get the type aliased
		    _concrete_base = new TypeCodeImpl(_orb);
		    _concrete_base.read_value_recursive(_encap);

		    // get the number of members
		    _memberCount = _encap.read_long();

		    // create arrays for the names, types and visibility of members
		    _memberNames = new String[_memberCount];
		    _memberTypes = new TypeCodeImpl[_memberCount];
		    _memberAccess = new short[_memberCount];

		    // read off value member visibilities
		    for (int i=0; i < _memberCount; i++) {
			_memberNames[i] = _encap.read_string();
			_memberTypes[i] = new TypeCodeImpl(_orb);
			_memberTypes[i].read_value_recursive(_encap);
			_memberTypes[i].setParent(this);
			_memberAccess[i] = _encap.read_short();
		    }
		}
		break;

	    default:
		throw new MARSHAL();
	    }
	    break;
	}
    }
}

public void write_value(OutputStream os) {
    // Wrap OutputStream into TypeCodeOutputStream.
    // This test shouldn't be necessary according to the language spec.
    if (os instanceof TypeCodeOutputStream) {
	this.write_value((TypeCodeOutputStream)os);
    } else {
        boolean littleEndian = false;
        if (os instanceof CDROutputStream)
	    littleEndian = ((CDROutputStream)os).littleEndian();
	TypeCodeOutputStream _encap = new TypeCodeOutputStream(_orb, littleEndian);
	_encap.setEnclosingOutputStream(os);
	this.write_value(_encap);
	_encap.writeOctetSequenceNoLengthTo(os);
	return;
    }
}

public void write_value(TypeCodeOutputStream tcos) {

    // Don't do any work if this is native
    if (_kind == TCKind._tk_native)
        throw new MARSHAL();

    // We have to remember the stream and position for EVERY type code
    // in case some recursive or indirect type code references it.
    _lastOutStream = tcos.getTopLevelStream();
    // calculate position resetting to where it was before we wrote the _kind
    _outStreamPosition = tcos.getTopLevelPosition();

    // marshal the kind
    tcos.write_long(_kind);

    if (_kind == tk_indirect) {
	OutputStream indirectTypeStream = indirectType()._lastOutStream;
	if (indirectTypeStream == null)
	    throw new MARSHAL("Referenced type of indirect type not marshaled!");
	if (_lastOutStream != indirectTypeStream)
	    throw new MARSHAL("Referenced type of indirect type not marshaled to same stream!");

	// The encoding used for indirection is the same as that used for recursive TypeCodes,
	// i.e., a 0xffffffff indirection marker followed by a long offset
	// (in units of octets) from the beginning of the long offset.
	// _REVISIT_ The constant 4 for the long value of the indirection marker.
	int streamOffset = indirectType()._outStreamPosition - (_outStreamPosition + 4);
	if (streamOffset > -4)
	    throw new MARSHAL();

	tcos.write_long(streamOffset);
	// All that gets written is _kind and offset.
	return;
    }

    switch (typeTable[_kind]) {
    case EMPTY:
	// nothing more to marshal
	break;
      
    case SIMPLE:
	switch (_kind) {
	case TCKind._tk_string:
	case TCKind._tk_wstring:
	    // marshal the bound on string length
	    tcos.write_long(_length);
	    break;
	case TCKind._tk_fixed:
	    tcos.write_ushort(_digits);
	    tcos.write_short(_scale);
	    break;
	default:
	    // unknown typecode kind
	    throw new MARSHAL();
	}
	break;
      
    case COMPLEX:
	{
	    // create an encapsulation
	    TypeCodeOutputStream _encap = tcos.init_encapsulation(_orb);

	    switch(_kind) {
	  
	    case TCKind._tk_objref:
	    case TCKind._tk_abstract_interface:
		{
		    // put the repository id
		    _encap.write_string(_id);
	    
		    // put the name
		    _encap.write_string(_name);
		}
		break;
	
	    case TCKind._tk_union:
		{
		    // put the repository id
		    _encap.write_string(_id);

		    // put the name
		    _encap.write_string(_name);

		    // discriminant typecode
		    _discriminator.write_value(_encap);

		    // default index
		    _encap.write_long(_defaultIndex);

		    // put the number of members
		    _encap.write_long(_memberCount);

		    // marshal label values, names and types
		    for (int i=0; i < _memberCount; i++) {

			// for the default case, marshal the zero octet
			if (i == _defaultIndex)
			    _encap.write_octet(_unionLabels[i].extract_octet());

			else {
			    switch (_discriminator.kind().value()) {
			    case TCKind._tk_short:
				_encap.write_short(_unionLabels[i].extract_short());
				break;
			    case TCKind._tk_long:
				_encap.write_long(_unionLabels[i].extract_long());
				break;
			    case TCKind._tk_ushort:
				_encap.write_short(_unionLabels[i].extract_ushort());
				break;
			    case TCKind._tk_ulong:
				_encap.write_long(_unionLabels[i].extract_ulong());
				break;
			    case TCKind._tk_float:
				_encap.write_float(_unionLabels[i].extract_float());
				break;
			    case TCKind._tk_double:
				_encap.write_double(_unionLabels[i].extract_double());
				break;
			    case TCKind._tk_boolean:
				_encap.write_boolean(_unionLabels[i].extract_boolean());
				break;
			    case TCKind._tk_char:
				_encap.write_char(_unionLabels[i].extract_char());
				break;
			    case TCKind._tk_enum:
				int value = _unionLabels[i].create_input_stream().
				    read_long();
				_encap.write_long(value);
				break;
			    case TCKind._tk_longlong:
				_encap.write_longlong(_unionLabels[i].extract_longlong());
				break;
			    case TCKind._tk_ulonglong:
				_encap.write_longlong(_unionLabels[i].extract_ulonglong());
				break;
				// _REVISIT_ figure out long double mapping
				// case TCKind.tk_longdouble:
				// _encap.putDouble(_unionLabels[i].extract_longdouble());
				// break;
				//		case TCKind._tk_wchar:
				//		  _encap.write_wchar(_unionLabels[i].extract_wchar());
				//		  break;
			    default:
				throw new MARSHAL();
			    }
			}
			_encap.write_string(_memberNames[i]);
			_memberTypes[i].write_value(_encap);
		    }
		}
		break;

	    case TCKind._tk_enum:
		{
		    // put the repository id
		    _encap.write_string(_id);

		    // put the name
		    _encap.write_string(_name);

		    // put the number of members
		    _encap.write_long(_memberCount);

		    // marshal identifier names
		    for (int i=0; i < _memberCount; i++)
			_encap.write_string(_memberNames[i]);
		}
		break;

	    case TCKind._tk_sequence:
		{
		    // put the type of the sequence
		    lazy_content_type().write_value(_encap);
	    
		    // put the bound on the length of the sequence
		    _encap.write_long(_length);
		}
		break;

	    case TCKind._tk_array:
		{
		    // put the type of the array
		    _contentType.write_value(_encap);
	    
		    // put the length of the array
		    _encap.write_long(_length);
		}
		break;

	    case TCKind._tk_alias:
	    case TCKind._tk_value_box:
		{
		    // put the repository id
		    _encap.write_string(_id);

		    // put the name
		    _encap.write_string(_name);

		    // put the type aliased
		    _contentType.write_value(_encap);
		}
		break;

	    case TCKind._tk_struct:
	    case TCKind._tk_except:
		{
		    // put the repository id
		    _encap.write_string(_id);

		    // put the name
		    _encap.write_string(_name);

		    // put the number of members
		    _encap.write_long(_memberCount);

		    // marshal member names and types
		    for (int i=0; i < _memberCount; i++) {
			_encap.write_string(_memberNames[i]);
			_memberTypes[i].write_value(_encap);
		    }
		}
		break;
	
	    case TCKind._tk_value:
		{
		    // put the repository id
		    _encap.write_string(_id);

		    // put the name
		    _encap.write_string(_name);

		    // put the type modifier
		    _encap.write_short(_type_modifier);

		    // put the type aliased
		    _concrete_base.write_value(_encap);

		    // put the number of members
		    _encap.write_long(_memberCount);

		    // marshal member names and types
		    for (int i=0; i < _memberCount; i++) {
			_encap.write_string(_memberNames[i]);
			_memberTypes[i].write_value(_encap);
			_encap.write_short(_memberAccess[i]);
		    }
		}
		break;
          
	    default:
		throw new MARSHAL();
	    }

	    // marshal the encapsulation
	    _encap.writeOctetSequenceTo(tcos);
	    break;
	}
    }
}

/**
 * This is not a copy of the TypeCodeImpl objects, but instead it
 * copies the value this type code is representing.
 * See AnyImpl read_value and write_value for usage.
 * The state of this TypeCodeImpl instance isn't changed, only used
 * by the Any to do the correct copy.
 */
protected void copy(InputStream src, OutputStream dst)
{
    switch (_kind) {

    case TCKind._tk_null:
    case TCKind._tk_void:
	break;

    case TCKind._tk_short:
    case TCKind._tk_ushort:
	dst.write_short(src.read_short());
	break;

    case TCKind._tk_long:
    case TCKind._tk_ulong:
	dst.write_long(src.read_long());
	break;

    case TCKind._tk_float:
	dst.write_float(src.read_float());
	break;

    case TCKind._tk_double:
	dst.write_double(src.read_double());
	break;

    case TCKind._tk_longlong:
    case TCKind._tk_ulonglong:
	dst.write_longlong(src.read_longlong());
	break;

    case TCKind._tk_longdouble:
	dst.write_double(src.read_double());
	break;

    case TCKind._tk_boolean:
	dst.write_boolean(src.read_boolean());
	break;
      
    case TCKind._tk_char:
	//  case TCKind._tk_wchar:
	dst.write_char(src.read_char());
	break;
      
    case TCKind._tk_octet:
	dst.write_octet(src.read_octet());
	break;

    case TCKind._tk_string:
	{
	    String s;
	    s = src.read_string();
	    // make sure length bound in typecode is not violated
	    if ((_length != 0) && (s.length() > _length))
		throw new MARSHAL();
	    dst.write_string(s);
	}
	break;

    case TCKind._tk_wstring:
	{
	    String s;
	    s = src.read_wstring();
	    // make sure length bound in typecode is not violated
	    if ((_length != 0) && (s.length() > _length))
		throw new MARSHAL();
	    dst.write_wstring(s);
	}
	break;

    case TCKind._tk_fixed:
	{
	    dst.write_ushort(src.read_ushort());
	    dst.write_short(src.read_short());
	}
	break;

    case TCKind._tk_any: 
	{
	    //Any tmp = new AnyImpl(_orb);
	    Any tmp =  ((CDRInputStream)src).getORB().create_any();
	    TypeCodeImpl t = new TypeCodeImpl(_orb);
	    t.read_value(src);
	    t.write_value(dst);
	    tmp.read_value(src, t);
	    tmp.write_value(dst);
	    break;
	}
    
    case TCKind._tk_TypeCode: 
	{
	    dst.write_TypeCode(src.read_TypeCode());
	    break;
	}
    
    case TCKind._tk_Principal: 
	{
	    dst.write_Principal(src.read_Principal());
	    break;
	}

    case TCKind._tk_objref:
	{
	    dst.write_Object(src.read_Object());
	    break;
	}

    case TCKind._tk_except:
	// Copy repositoryId
	dst.write_string(src.read_string());

	// Fall into ...
    case TCKind._tk_struct:
    case TCKind._tk_value:
	{
	    // copy each element, using the corresponding member type
	    for (int i=0; i < _memberTypes.length; i++) {
		_memberTypes[i].copy(src, dst);
	    }
	    break;
	}
    case TCKind._tk_union:
	{
	    Any tagValue = new AnyImpl(_orb);

	    switch  (_discriminator.kind().value()) {
	    case TCKind._tk_short:
		{
		    short value = src.read_short();
		    tagValue.insert_short(value);
		    dst.write_short(value);
		    break;
		}
	    case TCKind._tk_long:
		{
		    int value = src.read_long();
		    tagValue.insert_long(value);
		    dst.write_long(value);
		    break;
		}
	    case TCKind._tk_ushort:
		{
		    short value = src.read_short();
		    tagValue.insert_ushort(value);
		    dst.write_short(value);
		    break;
		}
	    case TCKind._tk_ulong:
		{
		    int value = src.read_long();
		    tagValue.insert_ulong(value);
		    dst.write_long(value);
		    break;
		}
	    case TCKind._tk_float:
		{
		    float value = src.read_float();
		    tagValue.insert_float(value);
		    dst.write_float(value);
		    break;
		}
	    case TCKind._tk_double:
		{
		    double value = src.read_double();
		    tagValue.insert_double(value);
		    dst.write_double(value);
		    break;
		}
	    case TCKind._tk_boolean:
		{
		    boolean value = src.read_boolean();
		    tagValue.insert_boolean(value);
		    dst.write_boolean(value);
		    break;
		}
	    case TCKind._tk_char:
		{
		    char value = src.read_char();
		    tagValue.insert_char(value);
		    dst.write_char(value);
		    break;
		}
	    case TCKind._tk_enum:
		{
		    int value = src.read_long();
		    tagValue.type(_discriminator);
		    org.omg.CORBA.portable.OutputStream out = 
			tagValue.create_output_stream();
		    out.write_long(value);
		    tagValue.read_value(out.create_input_stream(), _discriminator);
		    dst.write_long(value);
		    break;
		}
	    case TCKind._tk_longlong:
		{
		    long value = src.read_longlong();
		    tagValue.insert_longlong(value);
		    dst.write_longlong(value);
		    break;
		}
	    case TCKind._tk_ulonglong:
		{
		    long value = src.read_longlong();
		    tagValue.insert_ulonglong(value);
		    dst.write_longlong(value);
		    break;
		}
		// _REVISIT_ figure out long double mapping
		// case TCKind.tk_longdouble:
		// {
		// double value = src.read_double();
		//  tagValue.insert_longdouble(value);
		//  dst.putDouble(value);
		//  break;
		//}
		//	case TCKind._tk_wchar:
		//	  {
		//	    char value = src.read_char();
		//	    tagValue.insert_wchar(value);
		//	    dst.write_char(value);
		//	    break;
		//	  }
	    default:
		throw new MARSHAL();
	    }

	    // using the value of the tag, find out the type of the value
	    // following. 

	    int labelIndex;
	    for (labelIndex = 0; labelIndex < _unionLabels.length; labelIndex++) {
		// use equality over anys
		if (tagValue.equal(_unionLabels[labelIndex])) {
		    _memberTypes[labelIndex].copy(src, dst);
		    break;
		}
	    }

	    if (labelIndex == _unionLabels.length) {
		// check if label has not been found
		if (_defaultIndex == -1)
		    // throw exception if default was not expected
		    throw new MARSHAL();
		else 
		    // must be of the default branch type
		    _memberTypes[_defaultIndex].copy(src, dst);
	    }
	    break;
	}

    case TCKind._tk_enum:
	dst.write_long(src.read_long());
	break;
      
    case TCKind._tk_sequence:
	// get the length of the sequence
	int seqLength = src.read_long();

	// check for sequence bound violated
	if ((_length != 0) && (seqLength > _length))
	    throw new MARSHAL();

	// write the length of the sequence
	dst.write_long(seqLength);

	// copy each element of the seq using content type
	lazy_content_type(); // make sure it's resolved
	for (int i=0; i < seqLength; i++)
	    _contentType.copy(src, dst);
	break;

    case TCKind._tk_array:
	// copy each element of the array using content type
	for (int i=0; i < _length; i++)
	    _contentType.copy(src, dst);
	break;

    case TCKind._tk_alias:
    case TCKind._tk_value_box:
	// follow the alias
	_contentType.copy(src, dst);
	break;

    case tk_indirect:
	// need to follow offset, get unmarshal typecode from that
	// offset, and use that to do the copy
	// Don't need to read type code before using it to do the copy.
	// It should be fully usable.
	indirectType().copy(src, dst);
	break;

    case TCKind._tk_native:
    case TCKind._tk_abstract_interface:
	throw new NO_IMPLEMENT();

    default:
	throw new MARSHAL();
    }
}

public TypeCode get_compact_typecode() {
    throw new org.omg.CORBA.NO_IMPLEMENT();
}


}
