/*
 * @(#)EndPoint.java	1.19 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.corba.se.internal.core;

import java.rmi.server.RMISocketFactory;

/**
 * EndPoint is an abstraction of a GIOP listening port.
 */
public interface EndPoint
{
    // These are the endpoint types
    public static final int CLEAR_TEXT = 123;
    public static final int SSL = 124;

    /**
     * Get the type of this end point (one of CLEAR_TEXT, SSL, ...)
     */
    public int getType();

    /**
     * Get the port number of this end point.
     */
    public int getPort();

    /**
     * Get the host name of this end point. Subcontracts must use this
     * instead of InetAddress.getHostName() because this would take
     * into account the value of the ORBServerHost property.
     */
    public String getHostName();

    /**
     * Get the socket factory for this end point.
     */
    public RMISocketFactory getSocketFactory();
}
