package com.sun.corba.se.internal.core ;

import org.omg.CORBA.portable.OutputStream ;

public class ORBVersionImpl implements ORBVersion {
    private byte orbType ;

    private ORBVersionImpl( byte orbType )
    {
	this.orbType = orbType ;
    }

    public static final ORBVersion FOREIGN = new ORBVersionImpl(
	ORBVersion.FOREIGN ) ;

    // Kestrel
    public static final ORBVersion OLD = new ORBVersionImpl(
	ORBVersion.OLD ) ;

    // Ladybird
    public static final ORBVersion NEW = new ORBVersionImpl(
	ORBVersion.NEW ) ;

    // Merlin and newer
    public static final ORBVersion NEWER = new ORBVersionImpl(
	ORBVersion.NEWER ) ;


    public byte getORBType()
    {
	return orbType ;
    }

    public void write( OutputStream os )
    {
	os.write_octet( (byte)orbType ) ;
    }

    public String toString()
    {
	return "ORBVersionImpl[" + Byte.toString( orbType ) + "]" ;
    }

    public boolean equals( Object obj )
    {
        try {
            ORBVersion version = (ORBVersion)obj ;
            return version.getORBType() == orbType ;
        } catch (ClassCastException cce) {
            return false;
        }
    }

    public boolean lessThan(ORBVersion version) {
        return orbType < version.getORBType();
    }
}
