/*
 * @(#)SendingContextServiceContext.java	1.8 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.corba.se.internal.core;

import org.omg.CORBA.SystemException;
import org.omg.CORBA_2_3.portable.InputStream ;
import org.omg.CORBA_2_3.portable.OutputStream ;
import com.sun.corba.se.internal.core.ServiceContext ;
import com.sun.corba.se.internal.core.IOR ;
import com.sun.corba.se.internal.core.MarshalOutputStream ;

public class SendingContextServiceContext extends ServiceContext {
    public SendingContextServiceContext( IOR ior )
    {
	this.ior = ior ;
    }

    public SendingContextServiceContext( InputStream is ) 
    {
	super( is ) ;
	ior = new IOR( (com.sun.corba.se.internal.core.ORB)(is.orb()) ) ;
	ior.read( in ) ;
    }

    // Required SERVICE_CONTEXT_ID and getId definitions
    public static final int SERVICE_CONTEXT_ID = 6 ;
    public int getId() { return SERVICE_CONTEXT_ID ; }

    public void writeData( OutputStream os ) throws SystemException
    {
	ior.write( (MarshalOutputStream)os ) ;
    }

    public IOR getIOR() 
    {
	return ior ;
    }

    private IOR ior = null ;

    public String toString() 
    {
	return "SendingContexServiceContext[ ior=" + ior + " ]" ;
    }
}
