/*
 * @(#)ServerRequest.java	1.19 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.corba.se.internal.core;

import org.omg.CORBA.SystemException;
import org.omg.CORBA.portable.ResponseHandler;
import org.omg.CORBA.portable.UnknownException;

/**
 * ServerRequest represents the incoming request on the server-side.
 */
public interface ServerRequest extends MarshalInputStream, Request, ResponseHandler {

    /**
     * Create a normal (invocation return) response for this request.
     */
    public ServerResponse
	createResponse(ServiceContexts svc);


    /**
     * Create a response that represents an user exception.
     *
     */
    public ServerResponse
	createUserExceptionResponse(ServiceContexts svc);


    /**
     * Create a response that represents an unknown exception.
     *
     */
    public ServerResponse
	createUnknownExceptionResponse(UnknownException ex);


    /**
     * Create a response that represents a system exception.
     */
    public ServerResponse
        createSystemExceptionResponse(SystemException ex,
				      ServiceContexts svc);


    /**
     * Create a response that represents a location forward.
     */
    public ServerResponse
	createLocationForward(IOR ior, ServiceContexts svc);
}
