/*
 * @(#)CancelRequestMessage.java	1.34 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.corba.se.internal.iiop;

import org.omg.CORBA.SystemException;
import org.omg.CORBA.portable.*;

public final class CancelRequestMessage extends Message {
    public CancelRequestMessage( boolean debug ) {
	super( debug ) ;
    }

    public CancelRequestMessage(int requestId, boolean debug )
    {
	super( debug );
	setType(Message.GIOPCancelRequest);
	this.requestId = requestId;
    }

    public void
	write(OutputStream s)
	throws SystemException
    {
	super.write(s);
	s.write_long(requestId);
    }

    public void
	read(InputStream s)
	throws SystemException
    {
	requestId = s.read_long();
    }
}
