/*
 * @(#)FVDCodeBaseDelegate.java	1.11 01/02/09
 *
 * Copyright 1999-2001 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * Licensed Materials - Property of IBM
 * RMI-IIOP v1.0
 * Copyright IBM Corp. 1998 1999  All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

package com.sun.corba.se.internal.iiop;

import org.omg.CORBA.ORB;
import java.util.Properties;
import java.util.Hashtable;

import com.sun.org.omg.CORBA.ValueDefPackage.FullValueDescription;
import com.sun.org.omg.SendingContext._CodeBaseImplBase;
import com.sun.org.omg.SendingContext.CodeBase;
import org.omg.SendingContext.RunTime;
import com.sun.org.omg.SendingContext.CodeBaseHelper;
import com.sun.corba.se.internal.io.FVDCodeBaseImpl;

//d11638 moved this class to this package from com.sun.corba.se.internal.io

/**
 * This class acts as the remote interface to receivers wishing to retrieve
 * the information of a remote Class.  However, it is not itself exported as a remote
 * servant.  This singleton instead acts as a late binding and caching
 * mechanism.
 *
 * Note that calls to this API are only successful when made from
 * a ReaderThread or CachedReaderThread.  This is because the Connection
 * for the current call must be located.
 */
public class FVDCodeBaseDelegate extends _CodeBaseImplBase
{
    private static FVDCodeBaseImpl local = new FVDCodeBaseImpl();

    private FVDCodeBaseDelegate(){}

    public static final FVDCodeBaseDelegate singleton =
	new FVDCodeBaseDelegate();

    // Operation to obtain the IR from the sending context
    public com.sun.org.omg.CORBA.Repository get_ir (){
	return null;
    }

    // Operations to obtain a URL to the implementation code
    public String implementation (String x){
	try{
	return IIOPConnection.getCurrentReaderConnection().getImplementation(x);
    }
	catch(ClassCastException cce){
	    return local.implementation(x);
	}
    }

    public String[] implementations (String[] x){
	try{
	String result[] = new String[x.length];
	IIOPConnection c = IIOPConnection.getCurrentReaderConnection();

	for (int i = 0; i < x.length; i++){
	    result[i] = c.getImplementation(x[i]);
	}
	return result;
    }
	catch(ClassCastException cce){
	    return local.implementations(x);
	}
    }

    // the same information
    public FullValueDescription meta (String x){
	try{
	return IIOPConnection.getCurrentReaderConnection().getFVD(x);
    }
	catch(ClassCastException cce){
	    return local.meta(x);
	}
    }

    public FullValueDescription[] metas (String[] x){
	try{
	FullValueDescription result[] = new FullValueDescription[x.length];
	IIOPConnection c = IIOPConnection.getCurrentReaderConnection();

	for (int i = 0; i < x.length; i++){
	    result[i] = c.getFVD(x[i]);
	}

	return result;
    }
	catch(ClassCastException cce){
	    return local.metas(x);
	}
    }

    // information
    public String[] bases (String x){
	try{
	return IIOPConnection.getCurrentReaderConnection().getBases(x);
    }
	catch(ClassCastException cce){
	    return local.bases(x);
	}
    }

}





































