/*
 * @(#)LocateReplyMessage.java	1.34 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.corba.se.internal.iiop;

import org.omg.CORBA.SystemException;
import org.omg.CORBA.portable.*;

public final class LocateReplyMessage extends Message {
    int status;

    public LocateReplyMessage( boolean debug )
    {
	super( debug ) ;
    }

    public LocateReplyMessage(int requestId, int status, boolean debug )
    {
	super( debug );
	setType(Message.GIOPLocateReply);
	this.requestId = requestId;
	this.status = status;
    }

    public int
	getRequestStatus()
    {
	return status;
    }

    public void
	write(OutputStream s)
	throws SystemException
    {
	super.write(s);
	s.write_long(requestId);
	s.write_long(status);
    }

    public void
	read(InputStream s)
	throws SystemException
    {
	requestId = s.read_long();
	status = s.read_long();
    }
}
