/*
 * @(#)LocateRequestMessage.java	1.36 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.corba.se.internal.iiop;

import org.omg.CORBA.SystemException;
import org.omg.CORBA.portable.*;

public final class LocateRequestMessage extends Message {
    private byte[] objectKey;

    public LocateRequestMessage( boolean debug )
    {
	super( debug ) ;
    }

    public LocateRequestMessage(int requestId, byte[] objectKey, boolean debug )
    {
	super( debug );
	setType(Message.GIOPLocateRequest);
	this.requestId = requestId;
	this.objectKey = objectKey;
    }

    public byte[]
	getObjectKey()
    {
	return objectKey;
    }

    public void
	write(OutputStream s)
	throws SystemException
    {
	super.write(s);
	s.write_long(requestId);
        s.write_long(objectKey.length);
	s.write_octet_array(objectKey, 0, objectKey.length);
    }

    public void
	read(InputStream s)
	throws SystemException
    {
	requestId = s.read_long();
	objectKey = new byte[s.read_long()];
	s.read_octet_array(objectKey, 0, objectKey.length);
    }
}
