/*
 * @(#)Condition.java	1.36 00/02/11
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.corba.se.internal.orbutil;

//
// Traditional Condition variables, unbound to any instance or class.
//							KGH April 95

final public class Condition {

    public Condition() {
    }

    public void wait(Lock lock) {
        synchronized (this) {
	    lock.unlock();
	    boolean ok = false;
	    while (!ok) {
	        try {
		    super.wait();
		    ok = true;
	        } catch (InterruptedException ex) {
		    // Eat it and loop again.  The user doesn't care how
		    // long we wait.
	        }
	    }
	}
	lock.lock();
    }

    public void wait(Lock lock, int timeout)
	throws InterruptedException {
	synchronized (this) {
	    lock.unlock();
	    super.wait(timeout);
	}
	lock.lock();
    }

    public synchronized void signal() {
	super.notify();
    }

    public synchronized void signalAll() {
	super.notifyAll();
    }
}

