/*
 * @(#)JDKClassLoader.java	1.8 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * Licensed Materials - Property of IBM
 * RMI-IIOP v1.0
 * Copyright IBM Corp. 1998 1999  All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

package com.sun.corba.se.internal.util;

import java.io.IOException;
import java.io.*;

/**
 *  Utility method for crawling call stack to load class
 */
class JDKClassLoader {

    private static ObjectInputStream link;

    static Class loadClass(Class c, String className, boolean jdk12)
	throws ClassNotFoundException {
	if (link == null) {
	    try {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		ObjectOutputStream oos = new ObjectOutputStream(baos);
		link = new ObjectInputStream(new ByteArrayInputStream(baos.toByteArray()));
	    }
	    catch(Throwable t){
		throw new RuntimeException("Failed to create JDKClassLoader link : " + t);
	    }
	}

        // Maintain the same error semantics as Class.forName() on both
        // 1.1 and 1.2...
        
        if (className == null) {
            throw new NullPointerException();
        }
        if (className.length() == 0) {
            if (jdk12) {
                throw new ClassNotFoundException();
            } else {
                throw new IllegalArgumentException();
            }
        }
        
	return specialLoadClass(link, c, className);

    }
	
    static native Class specialLoadClass(Object target, Class c, String className)
	throws ClassNotFoundException;

}
