/*
 * @(#)MinorCodes.java	1.16 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * Licensed Materials - Property of IBM
 * RMI-IIOP v1.0
 * Copyright IBM Corp. 1998 1999  All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

package com.sun.corba.se.internal.util;

import org.omg.CORBA.OMGVMCID;

public final class MinorCodes {

    // BAD_CONTEXT exception minor codes
    // BAD_INV_ORDER exception minor codes
    // from ServerRequestImpl.java
    public static final int DSIMETHOD_NOTCALLED = SUNVMCID.value + 1;

    // BAD_OPERATION exception minor codes

    //
    // BAD_PARAM exception minor codes
    //

    public static final int UNABLE_REGISTER_VALUE_FACTORY = OMGVMCID.value + 1;
    public static final int NULL_PARAM = SUNVMCID.value + 1;
    // For some reason this is used in ORB.lookup_value_factory()
    // instead of UNABLE_LOCATE_VALUE_FACTORY, so we define it here.
    public static final int UNABLE_FIND_VALUE_FACTORY = SUNVMCID.value + 2;
    // This code is used in com.sun.rmi.util.Utility.throwNotSerializableForCorba().
    // The CORBA equivalent of a java.io.NotSerializableException
    public static final int NOT_SERIALIZABLE = SUNVMCID.value + 6;

    // BAD_TYPECODE exception minor codes
    // BOUNDS exception minor codes

    //
    // NO_IMPLEMENT exception minor codes
    //

    // from FVDCodeBaseImpl
    public static final int MISSING_LOCAL_VALUE_IMPL = OMGVMCID.value + 1;
    public static final int INCOMPATIBLE_VALUE_IMPL = OMGVMCID.value + 2;
    /** This is redundant now because DSI is implemented. */
    public static final int DSI_NOT_IMPLEMENTED = SUNVMCID.value + 1 ;

    //
    // COMM_FAILURE exception minor codes
    //

    // from IIOPConnection.java
    public static final int CONNECT_FAILURE = SUNVMCID.value + 1 ;
    public static final int CONN_CLOSE_REBIND = SUNVMCID.value + 2 ;
    public static final int WRITE_ERROR_SEND = SUNVMCID.value + 3 ;
    // from ORB.java
    public static final int GET_PROPERTIES_ERROR = SUNVMCID.value + 4 ;
    public static final int BOOTSTRAP_SERVER_NOT_AVAIL = SUNVMCID.value + 5 ;
    // from Generic.java
    /** 
     * Unable to successfully connect to the server after several
     * attempts.
     */
    public static final int INVOKE_ERROR = SUNVMCID.value + 6 ;

    //
    // DATA_CONVERSION exception minor codes
    //

    // from ORB.java
    /** 
     * Encountered a bad hexadecimal character while doing 
     * ORB string_to_object operation.
     */
    public static final int BAD_HEX_DIGIT = SUNVMCID.value + 1 ;
    /** 
     * The given IOR for string_to_object operation has odd
     * length. It must be even.
     */
    public static final int BAD_STRINGIFIED_IOR_LEN = SUNVMCID.value + 2 ;
    /** 
     * The given string does not start with "IOR:" and hence is a
     * bad stringified IOR.
     */
    public static final int BAD_STRINGIFIED_IOR = SUNVMCID.value + 3 ;
    /** 
     * Unable to perform ORB resolve_initial_references operation
     * due to the host or the post being incorrect or unspecified.
     */
    public static final int BAD_MODIFIER = SUNVMCID.value + 4;
    public static final int CODESET_INCOMPATIBLE = SUNVMCID.value + 5;
    

    // IMP_LIMIT exception minor codes
    // INTF_REPOS exception minor codes

    //
    // INTERNAL exception minor codes
    //

    // from Generic.java
    /** 
     * Bad status returned in the IIOP Reply message by the server.
     */
    public static final int BAD_REPLYSTATUS = SUNVMCID.value + 3 ;
    /** 
     * When unmarshalling, the repository id of the user exception
     * was found to be of incorrect length.
     */
    public static final int PEEKSTRING_FAILED = SUNVMCID.value + 6 ;
    // from IIOPConnection.java
    /** 
     * Unable to determine local hostname using the Java APIs 
     * InetAddress.getLocalHost().getHostName().
     */
    public static final int GET_LOCAL_HOST_FAILED = SUNVMCID.value + 7 ;
    /** 
     * Unable to create the listener thread on the specific port.
     * Either the post is taken or there was an error creating the
     * daemon thread.
     */
    public static final int CREATE_LISTENER_FAILED = SUNVMCID.value + 8 ;
    /**
     * Bad locate request status found in the IIOP locate reply.
     */
    public static final int BAD_LOCATE_REQUEST_STATUS = SUNVMCID.value + 9 ;
    // from IOR.java
    /** 
     * Error encountered while stringifying an object reference.
     */
    public static final int STRINGIFY_WRITE_ERROR = SUNVMCID.value + 10 ;
    // from Message.java
    /** 
     * IIOP message with bad GIOP v1.0 message type found. 
     */
    public static final int BAD_GIOP_REQUEST_TYPE = SUNVMCID.value + 11 ;
    // from Utility.java
    /** 
     * Error encountered while unmarshalling the user exception.
     */
    public static final int ERROR_UNMARSHALING_USEREXC = SUNVMCID.value + 14 ;
    // from SubcontractRegistry.java
    /** 
     * The client, or a server subcontract being registered 
     * will overflow the suncontract registry.
     */
    public static final int SUBCONTRACTREGISTRY_ERROR = SUNVMCID.value + 18 ;
    // from GenericCORBAClientSC.java, RequestImpl.java
    /** 
     * Error while processing a LocationForward.
     */
    public static final int LOCATIONFORWARD_ERROR = SUNVMCID.value + 19 ;
	

    // INV_FLAG exception minor codes
    // INV_IDENT exception minor codes

    //
    // INV_OBJREF exception minor codes
    //

    // from IOR.java
    /** 
     * An IOR with no profiles was encountered.
     */
    public static final int NO_PROFILE_PRESENT = SUNVMCID.value + 1 ;
    public static final int BAD_CODE_SET = SUNVMCID.value + 2;
    
    //
    // MARSHAL exception minor codes
    //

    public static final int UNABLE_LOCATE_VALUE_FACTORY = OMGVMCID.value + 1;
    public static final int UNABLE_LOCATE_VALUE_HELPER = SUNVMCID.value + 1;
    /** 
     * Error occured while trying to read a marshalled object 
     * reference and converting into an in memory object reference.
     */
    public static final int READ_OBJECT_EXCEPTION = SUNVMCID.value + 4 ;
    /** 
     * Marshalling/Unmarshalling unsupported IDL types like wide
     * characters and wide strings.
     */
    public static final int UNSUPPORTED_IDLTYPE = SUNVMCID.value + 5 ;
    /** 
     * Character encountered while marshalling or unmarshalling 
     * that is not ISO Latin-1 (8859.1) compliant. It is not in
     * the range of 0 to 255.
     */
    // Also used for DATA_CONVERSION exception
    public static final int CHARACTER_OUTOFRANGE = SUNVMCID.value + 6 ;
    /**
     * An exception was thrown while doing the result()
     * operation on ServerRequest.
     */
    public static final int DSI_RESULT_EXCEPTION = SUNVMCID.value + 7 ;
    /**
     * IIOPInputStream.grow was called.
     */
    public static final int IIOPINPUTSTREAM_GROW = SUNVMCID.value + 8 ;


    // NO_MEMORY exception minor codes
    // FREE_MEM exception minor codes

    //
    // NO_IMPLEMENT
    //

    /** 
     * get_interface is not implemented on server.
     */
    public static final int GETINTERFACE_NOT_IMPLEMENTED = SUNVMCID.value + 2 ;
    /** 
     * deferred sends are not implemented.
     */
    public static final int SEND_DEFERRED_NOTIMPLEMENTED = SUNVMCID.value + 3 ;

    // NO_PERMISSION exception minor codes
    // NO_RESOURCES exception minor codes
    // NO_RESPONSE exception minor codes

    //
    // OBJ_ADAPTER exception minor codes
    //

    // from ORB.java
    /** 
     * There was no subcontract found that matches the one in 
     * the object key when dispatching the request on the server
     * side to the object adapter layer.
     */
    public static final int NO_SERVER_SC_IN_DISPATCH = SUNVMCID.value + 1 ;
    /** 
     * There was no subcontract found that matches the one in 
     * the object key when dispatching the locate request on the server
     * side to the object adapter layer.
     */
    // Not used
    public static final int NO_SERVER_SC_IN_LOOKUP = SUNVMCID.value + 2 ;
    /** 
     * Unable to create the default server-side subcontract while 
     * connecting a servant to the ORB.
     */
    public static final int NO_SERVER_SC_IN_CREATE_DEFAULT_SERVER = SUNVMCID.value + 3 ;
    /** 
     * Error occured when trying to connect a servant to the ORB.
     */
    public static final int ORB_CONNECT_ERROR = SUNVMCID.value + 4 ;

    //
    // Internal Exception Minor Code.
    //

    // There is another minor code with that name in com.sun.PortableServer.MinorCodes
    public static final int WRONG_CLIENTSC = SUNVMCID.value + 5 ;


    // INITIALIZE exception minor codes
    // PERSIST_STORE exception minor codes
    // TRANSIENT exception minor codes

    //
    // UNKNOWN exception minor codes
    //

    // from Utility.java
    /** 
     * Unknown user exception encountered while unmarshalling.
     */
    public static final int UNKNOWN_CORBA_EXC = SUNVMCID.value + 1 ;
    // from GenericServerSC.java
    /** 
     * Unknown user exception thrown by the server implementation.
     */
    public static final int RUNTIMEEXCEPTION = SUNVMCID.value + 3 ;
    // from WorkerThread.java
    /** 
     * Unknown exception/error thrown by the ORB/application implementation.
     */
    public static final int UNKNOWN_SERVER_ERROR = SUNVMCID.value + 4 ;
    // from Utility.java
    /**
     * Error while marshaling SystemException after DSI-based invocation. 
     */
    public static final int UNKNOWN_DSI_SYSEX = SUNVMCID.value + 5 ;

    //
    // OBJECT_NOT_EXIST  exception minor codes
    //

    // from IIOPConnection.java
    /** 
     * The locate request got the response indicating that the
     * object is not known to the locator.
     */
    public static final int LOCATE_UNKNOWN_OBJECT = SUNVMCID.value + 1 ; 
    // from GenericServerSC.java
    /** 
     * The server id of the server that received the request does
     * not match the server id baked into the object key of the
     * object reference that was invoked upon.
     */
    public static final int BAD_SERVER_ID = SUNVMCID.value + 2 ; 
    /** 
     * The implementation id baked into the object reference does not 
     * match any implementation in the server. 
     */
    // Not used
    public static final int BAD_IMPLID = SUNVMCID.value + 3 ; 
    /** 
     * No skeleton was found on the server side that matches the
     * contents of the object key inside the object reference.
     */
    // There is another minor code with that name in com.sun.PortableServer.MinorCodes
    public static final int BAD_SKELETON = SUNVMCID.value + 4 ; 

    public static final int SERVANT_NOT_FOUND = SUNVMCID.value + 5 ; 

}
