/*
 * @(#)MacSeparatorUI.java	1.4 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.java.swing.plaf.mac;

import javax.swing.*;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.Rectangle;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.BasicSeparatorUI;


/**
 * A Mac L&F implementation of SeparatorUI.  This implementation 
 * is a "combined" view/controller.
 * @version 1.4, 02/02/00
 * @author Steve Wilson
 */

public class MacSeparatorUI extends BasicSeparatorUI {
    public static ComponentUI createUI( JComponent c )
    {
        return new MacSeparatorUI();
    }

    protected void installDefaults( JSeparator s )
    {
        LookAndFeel.installColors( s, "Separator.background", "Separator.foreground" );
    }

    public void paint( Graphics g, JComponent c )
    {
        int h = c.getHeight();
        int w = c.getWidth();

        Color dark = c.getForeground();
        Color light = c.getBackground();

        if ( ((JSeparator)c).getOrientation() == JSeparator.VERTICAL ) {

         // ?????

        } else {  // HORIZONTAL
            g.setColor( light );
            g.drawLine( 0, 0, 0, h-1 );

            g.setColor( dark );
            g.drawLine( w-1, 0, w-1, h-1 );
            g.drawLine( 0, 2, w-1, 2);

            g.setColor(light);
            g.drawLine(0, 3, w-1, 3);
        }
    }

    public Dimension getPreferredSize( JComponent c )
    { 
        if ( ((JSeparator)c).getOrientation() == JSeparator.VERTICAL )
            return new Dimension( 6, 0 );
        else
            return new Dimension( 0, 6 );
    }
}

