/*
 * @(#)MacTextFieldUI.java	1.3 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package com.sun.java.swing.plaf.mac;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

/**
 * Mac look and feel for a JTextField.
 *
 * @version 1.3 02/02/00
 * @author Steve Wilson
 */
public class MacTextFieldUI extends BasicTextFieldUI {

	FocusListener macFocusHandler;

	/**
	 * Creates a UI for a JTextField.
	 *
	 * @param c the text field
	 * @return the UI
	 */
	public static ComponentUI createUI(JComponent c) {
		return new MacTextFieldUI();
	}

	/**
	 * Creates a new MacTextFieldUI.
	 */
	public MacTextFieldUI() {
		super();
	}

	protected void installListeners() {
		macFocusHandler = new MacFocusHandler();
		getComponent().addFocusListener(macFocusHandler);
	}

	protected void uninstallListeners() {
		getComponent().removeFocusListener(macFocusHandler);
	}

   // gross hack for compiler protected bug yuck!
   protected JTextComponent myGetCompontent() {
      return getComponent();
   }


	class MacFocusHandler implements FocusListener {
		public void focusGained(FocusEvent e) {
			myGetCompontent().repaint();
		}

		public void focusLost(FocusEvent e) {
			myGetCompontent().repaint();
		}

	}
}
