/*
 * @(#)DocErrorReporter.java	1.4 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.javadoc;

/**
 * This interface provides error, warning and notice printing.
 *
 * @since JDK1.2
 * @author Robert Field
 */
public interface DocErrorReporter {

    /**
     * Print error message, increment error count.
     *
     * @param msg message to print
     */
    void printError(String msg);

    /**
     * Print warning message, increment warning count.
     *
     * @param msg message to print
     */
    void printWarning(String msg);

    /**
     * Print a message.
     *
     * @param msg message to print
     */
    void printNotice(String msg);
}
