/*
 * @(#)ReferenceWrapper.java	1.3 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.jndi.rmi.registry;


import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;

import javax.naming.*;


/**
 * The ReferenceWrapper class is a Remote wrapper for Reference
 * objects.  It wraps around a Reference on the server, and makes the
 * Reference accessible to clients.
 *
 * @author Scott Seligman
 * @version 1.3 00/02/02
 */


public class ReferenceWrapper
	extends UnicastRemoteObject
	implements RemoteReference
{
    protected Reference wrappee;	// reference being wrapped

    public ReferenceWrapper(Reference wrappee)
	    throws NamingException, RemoteException
    {
	this.wrappee = wrappee;
    }

    public Reference getReference() throws RemoteException {
	return wrappee;
    }
}
