/*
 * @(#)AiffFileFormat.java	1.7 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.media.sound;	  	 

import javax.sound.sampled.AudioFileFormat;
import javax.sound.sampled.AudioFormat;


/**
 * AIFF file format.
 *
 * @version 1.7 00/02/02
 * @author Jan Borgersen
 */

class AiffFileFormat extends AudioFileFormat {

    static final int AIFF_MAGIC         = 1179603533;

	// for writing AIFF
	static final int AIFC_MAGIC			= 0x41494643;	// 'AIFC'
	static final int AIFF_MAGIC2		= 0x41494646;	// 'AIFF'
	static final int FVER_MAGIC			= 0x46564552;	// 'FVER'
	static final int FVER_TIMESTAMP		= 0xA2805140;	// timestamp of last AIFF-C update
	static final int COMM_MAGIC			= 0x434f4d4d;	// 'COMM'
	static final int SSND_MAGIC			= 0x53534e44;	// 'SSND'

	// compression codes
	static final int AIFC_PCM			= 0x4e4f4e45;	// 'NONE' PCM
	static final int AIFC_ACE2			= 0x41434532;	// 'ACE2' ACE 2:1 compression
	static final int AIFC_ACE8			= 0x41434538;	// 'ACE8' ACE 8:3 compression
	static final int AIFC_MAC3			= 0x4d414333;	// 'MAC3' MACE 3:1 compression
	static final int AIFC_MAC6			= 0x4d414336;	// 'MAC6' MACE 6:1 compression
	static final int AIFC_ULAW			= 0x756c6177;	// 'ulaw' ITU G.711 u-Law
	static final int AIFC_IMA4			= 0x696d6134;	// 'ima4' IMA ADPCM

	static final int AIFF_HEADERSIZE	= 54;


	AiffFileFormat( AudioFileFormat aff ) {
		this( aff.getType(), aff.getByteLength(), aff.getFormat(), aff.getFrameLength() );
	}

	AiffFileFormat(Type type, int byteLength, AudioFormat format, int frameLength) {		
		super(type, byteLength, format, frameLength);
	}

}

