/*
 * @(#)HeadspaceMixerProvider.java	1.6 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.media.sound;	  

import javax.sound.sampled.Mixer;
import javax.sound.sampled.spi.MixerProvider;


/**
 * Provider for the Headspace Mixer.
 *
 * @version 1.6 00/02/02
 * @author Kara Kytle
 */
public class HeadspaceMixerProvider extends MixerProvider {

	/**
	 * Headspace mixer instance
	 */
	private static HeadspaceMixer theMixer = HeadspaceMixer.getMixerInstance();


	/**
	 * Headspace mixer description.
	 */
	private static final Mixer.Info info					= theMixer.getMixerInfo();

	
	public Mixer.Info[] getMixerInfo() {

		Mixer.Info[] localInfo = { info };
		return localInfo;
	}

	public Mixer getMixer(Mixer.Info info) {

		if ( (info == null) || (info.equals(this.info)) ) {
			return theMixer;
		} 

		throw new IllegalArgumentException("Mixer " + info.toString() + " not supported by this provider.");
	}
}
