/*
 * @(#)MidiOutDevice.java	1.7 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.media.sound;

import java.util.Vector;
import java.util.StringTokenizer;	// for parsing classpath

import java.net.URL;
import java.net.MalformedURLException;

import java.io.File;
import java.io.IOException;

import javax.sound.midi.*;
			 


/******************************************************************************************
IMPLEMENTATION TODO:


******************************************************************************************/



/**
 * MidiOutDevice class representing functionality of MidiOut devices.
 *
 * @version 1.7, 00/02/02
 * @author David Rivas
 * @author Kara Kytle
 */
class MidiOutDevice extends AbstractMidiDevice /*implements Receiver*/ {


// STATIC VARIABLES


// INSTANCE VARIABLES

	/**
	 * This is the device handle returned from native code
	 */
	//private int id = 0;
	

	// DEVICE STATE

	private Vector receivers	= new Vector();


// CONSTRUCTOR

/*	
	MidiOutDevice(MidiOutDeviceProvider.MidiOutDeviceInfo info, int mode, int[] modes) {
		
		super(info, mode, modes);

		if(Printer.trace) Printer.trace(">> MidiOutDevice CONSTRUCTOR");
		if(Printer.trace) Printer.trace("<< MidiOutDevice CONSTRUCTOR completed");
	}
*/

	MidiOutDevice(MidiOutDeviceProvider.MidiOutDeviceInfo info) {
		
		super(info);

		if(Printer.trace) Printer.trace(">> MidiOutDevice CONSTRUCTOR");
		if(Printer.trace) Printer.trace("<< MidiOutDevice CONSTRUCTOR completed");
	}


// IMPLEMENTATION OF ABSTRACT MIDI DEVICE METHODS

	synchronized void implOpen() throws MidiUnavailableException {

		id = nOpen( ((MidiOutDeviceProvider.MidiOutDeviceInfo)getDeviceInfo()).getIndex() );

		if (id == 0) {
			throw new MidiUnavailableException("Unable to open native device");
		}
	}


	synchronized void implClose() {

		// close all receivers
		for(int i = 0; i < receivers.size(); i++) {
			((Receiver)receivers.elementAt(i)).close();
		}
		receivers.removeAllElements();

		// close the device
		int oldId = id;
		id = 0;
		nClose(oldId);
	}


// OVERRIDES OF ABSTRACT MIDI DEVICE METHODS

					
	public int getMaxReceivers() {

		// $$kk: 09.27.99: need a not-specified value here
		return -1;		
	}


	public synchronized Receiver getReceiver() throws MidiUnavailableException {
		
		Receiver receiver = new MidiOutReceiver();
		receivers.addElement(receiver);
		return receiver;
	}


// INNER CLASSES

	class MidiOutReceiver implements Receiver {

		private boolean open = true;
			 

		public void send(ShortMessage message, long timeStamp) {

			if (open) {
				nSendShortMessage(id, message.getStatus(), message.getData1(), message.getData2(), timeStamp);
			}
		}


		public void send(SysexMessage message, long timeStamp) {
  
			/* $$kk: 06.22.99: need to implement! */
			return;
		}


		public void send(MidiMessage message, long timeStamp) {

			/* something we don't handle! */
		}


	//	/**
	//	 * $$kk: 06.22.99: sort of seems like this should throw an InvalidMidiDataException??
	//	 */
	//	public void send(MetaMessage message, long timeStamp) {
	//  
	//		/* we shouldn't process these -- or even get them! */
	//		return;
	//	}


		public void close() {
			receivers.removeElement(this);
			open = false;
		}

	} // class MidiOutReceiver


// NATIVE METHODS

	private native int nOpen(int index) throws MidiUnavailableException;
	private native void nClose(int id);

	private native void nSendShortMessage(int id, int status, int data1, int data2, long timeStamp);

} // class MidiOutDevice


										
