/*
 * @(#)Printer.java	1.19 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.media.sound;

/**
 * Printer allows you to set up global debugging status and print
 * messages accordingly.
 *
 * @version 1.19 00/02/02
 * @author David Rivas
 * @author Kara Kytle
 */
class Printer {

	static boolean err = false;
	static boolean debug = false;
	static boolean trace = false;
	static boolean verbose = false;
	static boolean release = false;

	static void setErrorPrint(boolean on) {

		err = on;
	}

	static void setDebugPrint(boolean on) {

		debug = on;
	}

	static void setTracePrint(boolean on) {

		trace = on;
	}

	static void setVerbosePrint(boolean on) {

		verbose = on;
	}

	static void setReleasePrint(boolean on) {

		release = on;
	}

	public static void err(String str) {
	
		if (err)
			System.out.println(str);
	}	

	public static void debug(String str) {
	
		if (debug)
			System.out.println(str);
	}	

	public static void trace(String str) {
	
		if (trace)
			System.out.println(str);
	}	

	public static void verbose(String str) {
	
		if (verbose)
			System.out.println(str);
	}	

	public static void release(String str) {
	
		if (release)
			System.out.println(str);
	}	
}
