/*
 * @(#)Toolkit.java	1.5 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.media.sound;	  


/**
 * Common conversions etc. 
 *
 * @version 1.5 00/02/02
 * @author Kara Kytle
 */
class Toolkit {

	
	/**
	 * Converts bytes from signed to unsigned.
	 */
	static void getUnsigned8(byte[] b, int off, int len) {

		for (int i = off; i < (off+len); i++) {

			b[i] = (b[i] >= 0) ? (byte)(0x80 | b[i]) : (byte)(0x7F & b[i]);
		}
	}


	/**
	 * Swaps bytes.
	 * @throws ArrayOutOfBoundsException if len is not a multiple of 2.
	 */
	static void getByteSwapped(byte[] b, int off, int len) {
	
		byte tempByte;
		for (int i = off; i < (off+len); i+=2) {

			tempByte = b[i];
			b[i] = b[i+1];
			b[i+1] = tempByte;			
		}		
	}


	/**
	 * Linear to DB scale conversion.
	 */
	static float linearToDB(float linear) {

		float dB = (float) (Math.log((double)((linear==0.0)?0.0001:linear))/Math.log(10.0) * 20.0);
		return dB;
	}


	/**
	 * DB to linear scale conversion.
	 */
	static float dBToLinear(float dB) {

	    float linear = (float) Math.pow(10.0, dB/20.0);
		return linear;
	}
}
