/*
 * @(#)ConstructorDocImpl.java	1.7 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.tools.javadoc;

import com.sun.javadoc.*;

import sun.tools.java.MemberDefinition;

import java.util.Map;
import java.util.HashMap;

/**
 * Represents a constructor of a java class.
 *
 * @since JDK1.2
 * @author Robert Field
 */
class ConstructorDocImpl extends ExecutableMemberDocImpl
                                implements ConstructorDoc {

    /**
     * map MemberDefinitions to ConstructorDocImpl, for uniqueness.
     */
    private static Map map = new HashMap();

    /**
     * constructor.
     */
    private ConstructorDocImpl(Env env, MemberDefinition f, String lookupKey) {
        super(env, f);
        map.put(lookupKey, this);
    }

    static ConstructorDocImpl getConstructorDocImpl(Env env, MemberDefinition f) {
        String lookupKey = lookupKey(f);
        ConstructorDocImpl m = (ConstructorDocImpl)map.get(lookupKey);
        if (m == null) {
            m = new ConstructorDocImpl(env, f, lookupKey);
        }
        return m;
    }

    /**
     * Get the name.
     *
     * @return the qualified name of the member.
     */
    public String qualifiedName() {
	return containingClass.qualifiedName();
    }

    /**
     * Get the name.
     *
     * @return the unqualified name of the member.
     */
    public String name() {
	return containingClass.name;
    }

    /**
     * Return true if it is a constructor, which it is.
     *
     * @return true
     */
    public boolean isConstructor() {
        return true;
    }
}
