/*
 * @(#)DocErrorReporterImpl.java	1.4 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.tools.javadoc;

import com.sun.javadoc.*;

/**
 * This class implements error, warning and notice printing.
 *
 * @since JDK1.2
 * @author Robert Field
 */
class DocErrorReporterImpl implements DocErrorReporter {

    /**
     * Print error message, increment error count.
     *
     * @param msg message to print
     */
    public void printError(String msg) {
        Res.printError(msg);
    }

    /**
     * Print warning message, increment warning count.
     *
     * @param msg message to print
     */
    public void printWarning(String msg) {
        Res.printWarning(msg);
    }

    /**
     * Print a message.
     *
     * @param msg message to print
     */
    public void printNotice(String msg) {
        Res.printNotice(msg);
    }
}
