/*
 * @(#)ParameterImpl.java	1.12 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package com.sun.tools.javadoc;

import com.sun.javadoc.*;

/**
 * ParameterImpl information.
 * This includes a parameter type and parameter name.
 *
 * @author Kaiyang Liu (original)
 * @author Robert Field (rewrite)
 */
public class ParameterImpl implements Parameter {

    /**
     * parameter type information.
     */
    Type type;

    /**
     * paramter local name.
     */
    String name;

    /**
     * constructor of paramter info class.
     */
    ParameterImpl(Type type, String name) {
        this.type = type;
        this.name = name;
    }

    /**
     * Get the type of this parameter.
     */
    public Type type() {
        return type;
    }

    /**
     * Get local name of this parameter.
     * For example if parameter is the short 'index', returns "index".
     */
    public String name() {
	return name;
    }

    /**
     * Get type name of this parameter.
     * For example if parameter is the short 'index', returns "short".
     */
    public String typeName() {
	return type.toString();
    }

    /**
     * Returns a string representation of the class.
     * <p>
     * For example if parameter is the short 'index', returns "short index".
     *
     * @return type name and parameter name of this parameter.
     */
    public String toString() {
	return type.toString() + " " + name;
    }
}


