/*
 * @(#)GetORBPropertiesFileAction.java	1.5 00/01/28
 *
 * Copyright 1993-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 * (C) Copyright IBM Corp. 1993 - 1997 - All Rights Reserved
 *
 * The original version of this source code and documentation is
 * copyrighted and owned by IBM, Inc. These materials are provided under
 * terms of a License Agreement between IBM and Sun. This technology is
 * protected by multiple US and International patents. This notice and
 * attribution to IBM may not be removed.
 *
 */


package javax.rmi.CORBA;

import java.io.IOException;
import java.io.File;
import java.io.FileInputStream;

import java.security.AccessController;
import java.security.PrivilegedAction;
import sun.security.action.GetPropertyAction;
import java.util.Properties;

      
class GetORBPropertiesFileAction implements PrivilegedAction {
    public GetORBPropertiesFileAction () {
    }
    public Object run() {
        Properties props = new Properties();
        try {
            // Check if orb.properties exists
            String javaHome = System.getProperty("java.home");
            File propFile = new File(javaHome + File.separator
                                     + "lib" + File.separator
                                     + "orb.properties");
            if ( !propFile.exists() )
                return null;

            // Load properties from orb.properties
            FileInputStream fis = new FileInputStream(propFile);
            props.load(fis);
            fis.close();
        } catch ( Exception ex ) {
            return null;
        }

        return props;
    }
}
