/*
 * @(#)MetaEventListener.java	1.12 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package javax.sound.midi;		  	 

import java.util.EventListener;


/**
 * The <code>MetaEventListener</code> interface should be implemented
 * by classes whose instances need to be notified when a <code>{@link Sequencer}</code> 
 * has processed a <code>{@link MetaMessage}</code>.  
 * To register a <code>MetaEventListener</code> object to receive such 
 * notifications, pass it as the argument to the 
 * <code>{@link Sequencer#addMetaEventListener(MetaEventListener) addMetaEventListener}</code>
 * method of <code>Sequencer</code>.
 *
 * @version 1.12, 00/02/02
 * @author Kara Kytle
 */
public interface MetaEventListener extends EventListener {

	/**
	 * Invoked when a <code>{@link Sequencer}</code> has encountered and processed 
	 * a <code>MetaMessage</code> in the <code>{@link Sequence}</code> it is processing.
	 * @param meta the meta-message that the sequencer encountered 
	 */
	public void meta(MetaMessage meta);
}
