/*
 * @(#)FontDescriptor.java	1.12 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.awt;

import sun.io.CharToByteConverter;

public class FontDescriptor implements Cloneable {

    static {
        NativeLibLoader.loadLibraries();
        initIDs();
    }

    String nativeName;
    public CharToByteConverter fontCharset;
    int[] exclusionRanges;

    public FontDescriptor(String nativeName, CharToByteConverter fontCharset,
			  int[] exclusionRanges){

	this.nativeName = nativeName;
	this.fontCharset = fontCharset;
	this.exclusionRanges = exclusionRanges;
    }

    /**
     * Return true if the character is exclusion character.
     */
    public boolean isExcluded(char ch){
	for (int i = 0; i < exclusionRanges.length; i++){

	    int lo = (exclusionRanges[i] >> 16) & 0xffff;
	    int up = (exclusionRanges[i]) & 0xffff ;

	    if (ch >= lo && ch <= up){
		return true;
	    }
	}
	return false;
    }

    public String toString() {
	return super.toString() + " [" + nativeName + "|" + fontCharset + "]";
    }

    /**
     * Initialize JNI field and method IDs
     */
    private static native void initIDs();
}
