/*
 * @(#)Mutex.java	1.3 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.awt;

public class Mutex {
    private boolean locked;
    private Thread owner;

    public synchronized void lock() {
        if (locked && Thread.currentThread() == owner) {
	    throw new IllegalMonitorStateException();
	}
	do {
	    if (!locked) {
	        locked = true;
		owner = Thread.currentThread();
	    } else {
	        try {
		    wait();
		} catch (InterruptedException e) {
		    // try again
		}
	    }
	} while (owner != Thread.currentThread()); 
    }

    public synchronized void unlock() {
        if (Thread.currentThread() != owner) {
	    throw new IllegalMonitorStateException();
	}
	owner = null;
	locked = false;
	notify(); 
    }
}
