/*
 * @(#)PhysicalDrawingSurface.java	1.6 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.awt;

/**
 * The PhysicalDrawingSurface interface provides a common interface
 * which can be implemented by all of the objects which provide
 * implementation-specific information about the physical surface
 * upon which a DrawingSurface resides.  There are no common methods
 * for all of these objects to implement, thus this interface is
 * empty.  This interface merely exists to provide a common root type
 * for all of the possible objects that can be returned from the
 * DrawingSurfaceInfo.getSurface() method under different implementations.
 * The caller must be able to recognize the specific type of the
 * PhysicalDrawingSurface object in order to render directly to
 * that surface.  Many of the physical handles will be usable only
 * by native code which accesses platform-specific drawing interfaces.
 *
 * @version 	1.6, 02/02/00
 * @author 	Jim Graham
 */
public interface PhysicalDrawingSurface {
}
