/*
 * @(#)SunClipboard.java	1.4 01/02/09
 *
 * Copyright 1999-2001 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.awt;

import java.awt.datatransfer.*;

public class SunClipboard extends Clipboard {

    protected AppContext contentsContext = null;

    public SunClipboard(String name) {
        super(name);
    }
    protected void initContext(Transferable contents) {
	// 4378007 : Toolkit.getSystemClipboard().setContents(null, null)
	// should throw NPE
	if (contents == null) {
	    throw new NullPointerException("contents");
	}
        contentsContext = AppContext.getAppContext();
    }
    protected synchronized void lostOwnership() {
    }
    protected void lostOwnershipImpl() {
        if ( contentsContext != null) {
            AppContext context = contentsContext;           
            contentsContext = null;             
            SunToolkit.postEvent(context, new PeerEvent(this, new Runnable() {
                public void run() {
                    lostOwnership();
                }
            }, PeerEvent.PRIORITY_EVENT));
        }
    }   
    void clearAppContext() {
        contentsContext = null;
    }
};
