/*
 * @(#)RobotPeer.java	1.3 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.awt.robot;

import java.awt.*;

/**
 * An internal interface optionally implemented by Toolkit implementations.
 *
 * RobotPeer defines an interface whereby toolkits support automated testing
 * by allowing native input events to be generated from Java code.
 *
 * @version 	@(#)RobotPeer.java	1.3 00/02/02
 * @author 	Robi Khan
 */
public interface RobotPeer
{
    public void mouseMove(int x, int y);
    public void mousePress( long buttons );
    public void mouseRelease( long buttons );

    public void keyPress( int keycode );
    public void keyRelease( int keycode );

    public int getRGBPixel(int x, int y);
    public int [] getRGBPixels(Rectangle bounds);
}
