/*
 * @(#)ProbeInputMethodEvent.java	1.5 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.awt.robot.probe;

import java.awt.AWTEvent;
import java.awt.event.InputMethodEvent;

/**
 * ProbeObject that encapsulates InputMethodEvent structures.
 *
 * @see ProbeMonitor
 * @see ProbeObject
 *
 * @author David Herron <tt>&lt;David.Herron@eng.sun.com&gt;</tt>
 */
public class ProbeInputMethodEvent extends ProbeAWTEvent {

  /**
   * Initialize the object.
   *
   * @param evt The Event being encapsulated.
   * @param otherInfo Other information to be included.
   */
  public ProbeInputMethodEvent(InputMethodEvent evt, String otherInfo, String method) {
    super(evt, otherInfo, method);
  } 

  /**
   * Initialize the object.
   *
   * @param evt The Event being encapsulated.
   */
  public ProbeInputMethodEvent(InputMethodEvent evt) {
    this(evt, "", null);
  }
}
