/*
 * @(#)ProbeStatusBuffer.java	1.4 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.awt.robot.probe;

/**
 * Probe listener that specifically only records ProbeStatus messages.
 */
public class ProbeStatusBuffer extends ProbeBuffer {

  /**
   * Initialize the ProbeStatusBuffer.
   */
  public ProbeStatusBuffer(ProbeMonitor monitor) {
    super(monitor);
  }

  /**
   * Method to receive the ProbeStatus's via the probe monitor Listener
   * interface.  Ignore the event (do not record) if
   * <ul>
   * <li> we are not recording (<tt>bRecording</tt>), or
   * <li> it is not a ProbeStatus
   * </ul>
   */
  public void probeTriggered(ProbeObject evt) {
    if (!bRecording) { return; }
    if (!(evt instanceof sun.awt.robot.probe.ProbeStatus)) { return; }
    events.add(evt);
  }

}
