/*
 * @(#)ProbeTextEvent.java	1.5 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.awt.robot.probe;

import java.awt.AWTEvent;
import java.awt.event.TextEvent;

/**
 * ProbeObject that encapsulates TextEvent structures.
 *
 * @see ProbeMonitor
 * @see ProbeObject
 *
 * @author David Herron <tt>&lt;David.Herron@eng.sun.com&gt;</tt>
 */
public class ProbeTextEvent extends ProbeAWTEvent {

  /**
   * Initialize the object.
   *
   * @param evt The Event being encapsulated.
   * @param otherInfo Other information to be included.
   */
  public ProbeTextEvent(TextEvent evt, String otherInfo, String method) {
    super(evt, otherInfo, method);
  }

  /**
   * Initialize the object.
   *
   * @param evt The Event being encapsulated.
   */
  public ProbeTextEvent(TextEvent evt) {
    this(evt, "", null);
  }
}

