/*
 * @(#)ColorPaint.java	1.10 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 * @author Charlton Innovations, Inc.
 */

package sun.java2d.loops;

import sun.java2d.loops.GraphicsPrimitive;
import java.awt.Color;

/**
*   ColorPaint
*   1) blend filled solid color onto destination surface
*   2) must accept [dx, dy]
*      from within the surface description data
*/

public abstract class ColorPaint extends GraphicsPrimitive
{
    private final static String methodSignature =
        "ColorPaint(Lsun/java2d/loops/ImageData;I[BIIFLjava/awt/Color;)V";
                
    public static String getMethodSignature() {
        return methodSignature;
    }

    private final static int lockFlags[] = {LOCK_FOR_READ | LOCK_FOR_WRITE};

    protected ColorPaint(int[] surfaceTypes) {
	super(surfaceTypes, lockFlags, methodSignature);
    }

    /**
    *   All ColorPaint implementors must have this invoker method
    */
    public abstract void ColorPaint(
        ImageData dstImage,

        int nRule,

        byte [] bAlphaArray, int nAlphaArrayOffset, int nAlphaArraySize,
        float fExtraAlpha,
        Color fgColor
    );
}
