/*
 * @(#)FillSpans.java	1.4 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

 /*
 * @author Jim Graham
 * @author Charlton Innovations, Inc.
 */

package sun.java2d.loops;

import sun.java2d.loops.GraphicsPrimitive;
import sun.java2d.pipe.SpanIterator;
import java.awt.Color;
import java.awt.image.ColorModel;
import java.awt.image.Raster;

/**
 * FillSpans
 * 1) draw solid color onto destination surface
 * 2) rectangular areas to fill come from SpanIterator
 */

public abstract class FillSpans extends GraphicsPrimitive
{
    private final static String methodSignature =
        "FillSpans(Lsun/java2d/loops/ImageData;"+
		 "Ljava/awt/Color;"+
		 "Lsun/java2d/pipe/SpanIterator;)V";

    public static String getMethodSignature() {
        return methodSignature;
    }

    private final static int lockFlags[] = {LOCK_FOR_WRITE};

    protected FillSpans(int[] surfaceTypes) {
	super(surfaceTypes, lockFlags, methodSignature);
    }


    /**
     * All FillSpan implementors must have this invoker method
     */
    public abstract void FillSpans(
        ImageData dstImage,
        Color color,
	SpanIterator sr
    );

    /*
     * create cached context for raster drawing
     */
     /*
    public FillSpanRasterContext createCachedContext(
            Raster raster, ColorModel cm, Color color,
            int clipX, int clipY, int clipW, int clipH) {
        return null;
    }
    */
}
