/*
 * @(#)OpaqueBlit.java	1.9 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 * @author Charlton Innovations, Inc.
 */

package sun.java2d.loops;

import sun.java2d.loops.GraphicsPrimitive;

/**
*   OpaqueBlit
*   1) copies rectangle of pixels from one surface to another
*   2) does not perform dithering
*   3) must accept [sx, sy, dx, dy]
*      from within the surface description data
*
*   precise behavior is undefined if the source surface
*   and the destination surface are the same surface
*   with overlapping regions of pixels
*/

public abstract class OpaqueBlit extends GraphicsPrimitive
{
    private static String methodSignature =
        "OpaqueBlit(Lsun/java2d/loops/ImageData;Lsun/java2d/loops/ImageData;II)V";

    public static String getMethodSignature() {
        return methodSignature;
    }

    private final static int lockFlags[] = {LOCK_FOR_READ, LOCK_FOR_WRITE};

    protected OpaqueBlit(int[] surfaceTypes) {
	super(surfaceTypes, lockFlags, methodSignature);
    }

    protected OpaqueBlit(String subMethodSignature, int[] surfaceTypes) {
	super(surfaceTypes, lockFlags, subMethodSignature);
    }

    /**
    *   All OpaqueBlit implementors must have this invoker method
    */
    public abstract void OpaqueBlit(
        ImageData src, ImageData dst,
        int width, int height);
}
