/*
 * @(#)OpaqueDitheredBlit.java	1.9 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 * @author Charlton Innovations, Inc.
 */

package sun.java2d.loops;

import sun.java2d.loops.GraphicsPrimitive;

/**
*   OpaqueDitheredBlit
*   1) copies rectangle of pixels from one surface to another
*   2) performs dithering
*   3) must accept [sx, sy, dx, dy]
*      from within the surface description data
*
*   precise behavior is undefined if the source surface
*   and the destination surface are the same surface
*   with overlapping regions of pixels
*/

public abstract class OpaqueDitheredBlit extends OpaqueBlit
{
    private final static String methodSignature =
        "OpaqueDitheredBlit(Lsun/java2d/loops/ImageData;Lsun/java2d/loops/ImageData;II)V";

    public static String getMethodSignature() {
        return methodSignature;
    }

    protected OpaqueDitheredBlit(int[] surfaceTypes) {
	super(methodSignature, surfaceTypes);
    }

    /**
    *   All OpaqueBlit implementors must have this invoker method
    */
    public void OpaqueBlit(ImageData src, ImageData dst,
                            int width, int height) {
        OpaqueDitheredBlit(src, dst, width, height);
    }

    /**
    *   All OpaqueDitheredBlit implementors must have this invoker method
    */
    public abstract void OpaqueDitheredBlit(
        ImageData src, ImageData dst,
        int width, int height);
}
