/*
 * @(#)TransparentDitheredBlit.java	1.9 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 * @author Charlton Innovations, Inc.
 */

package sun.java2d.loops;

import sun.java2d.loops.GraphicsPrimitive;

/**
*   TransparentDitheredBlit
*   1) copies rectangle of pixels from one surface to another
*   2) must accept [sx, sy, dx, dy]
*      from within the surface description data
*   3) uses bitmask to determine transparent pixels
*
*   precise behavior is undefined if the source surface
*   and the destination surface are the same surface
*   with overlapping regions of pixels
*/

public abstract class TransparentDitheredBlit extends GraphicsPrimitive
{
    private final static String methodSignature =
        "TransparentDitheredBlit(Lsun/java2d/loops/ImageData;Lsun/java2d/loops/ImageData;II)V";

    public static String getMethodSignature() {
        return methodSignature;
    }

    private final static int lockFlags[] = {
        LOCK_FOR_READ,
        LOCK_FOR_READ | LOCK_FOR_WRITE};

    protected TransparentDitheredBlit(int[] surfaceTypes) {
	super(surfaceTypes, lockFlags, methodSignature);
    }


    /**
    *   All TransparentDitheredBlit implementors must have this invoker method
    */
    public abstract void TransparentDitheredBlit(
        ImageData src, ImageData dst,
        int width, int height);
}
