/*
 * @(#)NullPixelPipe.java	1.5 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.java2d.pipe;

import sun.java2d.SunGraphics2D;

/**
 * This is a class that implements all of the basic pixel rendering
 * methods as NOPs.
 * This class is useful for installing as the pipeline when the
 * clip is determined to be empty or when the composite operation is
 * determined to have no effect (i.e. rule == SRC_OVER, extraAlpha == 0.0).
 */
public class NullPixelPipe implements PixelDrawPipe {
    public void drawLine(SunGraphics2D sg,
			 int x1, int y1, int x2, int y2) {
    }

    public void drawRect(SunGraphics2D sg,
			 int x, int y, int width, int height) {
    }

    public void fillRect(SunGraphics2D sg,
			 int x, int y, int width, int height) {
    }

    public void drawRoundRect(SunGraphics2D sg,
			      int x, int y, int width, int height,
			      int arcWidth, int arcHeight) {
    }

    public void fillRoundRect(SunGraphics2D sg,
			      int x, int y, int width, int height,
			      int arcWidth, int arcHeight) {
    }

    public void drawOval(SunGraphics2D sg,
			 int x, int y, int width, int height) {
    }

    public void fillOval(SunGraphics2D sg,
			 int x, int y, int width, int height) {
    }

    public void drawArc(SunGraphics2D sg,
			int x, int y, int width, int height,
			int startAngle, int arcAngle) {
    }

    public void fillArc(SunGraphics2D sg,
			int x, int y, int width, int height,
			int startAngle, int arcAngle) {
    }

    public void drawPolyline(SunGraphics2D sg,
			     int xPoints[], int yPoints[],
			     int nPoints) {
    }

    public void drawPolygon(SunGraphics2D sg,
			    int xPoints[], int yPoints[],
			    int nPoints) {
    }

    public void fillPolygon(SunGraphics2D sg,
			    int xPoints[], int yPoints[],
			    int nPoints) {
    }
}
