/*
 * @(#)TextPipe.java	1.7 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 * @author Charlton Innovations, Inc.
 */

package sun.java2d.pipe;

import sun.java2d.SunGraphics2D;
import java.awt.font.GlyphVector;
import java.awt.font.TextLayout;

/**
 * This interface defines the set of calls that pipeline objects
 * can use to pass on responsibility for drawing various text
 * representations.
 */
public interface TextPipe {
    public Object drawString(SunGraphics2D g2d, String s,
                                float x, float y, Object cachedState);
    public Object drawGlyphVector(SunGraphics2D g2d, GlyphVector g,
                                float x, float y, Object cachedState);
    public Object drawChars(SunGraphics2D g2d,
                                char data[], int offset, int length,
                                int x, int y, Object cachedState);
    public Object drawBytes(SunGraphics2D g2d,
                                byte data[], int offset, int length,
                                int x, int y, Object cachedState);
};
