/*
 * @(#)CompoundEnumeration.java	1.4 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.misc;

import java.util.Enumeration;
import java.util.NoSuchElementException;

/*
 * A useful utility class that will enumerate over an array of
 * enumerations.
 */
public class CompoundEnumeration implements Enumeration {
    private Enumeration[] enums;
    private int index = 0;

    public CompoundEnumeration(Enumeration[] enums) {
	this.enums = enums;
    }

    private boolean next() {
	while (index < enums.length) {
	    if (enums[index] != null && enums[index].hasMoreElements()) {
		return true;
	    }
	    index++;
	}
	return false;
    }

    public boolean hasMoreElements() {
	return next();
    }

    public Object nextElement() {
	if (!next()) {
	    throw new NoSuchElementException();
	}
	return enums[index].nextElement();
    }
}
