/*
 * @(#)NewsgroupInfo.java	1.18 00/02/02
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.net.nntp;

import java.io.*;
import java.util.*;

/**
 * This class manages information related to the current status of 
 * newsgroups. 
 * 
 * @version 	1.5, 12 Dec 1994
 * @author	Jonathan Payne, James Gosling
 * @see		NntpClient
 */
public class NewsgroupInfo {
    /** This newsgroup's name in network form (eg rec.pets) */
    public String   name;

    /** Number of the first and last articles in the group */
    public int	    firstArticle;
    public int	    lastArticle;

    public NewsgroupInfo(String name, int start, int end) {
	this.name = name;
	firstArticle = start;
	lastArticle = end;
    }

    /** convert the information to a printable string of the form:
     *  <p>
     *  NewsgroupInfo[name=<i>name</i>[<i>firstArticle</i>,<i>lastArticle</i>]
     */
    public String toString() {
	return "NewsgroupInfo[name=" + name + "[" + firstArticle + ", "
	    + lastArticle + "]";
    }

    /** Reload news in the group using nntp.getGroup(this.name) */
    public void reload(NntpClient nntp) throws IOException {
	NewsgroupInfo newinfo = nntp.getGroup(name);
	this.firstArticle = newinfo.firstArticle;
	this.lastArticle = newinfo.lastArticle;
    }
}
