/*
 * @(#)CachedFile.java	1.8 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.net.www.httpd;
import java.io.*;
import sun.net.www.MessageHeader;

/**
 * A class to represent a file in the RAM cache.
 * @author  James Gosling
 */

class CachedFile {
    private byte body[];
    public MessageHeader mh;
    CachedFile(InputStream src, int size, MessageHeader fmh) {
	body = new byte[size];
	int pos = 0;
	int pending = size;
	while (pending > 0) {
	    int nr = src.read(body, pos, size);
	    if (nr < 0)
		break;
	    pending -= nr;
	    pos += nr;
	}
	if (pending != 0) {
System.out.print("Expected "+size+", missed by "+pending+"\n");
	    throw new IOException();
	}
	mh = fmh;
    }
    void sendto(OutputStream os) {
	os.write(body, 0, body.length);
    }
    void headerto(PrintStream ps) {
	if (mh != null)
	    mh.print(ps);
    }
    int length() {
	return body.length;
    }
}

