/*
 * @(#)Channel.java	1.8 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.rmi.transport;

import java.rmi.RemoteException;


public interface Channel extends Notifier {

    /**
     * Generates a new connection to the endpoint of the address space
     * for which this is a channel.
     */
    public Connection newConnection()
	throws RemoteException;

    /**
     * Returns the endpoint of the address space for which this is a
     * channel.
     */
    public Endpoint getEndpoint();

    /**
     * Free the connection generated by this channel.
     * @param c The connection
     * @param reuse If true, the connection is in a state in which it
     *        can be reused for another method call.
     */
    public void free(Connection conn, boolean reuse)
	throws RemoteException;
}
