/*
 * @(#)LocateDGC.java	1.11 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.rmi.transport;

import java.rmi.RemoteException;
import java.rmi.dgc.DGC;
import sun.rmi.server.RemoteProxy;
import sun.rmi.server.UnicastRef;

/**
 * This class is used to obtain the remote object collector on a particular
 * host.
 */
final class LocateDGC {
    /**
     * Returns the remote object garbage collector at the specified
     * endpoint.
     */
    static DGC getDGC(Endpoint ep)
	throws RemoteException
    {
	String classname = "sun.rmi.transport.DGCImpl";

	// Create the needed remote reference
	// Then find and initialize the stub
	LiveRef ref = new LiveRef(DGCImpl.getID(), ep, false);
	return (DGC)RemoteProxy.getStub(classname, new UnicastRef(ref));
    }

}
