/*
 * @(#)Notifiable.java	1.7 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.rmi.transport;

/**
 * Objects supporting the Notifiable interface are capable of being
 * called back when an address space (associated with a specific
 * endpoint) becomes inaccessible.  An object registers interest in
 * receiving such a callback via the Notifier.add method.
 */
public interface Notifiable {
    
    /**
     * Informs that the endpoint (ep) has become inaccessible.  The
     * parameter "state" indicates whether the address space is
     * permanently inaccessible (Notifier.Dead) or a transient failure
     * has been detected (Notifier.Failed)
     */
    void notify(Endpoint ep, int state);
}
