/*
 * @(#)Notifier.java	1.7 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.rmi.transport;

interface Notifier {
    
    /** VM is alive */
    final static int Alive = 0;
    /** VM is permanently inaccessible */
    final static int Dead = 1;
    /** indicates Transient  failure */
    final static int Failed = 2;
    
    /**
     * Register interest in receiving a callback when the address
     * space indicated by the endpoint ep goes away.
     */
    public void addNotifiable(Endpoint ep, Notifiable obj);
    
    /**
     * Remove notification request.
     */
    public void removeNotifiable(Endpoint ep, Notifiable obj);
    
}
