/*
 * @(#)Utils.java	1.6 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.rmi.transport;

public abstract class Utils {
    /**
     * Gets the System property indicated by the specified name.
     * If obtaining the property throws an exception (such as
     * a SecurityException), then simply return the value.
     * @param name the name of the system property
     * @param value the default value to use if this property is not set
     */
    public static Long getLong(String name, long value) {
	try {
	    return Long.getLong(name, value);
	} catch (Exception e) {
	    return new Long(value);
	}
    }
    
    /**
     * Gets the System property indicated by the specified key.
     * @param key the name of the system property
     */
    public static String getProperty(String key) {
	try {
	    return System.getProperty(key);
	} catch (Exception e) {
	    return null;
	}
    }
    
    /**
     * Gets a Boolean from the properties.
     * @param name the property name.
     */
    public static boolean getBoolean(String name) {
	try {
	    return Boolean.getBoolean(name);
	} catch (Exception e) {
	    return false;
	}
    }
}

