/*
 * @(#)AgentOutputStream.java	1.15 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.tools.agent;

import java.io.*;

class AgentOutputStream extends FilterOutputStream implements AgentConstants {

    private DataOutputStream outAsDataStream;  /* cache to avoid casting */

    AgentOutputStream(DataOutputStream out) {
	super(out);
	outAsDataStream = out;
    }

    public void write(int b) throws IOException {
        synchronized (out) {
            out.write(CMD_WRITE_BYTES);
            outAsDataStream.writeInt(1);
            out.write(b);
        }
    }

    public void write(byte b[]) throws IOException {
	write(b, 0, b.length);
    }

    public void write(byte b[], int off, int len) throws IOException {
        synchronized (out) {
            out.write(CMD_WRITE_BYTES);
            outAsDataStream.writeInt(len);
            out.write(b, off, len);
        }
    }

    public void flush() throws IOException {
        synchronized (out) {
        	out.flush();
        }
    }
}
