/*
 * @(#)CachedLocalVariable.java	1.5 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.tools.agent;

/**
 *   The Cached* classes cache data retrieved from JVMDI.  
 *   This class provides access to field information.
 *   @author Gordon Hirsch
 */
class CachedLocalVariable {
    final CachedMethod method;
    final String name;
    final String signature;
    final int startBCI;
    final int scopeLength;
    final int slot;

    CachedLocalVariable(CachedMethod method, String name, String signature,
                        int startBCI, int scopeLength, int slot) {
        this.method = method;
        this.name = name;
        this.signature = signature;
        this.startBCI = startBCI;
        this.scopeLength = scopeLength;
        this.slot = slot;
    }

    boolean isVisible(int bci) {
        return ((startBCI <= bci) && (bci < startBCI + scopeLength));
    }

    boolean isArgument() {
         try {
             return method.isArgument(this);
         } catch (AbsentInformationException exc) {
             throw new InternalError("Local variable missing from its method's table");
         }
    }
}

    

