/*
 * @(#)Location.java	1.4 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.tools.agent;

/**
 *   Chunk of program location information.
 *   @author Robert Field
 */
public class Location {
    public final CachedMethod method;
    public final int line;
    public final int startBCI;
    public final int endBCI;

    /**
     * Constructor.
     */
    public Location(CachedMethod method, int line, int startBCI, int endBCI) {
	this.method = method;
        this.line = line;
        this.startBCI = startBCI;
        this.endBCI = endBCI;
    }

    public String toString() {
        return method.toString() + ":" + line + "(" + startBCI + "-" + endBCI + ")";
    }

}
