/*
 * @(#)RemoteBoolean.java	1.11 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.tools.debug;

/**
 * The RemoteBoolean class extends RemoteValue for booleans.
 *
 * @see RemoteValue
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteBoolean extends RemoteValue {
    private boolean value;

    RemoteBoolean(boolean b) {
	super(TC_BOOLEAN);
	value = b;
    }

    /** Return the boolean's value. */
    public boolean get() {
	return value;
    }

    /** Print this RemoteValue's type ("boolean"). */
    public String typeName() {
	return new String("boolean");
    }

    /** Return the boolean's value as a string. */
    public String toString() {
	return (new Boolean(value).toString());
    }
}
