/*
 * @(#)RemoteByte.java	1.10 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.tools.debug;

/**
 * The RemoteByte class extends RemoteValue for bytes.
 *
 * @see RemoteValue
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteByte extends RemoteValue {
    private byte value;

    RemoteByte(byte b) {
	super(TC_BYTE);
	value = b;
    }
    
    /** Return the byte's value. */
    public byte get() {
	return value;
    }

    /** Print this RemoteValue's type ("byte"). */
    public String typeName() {
	return new String("byte");
    }
    
    /** Return the byte's value as a string. */
    public String toString() {
	return toHex(value);
    }
}
