/*
 * @(#)RemoteChar.java	1.10 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.tools.debug;

/**
 * The RemoteChar class extends RemoteValue for chars.
 *
 * @see RemoteValue
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteChar extends RemoteValue {
    private char value;

    RemoteChar(char c) {
	super(TC_CHAR);
	value = c;
    }
    
    /** Return the char's value. */
    public char get() {
	return value;
    }

    /** Print this RemoteValue's type ("char"). */
    public String typeName() {
	return new String("char");
    }
    
    /** Return the char's value as a string. */
    public String toString() {
	return (new Character(value).toString());
    }
}
