/*
 * @(#)RemoteDouble.java	1.10 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.tools.debug;

/**
 * The RemoteDouble class extends RemoteValue for doubles.
 *
 * @see RemoteValue
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteDouble extends RemoteValue {
    private double value;

    RemoteDouble(double d) {
	super(TC_DOUBLE);
	value = d;
    }
    
    /** Return the double's value. */
    public double get() {
	return value;
    }

    /** Print this RemoteValue's type ("double"). */
    public String typeName() {
	return new String("double");
    }
    
    /** Return the double's value as a string. */
    public String toString() {
	return (new Double(value).toString());
    }
}
