/*
 * @(#)RemoteFloat.java	1.10 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.tools.debug;

/**
 * The RemoteFloat class extends RemoteValue for floats.
 *
 * @see RemoteValue
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteFloat extends RemoteValue {
    private float value;

    RemoteFloat(float f) {
	super(TC_FLOAT);
	value = f;
    }
    
    /** Return the float's value. */
    public float get() {
	return value;
    }

    /** Print this RemoteValue's type ("float"). */
    public String typeName() {
	return new String("float");
    }
    
    /** Return the float's value as a string. */
    public String toString() {
	return (new Float(value).toString());
    }
}
