/*
 * @(#)RemoteInt.java	1.11 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.tools.debug;

/**
 * The RemoteInt class extends RemoteValue for ints.
 *
 * @see RemoteValue
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteInt extends RemoteValue {
    private int value;

    public RemoteInt(int i) {
	super(TC_INT);
	value = i;
    }
    
    /** Return the int's value. */
    public int get() {
	return value;
    }

    /** Print this RemoteValue's type ("int"). */
    public String typeName() {
	return new String("int");
    }
    
    /** Return the int's value as a string. */
    public String toString() {
	return new Integer(value).toString();
    }
}
