/*
 * @(#)RemoteLong.java	1.10 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.tools.debug;

/**
 * The RemoteLong class extends RemoteValue for longs.
 *
 * @see RemoteValue
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteLong extends RemoteValue {
    private long value;

    RemoteLong(long l) {
	super(TC_LONG);
	value = l;
    }
    
    /** Return the long's value. */
    public long get() {
	return value;
    }

    /** Print this RemoteValue's type ("long"). */
    public String typeName() {
	return new String("long");
    }
    
    /** Return the long's value as a string. */
    public String toString() {
	return (new Long(value).toString());
    }
}
