/*
 * @(#)RemoteShort.java	1.10 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.tools.debug;

/**
 * The RemoteShort class extends RemoteValue for shorts.
 *
 * @see RemoteValue
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteShort extends RemoteValue {
    private short value;

    RemoteShort(short s) {
	super(TC_SHORT);
	value = s;
    }
    
    /** Return the short's value. */
    public short get() {
	return value;
    }

    /** Print this RemoteValue's type ("short"). */
    public String typeName() {
	return new String("short");
    }

    /** Return the short's value as a string. */
    public String toString() {
	return toHex(value);
    }
}
