/*
 * @(#)RemoteString.java	1.11 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.tools.debug;

/**
 * The RemoteString class allows access to a string in a remote Java
 * interpreter.  
 *
 * @see RemoteDebugger
 * @author Thomas Ball
 */
public class RemoteString extends RemoteObject {

    RemoteString(RemoteAgent agent, int id) {
	super(agent, TP_STRING, id, agent.classString);
    }

    /** Print this RemoteValue's type ("String"). */
    public String typeName() {
	return new String("String");
    }
    
    /** Return the string value, or "null" */
    public String description() {
	return toString();
    }

    /** Return the string value, or "null" */
    public String toString() {
	String retStr = agent.objectToString(id);
	return (retStr.length() == 0) ? new String("null") : retStr;
    }
}
