/*
 * @(#)ShiftLeftExpression.java	1.17 00/02/02
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.tools.tree;
import sun.tools.java.*;
import sun.tools.asm.Assembler;

public
class ShiftLeftExpression extends BinaryShiftExpression {
    /**
     * constructor
     */
    public ShiftLeftExpression(long where, Expression left, Expression right) {
	super(LSHIFT, where, left, right);
    }

    /**
     * Evaluate
     */
    Expression eval(int a, int b) {
	return new IntExpression(where, a << b);
    }
    Expression eval(long a, long b) {
	return new LongExpression(where, a << b);
    }

    /**
     * Simplify
     */
    Expression simplify() {
	if (right.equals(0)) {
	    return left;
	}
	if (left.equals(0)) {
	    return new CommaExpression(where, right, left).simplify();
	}
	return this;
    }

    /**
     * Code
     */
    void codeOperation(Environment env, Context ctx, Assembler asm) {
	asm.add(where, opc_ishl + type.getTypeCodeOffset());
    }
}
