/*
 * @(#)TypeExpression.java	1.22 00/02/02
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.tools.tree;

import sun.tools.java.*;
import java.io.PrintStream;
import java.util.Hashtable;

public
class TypeExpression extends Expression {
    /**
     * Constructor
     */
    public TypeExpression(long where, Type type) {
	super(TYPE, where, type);
    }

    /**
     * Convert to a type
     */
    Type toType(Environment env, Context ctx) {
	return type;
    }

    /**
     * Check an expression
     */
    public Vset checkValue(Environment env, Context ctx, Vset vset, Hashtable exp) {
	env.error(where, "invalid.term");
	type = Type.tError;
	return vset;
    }

    public Vset checkAmbigName(Environment env, Context ctx, Vset vset, Hashtable exp,
			       UnaryExpression loc) {
	return vset;
    }

    public Expression inline(Environment env, Context ctx) {
	return null;
    }

    /**
     * Print
     */
    public void print(PrintStream out) {
	out.print(type.toString());
    }
}
