package com.sun.tools.javac.v8.util;

/**
 * An interface containing layout character constants used in Java
 *  programs.
 */
public interface LayoutCharacters {

    /**
     * Tabulator column increment.
     */
    static final int TabInc = 8;

    /**
     * Tabulator character.
     */
    static final byte TAB = 8;

    /**
     * Line feed character.
     */
    static final byte LF = 10;

    /**
     * Form feed character.
     */
    static final byte FF = 12;

    /**
     * Carriage return character.
     */
    static final byte CR = 13;

    /**
     * End of input character.
     */
    static final byte EOI = 26;

    /**
     * End-of-buffer character, used as a sentinel to denote the
     *  a character one beyond the last defined character in a
     *  source file.
     */
    static final byte EOB = 0;
}
