/*
 * @(#)globals.c	1.46 00/02/02
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 *      Some development environments don't support common storage
 *      (i.e. data in multiply included .h files not marked extern).
 *      Here is where we declare everything in .h files marked extern.
 */


#include "oobj.h"
#include "tree.h"
#include "interpreter.h"

ClassClass **binclasses;
int nbinclasses, sizebinclasses;
bool_t verbose = FALSE;
bool_t verbosegc = FALSE;
bool_t verboseclassdep = FALSE;
bool_t classgc = TRUE;
int verifyclasses = VERIFY_REMOTE;
bool_t debugging = FALSE;
bool_t instruction_tracing = FALSE; /* Flag indicating whether instruction-level
                                 * tracing is enabled. Setting this flag makes
                                 * JVM use C-version of the interpreter.
                                 */
char *init_sysclasspath = 0;
char *java_home_dir;
char *java_dll_dir;

bool_t (*pExecuteJava)(unsigned char  *, ExecEnv *ee);

typedef jint (JNICALL *vfprintf_hook_t)(FILE *fp, const char *format, 
					va_list args);
typedef void (JNICALL *exit_hook_t)(jint code);
typedef void (JNICALL *abort_hook_t)(void);

/* initialize all to zero, so that we can tell whether they've been 
   overwritten.
 */
vfprintf_hook_t vfprintf_hook = 0;
exit_hook_t exit_hook = 0;
abort_hook_t abort_hook = 0;

/* Win32 can't export variables to shared-libraries, just functions.
 * These access routines are therefore needed by the debugger.
 */
ClassClass** get_binclasses(void)  { return binclasses; }
int          get_nbinclasses(void) { return nbinclasses; }
