/*
 * @(#)MidiOutDevice.c	1.4 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */


// STANDARD includes


// JNI includes
#include <jni.h>

// Platform MIDI includes
#include "PlatformMidi.h"

// UTILITY includes
#include "Utilities.h"

// SimpleInputDeviceProvider includes
#include "com_sun_media_sound_MidiOutDevice.h"


// NATIVE METHODS


JNIEXPORT jint JNICALL
Java_com_sun_media_sound_MidiOutDevice_nOpen(JNIEnv* e, jobject thisObj, jint index)
{
	long deviceHandle = 0;
		
	TRACE1("Java_com_sun_media_sound_MidiOutDevice_nOpen: index: %d\n", index);

#if USE_PLATFORM_MIDI_OUT == TRUE

	deviceHandle = MIDI_OUT_OpenDevice((long)index, (long)thisObj);

#endif // USE_PLATFORM_MIDI_OUT 

	// if we didn't get a valid handle, throw a MidiUnavailableException
	// $$kk: 06.24.99: should be getting more information here!
	if ( !deviceHandle )
	{
		char *msg = "Failed to open the device.\0";
		ERROR0("Java_com_sun_media_sound_MidiOutDevice_nOpen: Failed to open the device\n");
		ThrowJavaMessageException(e, JAVA_MIDI_PACKAGE_NAME"/MidiUnavailableException", msg);
	}

	TRACE0("Java_com_sun_media_sound_MidiOutDevice_nOpen succeeded\n");
	return (jint)deviceHandle;
}


JNIEXPORT void JNICALL
Java_com_sun_media_sound_MidiOutDevice_nClose(JNIEnv* e, jobject thisObj, jint deviceHandle)
{
    TRACE0("Java_com_sun_media_sound_MidiOutDevice_nClose.\n");

#if USE_PLATFORM_MIDI_OUT == TRUE

	MIDI_OUT_CloseDevice((long)deviceHandle);

#endif // USE_PLATFORM_MIDI_OUT 

	TRACE0("Java_com_sun_media_sound_MidiOutDevice_nClose succeeded\n");
}


JNIEXPORT void JNICALL
Java_com_sun_media_sound_MidiOutDevice_nSendShortMessage(JNIEnv* e, jobject thisObj, jint deviceHandle, jint status, jint data1, jint data2, jlong timeStamp)
{
    TRACE0("Java_com_sun_media_sound_MidiOutDevice_nSendShortMessage.\n");

#if USE_PLATFORM_MIDI_OUT == TRUE

	MIDI_OUT_ProcessShortMessage((long)deviceHandle, (unsigned char)status, (unsigned char)data1, (unsigned char)data2, (unsigned long)timeStamp);

#endif // USE_PLATFORM_MIDI_OUT 

    TRACE0("Java_com_sun_media_sound_MidiOutDevice_nSendShortMessage succeeded\n");
}

