/*
 * @(#)Method.c	1.50 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#include "jni.h"
#include "jvm.h"
#include "java_lang_reflect_Method.h"
#include "java_lang_reflect_Constructor.h"

/*
 * Native code for java.lang.reflect.Method and
 * java.lang.reflect.Constructor.
 * 
 * TODO: Performance.
 */

/*
 * Invoke an instance or a static method
 */
JNIEXPORT jobject JNICALL
Java_java_lang_reflect_Method_invoke(JNIEnv *env, jobject method, jobject obj,
				     jobjectArray args)
{
    return JVM_InvokeMethod(env, method, obj, args);
}

/*
 * Use constructor to make a new instance of declaring class
 */
JNIEXPORT jobject JNICALL
Java_java_lang_reflect_Constructor_newInstance(JNIEnv *env, jobject c,
					       jobjectArray args)
{
    return JVM_NewInstanceFromConstructor(env, c, args);
}
