/*
 * @(#)TimeZone.c	1.3 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#include <stdlib.h>
#include <string.h>

#include "jni.h"
#include "jni_util.h"
#include "jvm.h"
#include "TimeZone_md.h"

#include "java_util_TimeZone.h"

/*
 * Gets the platform defined TimeZone ID
 */
JNIEXPORT jstring JNICALL
Java_java_util_TimeZone_getSystemTimeZoneID(JNIEnv *env, jclass ign, 
                                            jstring java_home, jstring region)
{
    const char *rname;
    const char *java_home_dir;
    char *javaTZ;

    java_home_dir = JNU_GetStringPlatformChars(env, java_home, 0);
    if (java_home_dir == NULL)
        return NULL;

    if (region != NULL) {
	rname = JNU_GetStringPlatformChars(env, region, 0);
	/* ignore error cases for rname */
    } else {
	rname = NULL;
    }

    /*
     * Invoke plaform dependent mapping function
     */
    javaTZ = findJavaTZ_md(java_home_dir, rname);

    free((void *)java_home_dir);
    if (rname != NULL) {
	free((void *)rname);
    }

    if (javaTZ != NULL) {
	jstring jstrJavaTZ = JNU_NewStringPlatform(env, javaTZ);
	free((void *)javaTZ);
        return jstrJavaTZ;
    }
    return NULL;
}
