/*
 * @(#)alphaCompst.c	1.14 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */


#include <alpha_uti.h>
#include <alphaCompst.h>
#include <alphaCompst_loop_uti.h>

unsigned char *
getAlphaInfo(JNIEnv *env, jbyteArray alpha)
{
    jbyte *base;
    if (alpha) {
	base = (*env)->GetPrimitiveArrayCritical(env, alpha, 0);
    } else {
	base = (jbyte *) 0;
    }
    return (unsigned char *) base;
}

void
dropBufs(JNIEnv *env,
	 jbyteArray pathAlpha, unsigned char *pathBase,
	 jarray src, void *srcBase)
{
    if (pathBase) {
	(*env)->ReleasePrimitiveArrayCritical(env, pathAlpha, pathBase, 0);
    }
    if (srcBase) {
        (*env)->ReleasePrimitiveArrayCritical(env, src, srcBase, 0);
    }
}

JNIEXPORT void JNICALL
Java_sun_java2d_pipe_DuctusClipRenderer_mergeAlphas(JNIEnv *env,
						    jobject DCR,
						    jbyteArray srcA,
						    jbyteArray dstA,
						    jint srcOff,
						    jint dstOff,
						    jint tsize,
						    jint w,
						    jint h,
						    jint bitDepth)
{
    unsigned char *srcBase, *srcData;
    unsigned char *dstBase, *dstData;
    int x, y;
    int tileScanStr = tsize - w;

    srcData = srcBase = getAlphaInfo(env, srcA);
    dstData = dstBase = getAlphaInfo(env, dstA);

    if (bitDepth == 8) {
	srcData += srcOff;
	dstData += dstOff;

	for (y = 0; y < h; y++) {
	    for (x = 0; x < w; x++) {
                *dstData =  ALPHAMULT(*srcData,*dstData);
		dstData++;
		srcData++;
	    }
	    srcData += tileScanStr;
	    dstData += tileScanStr;
	}
    } else {
	printf("Eek! 1 bit alpha merging not supported yet!\n");
    }
    dropBufs(env, srcA, srcBase, dstA, dstBase);
}

