/*
 * @(#)alphaCompst_DST_OVER.h	1.19 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#undef DST_OVER_RULE

#ifdef COMPST_TWO_COMPONENTS
#define DST_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_OVER_RULE2(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_FOUR_COMPONENTS
#define DST_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_OVER_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_SRC16
#define DST_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_OVER_RULE_SRC16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_DST16
#define DST_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_OVER_RULE_DST16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPS_SRCDST16
#define DST_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_OVER_RULE_SRCDST16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifndef DST_OVER_RULE
#define DST_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        DST_OVER_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#define DST_OVER_RULE2(rA, cA, xA,					\
                       sA, sR, sG, sB,           			\
                       dA, dR, dG, dB)					\
do {								        \
        unsigned int a = NORM_SCALE - dA;                               \
        rA = ALPHAMULT(rA,a);                                       \
        rA = ALPHAMULT(rA,xA);                                      \
	if (rA) {                                                       \
            dA += ALPHAMULT(rA,sA);                                     \
            dR += ALPHAMULT(rA,sR);                                     \
	} else {                                                        \
            skipDst = 1;                                                \
	}								\
} while (0)

#define DST_OVER_RULE4(rA, cA, xA,					\
                       sA, sR, sG, sB,           			\
                       dA, dR, dG, dB)					\
do {                                            			\
        unsigned int a = NORM_SCALE - dA;                               \
        rA = ALPHAMULT(rA,a);                                       \
        rA = ALPHAMULT(rA,xA);                                      \
	if (rA) {                                                       \
            dA += ALPHAMULT(rA,sA);                                     \
            dR += ALPHAMULT(rA,sR);                                     \
            dG += ALPHAMULT(rA,sG);                                     \
            dB += ALPHAMULT(rA,sB);                                     \
	} else {                                                        \
            skipDst = 1;                                                \
	}								\
} while (0)

#define DST_OVER_RULE_SRC16(rA, cA, xA,					\
                            sA, sR, sG, sB,           			\
                            dA, dR, dG, dB)				\
do {                                            			\
        unsigned int a = NORM_SCALE - dA;                               \
        rA = ALPHAMULT(rA,a);                                       \
        rA = ALPHAMULT(rA,xA);                                      \
	if (rA) {                                                       \
            dA += (rA * sA) / SHORT_NORM_SCALE;                         \
            dR += (rA * sR) / SHORT_NORM_SCALE;                         \
            dG += (rA * sG) / SHORT_NORM_SCALE;                         \
            dB += (rA * sB) / SHORT_NORM_SCALE;                         \
	} else {                                                        \
            skipDst = 1;                                                \
	}								\
} while (0)

#define DST_OVER_RULE_DST16(rA, cA, xA,					\
                            sA, sR, sG, sB,           			\
                            dA, dR, dG, dB)				\
do {                                            			\
        unsigned int a = SHORT_NORM_SCALE - dA;                         \
        if (a < SHORT_NORM_SCALE) {                                     \
            rA = (rA * a)/NORM_SCALE;                                   \
        } else {                                                        \
            rA <<= 8;                                                   \
        }                                                               \
        if (xA < NORM_SCALE) {                                          \
            rA = (rA * xA) / NORM_SCALE;                                \
	}								\
	if (rA) {                                                       \
            dA += (rA * sA) / NORM_SCALE;                               \
            dR += (rA * sR) / NORM_SCALE;                               \
            dG += (rA * sG) / NORM_SCALE;                               \
            dB += (rA * sB) / NORM_SCALE;                               \
	} else {                                                        \
            skipDst = 1;                                                \
	}								\
} while (0)

#define DST_OVER_RULE_SRCDST16(rA, cA, xA,				\
                               sA, sR, sG, sB,         			\
                               dA, dR, dG, dB)				\
do {                                            			\
        unsigned int a = SHORT_NORM_SCALE - dA;                         \
        if (a < SHORT_NORM_SCALE) {                                   \
            rA = (rA * a)/NORM_SCALE;                                   \
        } else {                                                        \
            rA <<= 8;                                                   \
        }                                                               \
        if (xA < NORM_SCALE) {                                          \
            rA = (rA * xA) / NORM_SCALE;                                \
	}								\
	if (rA) {                                                       \
            dA += (rA * sA) / SHORT_NORM_SCALE;                         \
            dR += (rA * sR) / SHORT_NORM_SCALE;                         \
            dG += (rA * sG) / SHORT_NORM_SCALE;                         \
            dB += (rA * sB) / SHORT_NORM_SCALE;                         \
	} else {                                                        \
            skipDst = 1;                                                \
	}								\
} while (0)

