/*
 * @(#)alphaCompst_SRC.h	1.20 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#undef SRC_RULE

#ifdef COMPST_TWO_COMPONENTS
#define SRC_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_RULE2(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_FOUR_COMPONENTS
#define SRC_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_SRC16
#define SRC_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_RULE_SRC16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_DST16
#define SRC_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_RULE_DST16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_SRCDST16
#define SRC_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_RULE_SRCDST16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifndef SRC_RULE
#define SRC_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif


#define SRC_RULE2(rA, cA, xA,						\
                  sA, sR, sG, sB,					\
                  dA, dR, dG, dB)					\
do {                                                                    \
    if (rA > 0) {                                                       \
        if (xA < NORM_SCALE) {                                          \
	    sA = ALPHAMULT(sA,xA);                                      \
	    sR = ALPHAMULT(sR,xA);                                      \
        }								\
	if (rA < NORM_SCALE) {						\
	    cA = NORM_SCALE - rA;					\
            ReadDstPixel(dA, dR, dG, dB);                               \
	    dA = CLIP_BLEND(rA, cA, sA, dA);				\
	    dR = CLIP_BLEND(rA, cA, sR, dR);				\
            DitherON;                                                   \
	} else {                                                        \
	    dA = sA;                    				\
	    dR = sR;                                            	\
            DitherOFF;                                                  \
        }                                                               \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_RULE4(rA, cA, xA,						\
                  sA, sR, sG, sB,					\
                  dA, dR, dG, dB)					\
do {                                                                    \
    if (rA > 0) {                                                       \
        if (xA < NORM_SCALE) {                                          \
	    sA = ALPHAMULT(xA,sA);                                      \
	    sR = ALPHAMULT(xA,sR);                                      \
	    sG = ALPHAMULT(xA,sG);                                      \
	    sB = ALPHAMULT(xA,sB);                                      \
        }								\
	if (rA < NORM_SCALE) {						\
	    cA = NORM_SCALE - rA;					\
            ReadDstPixel(dA, dR, dG, dB);                               \
	    dA = CLIP_BLEND(rA, cA, sA, dA);				\
	    dR = CLIP_BLEND(rA, cA, sR, dR);				\
	    dG = CLIP_BLEND(rA, cA, sG, dG);				\
	    dB = CLIP_BLEND(rA, cA, sB, dB);				\
            DitherON;                                                   \
	} else {                                                        \
	    dA = sA;                    				\
	    dR = sR;                                            	\
	    dG = sG;                                                    \
	    dB = sB;                                                    \
            DitherOFF;                                                  \
        }                                                               \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_RULE_SRC16(rA, cA, xA,					\
                       sA, sR, sG, sB,					\
                       dA, dR, dG, dB)					\
do {                                                                    \
    if (rA > 0) {                                                       \
        if (xA < NORM_SCALE) {                                          \
	    sA = (sA * xA) / NORM_SCALE;                                \
	    sR = (sR * xA) / NORM_SCALE;                                \
	    sG = (sG * xA) / NORM_SCALE;                                \
	    sB = (sB * xA) / NORM_SCALE;                                \
        }								\
	if (rA < NORM_SCALE) {						\
	    cA = NORM_SCALE - rA;					\
            ReadDstPixel(dA, dR, dG, dB);                               \
	    dA = ((rA*sA)/SHORT_NORM_SCALE)+(ALPHAMULT(cA,dA)); 	\
	    dR = ((rA*sR)/SHORT_NORM_SCALE)+(ALPHAMULT(cA,dR)); 	\
	    dG = ((rA*sG)/SHORT_NORM_SCALE)+(ALPHAMULT(cA,dG));         \
	    dB = ((rA*sB)/SHORT_NORM_SCALE)+(ALPHAMULT(cA,dB));         \
            DitherON;                                                   \
	} else {                                                        \
	    dA = (sA >> 8);                      			\
	    dR = (sR >> 8);                                             \
	    dG = (sG >> 8);                                             \
	    dB = (sB >> 8);                                             \
            DitherOFF;                                                  \
        }                                                               \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_RULE_DST16(rA, cA, xA,					\
                       sA, sR, sG, sB,					\
                       dA, dR, dG, dB)					\
do {                                    				\
    if (rA > 0) {                                                       \
        if (xA < NORM_SCALE) {                                          \
	    sA = ALPHAMULT(xA,sA);                                      \
	    sR = ALPHAMULT(xA,sR);                                      \
	    sG = ALPHAMULT(xA,sG);                                      \
	    sB = ALPHAMULT(xA,sB);                                      \
        }								\
	if (rA < NORM_SCALE) {						\
	    cA = NORM_SCALE - rA;					\
            ReadDstPixel(dA, dR, dG, dB);                               \
	    dA = ((ALPHAMULT(rA,sA))<<8)+((cA*dA)/NORM_SCALE);  	\
	    dR = ((ALPHAMULT(rA,sR))<<8)+((cA*dR)/NORM_SCALE);          \
	    dG = ((ALPHAMULT(rA,sG))<<8)+((cA*dG)/NORM_SCALE);          \
	    dB = ((ALPHAMULT(rA,sB))<<8)+((cA*dB)/NORM_SCALE);          \
            DitherON;                                                   \
	} else {                                                        \
            dA = (sA << 8) + sA;                                        \
	    dR = (sR << 8) + sR;                                        \
	    dG = (sG << 8) + sG;                                        \
	    dB = (sB << 8) + sB;                                        \
            DitherOFF;                                                  \
        }                                                               \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_RULE_SRCDST16(rA, cA, xA,					\
                          sA, sR, sG, sB,				\
                          dA, dR, dG, dB)				\
do {                                                                    \
    if (rA > 0) {                                                       \
        if (xA < NORM_SCALE) {                                          \
	    sA = (sA * xA) / NORM_SCALE;                                \
	    sR = (sR * xA) / NORM_SCALE;                                \
	    sG = (sG * xA) / NORM_SCALE;                                \
	    sB = (sB * xA) / NORM_SCALE;                                \
        }								\
	if (rA < NORM_SCALE) {						\
	    cA = NORM_SCALE - rA;					\
            ReadDstPixel(dA, dR, dG, dB);                               \
	    dA = CLIP_BLEND16(rA, cA, sA, dA);				\
	    dR = CLIP_BLEND16(rA, cA, sR, dR);				\
	    dG = CLIP_BLEND16(rA, cA, sG, dG);				\
	    dB = CLIP_BLEND16(rA, cA, sB, dB);				\
            DitherON;                                                   \
	} else {                                                        \
	    dA = sA;                    				\
	    dR = sR;                                            	\
	    dG = sG;                                                    \
	    dB = sB;                                                    \
            DitherOFF;                                                  \
        }                                                               \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)
