/*
 * @(#)alphaCompst_SRC_IN.h	1.18 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#undef SRC_IN_RULE

#ifdef COMPST_TWO_COMPONENTS
#define SRC_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_IN_RULE2(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_FOUR_COMPONENTS
#define SRC_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_IN_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_SRC16
#define SRC_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_IN_RULE_SRC16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_DST16
#define SRC_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_IN_RULE_DST16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_SRCDST16
#define SRC_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_IN_RULE_SRCDST16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifndef SRC_IN_RULE
#define SRC_IN_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_IN_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#define SRC_IN_RULE2(rA, cA, xA,					\
                     sA, sR, sG, sB,                			\
                     dA, dR, dG, dB)					\
do {    								\
    if (rA > 0) {                                                       \
        cA = NORM_SCALE - rA;                                           \
        rA = ALPHAMULT(rA,dA);      				\
        rA = ALPHAMULT(rA,xA);                                      \
        dA = CLIP_BLEND(rA, cA, sA, dA);				\
        dR = CLIP_BLEND(rA, cA, sR, dR);				\
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_IN_RULE4(rA, cA, xA,					\
                     sA, sR, sG, sB,                			\
                     dA, dR, dG, dB)					\
do {                                                                    \
    if (rA > 0) {                                                       \
        cA = NORM_SCALE - rA;                                           \
        rA = ALPHAMULT(rA,dA);      				\
        rA = ALPHAMULT(rA,xA);                                      \
        dA = CLIP_BLEND(rA, cA, sA, dA);				\
        dR = CLIP_BLEND(rA, cA, sR, dR);				\
        dG = CLIP_BLEND(rA, cA, sG, dG);				\
        dB = CLIP_BLEND(rA, cA, sB, dB);				\
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_IN_RULE_SRC16(rA, cA, xA,					\
                          sA, sR, sG, sB,              			\
                          dA, dR, dG, dB)				\
do {                                                            	\
    if (rA > 0) {                                                       \
        cA = NORM_SCALE - rA;                                           \
        rA = ALPHAMULT(rA,dA);      				\
        rA = ALPHAMULT(rA,xA);                                      \
        dA = ((rA*sA)/SHORT_NORM_SCALE)+(ALPHAMULT(cA,dA));     	\
        dR = ((rA*sR)/SHORT_NORM_SCALE)+(ALPHAMULT(cA,dR));             \
        dG = ((rA*sG)/SHORT_NORM_SCALE)+(ALPHAMULT(cA,dG));             \
        dB = ((rA*sB)/SHORT_NORM_SCALE)+(ALPHAMULT(cA,dB));             \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_IN_RULE_DST16(rA, cA, xA,					\
                          sA, sR, sG, sB,              			\
                          dA, dR, dG, dB)				\
do {                                                                    \
    if (rA > 0) {                                                       \
        cA = NORM_SCALE - rA;                                           \
	if (dA < SHORT_NORM_SCALE) {                         		\
	    rA = (rA * dA) / SHORT_NORM_SCALE;  			\
	}								\
        if (xA < NORM_SCALE) {                                          \
            rA = (rA * xA) / NORM_SCALE;                                \
	}								\
        dA = ((ALPHAMULT(rA,sA))<<8)+((cA*dA)/NORM_SCALE);              \
        dR = ((ALPHAMULT(rA,sR))<<8)+((cA*dR)/NORM_SCALE);              \
        dG = ((ALPHAMULT(rA,sG))<<8)+((cA*dG)/NORM_SCALE);              \
        dB = ((ALPHAMULT(rA,sB))<<8)+((cA*dB)/NORM_SCALE);              \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_IN_RULE_SRCDST16(rA, cA, xA,				\
                             sA, sR, sG, sB,           			\
                             dA, dR, dG, dB)				\
do {                                                                    \
    if (rA > 0) {                                                       \
        cA = NORM_SCALE - rA;                                           \
	if (dA < NORM_SCALE) {                             		\
	    rA = (rA * dA) / SHORT_NORM_SCALE;  			\
	}								\
        if (xA < NORM_SCALE) {                                          \
            rA = (rA * xA) / NORM_SCALE;                                \
	}								\
        dA = CLIP_BLEND16(rA, cA, sA, dA);				\
        dR = CLIP_BLEND16(rA, cA, sR, dR);				\
        dG = CLIP_BLEND16(rA, cA, sG, dG);				\
        dB = CLIP_BLEND16(rA, cA, sB, dB);				\
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)
