/*
 * @(#)alphaCompst_SRC_OUT.h	1.21 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#undef SRC_OUT_RULE

#ifdef COMPST_TWO_COMPONENTS
#define SRC_OUT_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OUT_RULE2(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_FOUR_COMPONENTS
#define SRC_OUT_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OUT_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_SRC16
#define SRC_OUT_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OUT_RULE_SRC16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_DST16
#define SRC_OUT_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OUT_RULE_DST16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_SRCDST16
#define SRC_OUT_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OUT_RULE_SRCDST16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifndef SRC_OUT_RULE
#define SRC_OUT_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OUT_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#define SRC_OUT_RULE2(rA, cA, xA,					\
                      sA, sR, sG, sB,                			\
                      dA, dR, dG, dB)					\
do {    								\
    if (rA > 0) {                                                       \
        unsigned int a = NORM_SCALE - dA;                               \
        unsigned int b = NORM_SCALE - rA;                               \
        a = ALPHAMULT(a,rA);                                            \
        a = ALPHAMULT(a,xA);                                            \
        dA = CLIP_BLEND(a, b, sA, dA);                                  \
        dR = CLIP_BLEND(a, b, sR, dR);                                  \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_OUT_RULE4(rA, cA, xA,					\
                      sA, sR, sG, sB,                			\
                      dA, dR, dG, dB)					\
do {                                                                    \
    if (rA > 0) {                                                       \
        unsigned int a = NORM_SCALE - dA;                               \
        unsigned int b = NORM_SCALE - rA;                               \
        a = ALPHAMULT(a,rA);                                            \
        a = ALPHAMULT(a,xA);                                            \
	dA = CLIP_BLEND(a, b, sA, dA);				        \
	dR = CLIP_BLEND(a, b, sR, dR);					\
	dG = CLIP_BLEND(a, b, sG, dG);					\
	dB = CLIP_BLEND(a, b, sB, dB);					\
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)
        
#define SRC_OUT_RULE_SRC16(rA, cA, xA,					\
                           sA, sR, sG, sB,             			\
                           dA, dR, dG, dB)				\
do {                                                                    \
    if (rA > 0) {                                                       \
        unsigned int a = NORM_SCALE - dA;                               \
        unsigned int b = NORM_SCALE - rA;                               \
        a = ALPHAMULT(a,rA);                                            \
        a = ALPHAMULT(a,xA);                                            \
        dA = ((a*sA)/SHORT_NORM_SCALE)+(ALPHAMULT(b,dA));               \
        dR = ((a*sR)/SHORT_NORM_SCALE)+(ALPHAMULT(b,dR));               \
        dG = ((a*sG)/SHORT_NORM_SCALE)+(ALPHAMULT(b,dG));               \
        dB = ((a*sB)/SHORT_NORM_SCALE)+(ALPHAMULT(b,dB));               \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_OUT_RULE_DST16(rA, cA, xA,					\
                           sA, sR, sG, sB,             			\
                           dA, dR, dG, dB)				\
do {                                                                    \
    if (rA > 0) {                                                       \
        unsigned int a = SHORT_NORM_SCALE - dA;                         \
        unsigned int b = NORM_SCALE - rA;                               \
        int c = ALPHAMULT(rA,xA);                                       \
	if (c < NORM_SCALE) {                             		\
	    a = (a * c) / NORM_SCALE;                                   \
	}								\
        dA = ((a*sA)/NORM_SCALE)+((b*dA)/NORM_SCALE);                   \
        dR = ((a*sR)/NORM_SCALE)+((b*dR)/NORM_SCALE);                   \
        dG = ((a*sG)/NORM_SCALE)+((b*dG)/NORM_SCALE);                   \
        dB = ((a*sB)/NORM_SCALE)+((b*dB)/NORM_SCALE);                   \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_OUT_RULE_SRCDST16(rA, cA, xA,				\
                              sA, sR, sG, sB,          			\
                              dA, dR, dG, dB)				\
do {                                                                    \
    if (rA > 0) {                                                       \
        unsigned int a = SHORT_NORM_SCALE - dA;                         \
        unsigned int b = NORM_SCALE - rA;                               \
        int c = ALPHAMULT(rA,xA);                                       \
	if (c < NORM_SCALE) {                             		\
	    a = (a * c) / NORM_SCALE;                                   \
	}								\
        dA = ((a*sA)/SHORT_NORM_SCALE)+((b*dA)/NORM_SCALE);             \
        dR = ((a*sR)/SHORT_NORM_SCALE)+((b*dR)/NORM_SCALE);             \
        dG = ((a*sG)/SHORT_NORM_SCALE)+((b*dG)/NORM_SCALE);             \
        dB = ((a*sB)/SHORT_NORM_SCALE)+((b*dB)/NORM_SCALE);             \
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)
