/*
 * @(#)alphaCompst_SRC_OVER.h	1.23 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#undef SRC_OVER_RULE

#ifdef COMPST_TWO_COMPONENTS
#define SRC_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OVER_RULE2(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_FOUR_COMPONENTS
#define SRC_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OVER_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_SRC16
#define SRC_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OVER_RULE_SRC16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_DST16
#define SRC_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OVER_RULE_DST16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifdef COMPST_SRCDST16
#define SRC_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OVER_RULE_SRCDST16(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif

#ifndef SRC_OVER_RULE
#define SRC_OVER_RULE(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB) \
        SRC_OVER_RULE4(rA, cA, xA, sA, sR, sG, sB, dA, dR, dG, dB)
#endif


#define SRC_OVER_RULE2(rA, cA, xA,					\
                       sA, sR, sG, sB,           			\
                       dA, dR, dG, dB)					\
do {                                                                    \
    if (sA > 0 && rA > 0) {                                             \
        rA = ALPHAMULT(rA,xA);                                          \
	if (rA >= NORM_SCALE && sA >= NORM_SCALE) {			\
	    dA = sA;							\
	    dR = sR;							\
            DitherOFF;                                                  \
	} else {							\
	    cA = NORM_SCALE - ALPHAMULT(rA,sA);                         \
            ReadDstPixel(dA, dR, dG, dB);                               \
	    dA = CLIP_BLEND(rA, cA, sA, dA);				\
	    dR = CLIP_BLEND(rA, cA, sR, dR);				\
            DitherON;                                                   \
	}								\
    } else {                                                            \
        skipDst = 1;                                                    \
    }                                                                   \
} while (0)

#define SRC_OVER_RULE4(rA, cA, xA,					\
                      sA, sR, sG, sB,           			\
                      dA, dR, dG, dB)					\
do {                                                                    \
    if (sA > 0 && rA > 0) {                                             \
        rA = ALPHAMULT(rA,xA);                                          \
	if (rA >= NORM_SCALE && sA >= NORM_SCALE) {			\
	    dA = sA;							\
	    dR = sR;							\
	    dG = sG;							\
	    dB = sB;                                                    \
            DitherOFF;                                                  \
	} else {							\
	    cA = NORM_SCALE - ALPHAMULT(rA,sA);                         \
            ReadDstPixel(dA, dR, dG, dB);                               \
	    dA = CLIP_BLEND(rA, cA, sA, dA);				\
	    dR = CLIP_BLEND(rA, cA, sR, dR);				\
	    dG = CLIP_BLEND(rA, cA, sG, dG);				\
	    dB = CLIP_BLEND(rA, cA, sB, dB);				\
            DitherON;                                                   \
	}								\
    } else {                                                            \
       skipDst = 1;                                                     \
    }                                                                   \
} while (0)

#define SRC_OVER_RULE_SRC16(rA, cA, xA,					\
                            sA, sR, sG, sB,           			\
                            dA, dR, dG, dB)				\
do {                                                                    \
    if (sA > 0 && rA > 0) {                                             \
        rA = ALPHAMULT(rA,xA);                                          \
	if (rA >= NORM_SCALE && sA >= SHORT_NORM_SCALE) {		\
	    dA = sA >> 8;                                               \
            dR = sR >> 8;                                               \
            dG = sG >> 8;                                               \
            dB = sB >> 8;                                               \
            DitherOFF;                                                  \
	} else {							\
	    cA = NORM_SCALE - ((rA * sA)/SHORT_NORM_SCALE);             \
            ReadDstPixel(dA, dR, dG, dB);                               \
            dA = ((rA*sA)/SHORT_NORM_SCALE)+(ALPHAMULT(cA,dA));         \
            dR = ((rA*sR)/SHORT_NORM_SCALE)+(ALPHAMULT(cA,dR));         \
            dG = ((rA*sG)/SHORT_NORM_SCALE)+(ALPHAMULT(cA,dG));         \
            dB = ((rA*sB)/SHORT_NORM_SCALE)+(ALPHAMULT(cA,dB));         \
            DitherON;                                                   \
	}								\
    } else {                                                            \
        skipDst = 1;                                                    \
    }                                                                   \
} while (0)

#define SRC_OVER_RULE_DST16(rA, cA, xA,					\
                            sA, sR, sG, sB,           			\
                            dA, dR, dG, dB)				\
do {                                                                    \
    if (sA > 0 && rA > 0) {                                             \
        rA = ALPHAMULT(rA,xA);                                          \
	if (rA >= NORM_SCALE && sA >= NORM_SCALE) {                     \
            dA = (sA << 8) + sA;					\
	    dR = (sR << 8) + sR;					\
	    dG = (sG << 8) + sG;					\
	    dB = (sB << 8) + sB;                                        \
            DitherOFF;                                                  \
	} else {							\
	    cA = NORM_SCALE - ALPHAMULT(rA,sA);                         \
            ReadDstPixel(dA, dR, dG, dB);                               \
            dA = ((ALPHAMULT(rA,sA))<<8)+((cA*dA)/NORM_SCALE);      	\
            dR = ((ALPHAMULT(rA,sR))<<8)+((cA*dR)/NORM_SCALE);          \
            dG = ((ALPHAMULT(rA,sG))<<8)+((cA*dG)/NORM_SCALE);          \
            dB = ((ALPHAMULT(rA,sB))<<8)+((cA*dB)/NORM_SCALE);          \
            DitherON;                                                   \
	}								\
    } else {                                                            \
        skipDst = 1;                                                    \
    }                                                                   \
} while (0)

#define SRC_OVER_RULE_SRCDST16(rA, cA, xA,				\
                               sA, sR, sG, sB,         			\
                               dA, dR, dG, dB)				\
do {                                                                    \
    if (sA > 0 && rA > 0) {                                             \
        rA = ALPHAMULT(rA,xA);                                          \
	if (rA >= NORM_SCALE && sA >= SHORT_NORM_SCALE) {		\
	    dA = sA;							\
	    dR = sR;							\
	    dG = sG;							\
	    dB = sB;                                                    \
            DitherOFF;                                                  \
	} else {							\
	    cA = NORM_SCALE - ((rA * sA)/SHORT_NORM_SCALE);             \
            ReadDstPixel(dA, dR, dG, dB);                               \
	    dA = CLIP_BLEND16(rA, cA, sA, dA);				\
	    dR = CLIP_BLEND16(rA, cA, sR, dR);				\
	    dG = CLIP_BLEND16(rA, cA, sG, dG);				\
	    dB = CLIP_BLEND16(rA, cA, sB, dB);				\
            DitherON;                                                   \
	}								\
    } else {                                                            \
        skipDst = 1;                                                    \
    }                                                                   \
} while (0)

