/*
 * @(#)alphaCompst_colorloop.h	1.32 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#include <alphaCompst_XOR_MODE.h>
#include <alphaCompst_SRC.h>
#include <alphaCompst_SRC_OVER.h>
#include <alphaCompst_DST_OVER.h>
#include <alphaCompst_SRC_IN.h>
#include <alphaCompst_DST_IN.h>
#include <alphaCompst_SRC_OUT.h>
#include <alphaCompst_DST_OUT.h>
#include <alphaCompst_loop_uti.h>

#ifndef PrepColorDst
#define PrepColorDst
#endif

extern ColorLoopFunc   COLOR_BLENDFUNC;

void
COLOR_BLENDFUNC(JNIEnv *env,
		void *dstBase, jint dstScanStr, jint dstPixStr,
		unsigned char *pathData, jint offset,
		jint alphaTileScan, jint rule, jfloat fXtraAlpha,
                jint width, jint height, jint color, ColorData *cData)
{
    int extraAlpha = (int)(fXtraAlpha*(float)NORM_SCALE);
    int row, column;
    int rastAlpha = 255;
    int compAlpha = 0;
    int colorAlpha = (color >> 24) & 0xff;
    int colorRed   = (((color >> 16) & 0xff)*colorAlpha)/255;
    int colorGreen = (((color >>  8) & 0xff)*colorAlpha)/255;
    int colorBlue  = (((color >>  0) & 0xff)*colorAlpha)/255;
    int srcAlpha   = colorAlpha;
    int srcRed     = colorRed;
    int srcGreen   = colorGreen;
    int srcBlue    = colorBlue;
    int dstAlpha = 0;
    int dstRed = 0;
    int dstGreen = 0;
    int dstBlue = 0;
    int pathDataInc = 1;
    int skipDst;

    DeclareDitherVar
        
    DeclareDst
#ifdef DST_XCCC
    PrepColorDst;
#endif

    if (!blendlutInitialized) {
        initBlendLut();
    }
    
    InitRastAlpha;

    if (rule == SRC_OVER && extraAlpha == NORM_SCALE && colorAlpha == 255) {
        rule = SRC;
    }
    InitDst;

    switch (rule) {

    case XOR_MODE:
        DitherOFF;
#ifdef FastXORLoop
        FastXORLoop;
#else
        COMPOSITE_COLOR(RASTEROP_XOR(rastAlpha, compAlpha, extraAlpha,
                                     srcAlpha, srcRed, srcGreen, srcBlue,
                                     dstAlpha, dstRed, dstGreen, dstBlue));
#endif
        DitherON;
        break;

    case CLEAR:
        CLEAR_COMP;
        break;

#undef ReadDst
#define ReadDst
    case SRC:
	{
            COMPOSITE_COLOR(SRC_RULE(rastAlpha, compAlpha, extraAlpha,
                                     srcAlpha, srcRed, srcGreen, srcBlue,
                                     dstAlpha, dstRed, dstGreen, dstBlue));
	}
        break;

    case SRC_OVER:
        COMPOSITE_COLOR(SRC_OVER_RULE(rastAlpha, compAlpha, extraAlpha,
                                      srcAlpha, srcRed, srcGreen, srcBlue,
                                      dstAlpha, dstRed, dstGreen, dstBlue));
        break;
#undef ReadDst
#define ReadDst ReadDst_Default
        
    case DST_OVER:
        COMPOSITE_COLOR(DST_OVER_RULE(rastAlpha, compAlpha, extraAlpha,
                                      srcAlpha, srcRed, srcGreen, srcBlue,
                                      dstAlpha, dstRed, dstGreen, dstBlue));
        break;

    case SRC_IN:
        COMPOSITE_COLOR(SRC_IN_RULE(rastAlpha, compAlpha, extraAlpha,
                                    srcAlpha, srcRed, srcGreen, srcBlue,
                                    dstAlpha, dstRed, dstGreen, dstBlue));
        break;

    case DST_IN:
        COMPOSITE_COLOR(DST_IN_RULE(rastAlpha, compAlpha, extraAlpha,
                                    srcAlpha, srcRed, srcGreen, srcBlue,
                                    dstAlpha, dstRed, dstGreen, dstBlue));
        break;

    case SRC_OUT:
        COMPOSITE_COLOR(SRC_OUT_RULE(rastAlpha, compAlpha, extraAlpha,
                                     srcAlpha, srcRed, srcGreen, srcBlue,
                                     dstAlpha, dstRed, dstGreen, dstBlue));
        break;

    case DST_OUT:
        COMPOSITE_COLOR(DST_OUT_RULE(rastAlpha, compAlpha, extraAlpha,
                                     srcAlpha, srcRed, srcGreen, srcBlue,
                                     dstAlpha, dstRed, dstGreen, dstBlue));
        break;

    }
}
