/*
 * @(#)blendlut.c	1.4 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */


/* @(#)blendlut.c	1.4 00/02/02 */

#include <stdlib.h>
#include <jni.h>
#include <jni_util.h>
extern JavaVM *jvm;

unsigned char blendlut[256][256];
int blendlutInitialized = 0;

void initBlendLut() {

    unsigned int i;
    unsigned int j;
    
    for (i = 0; i < 256; i++) {
        for (j = 0; j <= i; j++) {
            blendlut[i][j] = blendlut[j][i] =
                (unsigned char)((i*j)/255);
        }
    }
    blendlutInitialized = 1; 

#ifdef PRINTDEBUGOUTPUTSOWECANSEE
    printf("\n\n/* %@(#)blendlut.c	1.4% %00/02/02% */\n\n");
    printf("unsigned char blendlut[256][256] = {\n", i);
    for (i = 0 ; i < 256 ; i++) {
        printf("\n{ /* %03d */\n", i);
        for (j = 0 ; j < 256 ; j++) {
            if (i && !((j) % 16)) printf("\n");
            printf("%3d,", blendlut[i][j]);
        }
        printf("\n},\n");
    }
    printf("\n};\n");
#endif

}


#ifdef PRINTDEBUGOUTPUTSOWECANSEE
unsigned char oor(unsigned int a, unsigned int b) {
    if (a > 255) {
        printf("a=%d\n", a);
        a = 255;
    }
    if (b > 255) {
        printf("b=%d\n", b);
        b = 255;
    }

    printf("a=%d, b=%d, lut=%d\n", a, b, blendlut[a][b]);
    return blendlut[a][b];
}
#endif
