/*
 * @(#)debug_util.c	1.4 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#include "debug_util.h"

#if defined(DEBUG)

dmutex_t DMutex_Create() {
    dmutex_t	mutex;
    mutex = (dmutex_t)JVM_RawMonitorCreate();
    DASSERT(mutex != NULL);

    return mutex;
}

void DMutex_Destroy(dmutex_t mutex) {
    DASSERT(mutex != NULL);
    JVM_RawMonitorDestroy(mutex);
}

void DMutex_Enter(dmutex_t mutex) {
    DASSERT(mutex != NULL);
    JVM_RawMonitorEnter(mutex);
}

void DMutex_Exit(dmutex_t mutex) {
    DASSERT(mutex != NULL);
    JVM_RawMonitorExit(mutex);
}

#endif
