/*
 * @(#)t2kmem.c	1.4 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#include <malloc.h>
#include <string.h>
#include "HeadSpin.h"

#ifdef __cplusplus
extern "C"
{
#endif

struct sizeBlock {
	size_t	size;
};

typedef struct sizeBlock sizeBlock;

void* t2k_malloc(size_t size)
{
	sizeBlock* block = (sizeBlock*)malloc(size + sizeof(sizeBlock));

	if (block)
	{	block->size = size;
		return block + 1;
	}
	return 0;
}

void t2k_free(void* p)
{
	free((sizeBlock*)p - 1);
}

void* t2k_realloc(void* oldp, size_t newSize)
{
	size_t	oldSize = ((sizeBlock*)oldp - 1)->size;
	void*	newp = malloc(newSize);

	if (newp)
	{	((sizeBlock*)newp - 1)->size = newSize;

		memmove(newp, oldp, hsMinimum(oldSize, newSize));
	
		t2k_free(oldp);
	}
	return newp;
}

#ifdef __cplusplus
}
#endif
