/*
 * @(#)swaps.h	1.10 00/09/01
 *
 * Copyright 2000 Sun Microsystems, Inc. All rights reserved.
 * Copyright 2000 Sun Microsystems, Inc. Tous droits rservs.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 */

#ifndef swapsDefined
#define swapsDefined

#include "HeadSpin.h"

#if defined(_LITTLE_ENDIAN)

#ifdef __cplusplus
extern "C"
{
#endif

UInt32 swapLong(UInt32 value);
UInt16 swapWord(UInt16 value);
UInt16 swapWordPtr(UInt16** value);

#ifdef __cplusplus
}
#endif

#define SWAPW(a)		swapWord(a)
#define SWAPL(a)		swapLong(a)
#define SWAPWINC(a)		swapWordPtr((unsigned short**)&a)
#define SWAPLINC(a)		swapLong(*(a)++)
#define DELTASWAPPED(a,d)		(((a) = SWAP_ (a) d), ((a) = SWAP_ (a)))

#define SWAP_(a)	\
(sizeof(a) == 1 ? (a) : \
 sizeof(a) == 2 ? SWAPW(a) : \
 sizeof(a) == 4 ? SWAPL(a) : \
 (a))

#else

#define SWAPW(a)			(a)
#define SWAPWINC(a)		(*(a)++)
#define SWAPLINC(a)		(*(a)++)
#define SWAPL(a)			(a)
#define DELTASWAPPED(a,d)	((a) = (a) d)
#define SWAP_(a)			(a)
#endif

#endif /*swapsDefined*/
