/*
 * @(#)t2kScalerContext.h	1.12 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#include "hsGScalerContext.h"
extern "C" 
{
#include "scaler_types.h"
#include "t2k.h"
#include "shapet.h"
}
#include "fontObject.h"
#include "hsGFontScaler.h"

#ifndef t2kScalerContextDefined
#define t2kScalerContextDefined

class t2kScalerContext: public hsGScalerContext {
        fontObject      *fFont;
        CharToGlyphMapper *t1Mapper;
        CharToGlyphMapper *ttMapper;
	hsFixed		fBoldness;
	float		fMatrix[4];
	Boolean		fDoAntiAlias, fDoFractEnable;

	class T2KEntry* fT2KEntry;
	int			fGreyLevel, fT2KFlags;
	
	T2K*		SetupTrans();
public:
    int fNumGlyphs;
    t2kScalerContext(fontObject *font, const float matrix[],
                    Boolean doAntiAlias, Boolean doFractEnable,
                    int style);
    virtual		~t2kScalerContext();
    
    virtual UInt32	CountGlyphs();
    virtual void	GenerateMetrics(UInt16 glyphID, hsGGlyph* glyph,
                                        hsFixedPoint2* advance);
    virtual void	GenerateMetricsWithImage(
                                        UInt16 glyphID, hsGGlyph* glyph,
                                        hsFixedPoint2* advance);
    virtual void	GenerateImage(UInt16 glyphID, const hsGGlyph* glyph,
                                      void* buffer);
    virtual void	GeneratePath(UInt16 index, hsPathSpline* path,
                                     hsFixedPoint2* advance);
    virtual void	    GetLineHeight(hsFixedPoint2* ascent,
                                        hsFixedPoint2* descent,
                                        hsFixedPoint2* baseline,
                                        hsFixedPoint2* leading,
                                        hsFixedPoint2* maxAdvance);
    /**
     * This method returns the vector which gives the caret angle.  For 
     * standard (right-leaning) carets, both elements of caret should be
     * positive.
     */
    virtual void GetCaretAngle(hsFixedPoint2* caret);
    virtual CharToGlyphMapper *getMapper();
    virtual Boolean isStyleSupported(int);
};

class t2kFontScaler : public hsGFontScaler {
public:
    virtual hsGScalerContext* CreateContext(hsConstDescriptor desc);
};

#endif
