/*
 * @(#)t2ksc.h	1.10 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * T2KSC.H
 * Copyright (C) 1989-1998 all rights reserved by Type Solutions, Inc. Plaistow, NH, USA.
 * Author: Sampo Kaasila
 *
 * This software is the property of Type Solutions, Inc. and it is furnished
 * under a license and may be used and copied only in accordance with the
 * terms of such license and with the inclusion of the above copyright notice.
 * This software or any other copies thereof may not be provided or otherwise
 * made available to any other person or entity except as allowed under license.
 * No title to and ownership of the software or intellectual property
 * therewithin is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */


#ifndef __T2K_SC__
#define __T2K_SC__
#ifdef __cplusplus
extern "C" {            /* Assume C declarations for C++ */
#endif  /* __cplusplus */


#define POS_XEDGE 	0x01
#define NEG_XEDGE 	0x02
#define POS_YEDGE 	0x04
#define NEG_YEDGE 	0x08
#define DELETE_EDGE	0x10

#define IS_XEDGE (POS_XEDGE | NEG_XEDGE)
#define IS_YEDGE (POS_YEDGE | NEG_YEDGE)

typedef struct {
	/* public */	
	
	long left, right, top, bottom;
	F26Dot6 fTop26Dot6, fLeft26Dot6;
	long rowBytes;
	unsigned char *baseAddr;

	/* semi private */
	long *xEdge;
	long *yEdge;
	char *edgeData; /* isXEdge */
	long numEdges;
	
	
	/* private */
	long xmin, xmax;
	long ymin, ymax;
	
	long maxEdges;
	short gMul;

	short *startPoint;
	short *endPoint;
	short numberOfContours;

	long *x;
	long *y;
	char *onCurve;

	tsiMemObject *mem;
} tsiScanConv;

tsiScanConv *tsi_NewScanConv( tsiMemObject *mem, short numberOfContours, short *startPtr, short *endPtr,
				              long *xPtr, long *yPtr, char *onCurvePtr, char greyScaleLevel, char curveType );
void MakeBits( tsiScanConv *t, char greyScaleLevel, char xWeightIsOne, char omitBitMap, char computeBBox );

void tsi_DeleteScanConv( tsiScanConv *t );


#ifdef __cplusplus
}
#endif  /* __cplusplus */
#endif /* __T2K_SC__ */
