/*
 * @(#)mlib_types.h	1.12 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 * @(#)mlib_types.h	4.4	98/10/21 SMI
 *
 * Copyright (c) 1996 - 1998, Sun Microsystems, Inc.
 */

/* Copyright (C) 1996, Sun Microsystems, Inc. */

#ifndef MLIB_TYPES_H
#define MLIB_TYPES_H

#ifdef __SUNPRO_C
#pragma ident	"@(#)mlib_types.h	1.22	98/10/19 SMI"
#endif /* __SUNPRO_C */

#include <limits.h>
#if defined(_MSC_VER)
#include <float.h>		/* for FLT_MAX and DBL_MAX */
#endif

           /*  for Cafe */
#ifndef DBL_MAX
#define	DBL_MAX		1.7976931348623157E+308	/* max decimal value of a */
#endif
						/* "double" */
#ifndef FLT_MAX
#define	FLT_MAX		3.402823466E+38F  /* max decimal value of a "float" */
#endif

#ifdef  __cplusplus
extern "C" {
#endif

typedef signed char        mlib_s8;
typedef unsigned char      mlib_u8;
typedef short              mlib_s16;
typedef unsigned short     mlib_u16;
typedef int                mlib_s32;
typedef unsigned int       mlib_u32;
typedef float              mlib_f32;
typedef double             mlib_d64;

#if defined(__SUNPRO_C) || defined(__GNUC__)

typedef long long          mlib_s64;
typedef unsigned long long mlib_u64;

#elif defined(_MSC_VER)

typedef __int64            mlib_s64;
typedef unsigned __int64   mlib_u64;

#else

#error	"unknown platform"

#endif

typedef unsigned long      mlib_addr;
typedef void*              mlib_ras;

#define MLIB_S8_MIN        SCHAR_MIN
#define MLIB_S8_MAX        SCHAR_MAX
#define MLIB_U8_MIN        0
#define MLIB_U8_MAX        UCHAR_MAX
#define MLIB_S16_MIN       SHRT_MIN
#define MLIB_S16_MAX       SHRT_MAX
#define MLIB_U16_MIN       0
#define MLIB_U16_MAX       USHRT_MAX
#define MLIB_S32_MIN       INT_MIN
#define MLIB_S32_MAX       INT_MAX
#define MLIB_U32_MIN       0
#define MLIB_U32_MAX       UINT_MAX
#define MLIB_F32_MIN      -FLT_MAX
#define MLIB_F32_MAX       FLT_MAX
#define MLIB_D64_MIN      -DBL_MAX
#define MLIB_D64_MAX       DBL_MAX

#ifdef  __cplusplus
}
#endif

#endif  /* MLIB_TYPES_H */
