/*
 * @(#)ARGB_DstData.h	1.13 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#define NORM_SCALE   255

#define DeclareDst                                                      \
     unsigned int *dstPtr;

#define InitDst                                                         \
do {                                                                    \
    dstPtr = dstBase;							\
    dstScanStr -= width * dstPixStr;                                    \
} while(0)

#define ReadDstPixel(dA, dR, dG, dB)                                    \
do {                                                                    \
    unsigned int tmp;							\
    tmp = *dstPtr;							\
    dA = (tmp >> 24) & 0xff;   						\
    dR = (tmp >> 16) & 0xff;						\
    dG = (tmp >>  8) & 0xff;						\
    dB = (tmp >>  0) & 0xff;						\
    if (dA < NORM_SCALE) {                                              \
        if (dA) {                                                       \
            dR = ALPHAMULT(dA,dR);                                       \
            dG = ALPHAMULT(dA,dG);                                       \
            dB = ALPHAMULT(dA,dB);                                       \
        } else {                                                        \
            dR = dG = dB = 0;                                           \
        }                                                               \
    }                                                                   \
}while (0);


#define WriteDstPixel(dA, dR, dG, dB)                                   \
do {                                                                    \
    if (dA) {                                                           \
        if (dA < NORM_SCALE) {                                          \
            dR = (dR * NORM_SCALE) / dA;                                \
            dG = (dG * NORM_SCALE) / dA;                                \
            dB = (dB * NORM_SCALE) / dA;                                \
        }                                                               \
        *dstPtr = (((dA & 0xff) << 24) |                                \
                   ((dR & 0xff) << 16) |				\
                   ((dG & 0xff) <<  8) |				\
                   ((dB & 0xff) <<  0));				\
    } else {                                                            \
        *dstPtr = 0;                                                    \
    }                                                                   \
} while(0)

#define NextDstPixel                                                    \
do {                                                                    \
    dstPtr++;                                                           \
} while(0)

#define NextDstRow                                                      \
do {                                                                    \
    dstPtr += dstScanStr;                                               \
} while(0)
