/*
 * @(#)ARGB_SrcData.h	1.11 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#define NORM_SCALE   255

#define DeclareSrc                                                      \
    unsigned int *srcPtr;

#define InitSrc                                                         \
do {                                                                    \
    srcPtr = srcBase;							\
    srcScanStr -= width * srcPixStr;                                    \
} while(0)

#define ReadSrcPixel(sA, sR, sG, sB)                                    \
do {                                                                    \
    unsigned int tmp;							\
    tmp = *srcPtr;							\
    sA = (tmp >> 24) & 0xff;						\
    sR = (tmp >> 16) & 0xff;						\
    sG = (tmp >>  8) & 0xff;						\
    sB = (tmp >>  0) & 0xff;						\
    if (!srcPre && (sA < NORM_SCALE)) {                                 \
        if (sA) {                                                       \
            sR = ALPHAMULT(sA,sR);                                      \
            sG = ALPHAMULT(sA,sG);                                      \
            sB = ALPHAMULT(sA,sB);                                      \
        } else {                                                        \
            sR = sG = sB = 0;                                           \
        }                                                               \
    }                                                                   \
}while (0)

#define NextSrcPixel                                                    \
do {                                                                    \
    srcPtr++;                                                           \
} while(0)

#define NextSrcRow                                                      \
do {                                                                    \
    srcPtr += srcScanStr;                                               \
} while(0)
