/*
 * @(#)Gray16_DstData.h	1.7 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#define SHORT_NORM_SCALE     0xffff
#define SHORT_NORM_SCALE_R   19532
#define SHORT_NORM_SCALE_G   38807
#define SHORT_NORM_SCALE_B   7196
#define NORM_SCALE           255
#define NORM_SCALE_R         76
#define NORM_SCALE_G         151
#define NORM_SCALE_B         28

#define DeclareDst                                                      \
     unsigned short *dstPtr;
     
#define InitDst                                                         \
do {                                                                    \
    dstPtr = dstBase;							\
    dstScanStr -= width;                                                \
} while(0)

#define ReadDstPixel(dA, dR, dG, dB)                                    \
do {                                                                    \
    dA = 0xffff;          						\
    dR = dG = dB = *dstPtr;                                             \
}while (0);

#define PrepColorDst							\
   unsigned short colorPrep = *dstPtr;

#define CopyColorToDst                                                  \
do {                                                                    \
    *dstPtr = colorPrep;                                                \
} while (0)


#define WriteDstPixel(dA, dR, dG, dB)                                   \
do {                                                                    \
    if (dA) {                                                           \
        unsigned int tmp;                                               \
        dR = (dR * SHORT_NORM_SCALE_R) / dA;                            \
        dG = (dG * SHORT_NORM_SCALE_G) / dA;                            \
        dB = (dB * SHORT_NORM_SCALE_B) / dA;                            \
        tmp = (dR&0xffff) + (dG&0xffff) + (dB&0xffff);                  \
        if (tmp > SHORT_NORM_SCALE) tmp = SHORT_NORM_SCALE;             \
        *dstPtr = tmp;                                                  \
    } else {                                                            \
        *dstPtr = 0;                                                    \
    }                                                                   \
} while(0)

#define NextDstPixel                                                    \
do {                                                                    \
    dstPtr++;                                                           \
} while(0)

#define NextDstRow                                                      \
do {                                                                    \
    dstPtr += dstScanStr;                                               \
} while(0)
