/*
 * @(#)S555_DstData.h	1.10 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 * @author Charlton Innovations, Inc.
 */

#define NORM_SCALE   255

#define DeclareDst                                                      \
     unsigned short *dstPtr;                                             

#define InitDst                                                         \
do {                                                                    \
    dstPtr = dstBase;							\
    dstScanStr -= width * dstPixStr;                                    \
} while(0)

#define ReadDstPixel(dA, dR, dG, dB)                                    \
do {                                                                    \
    unsigned short tmp;							\
    tmp = *dstPtr;							\
    dA = 255;		  						\
    dB = ((tmp & 0x001f) <<  3) | ((tmp & 0x001f) >> 2);                \
    dG = ((tmp & 0x03E0) >>  2) | ((tmp & 0x03E0) >> 7);                \
    dR = ((tmp & 0x7C00) >>  7) | ((tmp & 0x7C00) >> 12);               \
}while (0);

#define PrepColorDst							\
   unsigned short colorPrep = (((colorBlue*extraAlpha)/255) >> 3) |     \
                              ((((colorGreen & 0xf8)*extraAlpha)/255) << 2) |\
                              ((((colorRed & 0xf8)*extraAlpha)/255) << 7);

#define CopyColorToDst                                                  \
do {                                                                    \
    *dstPtr = colorPrep;                                                \
} while (0)

#define WriteDstPixel(dA, dR, dG, dB)                                   \
do {                                                                    \
    if (dA) {                                                           \
        if (dA < NORM_SCALE) {                                          \
            dR = (dR * NORM_SCALE) / dA;                                \
            dG = (dG * NORM_SCALE) / dA;                                \
            dB = (dB * NORM_SCALE) / dA;                                \
        }                                                               \
        *dstPtr = (((dB >> 3)) |                                        \
                   ((dG & 0xf8) <<  2) |                                \
                   ((dR & 0xf8) <<  7));				\
    } else {                                                            \
        *dstPtr = 0;                                                    \
    }                                                                   \
} while(0)

#define NextDstPixel                                                    \
do {                                                                    \
    dstPtr++;                                                           \
} while(0)

#define NextDstRow                                                      \
do {                                                                    \
    dstPtr += dstScanStr;                                               \
} while(0)
