/*
 * @(#)XBGR_DstData.h	1.15 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#define NORM_SCALE 255

#define DeclareDst                                                      \
     unsigned int *dstPtr;

#define InitDst                                                         \
do {                                                                    \
    dstPtr = dstBase;							\
    dstScanStr -= width * dstPixStr;                                    \
} while(0)

#define ReadDstPixel(dA, dR, dG, dB)                                    \
do {                                                                    \
    unsigned int tmp;							\
    tmp = *dstPtr;							\
    dA = 255;		  						\
    dB = (tmp >> 16) & 0xff;						\
    dG = (tmp >>  8) & 0xff;						\
    dR = (tmp >>  0) & 0xff;						\
}while (0);

#define PrepColorDst							\
unsigned int colorPrep = (((colorBlue*extraAlpha)/255) << 16) |         \
                         (((colorGreen*extraAlpha)/255) << 8) |         \
                         ((colorRed*extraAlpha)/256);

#define CopyColorToDst                                                  \
do {                                                                    \
    *dstPtr = colorPrep;                                                \
} while (0)

#define WriteDstPixel(dA, dR, dG, dB)                                   \
do {                                                                    \
    if (dA) {                                                           \
        if (dA < NORM_SCALE) {                                          \
            dR = (dR * NORM_SCALE) / dA;                                \
            dG = (dG * NORM_SCALE) / dA;                                \
            dB = (dB * NORM_SCALE) / dA;                                \
        }                                                               \
        *dstPtr = (((dB & 0xff) << 16) |				\
                   ((dG & 0xff) <<  8) |				\
                   ((dR & 0xff) <<  0));				\
    } else {                                                            \
        *dstPtr = 0;                                                    \
    }                                                                   \
} while(0)

#define NextDstPixel                                                    \
do {                                                                    \
    dstPtr++;                                                           \
} while(0)

#define NextDstRow                                                      \
do {                                                                    \
    dstPtr += dstScanStr;                                               \
} while(0)
