/*
 * @(#)SpanIterator.h	1.4 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 * This structure defines the methods used to communicate with a
 * Java SpanIterator at the native level.
 */
typedef struct {
    /**
     * Init and return native data
     */
    void     *(*open)(JNIEnv *env, jobject iterator);

    /**
     * End iteration, dispose data
     */
    void      (*close)(JNIEnv *env, void *clientData);

    /**
     * See PathIterator.getPathBox
     */
    void      (*getPathBox)(JNIEnv *env, void *clientData, jint pathbox[]);

    /**
     * See PathIterator.nextSpan
     */
    jboolean  (*nextSpan)(JNIEnv *env, void *clientData, jint spanbox[]);

    /**
     * See PathIterator.skipDownTo
     */
    void      (*skipDownTo)(JNIEnv *env, void *clientData, jint y);
} SpanIteratorFuncs;
