/*
 * @(#)TestApplet.java	1.13 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
import java.applet.*;
import java.awt.*;

public class TestApplet extends Applet {
    OutputHandler outh = new NullOutput();

    public TestApplet() {
    }

    public void print(String s) {
	if (outh instanceof NullOutput) {
	    try {
		AppletContext appCtxt = getAppletContext();

		if (appCtxt != null) {
		    Applet app = getAppletContext().getApplet("Output");

		    if (app != null && app instanceof OutputHandler) {
			outh = (OutputHandler)app;
			outh.setTitle("*" + getClass().getName() + " Output*");
		    }
		}
	    } catch (NullPointerException e) {
	    }
	}
	outh.print(s);
    }

    public void destroy() {
	if (outh instanceof Applet) {
	    ((Applet)outh).destroy();
	}
    }

    public void paint(Graphics g) {
	Dimension s = size();
	g.setColor(Color.black);
	g.drawRect(0, 0, s.width - 1, s.height - 1);
    }

    public Insets insets() {
	return new Insets(2, 2, 2, 2);
    }
}

class NullOutput implements OutputHandler {
    public void setTitle(String s) {
	System.out.println(s);
    }
    public void print(String s) {
	System.out.println(s);
    }
}
