/*
 * @(#)BlinkWriter.java	1.6 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/**
 * Create a Blink instance and serialize it out
 */

import java.applet.*;
import java.io.*;

public class BlinkWriter {
    public static void main(String args[]) {
	if (args.length != 1) {
	    throw new Error("wrong # of args");
	}

	String filename = args[0];
	ClassLoader cl = BlinkWriter.class.getClassLoader();

	try {
	    Applet applet = (Applet) java.beans.Beans.instantiate(cl, "Blink");
	    // instantiate does an init(), but not a start().
	    OutputStream os = new FileOutputStream(filename);
	    ObjectOutputStream oos = new ObjectOutputStream(os);
	    oos.writeObject(applet);
	    oos.close();
	    System.err.println("BlinkWriter: wrote Blink applet");
	    applet.destroy();
	    System.exit(0);
	} catch (Exception e) {
	    System.err.println("caught an exception "+e);
	    e.printStackTrace();
	}
    }
}
