/*
 * @(#)FontTransforms.java	1.4 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

import java.awt.*;
import java.awt.font.*;
import java.awt.geom.*;
import java.awt.event.*;

public class FontTransforms extends Canvas {

    public FontTransforms() {
        setBackground(Color.white);
    }

    public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;
        int w = getSize().width;
        int h = getSize().height;
        Font font = new Font("serif", Font.PLAIN, 72);
        // rotated
        AffineTransform at = new AffineTransform();
        at.translate(w/4, h*0.4);
        at.rotate(Math.toRadians(15));
        Font f2 = font.deriveFont(at);
        g2.setFont(f2);
        g2.setColor(Color.red);
        g2.drawString("JavaFont", 0, 0);
        // normal (graphics2D rotation)
        g2.setTransform(at);
        g2.setFont(font);
        g2.setColor(Color.black);
        g2.drawString("JavaFontTest", 0, 5);
        // textLayout (graphics2D rotation)
        TextLayout tl = new TextLayout("JavaFont", font, g2.getFontRenderContext());
        g2.setColor(Color.blue);
        tl.draw(g2, 0, 10);
        g2.setColor(Color.green);
        g2.fill(tl.getOutline(null, 0, 15));
//        g2.setColor(Color.green);
//        g2.drawString("Java", 0, 0);
    }

    public static void main(String s[]) {
        WindowListener l = new WindowAdapter() {
            public void windowClosing(WindowEvent e) {System.exit(0);
            }
        };
        Frame f = new Frame("Java2D Demo - test");
        f.addWindowListener(l);
        f.add("Center", new FontTransforms());
        f.pack();
        f.setSize(new Dimension(400,300));
        f.show();
    }
}
