/*
 * @(#)LineDistTest.java	1.7 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

import java.applet.Applet;
import java.awt.Frame;
import java.awt.Dimension;
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.geom.Line2D;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseEvent;

public class LineDistTest extends Applet implements MouseMotionListener {
    public LineDistTest() {
	addMouseMotionListener(this);
	setPoint(x0, y1);
    }

    public static void main(String argv[]) {
	Frame f = new Frame();
	f.add(new LineDistTest());
	f.pack();
	f.show();
    }

    int x0 = 50;
    int y0 = 50;
    int x1 = 150;
    int y1 = 150;
    int px, py;
    int sx = 10;
    int sy = 20;
    int sy2 = 40;
    int sy3 = 170;
    int sy4 = 190;
    double segdist;
    double lindist;

    public Dimension getPreferredSize() {
	return new Dimension(200, 200);
    }

    public static double round(double val) {
	return Math.round(val * 1000.0) / 1000.0;
    }

    public void setPoint(int x, int y) {
	px = x;
	py = y;
	segdist = round(Line2D.ptSegDist(x0, y0, x1, y1, px, py));
	lindist = round(Line2D.ptLineDist(x0, y0, x1, y1, px, py));
	repaint();
    }

    public void mouseDragged(MouseEvent e) {
	setPoint(e.getX(), e.getY());
    }

    public void mouseMoved(MouseEvent e) {}

    public static String label1 = "distance to segment";
    public static String label2 = "distance to line";

    public void paint(Graphics g) {
	g.drawString("point = ("+px+", "+py+")", sx, sy);
	g.drawString("click to drag test point", sx, sy2);
	FontMetrics fm = g.getFontMetrics();
	int vx = Math.max(fm.stringWidth(label1),
			  fm.stringWidth(label2));
	g.drawString(label1, sx, sy3);
	g.drawString(" = "+segdist, sx + vx, sy3);
	g.drawString(label2, sx, sy4);
	g.drawString(" = "+lindist, sx + vx, sy4);
	g.setColor(Color.red);
	g.drawLine(x0, y0, x1, y1);
	g.setColor(Color.green);
	g.drawLine(px, py-1, px, py+1);
	g.drawLine(px-1, py, px+1, py);
    }
}
