/*
 * @(#)Bug.java	1.4 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

import java.awt.*;
import java.awt.image.*;
import java.awt.color.ColorSpace;

public class Bug extends Canvas {
  private BufferedImage image;

  public Bug(boolean withAlpha) {
    DirectColorModel cm = new
      DirectColorModel(ColorSpace.getInstance(ColorSpace.CS_sRGB), 
		       withAlpha ? 32 : 24,
		       withAlpha ? 0xFF000000 : 0xFF0000,
		       withAlpha ? 0x00FF0000 : 0x00FF00,
		       withAlpha ? 0x0000FF00 : 0x0000FF,
		       withAlpha ? 0x000000FF : 0,
		       true);
    
 
    WritableRaster myRaster = cm.createCompatibleWritableRaster(103, 67);

    image = new BufferedImage(cm, myRaster, true);
    setSize(image.getWidth(), image.getHeight());
  }
    
  public void paint(Graphics g) {
    if (image != null) {
      g.drawImage(image, 0, 0, null);
    }
  }

  public static void main(String args[]) {
    Bug imageCanvas = new Bug(args.length != 0);

    Frame f = new Frame();

    f.add(imageCanvas);
    f.pack();
    f.validate();
    f.setVisible(true);
  }
    
}
