/*
 * @(#)TabManager.java	1.5 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.table.*;
import java.io.*;
import java.util.Vector;
import java.util.Date;


/**
 * Tabs for the test suite.
 *
 * @version @(#)TabManager.java	1.5 00/02/02
 * @author Brian Lichtenwalter
 */

public class TabManager extends JPanel implements ActionListener {

    static JTabbedPane tabbedPane;
    private JMenuItem introMI;

   /** 
    * The GUI with all the tabs
    */
    public TabManager() {
	setLayout(new BorderLayout());
        EmptyBorder eb = new EmptyBorder(5,5,5,5);
        SoftBevelBorder sbb = new SoftBevelBorder(BevelBorder.RAISED);
	setBorder(new CompoundBorder(eb, new BevelBorder(BevelBorder.LOWERED)));

        tabbedPane = new JTabbedPane();
	tabbedPane.setFont(new Font("TimesRoman", Font.PLAIN, 10));
	tabbedPane.addTab("Tests", new SelectionInterface());
        tabbedPane.addTab("Run", new RunInterface());
        tabbedPane.addTab("Controls", new ControlsInterface());
        tabbedPane.addTab("JarFiles", new JarFilesInterface());
        tabbedPane.addTab("Help", new HelpTextArea());
	add(tabbedPane);

	JMenuBar menuBar = new JMenuBar();
	JMenu options = (JMenu) menuBar.add(new JMenu("Options"));
        introMI = (JMenuItem) options.add(new JMenuItem("Intro"));
	introMI.addActionListener(this);
	add("North", menuBar);
    }


    public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(introMI)) { 
            TestProduct.group = null;
	    TestProduct.panel.removeAll();
	    TestProduct.panel.add(TestProduct.intro);
	    TestProduct.panel.validate();
	}
    }


    public class HelpTextArea extends JPanel {

        String s =  " Java2D TestProduct Help \n\n" +
	    " 1. To omit any controls for running or JarFile Creation,\n" +
	    "     click on the checkbox next to the control.\n" + 
	    " 2. To omit any tests for running or JarFile Creation\n" +
	    "     goto the 'Tests' tab, select the checkbox at the \n" +
	    "     bottom, choose the tests you do not want. \n" +
	    " 3. Generate the 'JarFiles' with the selected Controls.\n" +
	    "      Select the green button named 'Generate JarFiles'.\n" +
	    " 4. Wait until JarFile creation is completed before running.\n" +
	    " 5. Visit the 'Run' tab and click the run button. \n\n" +
	    " To run TestProduct in automation mode from the prompt:\n\n" +
	    "     java TestProduct -run -nogui -jtag=winNT.A -rfile=winNT.B\n\n" +
	    " All launch parameters : \n" +
            "     -run             start running.\n" +
            "     -jtag=winNT.A    the jarfiles tag for generation & running\n" +
            "     -rfile=winNT.B   the result file\n" + 
            "     -jfgeneration    Generate JarFiles of DataBuffers per Controls.\n" +
            "     -delay=10        the delay between tests.\n" +
            "     -nogui           run w/o any graphic user interface.\n"+
	    "     -print           print test to default printer.\n" +
            "     -exit            explicitly exit; -nogui triggers it.\n";


	public HelpTextArea() {
	    setLayout(new BorderLayout());
	    setBorder(new EmptyBorder(5,5,5,5));
	    JTextArea textarea = new JTextArea(s);
	    textarea.setMinimumSize(new Dimension(300,500));
            textarea.setEditable(false);
	    JScrollPane scroller = new JScrollPane();
	    scroller.getViewport().add(textarea);
	    add(scroller);
	}
    }

}
