/*
 * @(#)TestImages.java	1.5 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */


import java.awt.*;
import java.awt.image.*;
import java.net.URL;
import java.io.File;
import java.util.Hashtable;


/**
 * A cache of all the demo images found in the images directory.
 *
 * @version @(#)TestImages.java	1.5 00/02/02
 * @author Brian Lichtenwalter
 */

public class TestImages extends Component {

    private static Hashtable cache;

    public TestImages() {
        URL url = TestImages.class.getResource("images");
        File dir = new File(url.getFile());
        if (dir != null && dir.isDirectory()) {
            String list[] = dir.list();
            cache = new Hashtable(list.length);
            for (int i = 0; i < list.length; i++) {
                cache.put(list[i], getImage(list[i], this));
            }
        }
    }


    public static Image getImage(String name, Component cmp) {
        Image img = null;
        if (cache != null) {
            if ((img = (Image) cache.get(name)) != null) {
                return img;
            }
        }
        URL url = TestImages.class.getResource("images/" + name);
        img = cmp.getToolkit().createImage(url);
        MediaTracker tracker = new MediaTracker(cmp);
        tracker.addImage(img, 0);
        try {
            tracker.waitForID(0);
            if (tracker.isErrorAny()) {
                System.out.println("Error loading image " + name);
            }
        } catch (Exception ex) { ex.printStackTrace(); } 
        return img;
    }
}
