/*
 * @(#)TestPanel.java	1.6 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */


import java.awt.*;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.border.SoftBevelBorder;
import javax.swing.border.CompoundBorder;


/**
 * The panel for the TestSurface & ToolBar.
 *
 * @version @(#)TestPanel.java	1.6 00/02/02
 * @author Brian Lichtenwalter
 */

public class TestPanel extends JPanel {

    public TestSurface surface;
    public ToolBar toolbar;
    public String className;


    public TestPanel(Object obj) {
        setLayout(new BorderLayout());
        try {
            if (obj instanceof String) {
                className = (String) obj;
                String name = className.replace('/','.').replace('\\','.');
                obj = Class.forName(name).newInstance();
            }
            if (obj instanceof TestSurface) {
                add(surface = (TestSurface) obj);
                add("South", toolbar = new ToolBar(surface));
            } else if (obj instanceof Component) {
                add((Component) obj);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
