#!/bin/csh

if ($#argv < 2) then
    echo ""
    echo "usage: $0 jarfiletag runfilename"
    echo ""
    echo "Example :"
    echo "%$0 Sol7.E Sol7.F"
    echo ""
    set jartag = `uname``uname -r`
    set rfile  = `uname``uname -r`
else
    set jartag = $argv[1]
    set rfile  = $argv[2]
endif


set PREVBUILD = /usr/local/java/jdk1.3bak/solaris
echo $PREVBUILD/bin/java TestProduct -jtag=$jartag -jfgeneration -nogui
$PREVBUILD/bin/java TestProduct -jtag=$jartag -jfgeneration -nogui

set CURRBUILD = /usr/local/java/jdk1.3/solaris
echo $CURRBUILD/bin/java TestProduct -jtag=$jartag -rfile=$rfile -run -nogui
$CURRBUILD/bin/java TestProduct -jtag=$jartag -rfile=$rfile -run -nogui

head -5 results/$rfile >! test.runs.txt
tail -4 results/$rfile >> test.runs.txt
echo " " >> test.runs.txt
echo "Results at:" >> test.runs.txt
echo $PWD/results/$rfile >> test.runs.txt
set email = "${user}@eng.sun.com"
cat test.runs.txt | mailx -s "TestProduct Results `uname` `uname -r`" $email
rm -rf test.runs.txt
