/*
 * @(#)Images_SrcOver.java	1.6 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)Images_SrcOver.java	1.6    00/02/02
 * @summary - Shows nine different duke images with ascending SRC_OVER
 * composite values.
 */

package tests.AlphaComposite;

import java.awt.*;
import java.awt.geom.*;
import TestSurface;


public class Images_SrcOver extends TestSurface {

    private int numImgs = 9;
    private Image imgs[];
    private Color colors[] = { Color.blue, Color.cyan, Color.green,  
                        Color.magenta, Color.orange, Color.pink, 
                        Color.red, Color.yellow, Color.lightGray };

    public Images_SrcOver() {
        String s[] = { "box", "fight", "magnify", 
                        "boxwave", "globe", "snooze",
                        "tip", "thumbsup", "dukeplug"};
        imgs = new Image[numImgs];
        for (int i = 0; i < imgs.length; i++) {
            imgs[i] = getImage(s[i] + ".gif");
        }
    }


    public void render(int w, int h, Graphics2D g2) {
        float alpha = 0.0f;
        int iw = w/3;
        int ih = (h-45)/3;
        float xx = 0, yy = 15;
        for (int i =0; i < imgs.length; i++) {
            xx = (i%3 == 0) ? 0 : xx+w/3;
            switch (i) {
                case 3 : yy = h/3+15; break;
                case 6 : yy = h/3*2+15;
            }
            g2.setComposite(AlphaComposite.SrcOver);
            AlphaComposite ac = AlphaComposite.getInstance(AlphaComposite.SRC_OVER, alpha += .1f);
            Shape shape=null;
            switch (i%3) {
                case 0 : shape = new Ellipse2D.Float(xx, yy, iw, ih); break;
                case 1 : shape = new RoundRectangle2D.Float(xx, yy, iw, ih, 25, 25);
                        break;
                case 2 : shape = new Rectangle2D.Float(xx, yy, iw, ih);
            }
            g2.setColor(colors[i]);
            g2.setComposite(ac);
            g2.fill(shape);
            g2.drawImage(imgs[i], (int) xx, (int) yy, iw, ih, this);
        }
    }

    public static void main(String s[]) {
        createFrame("Images_SrcOver", new Images_SrcOver());
    }
} 
