/*
 * @(#)Rects_SrcOver.java	1.6 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)Rects_SrcOver.java	1.6    00/02/02
 * @summary - SRC_OVER composite with different colored rects.
 */

package tests.AlphaComposite;

import java.awt.*;
import java.awt.geom.GeneralPath;
import java.awt.geom.AffineTransform;
import TestSurface;


public class Rects_SrcOver extends TestSurface {

    public void render(int w, int h, Graphics2D g2) {
        int size = Math.min(w, h) / 3;
        g2.setColor(Color.red);
        g2.translate(w/2,h/4);
        g2.rotate((45*java.lang.Math.PI)/180); 
        g2.fillRect(0,0,size,size);
        g2.setTransform(new AffineTransform());

        AlphaComposite ac = AlphaComposite.getInstance(AlphaComposite.SRC_OVER,0.5f);
        g2.setComposite(ac);
        g2.setColor(Color.green);
        g2.fillRect(w/2-size/2,h/4-size/2,size,size);
        g2.setColor(Color.blue);
        g2.fillRect(w/2+size/4,h/4+size/4,size,size);
        g2.setColor(Color.yellow);
        g2.fillRect(w/2-size/2,h/4+size-size/4,size,size);
        g2.setColor(Color.pink);
        g2.fillRect(w/2-size-size/4,h/4+size/4,size,size);
    }


    public static void main(String s[]) {
        createFrame("Rects_SrcOver", new Rects_SrcOver());
    }
}
