/*
 * @(#)Rules.java	1.7 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)Rules.java	1.7    00/02/02
 * @summary - All the AlphaCompositing Rules.
 */


package tests.AlphaComposite;

import java.awt.*;
import java.awt.image.BufferedImage;
import TestSurface;


public class Rules extends TestSurface {

    private static int compRules[] = {
        AlphaComposite.SRC,
        AlphaComposite.SRC_OVER,
        AlphaComposite.SRC_IN,
        AlphaComposite.SRC_OUT,
        AlphaComposite.CLEAR,
        AlphaComposite.DST_OVER,
        AlphaComposite.DST_IN,
        AlphaComposite.DST_OUT
    };


    public void render(int w, int h, Graphics2D g2) {

        int PADLEFT  = 15;
        int PADRIGHT = 20;
        int HPAD     = (PADLEFT + PADRIGHT);
        int PADABOVE = 14;
        int PADBELOW = 12;
        int VPAD     = (PADABOVE + PADBELOW);
        int RECTWIDTH = w/2 - HPAD;
        int RECTHEIGHT = (h-PADABOVE)/4 - VPAD + 2;
        int PADDEDWIDTH  = (RECTWIDTH  + HPAD);
        int PADDEDHEIGHT = (RECTHEIGHT + VPAD);

        int x = 0, y = 0;

        for (int i = 0; i < compRules.length; i++) {
            y = (i == 0 || i == 4) ? PADABOVE : y + PADDEDHEIGHT;
            x = (i >= 4) ? w/2+PADLEFT : PADLEFT;
            g2.translate(x, y);
            g2.setComposite(AlphaComposite.Src);
            g2.setColor(Color.red);
            g2.fillRect(0, 0, RECTWIDTH, RECTHEIGHT);
            g2.setComposite(AlphaComposite.getInstance(compRules[i], 0.5f));
            g2.setColor(Color.blue);
            g2.fillRect(8, 8, RECTWIDTH, RECTHEIGHT);
            g2.translate(-x, -y);
        }
    }


    public static void main(String s[]) {
        createFrame("Rules", new Rules());
    }
} 
