/*
 * @(#)NativeWin32Clear.java	1.5 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type REGRESSION
 * @test @(#)NativeWin32Clear.java	1.5	00/02/02
 * @bug 4216180 win32 background changes to lightGray w/ AA-off & ... 
 * @summary This test verifies that Graphics2D.setBackground and clearRect
 * performs correctly on win32.  The entire surface area should be green.
 */


package tests.ClearRect;

import java.awt.*;
import TestSurface;


public class NativeWin32Clear extends TestSurface {
    
    public void render(int w, int h, Graphics2D g2) {
        g2.setBackground(Color.green);
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, 
                            RenderingHints.VALUE_ANTIALIAS_ON);
        g2.clearRect(0, 0, w/2, h);
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, 
                            RenderingHints.VALUE_ANTIALIAS_OFF);
        g2.clearRect(w/2, 0, w/2, h);
    }

    public static void main(String s[]) {
        createFrame("NativeWin32Clear", new NativeWin32Clear());
    }
}
