/*
 * @(#)PathClipLines.java	1.5 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)PathClipLines.java	1.5    00/02/02
 * @summary - Clip lines with a GeneralPath
 */

package tests.Clipping;

import java.awt.*;
import java.awt.geom.GeneralPath;
import TestSurface;


public class PathClipLines extends TestSurface {

    public void render(int w, int h, Graphics2D g2) {

        GeneralPath p = new GeneralPath();
        p.moveTo(- w / 2.0f, - h / 8.0f);
        p.lineTo(+ w / 2.0f, - h / 8.0f);
        p.lineTo(- w / 4.0f, + h / 2.0f);
        p.lineTo(+         0.0f, - h / 2.0f);
        p.lineTo(+ w / 4.0f, + h / 2.0f);
        p.closePath();

        Rectangle rect1 = new Rectangle(10, 10, w-20, h-20);
        g2.setClip(rect1);
        g2.translate(w/2, h/2);
        g2.clip(p);
        g2.translate(-w/2, -h/2);

        g2.setColor(Color.gray);
        g2.fill(rect1);

        Color colors[] = { Color.red, Color.white, Color.blue };
        for (int j = 0; j < h; j+=5) {
            g2.setColor(colors[j%colors.length]);
            g2.drawLine(0,j,w,j);
        }
        for (int j = 0; j < w; j+=5) {
            g2.setColor(colors[j%colors.length]);
            g2.drawLine(j,0,j,h);
        }

        g2.setClip(new Rectangle(0,0,w,h));
        g2.setColor(Color.black);
        g2.draw(rect1);
    }


    public static void main(String s[]) {
        createFrame("PathClipLines", new PathClipLines());
    }
} 
