/*
 * @(#)SubPaths.java	1.5 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)SubPaths.java	1.5    00/02/02
 * @summary - Clipping an image with shapes appended to a path.
 */

package tests.Clipping;

import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import TestSurface;


public class SubPaths extends TestSurface {

    public void render(int w, int h, Graphics2D g2) {
        Image img = getImage("clouds.jpg");
        GeneralPath p = new GeneralPath(GeneralPath.WIND_EVEN_ODD);
        for (int i = 0; i < 3; i++) 
            p.append(new Rectangle(w/8+(i*w/4),h/8+(i*h/4),w/4,h/4), false);
        for (int i = 1; i < 3; i++)
            p.append(new Ellipse2D.Float(w/8+(i*w/4),h/8,w/4,h/4), false);
        for (int i = 0; i < 3; i++)
            p.append(new Arc2D.Float(5+w/8+(i*w/4),h/8+h/4,w/4,h/4,45,270, Arc2D.PIE), false);
        for (int i = 0; i < 2; i++)
            p.append(new Ellipse2D.Float(w/8+(i*w/4),h/8+h/2,w/4,h/4), false);
        g2.setClip(p);
        g2.drawImage(img,0,0,w,h,this);
        g2.setClip(new Rectangle(0,0,w,h));
        Color colors[] = { Color.green.darker(), Color.lightGray, Color.black };
        for (int i = 0, j = 7; i < colors.length; i++, j -= 3) {
            g2.setColor(colors[i]);
            g2.setStroke(new BasicStroke((float) j));
            g2.draw(p);
        }
    }


    public static void main(String s[]) {
        createFrame("SubPaths", new SubPaths());
    }
} 
