/*
 * @(#)RGB_to_GRAY.java	1.6 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)RGB_to_GRAY.java	1.6    00/02/02
 * @summary - ColorConvertOp a ColorSpace.TYPE_RGB BufferedImage to a 
 * ColorSpace.CS_GRAY BufferedImage.
 */

package tests.Color;

import java.awt.*;
import java.awt.geom.Rectangle2D;
import java.awt.color.ColorSpace;
import java.awt.image.BufferedImage;
import java.awt.image.ColorConvertOp;
import TestSurface; 


public class RGB_to_GRAY extends TestSurface {

    public void render(int w, int h, Graphics2D g2) {

        Image img = getImage("clouds.jpg");
        int iw = img.getWidth(this);
        int ih = img.getHeight(this);

        BufferedImage srcImg = new BufferedImage(iw, ih, BufferedImage.TYPE_INT_RGB);
        Graphics2D srcG = srcImg.createGraphics();
        RenderingHints rhs = g2.getRenderingHints();
        srcG.setRenderingHints(rhs);
        srcG.drawImage(img, 0, 0, null);

        Color colors[] = { Color.red, Color.pink, Color.orange, Color.yellow, 
                   Color.green, Color.magenta, Color.cyan, Color.blue};
        int rw = iw/colors.length;
        int rh = ih/colors.length;
        for (int i = 0; i < colors.length; i++) {
            srcG.setColor(colors[i%colors.length]);
            srcG.fillRect(i*rw, ih-rh, rw, rh);
            srcG.setColor(colors[colors.length-1-i%colors.length]);
            srcG.fillRect(i*rw, 0, rw, rh);
        }

        ColorSpace cs = ColorSpace.getInstance(ColorSpace.CS_GRAY);
        ColorConvertOp theOp = new ColorConvertOp(cs, rhs);

        BufferedImage dstImg = 
                new BufferedImage(iw, ih, BufferedImage.TYPE_INT_RGB);
        theOp.filter(srcImg, dstImg);

        g2.drawImage(srcImg, 10, 10, w/2-20, h-20, this);
        g2.drawImage(dstImg, w/2+10, 10, w/2-20, h-20, this);
    }


    public static void main(String s[]) {
        createFrame("RGB_to_GRAY", new RGB_to_GRAY());
    }
}
