/*
 * @(#)CopyNegative.java	1.6 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type REGRESSION
 * @test @(#)CopyNegative.java	1.6    00/02/02
 * @bug 4188744 Graphics.CopyArea copies incorrectly when values are negative 
 *               [JDK 1.1.x okay]
 * @summary This test verifies that copyArea performs correctly for negative 
 * offset values. The correct output shows that the text area is moved to the 
 * left and down, there should be a green rect in the lower left corner. 
 * The problem appears when rendering into a offscreen graphics, BufferedImage.
 */

package tests.CopyArea;

import java.awt.*;
import TestSurface;


public class CopyNegative extends TestSurface {
    
    public void render(int w, int h, Graphics2D g2) {
        int w2 = w/2, h2 = h/2;
        g2.setColor(Color.black);
        g2.fillRect(0, 0, w2, h2);
        g2.setColor(Color.red);
        g2.fillRect(w2, 0, w2, h2);
        g2.setColor(Color.green);
        g2.fillRect(0, h2, w2, h2);
        g2.setColor(Color.blue);
        g2.fillRect(w2, h2, w2, h2);
        g2.copyArea(0, 0, w, h, -3, 3);
        for (int i = 0; i < 20; i++) {
            g2.copyArea(0, 0, w, h, -3, 3);
        }
    }

    public static void main(String s[]) {
        createFrame("CopyNegative", new CopyNegative());
    }
}
