/*
 * @(#)AttributedStr.java	1.5 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)AttributedStr.java	1.5    00/02/02
 * @summary - Rendering text as an outline shape.
 */

package tests.Font;

import java.awt.*;
import java.awt.geom.AffineTransform;
import java.awt.font.TextAttribute;
import java.awt.font.TextLayout;
import java.awt.font.FontRenderContext;
import java.text.AttributedString;
import java.text.AttributedCharacterIterator;
import TestSurface;


public class AttributedStr extends TestSurface {

    public void render(int w, int h, Graphics2D g2) {

        FontRenderContext frc = g2.getFontRenderContext();
        Font f = new Font("serif",Font.PLAIN,24);
        Font f1 = new Font("serif",Font.ITALIC,32);
        String s = "Plain24 Italic32";
        AttributedString as = new AttributedString(s);
        as.addAttribute(TextAttribute.FONT, f, 0, 7 );
        as.addAttribute(TextAttribute.FONT, f1, 7, s.length() );
        as.addAttribute(TextAttribute.JUSTIFICATION,
                        TextAttribute.JUSTIFICATION_FULL, 0, s.length());
        AttributedCharacterIterator aci = as.getIterator();
        TextLayout tl = new TextLayout(aci, frc);
        float sw = (float) tl.getBounds().getWidth();
        g2.setColor(Color.black);
        tl.draw(g2, w/2-sw/2, h*0.25f);

        f = new Font("serif", Font.BOLD,w/6);
        s = "UnderLine";
        as = new AttributedString(s);
        as.addAttribute(TextAttribute.FONT, f, 0, s.length() );
        as.addAttribute(TextAttribute.UNDERLINE,
                        TextAttribute.UNDERLINE_ON, 0, s.length());
        as.addAttribute(TextAttribute.FOREGROUND,
                        Color.red, 0, 5);
        as.addAttribute(TextAttribute.FOREGROUND,
                        Color.blue, 5, s.length());
        as.addAttribute(TextAttribute.BACKGROUND,
                        Color.lightGray, 0, s.length());
        as.addAttribute(TextAttribute.WEIGHT,
                        TextAttribute.WEIGHT_LIGHT, 0, 5);
        as.addAttribute(TextAttribute.WEIGHT,
                        TextAttribute.WEIGHT_ULTRABOLD, 5, s.length());
        tl = new TextLayout(as.getIterator(), frc);
        sw = (float) tl.getBounds().getWidth();
        tl.draw(g2, w/2-sw/2,h*0.55f);

        f = new Font("serif",Font.ITALIC,w/8);
        s = "SuperSubMIX";
        as = new AttributedString(s);
        as.addAttribute(TextAttribute.FONT, f, 0, s.length() );
        as.addAttribute(TextAttribute.SUPERSCRIPT,
                        TextAttribute.SUPERSCRIPT_SUB, 0, 5);
        as.addAttribute(TextAttribute.WIDTH,
                        TextAttribute.WIDTH_EXTENDED, 0, 5);
        as.addAttribute(TextAttribute.SUPERSCRIPT,
                        TextAttribute.SUPERSCRIPT_SUPER, 5, 8);
        as.addAttribute(TextAttribute.WIDTH,
                        TextAttribute.WIDTH_CONDENSED, 8, s.length());
        AffineTransform fontAT = new AffineTransform();
        fontAT.shear(+0.3, 0.0);
        fontAT.rotate(Math.toRadians(3));
        fontAT.scale(1.0, 1.5);
        as.addAttribute(TextAttribute.TRANSFORM, fontAT, 0, s.length());
        tl = new TextLayout(as.getIterator(), frc);
        sw = (float) tl.getBounds().getWidth();
        g2.setColor(Color.green);
        tl.draw(g2, w/2-sw/2,h*0.85f);
    }


    public static void main(String s[]) {
        createFrame("AttributedStr", new AttributedStr());
    }
}
