/*
 * @(#)Clipping.java	1.5 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)Clipping.java	1.5    00/02/02
 * @summary - Clipping an image, lines and text with text.
 */

package tests.Font;

import java.awt.*;
import java.awt.geom.Line2D;
import java.awt.geom.AffineTransform;
import java.awt.font.TextLayout;
import java.awt.font.FontRenderContext;
import TestSurface;


public class Clipping extends TestSurface {

    public void render(int w, int h, Graphics2D g2) {

        Image img = getImage("clouds.jpg");
        FontRenderContext frc = g2.getFontRenderContext();
        Font f = new Font("serif",Font.BOLD,w/6);
        String s = new String("Java 2D");
        TextLayout tl = new TextLayout(s, f, frc);
        float sw = (float) tl.getBounds().getWidth();
        float sh = (float) tl.getAscent();
        Shape shape = tl.getOutline(AffineTransform.getTranslateInstance(w/2-sw/2,h*0.25f));
        Rectangle r = shape.getBounds();
        g2.setColor(Color.gray);
        g2.draw(shape);
        g2.setClip(shape);
        g2.drawImage(img, r.x, r.y, r.width, r.height, this);

        f = new Font("serif",Font.BOLD,w/6);
        s = new String("T E X T");
        tl = new TextLayout(s, f, frc);
        sw = (float) tl.getBounds().getWidth();
        sh = (float) tl.getAscent();
        shape = tl.getOutline(AffineTransform.getTranslateInstance(w/2-sw/2,h/2));
        g2.setClip(shape);
        g2.setColor(Color.black);
        g2.fill(shape.getBounds());
        g2.setColor(Color.yellow);
        for (int j = shape.getBounds().y; j < shape.getBounds().y + shape.getBounds().height; j=j+3) {
            Line2D line = new Line2D.Float( 0.0f, (float) j, 
                                        (float) w, (float) j);
            g2.draw(line);
        }

        f = new Font("serif",Font.PLAIN,w/4);
        s = new String("FoNtS");
        tl = new TextLayout(s, f, frc);
        sw = (float) tl.getBounds().getWidth();
        shape = tl.getOutline(AffineTransform.getTranslateInstance(w/2-sw/2,h*0.85f));
        g2.setClip(shape);
        g2.setColor(Color.black);
        g2.fill(shape.getBounds());
        g2.setColor(Color.cyan);
        f = new Font("serif",Font.BOLD,10);
        tl = new TextLayout("java", f, frc);
        sw = (float) tl.getBounds().getWidth();

        r = shape.getBounds();
        int x = r.x;
        int y = r.y;
        while ( y < (r.y + r.height+(int) tl.getAscent()) ) {
            tl.draw(g2, x, y);
            if ((x += (int) sw) > (r.x+r.width)) {
                x = r.x;
                y += (int) tl.getAscent();
            }
        }
    }


    public static void main(String s[]) {
        createFrame("Clipping", new Clipping());
    }
}
