/*
 * @(#)Dynamic.java	1.3 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)Dynamic.java	1.3    00/02/02
 * @summary - Dynamic Font Loading
 */

package tests.Font;

import java.awt.*;
import java.awt.font.*;
import java.io.*;
import TestSurface;

public class Dynamic extends TestSurface {

    private Font font;

    public Dynamic() {
        try {
            InputStream is = Dynamic.class.getResourceAsStream("WINDWN__.TTF");
            font = Font.createFont(Font.TRUETYPE_FONT, is);
            font = font.deriveFont(Font.PLAIN, 36);
        } catch (Exception ex) { ex.printStackTrace(); }
    }

    public void render(int w, int h, Graphics2D g2) {
        String s = "AaBbCc";
        TextLayout tl = new TextLayout(s, font, g2.getFontRenderContext());
        double sh = (double) tl.getBounds().getHeight()+5.0;
        g2.setColor(Color.darkGray);
        tl.draw(g2, 5f, (float) sh);
        g2.setFont(font);
        g2.drawString(s, 5, (int) (sh*2));
        g2.drawChars(s.toCharArray(),0,s.length(),5,(int) (sh*3));
        g2.translate(5, sh*4);
        g2.fill(tl.getOutline(null));
    }

    public static void main(String s[]) {
        createFrame("Dynamic", new Dynamic());
    }
}
