/*
 * @(#)Outline.java	1.5 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)Outline.java	1.5    00/02/02
 * @summary - Rendering text as an outline shape.
 */

package tests.Font;

import java.awt.*;
import java.awt.geom.AffineTransform;
import java.awt.font.TextAttribute;
import java.awt.font.TextLayout;
import java.awt.font.FontRenderContext;
import java.awt.font.GlyphVector;
import TestSurface;


public class Outline extends TestSurface {

    public void render(int w, int h, Graphics2D g2) {
        FontRenderContext frc = g2.getFontRenderContext();
        Font f = new Font("serif",Font.PLAIN,w/10);
        GlyphVector gv = f.createGlyphVector(frc, "GlyphVector Outline");
        g2.setColor(Color.red);
        float sw = (float) gv.getOutline().getBounds().getWidth();
        g2.fill(gv.getOutline(w/2-sw/2, h*0.25f));

        TextLayout tl = new TextLayout("TextLayout Outline", f, frc);
        sw = (float) tl.getBounds().getWidth();
        AffineTransform outlineAT = new AffineTransform();
        outlineAT.translate(w/2-sw/2,h*0.55);
        outlineAT.scale(1.0,1.2);
        g2.setColor(Color.blue);
        g2.fill(tl.getOutline(outlineAT));

        f = new Font("serif",Font.ITALIC,w/8);
        AffineTransform fontAT = new AffineTransform();
        fontAT.shear(+0.3, 0.0);
        fontAT.rotate(Math.toRadians(3));
        fontAT.scale(1.0, 1.5);
        Font derivedFont = f.deriveFont(fontAT);
        tl = new TextLayout("Italic-Transform", derivedFont, frc);
        sw = (float) tl.getBounds().getWidth();
        g2.setColor(Color.green);
        g2.fill(tl.getOutline(AffineTransform.getTranslateInstance(w/2-sw/2,h*0.85f)));
    }


    public static void main(String s[]) {
        createFrame("Outline", new Outline());
    }
}
