/*
 * @(#)Concatenate.java	1.7 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)Concatenate.java	1.7    00/02/02
 * @summary - 
 */

package tests.Geom.AffineTransform;

import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import TestSurface;


public class Concatenate extends TestSurface {

    public void render(int w, int h, Graphics2D g2) {
        Object objects[] = new Object[3];
        objects[0] = new Rectangle(0, 0, w/2, h/2);
        objects[1] = getImage("star7.gif");
        objects[2] = new Ellipse2D.Float(0,0,w/3,w/3);

        for (int i = 0; i < objects.length; i++) {
            Rectangle r = null;
            if (objects[i] instanceof Image) {
                r = new Rectangle(0, 0, ((Image) objects[i]).getWidth(this),
                        ((Image) objects[i]).getHeight(this));
            } else {
                r = ((Shape) objects[i]).getBounds();
            }

            AffineTransform at = new AffineTransform();
            at.translate(w/2,h/2);
            at.rotate(Math.toRadians(15));
            switch (i) {
                case 0 : BufferedImage bi = new BufferedImage(5, 5, BufferedImage.TYPE_INT_RGB);
                         Graphics2D big = bi.createGraphics();
                         big.setColor(Color.yellow);
                         big.drawLine(0, 0, 5, 5);
                         g2.setPaint(new TexturePaint(bi, new Rectangle(0,0,5,5)));
                         at.scale(1.2, 1.2); break;
                case 1 : g2.setColor(Color.green);
                         at.scale(0.9, 0.9); break;
                case 2 : g2.setColor(Color.red);
                         at.scale(0.7, 0.7);
            }

            at.shear(0.2, 0.0); 

            AffineTransform toCenterAT = new AffineTransform();
            toCenterAT.concatenate(at);
            toCenterAT.translate(-(r.width/2), -(r.height/2));
            g2.setTransform(toCenterAT);

            if (objects[i] instanceof Image) {
                g2.drawImage((Image) objects[i], 0, 0, this);
            } else {
                g2.fill((Shape) objects[i]);
            }

        } 
    }

    public static void main(String s[]) {
        createFrame("Concatenate", new Concatenate());
    }
}
