/*
 * @(#)RotateShapes.java	1.6 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)RotateShapes.java	1.6    00/02/02
 * @summary - 
 */

package tests.Geom.AffineTransform;

import java.awt.*;
import java.awt.geom.*;
import java.awt.image.BufferedImage;
import TestSurface;


public class RotateShapes extends TestSurface {

    public void render(int w, int h, Graphics2D g2) {
        int x = 0, y = 0;
        int w4 = w/4, h4 = h/4;
        int w8 = w/8, h8 = h/8;
        String desc[] = { "Rectangle", "Ellipse", "Arc", "Multi" };
        double theta = Math.toRadians(15);
        for (int i = 0; i < desc.length; i++) {
            switch (i) {
                case 0 : x = 10; y = 15; break;
                case 1 : x = w/2+5; y = 15; break;
                case 2 : x = 10; y = h/2+15; break;
                case 3 : x = w/2+5; y = h/2+15;
            }
            g2.translate(x , y);

            switch (i) {
                case 0 : g2.drawRect(5,5,w4,h4);
                         g2.rotate(theta);
                         g2.setPaint(new GradientPaint(x,y,Color.blue,w8,y,Color.green));
                         g2.fillRect(5,5,w4,h4);
                         break;
                case 1 : g2.draw(new Ellipse2D.Float(5,5,w/3,h/6));
                         g2.setTransform(AffineTransform.getRotateInstance(theta,x,y));
                         g2.setColor(Color.cyan);
                         g2.fill(new Ellipse2D.Float(x+5,y+5,w/3,h/6));
                         break;
                case 2 : g2.draw(new Arc2D.Float(5,5,w4,h4,45,275,Arc2D.PIE));
                         g2.rotate(theta);
                         BufferedImage bi = new BufferedImage(5, 5, BufferedImage.TYPE_INT_RGB);
                         Graphics2D big = bi.createGraphics();
                         big.setColor(Color.red);
                         big.drawLine(0, 0, 5, 5);
                         g2.setPaint(new TexturePaint(bi, new Rectangle(0,0,5,5)));
                         g2.fill(new Arc2D.Float(5,5,w4,h4,45,275,Arc2D.PIE));
                         break;
                case 3 : AffineTransform at = new AffineTransform();
                         at.translate(x, y);
                         at.rotate(theta);
                         g2.setTransform(at);
                         g2.fill(new Rectangle(5,5,w4,h4));
                         g2.setColor(Color.red);
                         at.rotate(-theta);
                         g2.setTransform(at);
                         g2.draw(new Ellipse2D.Float(w8,5,w/3,h/6));
                         g2.setColor(Color.green);
                         at.rotate(theta);
                         g2.setTransform(at);
                         g2.draw(new Arc2D.Float(5,h8,w4,h4,45,275,Arc2D.PIE));
                         at.rotate(-theta*2);
                         g2.setTransform(at);
                         g2.setColor(Color.blue);
                         g2.draw(new RoundRectangle2D.Float(w8,h8,w4,h4,20,20));
            }
            g2.setTransform(new AffineTransform());
        }
    }

    public static void main(String s[]) {
        createFrame("RotateShapes", new RotateShapes());
    }
}
