/*
 * @(#)Arcs.java	1.5 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)Arcs.java	1.5	00/02/02
 * @summary - 
 */

package tests.Geom;

import java.awt.*;
import java.awt.geom.Arc2D;
import TestSurface;


public class Arcs extends TestSurface {

    private Arc2D.Float arcs[] = { new Arc2D.Float(Arc2D.CHORD), 
			           new Arc2D.Float(Arc2D.OPEN), 
				   new Arc2D.Float(Arc2D.PIE) };
    private String types[] = { "CHORD", "OPEN", "PIE" };


    public void render(int w, int h, Graphics2D g2) {
	g2.setStroke(new BasicStroke(5.0f));
	for (int i = 0; i < arcs.length; i++) {
	    arcs[i].setFrame((i+1)*w/5, (i+1)*h/5, w/6, h/6);
	    arcs[i].setAngleStart(45);
	    arcs[i].setAngleExtent(270);
	    g2.setColor(Color.blue);
	    g2.draw(arcs[i]);
	    g2.setColor(Color.gray);
	    g2.fill(arcs[i]);
	}
    }


    public static void main(String argv[]) {
        createFrame("Arcs", new Arcs());
    }
}
