/*
 * @(#)ExclusiveOr.java	1.5 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)ExclusiveOr.java	1.5    00/02/02
 * @summary - 
 */



package tests.Geom.Area;

import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import TestSurface;


public class ExclusiveOr extends TestSurface {

    public void render(int w, int h, Graphics2D g2) {
        int x = 0, y = 0;
        int w4 = w/4, h4 = h/4;
        int w8 = w/8, h8 = h/8;
        String desc[] = { "Rectangle", "Ellipse", "Arc", "Multi" };
        for (int i = 0; i < desc.length; i++) {
            switch (i) {
                case 0 : x = 10; y = 15; break;
                case 1 : x = w/2+5; y = 15; break;
                case 2 : x = 10; y = h/2+15; break;
                case 3 : x = w/2+5; y = h/2+15;
            }
            g2.translate(x , y);

            Area area = new Area();

            switch (i) {
                case 0 : area.exclusiveOr(new Area(new Rectangle(5,5,w4,h4)));
                         area.exclusiveOr(new Area(new Rectangle(w8,h8,w4,h4)));
                         break;
                case 1 : area.exclusiveOr(new Area(new Ellipse2D.Float(5,5,w4,h4)));
                         area.exclusiveOr(new Area(new Ellipse2D.Float(w8,h8,w4,h4)));
                         break;
                case 2 : area.exclusiveOr(new Area(new Arc2D.Float(5,5,w4,h4,45,275,Arc2D.PIE)));
                         area.exclusiveOr(new Area(new Arc2D.Float(w8,h8,w4,h4,45,275,Arc2D.PIE)));
                         break;
                case 3 : area.exclusiveOr(new Area(new Rectangle(5,5,w4,h4)));
                         area.exclusiveOr(new Area(new Ellipse2D.Float(w8,5,w4,h4)));
                         area.exclusiveOr(new Area(new Arc2D.Float(5,h8,w4,h4,45,275,Arc2D.PIE)));
                         area.exclusiveOr(new Area(new RoundRectangle2D.Float(w8,h8,w4,h4,20,20)));
            }

            g2.setColor(Color.yellow);
            g2.fill(area);
            g2.setColor(Color.red);
            g2.draw(area);

            g2.translate(-x, -y);
        }
    }

    public static void main(String s[]) {
        createFrame("ExclusiveOr", new ExclusiveOr());
    }
}
