/*
 * @(#)Pear.java	1.5 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)Pear.java	1.5    00/02/02
 * @summary - 
 * This applet renders a pear, using Constructive Area Geometry (CSG) methods,
 * add, intersect, and subtract.
 */



package tests.Geom.Area;

import java.awt.*;
import java.awt.geom.*;
import TestSurface;


public class Pear extends TestSurface {

    public void render(int w, int h, Graphics2D g2) {
        double ew = w/2;
        double eh = h/2;
        g2.setColor(Color.green);
        // Creates the first leaf by filling the intersection of two Area objects created from an ellipse.
        Ellipse2D leaf = new Ellipse2D.Double(ew-16, eh-29, 15.0, 15.0);
        Area leaf1 = new Area(leaf);
        leaf.setFrame(ew-14, eh-47, 30.0, 30.0);
        Area leaf2 = new Area(leaf); 
        leaf1.intersect(leaf2);   
        g2.fill(leaf1);   

        // Creates the second leaf.
        leaf.setFrame(ew+1, eh-29, 15.0, 15.0);
        leaf1 = new Area(leaf);
        leaf2.intersect(leaf1);
        g2.fill(leaf2);

        g2.setColor(Color.black);

        // Creates the stem by filling the Area resulting from the subtraction of two Area objects created from an ellipse.
        Ellipse2D stem = new Ellipse2D.Double(ew, eh-42, 40.0, 40.0);
        Area st1 = new Area(stem);
        stem.setFrame(ew+3, eh-47, 50.0, 50.0);
        st1.subtract(new Area(stem));
        g2.fill(st1);

        g2.setColor(Color.yellow);

        // Creates the pear itself by filling the Area resulting from the union of two Area objects created by two different ellipses.
        Ellipse2D circle = new Ellipse2D.Double(ew-25, eh, 50.0, 50.0);
        Ellipse2D oval = new Ellipse2D.Double(ew-19, eh-20, 40.0, 70.0);
        Area circ = new Area(circle);
        circ.add(new Area(oval));
        g2.fill(circ);
    }


    public static void main(String s[]) {
        createFrame("Pear", new Pear());
    }
}
