/*
 * @(#)Translate.java	1.6 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/**
 * @type REGRESSION
 * @test @(#)Translate.java	1.6    00/02/02
 * @bug 4183373
 * @summary Verifies that the translated Area objects display correctly
 * Problem appeared when rendering into a BufferedImage under jdk1.2
 */

package tests.Geom.Area;

import java.awt.*;
import java.awt.geom.*;
import TestSurface;


public class Translate extends TestSurface {

    Area a1,a2,a3,a4;

    public void initAreas(int w, int h) {
        a1 = new Area(new Rectangle2D.Double(10.0,10.0,60.0,60.0));

        a2 = new Area((Area)a1.clone());
        a2.subtract(new Area(new Rectangle2D.Double(20.0,20.0,40.0,40.0)));

        a3 = new Area((Area)a2.clone());
        a3.add(new Area(new Rectangle2D.Double(30.0,30.0,20.0,20.0)));

        AffineTransform at2 = new AffineTransform();
        at2.translate(w*.3,0.0);
        a2.transform(at2);
        
        AffineTransform at3 = new AffineTransform();
        at3.translate(w*.6,0.0);
        a3.transform(at3);
    }


    public void render(int w, int h, Graphics2D g2) {
        initAreas(w, h);
        // Notice that if you remove the translate() call, it works fine.
        g2.translate(-1, -1);
        g2.setPaint(Color.red);
        g2.fill(a1);
        g2.setPaint(Color.yellow);
        g2.fill(a2);
        g2.setPaint(Color.blue);
        g2.fill(a3);
        g2.translate(1, 1);
    }


    public static void main(String s[]) {
        createFrame("Translate", new Translate());
    }
}
