/*
 * @(#)Ellipses.java	1.6 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)Ellipses.java	1.6	00/02/02
 * @summary - 
 */

package tests.Geom;

import java.awt.*;
import java.awt.geom.*;
import TestSurface;


public class Ellipses extends TestSurface {

    public void render(int w, int h, Graphics2D g2) {
	g2.setColor(Color.blue);
	int size = Math.min(w, h);

	Ellipse2D ellipse = new Ellipse2D.Float(10, 10, w-20, h-20);
        PathIterator pi = ellipse.getPathIterator(null);
        FlatteningPathIterator fpi = new FlatteningPathIterator(pi,0.1);
        while ( !fpi.isDone() ) {
            float[] pts = new float[6]; 
            switch ( fpi.currentSegment(pts) ) {
	        case PathIterator.SEG_MOVETO:
	        case PathIterator.SEG_LINETO:
	            g2.draw(new Ellipse2D.Float(pts[0]-2, pts[1]-2,4,4));
    	    }
            fpi.next();
        }


	float ew = size/4;
	float eh = size-40;
	for (int i = 0; i < 36; i++) {
	    if (i % 9 == 0) {
	        g2.setStroke(new BasicStroke(2.0f));
	        g2.setColor(Color.gray);
	    } else {
	        g2.setColor(Color.lightGray);
	        g2.setStroke(new BasicStroke(0.5f));
	    }
	    g2.translate(w/2, h/2);
	    g2.rotate((5*i*java.lang.Math.PI)/180); 
	    g2.draw(new Ellipse2D.Float(-ew/2, -eh/2, ew, eh));
	    g2.setTransform(new AffineTransform());
	}
	g2.setColor(Color.red);
	ellipse = new Ellipse2D.Float(w/2-10,h/2-10,20,20);
	g2.fill(ellipse);
	g2.setColor(Color.green);
	g2.setStroke(new BasicStroke(4.0f));
	g2.draw(ellipse);
    }


    public static void main(String argv[]) {
        createFrame("Ellipses", new Ellipses());
    }
}
