/*
 * @(#)QuadCurves.java	1.6 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)QuadCurves.java	1.6	00/02/02
 * @summary - 
 */

package tests.Geom;

import java.awt.*;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Rectangle2D;
import java.awt.geom.QuadCurve2D;
import java.awt.geom.PathIterator;
import java.awt.geom.FlatteningPathIterator;
import TestSurface;


public class QuadCurves extends TestSurface {

    public void render(int w, int h, Graphics2D g2) {
	Shape shape = new QuadCurve2D.Float(w/8,0,w/2,-25,w-w/8,0);
	g2.setStroke(new BasicStroke(6.0f));
        g2.setColor(Color.blue);
	g2.translate(0, h*0.25);
        g2.draw(shape);

	g2.translate(0, h*0.25);
        g2.draw(shape);
        g2.setColor(Color.red);
        PathIterator pi = shape.getPathIterator(null);
        while ( !pi.isDone() ) {
    	    float[] pts = new float[6]; 
	    int segment = pi.currentSegment(pts);
	    if (segment == PathIterator.SEG_MOVETO || segment == PathIterator.SEG_LINETO) {
	        g2.fill(new Rectangle2D.Float(pts[0], pts[1], 10, 10));
	    } else if (segment == PathIterator.SEG_CUBICTO || segment == PathIterator.SEG_QUADTO) {
	        g2.fill(new Rectangle2D.Float(pts[0], pts[1], 10, 10));
		if (pts[2] != 0) {
	            g2.fill(new Rectangle2D.Float(pts[2], pts[3], 10, 10));
		}
		if (pts[4] != 0) {
	            g2.fill(new Rectangle2D.Float(pts[4], pts[5], 10, 10));
		}
            }
            pi.next();
        }

	g2.translate(0, h*0.25);
        g2.setColor(Color.green);
        pi = shape.getPathIterator(null);
        FlatteningPathIterator fpi = new FlatteningPathIterator(pi,0.1);
        while ( !fpi.isDone() ) {
            float[] pts = new float[6]; 
            switch ( fpi.currentSegment(pts) ) {
	        case PathIterator.SEG_MOVETO:
	        case PathIterator.SEG_LINETO:
	            g2.fill(new Ellipse2D.Float(pts[0], pts[1],6,6));
    	    }
            fpi.next();
        }

	g2.translate(0, -h*0.75);
   }


    public static void main(String argv[]) {
        createFrame("QuadCurves", new QuadCurves());
    }
}
