/*
 * @(#)FlipRS.java	1.5 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)FlipRS.java	1.5    00/02/02
 * @summary - Use drawImage to do scaling on the fly.
 */

package tests.Image;

import java.awt.*;
import TestSurface;


public class FlipRS extends TestSurface {

    public void render(int w, int h, Graphics2D g2) {
        Image img = getImage("duke.gif");
        int iw = img.getWidth(this);
        int ih = img.getHeight(this);
        int x1 = (w - iw) / 2;
        int y1 = (h - ih) / 2;
        int x2 = x1 + iw;
        int y2 = y1 + ih;
        // Flip H & V by flipping dest X and dest Y coords
        g2.drawImage(img,
                    x1 - 1, y1 - 1, 0, 0,
                    0, 0, iw, ih,
                    this);
        // Flip V by flipping dest Y coords
        g2.drawImage(img,
                    x1, y1 - 1, x2, 0,
                    0, 0, iw, ih,
                    this);
        // Flip H & V by flipping dest X and source Y coords
        g2.drawImage(img,
                    w, 0, x2 + 1, y1 - 1,
                    0, ih, iw, 0,
                    this);
        // Flip H by flipping dest X coords
        g2.drawImage(img,
                    x1 - 1, y1, 0, y2,
                    0, 0, iw, ih,
                    this);
        // No flipping
        g2.drawImage(img, x1, y1, x2, y2, 0, 0, iw, ih, this);
        // Flip H by flipping source X coords
        g2.drawImage(img,
                    x2 + 1, y1, w, y2,
                    iw, 0, 0, ih,
                    this);
        // Flip H & V by flipping source X and source Y coords
        g2.drawImage(img,
                    0, y2 + 1, x1 - 1, h,
                    iw, ih, 0, 0,
                    this);
        // Flip V by flipping source Y coords
        g2.drawImage(img,
                    x1, y2 + 1, x2, h,
                    0, ih, iw, 0,
                    this);
        // Flip H & V by flipping source X and dest Y coords
        g2.drawImage(img,
                    x2 + 1, h, w, y2 + 1,
                    iw, 0, 0, ih, this);
    }


    public static void main(String s[]) {
        createFrame("FlipRS", new FlipRS());
    }
}
