/*
 * @(#)Basic.java	1.4 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)Basic.java	1.4	00/02/02
 * @summary - Basic PNG image types, non-interlaced and interlaced.
 */

package tests.Image.PNG;

import java.awt.*;
import TestSurface;


public class Basic extends TestSurface {

    String names[] = { "basn6a16.png", "basn6a08.png", "basn4a16.png",
                       "basn4a08.png", "basn3p08.png", "basn3p04.png",
                       "basn3p02.png", "basn3p01.png", "basn2c16.png",
                       "basn2c08.png", "basn0g16.png", "basn0g08.png",
                       "basn0g04.png", "basn0g02.png", "basn0g01.png",

                       "basi6a16.png", "basi6a08.png", "basi4a16.png",
                       "basi4a08.png", "basi3p08.png", "basi3p04.png",
                       "basi3p02.png", "basi3p01.png", "basi2c16.png",
                       "basi2c08.png", "basi0g16.png", "basi0g08.png",
                       "basi0g04.png", "basi0g02.png", "basi0g01.png"};


    public void render(int w, int h, Graphics2D g2) {
        int x = 0, y = 0;
        for (int i = 0; i < names.length; i++) {
            Image img = getImage(names[i]);
            g2.drawImage(img, x, y, null);
            if ((x += img.getWidth(null)) > w-img.getWidth(null)) {
                x = 0;
                y += img.getHeight(null);
            }
        }
    }


    public static void main(String s[]) {
        createFrame("Basic", new Basic());
    }
}
