/*
 * @(#)Filters_Mix.java	1.3 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)Filters_Mix.java	1.3	00/02/02
 * @summary - see below
 */

package tests.Image.PNG;

import java.awt.*;
import TestSurface;


public class Filters_Mix extends TestSurface {

    String names[][] = {
 // Images with different compression filters.
        { "f00n2c08.png", "f01n2c08.png", "f02n2c08.png", 
          "f03n2c08.png", "f04n2c08.png" },
 
        { "f00n0g08.png", "f01n0g08.png", "f02n0g08.png", 
          "f03n0g08.png", "f04n0g08.png" },

 // Images with comments or time stamps.
        { "cm0n0g04.png", "cm7n0g04.png", "cm9n0g04.png",
          "ct0n0g04.png", "ct1n0g04.png", "ctzn0g04.png" },

 // Images with significant-bits chunks, both colormapped and truecolor.
        { "cs3n2c16.png", "cs3n3p08.png", "cs5n2c08.png",
          "cs5n3p08.png", "cs8n2c08.png", "cs8n3p08.png" },

 // Images with non-square pixels and/or pixels with physical dimensions.
/*
        { "cpsn2c08.png", "cphn2c08.png", "cpfn2c08.png",
          "cpun2c08.png" }};
*/
};



    public void render(int w, int h, Graphics2D g2) {
        int y = 0;
        int hh = getImage(names[0][0]).getHeight(null);
        for (int i = 0; i < names.length; i++) {
            int x = 0;
            for (int j = 0; j < names[i].length; j++) {
                Image img = getImage(names[i][j]);
                g2.drawImage(img, x, y, null);
                x += img.getWidth(null);
            }
            y += hh;
        }
    }


    public static void main(String s[]) {
        createFrame("Filters_Mix", new Filters_Mix());
    }
}
