/*
 * @(#)Gamma_Mix.java	1.3 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)Gamma_Mix.java	1.3	00/02/02
 * @summary - see below...
 */

package tests.Image.PNG;

import java.awt.*;
import TestSurface;


public class Gamma_Mix extends TestSurface {

    String names[][] = {

// Images with different gamma chunks.
       {"g25n2c08.png", "g10n2c08.png", "g07n2c08.png", 
        "g05n2c08.png", "g04n2c08.png", "g03n2c08.png" },
       {"g25n3p04.png", "g10n3p04.png", "g07n3p04.png",
        "g05n3p04.png", "g04n3p04.png", "g03n3p04.png" },
       {"g25n0g16.png", "g10n0g16.png", "g07n0g16.png",
        "g05n0g16.png", "g04n0g16.png", "g03n0g16.png" },

//Images with simple transparency and various background chunks
       { "tbbn1g04.png", "tbbn2c16.png", "tbbn3p08.png",
         "tbgn2c16.png", "tbgn3p08.png", "tbrn2c08.png",
         "tbwn1g16.png", "tbwn3p08.png", "tbyn3p08.png",
         "tp0n1g08.png", "tp0n2c08.png", "tp0n3p08.png",
         "tp1n3p08.png"}};


    public void render(int w, int h, Graphics2D g2) {
        int y = 0;
        int hh = getImage(names[0][0]).getHeight(null);
        for (int i = 0; i < names.length; i++) {
            int x = 0;
            for (int j = 0; j < names[i].length; j++) {
                Image img = getImage(names[i][j]);
                g2.drawImage(img, x, y, null);
                x += img.getWidth(null);
                if (x > w-img.getWidth(null)) {
                    x = 0; y += hh;
                }
            }
        }
    }


    public static void main(String s[]) {
        createFrame("Gamma_Mix", new Gamma_Mix());
    }
}
