/*
 * @(#)MultiSize.java	1.3 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)MultiSize.java	1.3	00/02/02
 * @summary - 1x1 to 9x9 and 32x32 to 40x40 images, non-interlaced 
 * and interlaced
 */

package tests.Image.PNG;

import java.awt.*;
import TestSurface;


public class MultiSize extends TestSurface {

    String names[][] = {

        { "s01n3p01.png", "s02n3p01.png", "s03n3p01.png", "s04n3p01.png",
          "s05n3p02.png", "s06n3p02.png", "s07n3p02.png", "s08n3p02.png",
          "s09n3p02.png", "s32n3p04.png", "s33n3p04.png", "s34n3p04.png",
          "s35n3p04.png", "s36n3p04.png", "s37n3p04.png", "s38n3p04.png",
          "s39n3p04.png", "s40n3p04.png" },

        { "s01i3p01.png", "s02i3p01.png", "s03i3p01.png", "s04i3p01.png",
          "s05i3p02.png", "s06i3p02.png", "s07i3p02.png", "s08i3p02.png",
          "s09i3p02.png", "s32i3p04.png", "s33i3p04.png", "s34i3p04.png",
          "s35i3p04.png", "s36i3p04.png", "s37i3p04.png", "s38i3p04.png",
          "s39i3p04.png", "s40i3p04.png" }};


    public void render(int w, int h, Graphics2D g2) {
        int y = 0;
        int hh = 40;
        for (int i = 0; i < names.length; i++) {
            int x = 0;
            for (int j = 0; j < names[i].length; j++) {
                Image img = getImage(names[i][j]);
                g2.drawImage(img, x, y, null);
                x += img.getWidth(null);
                if (x > w-img.getWidth(null)) {
                    x = 0; y += hh;
                }
            }
            y += hh;
        }
    }


    public static void main(String s[]) {
        createFrame("MultiSize", new MultiSize());
    }
}
