/*
 * @(#)Caps.java	1.5 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)Caps.java	1.5    00/02/02
 * @summary - Shows the three different styles of stroke ending.
 */

package tests.Stroke;


import java.awt.*;
import java.awt.geom.Line2D;
import TestSurface;


public class Caps extends TestSurface {

    public void render(int w, int h, Graphics2D g2) {
        int theCaps[] = { BasicStroke.CAP_BUTT, BasicStroke.CAP_ROUND, 
                            BasicStroke.CAP_SQUARE };
        String theDesc[] = { "Butt Cap", "Round Cap", "Square Cap" };
        g2.setColor(Color.black);
        for (int i=0; i < 3; i++) {
            g2.setStroke(new BasicStroke(15.0f, theCaps[i], BasicStroke.JOIN_MITER));
            g2.draw(new Line2D.Float(w/4,(i+1)*h/4,w-w/4,(i+1)*h/4));
        }
    }

    public static void main(String s[]) {
        createFrame("Caps", new Caps());
    }

} 
