/*
 * @(#)Joins.java	1.5 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type FUNCTIONAL
 * @test @(#)Joins.java	1.5    00/02/02
 * @summary - Shows the three different styles of joining strokes together.
 */

package tests.Stroke;

import java.awt.*;
import java.awt.geom.AffineTransform;
import java.awt.geom.GeneralPath;
import TestSurface;


public class Joins extends TestSurface {

    public void render(int w, int h, Graphics2D g2) {
        int theJoins[] = { BasicStroke.JOIN_MITER, BasicStroke.JOIN_ROUND, 
                            BasicStroke.JOIN_BEVEL };
        String theDesc[] = { "Mitered", "Rounded", "Beveled" };

        g2.translate(w/3, h/9);
        g2.setColor(Color.black);

        for (int i=0; i < 3; i++)
        {
            BasicStroke bs = new BasicStroke(20.0f, BasicStroke.CAP_BUTT, 
                                            theJoins[i]);
            GeneralPath p = new GeneralPath();
            p.moveTo(0, 0);
            p.lineTo(w/12, h/10);
            p.lineTo(0,h/5);
            g2.setStroke(bs);
            g2.draw(p);
            g2.translate(0, h/4);
        }
    }


    public static void main(String s[]) {
        createFrame("Joins", new Joins());
    }
} 
