/*
 * @(#)XORClearRect.java	1.5 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * @type REGRESSION
 * @test @(#)XORClearRect.java	1.5    00/02/02
 * @bug 4088173 java.awt.Graphics.clearRect() method should ignore the
 *               XOR mode.
 * @summary This interactive test verifies that the XOR mode is not affecting
 * the clearRect() call. The correct output looks like:
 *
 * \      /
 *  \    /
 *            The backgound is blue.
 *            The lines outside the central rectangle are green.
 *            The central rectangle is also blue (the result of clearRect())
 *  /    \     
 * /      \
 * Problem reported in jdk1.2-P, verify against jdk1.1.x
 */

package tests.XORmode;

import java.awt.*;
import TestSurface;


public class XORClearRect extends TestSurface {

    public void render(int w, int h, Graphics2D g2) {
        g2.setColor(Color.green);
        g2.drawLine(0,0,w,h);
        g2.drawLine(0,w,h,0);
        g2.setXORMode(Color.blue);
        g2.clearRect(w/4,h/4,w/2,h/2); //expecting the rectangle to be filled
                                    // with the background color (blue)
    }

    public static void main(String s[]) {
        createFrame("XORClearRect", new XORClearRect());
    }
}
