/*
 * @(#)Tree.java	1.9 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

import java.applet.Applet;
import java.awt.Frame;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Color;
import java.awt.Font;
import java.awt.font.FontRenderContext;
import java.awt.font.TextLayout;

public class Tree extends Applet {
    public static void main(String argv[]) {
	Frame f = new Frame();
	f.add(new Tree());
	f.pack();
	f.show();
    }
    public Dimension getPreferredSize() {
	return new Dimension(600, 600);
    }

    public void paint(Graphics g) {
	Dimension size = getSize();
	int mindim = Math.min(size.width, size.height);
	Graphics2D g2d = (Graphics2D) g;
	g2d.translate((size.width - mindim) / 2.0,
		     (size.height - mindim) / 2.0);
	g2d.scale(mindim, mindim);
	g2d.translate(0.5, 0.5);
	g2d.scale(0.3, 0.3);
	g2d.translate(-(Twidth + Rwidth), FontHeight / 4.0);
	tree(g2d, mindim * 0.3, 0);
    }

    static Font theFont = new Font("Palatino", Font.PLAIN, 1);
    static TextLayout theT = new TextLayout("T", theFont, new FontRenderContext(null, false, false));
    static double Twidth = 0.6;
    static TextLayout theR = new TextLayout("R", theFont, new FontRenderContext(null, false, false));
    static double Rwidth = 0.6;
    static double FontHeight = 0.75;

    static Color colors[] = {Color.blue,
			     Color.red.darker(),
			     Color.green.darker()};

    public void tree(Graphics2D g2d, double size, int phase) {
	g2d.setColor(colors[phase % 3]);
	theT.draw(g2d, 0.0f, 0.0f);
	if (size > 10.0) {
	    g2d.translate(Twidth, -0.1);
	    g2d.scale(0.6, 0.6);
	    size *= 0.6;
	    theR.draw(g2d, 0.0f, 0.0f);
	    g2d.translate(Rwidth+0.75, 0);
	    Graphics2D g2dt = (Graphics2D) g2d.create();
	    g2dt.rotate(-Math.PI / 2.0);
	    tree(g2dt, size, phase + 1);
	    g2dt.dispose();
	    g2d.translate(.75, 0);
	    g2d.rotate(-Math.PI / 2.0);
	    g2d.scale(-1.0, 1.0);
	    g2d.translate(-Twidth, 0);
	    tree(g2d, size, phase);
	}
    }
}
