/*
 * @(#)lists.c	1.3 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 * This file maintains the list of all Composite Sets and the list
 * of all Test Value sets for selection on the command line by name.
 */

#include "alphatest.h"

extern CompositeSet RefProxySet;
extern CompositeSet NullSet;
extern CompositeSet IntSet;
extern CompositeSet Int2Set;
extern CompositeSet OptSet;
extern CompositeSet Beta3Set;

CompositeSetEntry CompSetList[] = {
    {
	"Reference",
	"Proxy implementation based on the reference functions",
	&RefProxySet,
    },
    {
	"Null",
	"Null implementation for benchmark overhead checking",
	&NullSet,
    },
    {
	"Integer",
	"Simple integer implementation (no optimization)",
	&IntSet,
    },
    {
	"Short",
	"Simple 12-bit integer implementation (no optimization)",
	&Int2Set,
    },
    {
	"Beta3",
	"Beta3 AlphComposite implementation",
	&Beta3Set,
    },
};

int NumCompSets = (sizeof(CompSetList) / sizeof(CompSetList[0]));
