/*
 * @(#)AppleEvent.java	1.5 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

import java.util.Date;

/**
 * The AppleEvent class is simply an object to be passed back to a
 * remote objct exported by an applet to verify proper object
 * serialization.
 */
public class AppleEvent implements java.io.Serializable {

    public static final int BUY   = 0;
    public static final int EAT   = 1;
    public static final int THROW = 2;

    private int what;

    private java.util.Date when;

    public AppleEvent(int what)
    {
	this.what = what;
	this.when = new Date();
    }

    public String toString()
    {
	String desc = "[";
	switch (what) {
	case BUY:
	    desc += "BUY";
	    break;
	case EAT:
	    desc += "EAT";
	    break;
	case THROW:
	    desc += "THROW";
	    break;
	}
	desc += " @ " + when + "]";
	return desc;
    }
}
