/*
 * @(#)OrangeEchoImpl.java	1.5 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

import java.rmi.*;
import java.rmi.server.*;

import java.awt.*;

/**
 * The OrangeEchoImpl class implements the behavior of the remote "orange
 * echo" objects exported by the server.  The purpose of these objects
 * is simply to recursively call back to their caller.
 */
public class OrangeEchoImpl
    extends UnicastRemoteObject
    implements OrangeEcho
{

    String name;

    public OrangeEchoImpl(String name)
	throws RemoteException
    {
	this.name = name;
    }

    /**
     * Call back on supplied "orange" object (presumably the caller)
     * with the same message data and a decremented recursion level.
     */
    public int[] recurse(Orange orange, int[] message, int level)
	throws RemoteException
    {
	String threadName = Thread.currentThread().getName();
	System.err.println(
	    threadName + ": " + toString() +
	    ".recurse(message[" + message.length + "], " +
	    level + "): BEGIN");

	int[] response = orange.recurse(this, message, level - 1);

	System.err.println(
	    threadName + ": " + toString() +
	    ".recurse(message[" + message.length + "], " +
	    level + "): END\n");

	return response;
    }

    public String toString()
    {
	return name;
    }
}
