/*
 * @(#)OrangeImpl.java	1.6 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

import java.rmi.*;
import java.rmi.server.*;
import java.awt.*;

/**
 * The OrangeImpl class implements the behavior of the remote "orange"
 * objects exported by the applet.
 */
public class OrangeImpl
    extends UnicastRemoteObject
    implements Orange
{

    String name;

    JuicerDisplay display;

    public OrangeImpl(String name, JuicerDisplay display)
	throws RemoteException
    {
	this.name    = name;
	this.display = display;
    }

    /**
     * Return inverted message data, call through supplied OrangeEcho
     * object if not at recursion level zero.
     */
    public int[] recurse(OrangeEcho echo, int[] message, int level)
	throws RemoteException
    {
	try {
	    String threadName = Thread.currentThread().getName();
	    display.append(name + " is at recursion level " +
	        level + ". message size = " + message.length + "\n");

		//threadName + ": " + toString() +
		//".recurse(message[" + message.length + "], " +
		//level + "): BEGIN\n");

	    int[] response;
	    if (level > 0)
		response = echo.recurse(this, message, level);
	    else {
		for (int i = 0; i < message.length; ++ i)
		    message[i] = ~message[i];
		response = message;
	    }

	    return response;
	} catch (RuntimeException e) {
	    synchronized (System.err) {
		System.err.print("OrangeImpl.recurse(): ");
		e.printStackTrace();
	    }
	    throw e;
	}
    }

    public String toString()
    {
	return name;
    }
}
