/*
 * @(#)CollInterface.java	1.5 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package benchmarks;

import java.rmi.RemoteException;
import java.util.*;

/**
 * The set of Data Collector functions implemented by the Server
 */

public interface CollInterface extends java.rmi.Remote {

	/**
	 * Log the client site properties 
	 *
	 * @param c_desc the Client site properties including system properties
	 * @return a client identification number 
	 * @exception RemoteException if the client cannot log to the server
	 *                            or the Server cannot log the properties. 
	 */
	int logClientDesc (Properties c_desc, ClientInterface client)
		throws RemoteException;

	/**
	 * Log the performance data for the client identified by the client ID.
	 *
	 * @param data      a hashtable of sets of performance figures hashed by
	 *                  the measured attribute
	 * @param clientNum a client ID identifying the client to the Data 
	 *                  Collector.
	 * @exception RemoteException if the remote call fails or the server
	 *                            for some reason cannot record the data.
	 */
	void logPerfData (Hashtable data, int clientNum)
		throws RemoteException;

} 

