/*
 * @(#)LogData.java	1.5 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package benchmarks;

import java.io.*;
import java.util.*;

/**
 * LogData contains all the performance data for all the clients , the log date
 * and the median RMIPerfMark for the day. This is the data that is stored in
 * the log file.
 *
 * @see AttribData
 * @see ClientData
 * @see PerfFigures
 */

public class LogData implements Serializable {

        /**
         * Log Date
         */
        protected Date date;

        /**
         * The median RMIPerfMark for all the clients
         */
        protected float RMIPerfMark;

        /**
         * The Log for all Client Performance data
         *
         */
        protected Hashtable clientLog;

	/**
	 * Server System properties
	 */
	protected Properties serverDesc;

	protected void setDate(Date d) {
		
		date = d;

	}

	protected void setRMIPerfMark (float mark) {

		RMIPerfMark = mark;

	}

	protected void setClientLog (Hashtable log) {

		clientLog = log;

	}

	protected void setServerDesc (Properties props) {

		serverDesc = props;

	}

	public Date getDate() {

		return date;
	
	}

	public float getRMIPerfMark() {

		return RMIPerfMark;

	}

	public Hashtable getClientLog () {

		return clientLog;

	}

	public Properties getServerDesc() {

		return serverDesc;

	}


}


