/*
 * @(#)TestInfo.java	1.5 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package visualBenchmarks;

/**
 * A class to encapsulate the test information including wether it uses 
 * arrays, vectors or some such parameters beside the range of iterations
 */

public class TestInfo implements java.io.Serializable{

	private String testName;
	private boolean arraysUsed;
	
  	/**
	 * Constructs a TestInfo object for the test <i>testname</i>
	 * 
	 * @param testName   the unique identifier for the test
	 * @param arraysUsed a boolean value indicating whether a second 
	 *		     parameter is used in this test.
 	 */
	public TestInfo(String testName, boolean arraysUsed) {
	
		this.testName = testName;
		this.arraysUsed = arraysUsed;

	}

	public String getTestName() {
	
		String str = new String(testName);
		return str;

	}

	public boolean areArraysUsed(){

		return (arraysUsed?true:false);

	}
}
