/*
 * @(#)getLocalHostTest.java	1.8 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
/*
 * File: getLocalHostTest.java
 * Comment: THis file checks the output of InetAddress.getLocalHost() to be
 * 127.0.0.0. This modification was made so as not to reveal the hostname of
 * the machine on which the applet is running.
 *
 * @(#)author:  Vijay Srinivasan
 * @(#)version: 1.8
 * @(#)date:    02/02/00
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.net.InetAddress;
import java.net.UnknownHostException;

public class getLocalHostTest extends SecurityTest {
  public void test(Graphics g) {
    String inet, hostname, IPaddress;
    int separatorpt;

    try {
      inet = InetAddress.getLocalHost().toString();
      separatorpt = inet.indexOf('/');
      if (separatorpt == -1) {
	status = FAILED;
	return;
      }

      hostname = inet.substring(0, separatorpt);
      IPaddress = inet.substring(separatorpt+1);

      status = (hostname.equals("localhost")) ? PASSED : FAILED;
      status = (IPaddress.equals("127.0.0.1")) ? status : FAILED;
    } catch (UnknownHostException e) {
      e.printStackTrace();
      status = FAILED;
    }
  }
}
