/*
 * @(#)PKCS8KeyEncodeTest.java	1.6 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package crypto;

import test.*;

import java.math.BigInteger;
import sun.security.provider.DSAPrivateKey;

public class PKCS8KeyEncodeTest extends Test {

    String foo;

    public void run() throws TestException {
	try {
	    BigInteger p = BigInteger.valueOf(1);
	    BigInteger q = BigInteger.valueOf(2);
	    BigInteger g = BigInteger.valueOf(3);
	    BigInteger x = BigInteger.valueOf(4);

	    DSAPrivateKey priv = new DSAPrivateKey(p, q, g, x);

	    byte[] encodedKey = priv.getEncoded();
	    System.err.println("encodedKey: " + encodedKey.length);
	
	    DSAPrivateKey decodedKey = new DSAPrivateKey(encodedKey);
	
	    System.err.println("original: " + priv);
	    System.err.println("decoded: " + decodedKey);
	} catch (Exception e) {
	    throw new TestException("error", e);
	}
    }
}
    


