/*
 * @(#)Base64CertPrint.java	1.7 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

import java.io.*;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import sun.misc.BASE64Decoder;

/**
 * Usage: Base64CertPrint <fileName>
 */
public class Base64CertPrint {
    public static void main(String[] args) {
            if (args.length != 1) {
                System.out.println("Usage: Base64CertPrint <fileName>");
                System.exit(1);
            }

            try {
                // Certificate boundaries
                String beginCert = "-----BEGIN CERTIFICATE-----";
                String endCert = "-----END CERTIFICATE-----";
                InputStream inStrm = new FileInputStream(args[0]);
                BufferedReader bufRdr = new BufferedReader(new
                                            InputStreamReader(inStrm));
                StringBuffer strBuf = new StringBuffer();
                String temp;

                while ((temp = bufRdr.readLine()) != null &&
                       !temp.equals(beginCert))
                    continue;
                if (temp == null) {
                    System.out.println("Missing " + beginCert + " boundary");
                    System.exit(1);
                }
                while ((temp = bufRdr.readLine()) != null &&
                       !temp.equals(endCert))
                    strBuf.append(temp);
                if (temp == null) {
                    System.out.println("Missing " + endCert + " boundary");
                    System.exit(1);
                }

                BASE64Decoder decoder = new BASE64Decoder();
                byte data[];

                data = decoder.decodeBuffer(strBuf.toString());
                FileOutputStream fos = new FileOutputStream("derTestCert");
                fos.write(data);
                fos.close();

		ByteArrayInputStream bais = new ByteArrayInputStream(data);
		CertificateFactory cf = CertificateFactory.getInstance("X509");
                X509Certificate crt
		    = (X509Certificate)cf.generateCertificate(bais);
		bais.close();

                // if self-signed
                if ((crt.getIssuerDN()).equals(crt.getSubjectDN())) {
                    crt.verify(crt.getPublicKey());
                    System.out.println("***  Verified Certificate ***");
                } else
                    System.out.println("***  Un-verified Certificate ***");

                System.out.println(crt);
                System.out.println("*** End Certificate ***");

            } catch (Exception e) {
                e.printStackTrace();
            }
    }
}
