/*
 * @(#)CSRParse.java	1.3 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

import java.io.*;
import sun.security.pkcs.*;
import sun.misc.BASE64Decoder;

/**
 * Usage: CSRParse <fileName>
 */
public class CSRParse {
    public static void main(String[] args) {
            if (args.length != 1) {
                System.out.println("Usage: CSRParse <fileName>");
                System.exit(1);
            }
 
            try {
                // CSR boundaries
                String beginCSR = "-----BEGIN NEW CERTIFICATE REQUEST-----";
                String endCSR = "-----END NEW CERTIFICATE REQUEST-----";
                InputStream inStrm = new FileInputStream(args[0]);
                BufferedReader bufRdr = new BufferedReader(new
                                            InputStreamReader(inStrm));
                StringBuffer strBuf = new StringBuffer();
                String temp;

                while ((temp = bufRdr.readLine()) != null &&
                       !temp.equals(beginCSR))
                    continue;
                if (temp == null) {
                    System.out.println("Missing " + beginCSR + " boundary");
                    System.exit(1);
                }
                while ((temp = bufRdr.readLine()) != null &&
                       !temp.equals(endCSR))
                    strBuf.append(temp);
                if (temp == null) {
                    System.out.println("Missing " + endCSR + " boundary");
                    System.exit(1);
                }

                BASE64Decoder decoder = new BASE64Decoder();
                byte data[];

                data = decoder.decodeBuffer(strBuf.toString());
                FileOutputStream fos = new FileOutputStream("derTestCSR");
                fos.write(data);
                fos.close();

                PKCS10 csr = new PKCS10(data);

                System.out.println("***  Verified CSR ***");
                System.out.println(csr);
                System.out.println("*** End CSR ***");

            } catch (Exception e) {
                e.printStackTrace();
            }
    } 
}
