/*
 * @(#)DateFormatTest.java	1.6 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;

public class DateFormatTest {
    public static void main(String[] args) {
        try {
            TimeZone tz = TimeZone.getTimeZone("GMT");
            Date firstD = new Date();
	    Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("PST"));
            cal.set(1997, 11, 31, 12, 30, 30);
            Date lastD = cal.getTime();

            System.out.println(firstD.toString() + " & " + lastD.toString());

	    String utc = "yyMMddHHmmss'Z'";
	    String gt = "yyyyMMddHHmmss'Z'";
            SimpleDateFormat sdf = new SimpleDateFormat(utc);
            SimpleDateFormat gsdf = new SimpleDateFormat(gt);
            sdf.setTimeZone(tz);
            gsdf.setTimeZone(tz);
            System.out.println("UTC: " + sdf.format(firstD) +
                               " & " + sdf.format(lastD));
            System.out.println("GT: " + gsdf.format(firstD) +
                               " & " + gsdf.format(lastD));

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
