/*
 * @(#)HexStrToX509Cert.java	1.5 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

import java.io.*;
import java.math.BigInteger;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;

import sun.misc.*;

/**
 * Usage: HexStrToX509Cert <fileName>
 * This test was written for interop testing with SunSoft
 * authorization server.
 */
public class HexStrToX509Cert {
    public static void main(String[] args) {
            
            if (args.length != 1) {
                System.out.println("Usage: HexStrToX509Cert <fileName>");
                System.exit(1);
            }
            try {
                InputStream inStrm = new FileInputStream(args[0]);
                BufferedReader br = new BufferedReader(new
                                       InputStreamReader(inStrm));
                String temp;
                StringBuffer strBuf = new StringBuffer();

                // Read the certificate from the file into the buffer
                while ((temp = br.readLine()) != null) {
                   strBuf.append(temp);
                }
                inStrm.close();

                String dataStr = strBuf.toString();
                if ((dataStr.length() & 0x01) == 0x01)
                    dataStr = new String(dataStr+"0");
                BigInteger cI = new BigInteger(dataStr, 16);
                byte[] certData = cI.toByteArray();
                ByteArrayInputStream bais = new ByteArrayInputStream(certData);
                
                CertificateFactory cf = CertificateFactory.getInstance("X509");
                X509Certificate crt = (X509Certificate)
                                      cf.generateCertificate(bais);
                bais.close();
                System.out.println("***  Certificate ***");
                System.out.println(crt);
                System.out.println("*** End Certificate ***");

            } catch (Exception e) {
                e.printStackTrace();
            }
    } 
}
