/*
 * @(#)PKCS7CertPrint.java	1.3 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

import java.io.InputStream;
import java.io.FileInputStream;
import java.io.DataInputStream;
import java.io.ByteArrayInputStream;
import java.util.Collection;
import java.util.Iterator;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;

/**
 * Usage: PKCS7CertPrint <fileName>
 */
public class PKCS7CertPrint {
    public static void main(String[] args) {

            if (args.length != 1) {
                System.out.println("Usage: PKCS7CertPrint <fileName>");
                System.exit(1);
            }
            try {
                InputStream inStrm = new FileInputStream(args[0]);
                DataInputStream dis = new DataInputStream(inStrm);
                byte[] data = new byte[dis.available()];
                dis.readFully(data);
                ByteArrayInputStream bais = new ByteArrayInputStream(data);

		CertificateFactory cf = CertificateFactory.getInstance("X509");
                Collection c = cf.generateCertificates(bais);
                bais.close();
                Iterator i = c.iterator();
                while (i.hasNext()) {
                    X509Certificate crt = (X509Certificate)i.next();
                    System.out.println("***  Certificate ***");
                    System.out.println(crt.toString());
                    System.out.println("*** End Certificate ***");
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
    }
}
