/*
 * @(#)X509CRLPrint.java	1.7 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

import java.io.InputStream;
import java.io.FileInputStream;
import java.security.cert.CertificateFactory;
import java.security.cert.X509CRL;

/**
 * Usage: X509CRLPrint <fileName>
 */
public class X509CRLPrint {
    public static void main(String[] args) {

        if (args.length != 1) {
            System.out.println("Usage: X509CRLPrint <fileName>");
            System.exit(1);
        }
        try {
            InputStream inStrm = new FileInputStream(args[0]);
            CertificateFactory cf = CertificateFactory.getInstance("X509");
            X509CRL crl = (X509CRL)cf.generateCRL(inStrm);

            System.out.println("***  CRL ***");
            System.out.println(crl);
            System.out.println("*** End CRL ***");

            if (crl.hasUnsupportedCriticalExtension())
                System.out.println("Has unsupported critical extension!");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
