/*
 * @(#)X509CertPrint.java	1.10 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

import java.io.InputStream;
import java.io.FileInputStream;
import java.io.DataInputStream;
import java.io.ByteArrayInputStream;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;

/**
 * Usage: X509CertPrint <fileName>
 */
public class X509CertPrint {
    public static void main(String[] args) {

            if (args.length != 1) {
                System.out.println("Usage: X509CertPrint <fileName>");
                System.exit(1);
            }
            try {
                InputStream inStrm = new FileInputStream(args[0]);
                DataInputStream dis = new DataInputStream(inStrm);
                byte[] data = new byte[dis.available()];
                dis.readFully(data);
                ByteArrayInputStream bais = new ByteArrayInputStream(data);

		CertificateFactory cf = CertificateFactory.getInstance("X509");
                X509Certificate crt
		    = (X509Certificate)cf.generateCertificate(bais);
                bais.close();
                System.out.println("***  Certificate ***");
                System.out.println(crt.toString());
                System.out.println("*** End Certificate ***");

                if (crt.hasUnsupportedCriticalExtension())
                    System.out.println("Has unsupported critical extension!");

            } catch (Exception e) {
                e.printStackTrace();
            }
    }
}
