/*
 * @(#)TestParsePKCS7.java	1.8 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
import java.io.*;
import java.security.*;

import sun.security.pkcs.*;
import sun.security.util.*;

public class TestParsePKCS7 {

    static File file;

    public static void main(String[] args) {
	if (args.length != 1) {
	    System.err.println("usage: java TestPKCSParse <file.pkcs>");
	    System.exit(1);
	}

	file = new File(args[0]);

	if (!file.exists()) {
	    System.err.println("cannot find file: " + file);
	    System.exit(1);
	}

	try {
	    FileInputStream fis = new FileInputStream(file);
	    DataInputStream dis = new DataInputStream(fis);
	    byte[] data = new byte[dis.available()];
	    dis.readFully(data);
	    
	    PKCS7 pkcs = new PKCS7(new DerInputStream(data));
	    
	    System.err.println(pkcs);

	} catch (Exception e) {
	    e.printStackTrace();
	}
    }
}
    
