/*
 * @(#)ExceptionOutputStream.java	1.8 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
import java.io.OutputStream;
import java.io.IOException;


public
class ExceptionOutputStream extends OutputStream {
    /**
     * Writes a byte to the buffer.
     * @param b	the byte
     */
    public void write(int b) throws IOException
    {
	if (currentOffset >= exceptionOffset) {
	    throw new IOException("Debug exception");
	}
	currentOffset++;
    }

    private int exceptionOffset = 0;
    private int currentOffset = 0;
  
    public void setExceptionOffset(int offset)
    {
      exceptionOffset = offset;
      currentOffset = 0;
    }
  
}
