/*
 * @(#)URLTest.java	1.7 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
import java.io.*;
import java.net.URL;

class URLTest implements java.io.Serializable {

    /**
     * Test that instances of the File class are written and read correctly
     */
    public static void main (String argv[]) {
	FileInputStream istream = null;
	try {
	    FileOutputStream ostream = new FileOutputStream("_URLTest.tmp");
	    ObjectOutputStream p = new ObjectOutputStream(ostream);

	    URL a = new URL("http://java.sun.com/index.html#foo");
	    p.writeObject(a);
	    p.flush();

	    istream = new FileInputStream("_URLTest.tmp");
	    ObjectInputStream q = new ObjectInputStream(istream);

	    URL a_result = (URL)q.readObject();

	    if (!a.equals(a_result)) {
		System.err.println("URL test failed");
		System.err.println("a = " + a);
		System.err.println("a_result = " + a_result);
	    }
	}
	catch (Exception e) {
	    e.printStackTrace();
	    System.err.println("Input remaining");
	    int ch;
	    try {
		while ((ch = istream.read()) != -1)
		    System.err.print(Integer.toString(ch, 16)+ " ");
		System.err.println();
		
	    } catch (Exception f) {
	    }
	    
	}
    }
}

