/*
 * @(#)TestDesktopPaneUI.java	1.3 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
 
package testlnf;

import javax.swing.*;
import javax.swing.plaf.*;

public class TestDesktopPaneUI extends DesktopPaneUI{

    JDesktopPane desktop;
    DesktopManager desktopManager;

    public static ComponentUI createUI(JComponent c) {
        return new TestDesktopPaneUI();
    }

    public void installUI(JComponent c)   {
	desktop = (JDesktopPane)c;
	installDesktopManager();
    }

    public void uninstallUI(JComponent c) {
	uninstallDesktopManager();
	desktop = null;
    }

    protected void installDesktopManager() {
	if(desktop.getDesktopManager() == null) {
	    desktopManager = new DefaultDesktopManager();
	    desktop.setDesktopManager(desktopManager);
	}
    }

    protected void uninstallDesktopManager() {
	if(desktop.getDesktopManager() == desktopManager) {
	    desktop.setDesktopManager(null);
	}
	desktopManager = null;
    }

}
