/*
 * @(#)TestFileChooserUI.java	1.3 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
 
package testlnf;

import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.filechooser.*;
import javax.swing.plaf.*;

import java.awt.Component;
import java.awt.Graphics;
import java.io.File;

public class TestFileChooserUI extends FileChooserUI{
    public static ComponentUI createUI(JComponent c) {
        return new TestFileChooserUI();
    }

    FileFilter fileFilter = new FileFilter() {
	public boolean accept(File f) {
	    return true;
	}
	public String getDescription() {
	    return "test file filter";
	}
    };

    FileView fileView = new TestFileView();

    public FileFilter getAcceptAllFileFilter(JFileChooser fc) {
	return fileFilter;
    }

    public FileView getFileView(JFileChooser fc) {
	return fileView;
    }

    public String getApproveButtonText(JFileChooser fc) {
	return "okay";
    }

    public String getDialogTitle(JFileChooser fc) {
	return "filechooser";
    }

    public void rescanCurrentDirectory(JFileChooser fc) {}
    public void ensureFileIsVisible(JFileChooser fc, File f) {}
}

class TestFileView extends FileView {
    // Method implementations from BasicFileChooserUI.java

    public String getName(File f) {
	String fileName = null;
	if (f != null) {
	    fileName = f.getName();
	    if (fileName.equals("")) {
		fileName = f.getPath();
	    }
	}
	return fileName;
    }

    public String getDescription(File f) {
	return f.getName();
    }

    public String getTypeDescription(File f) {
	if (f.isDirectory()) {
	    return "directory";
	} else {
	    return "file";
	}
    }

    public Icon getIcon(File f) {
	return new Icon() {
	    public void paintIcon(Component c, Graphics g, int x, int y) {}
	    public int getIconWidth()  { return 0; }
	    public int getIconHeight() { return 0; }
	};
    }

    public Boolean isTraversable(File f) { 
	return Boolean.TRUE; 
    }
}
