/*
 * @(#)Ver.java	1.7 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package ver;

import java.net.*;
import java.awt.*;

public class Ver extends java.applet.Applet {
    GridLayout grid;

    public static void main (String[] args) {
	(new Ver()).init();
    }

    public synchronized void init() {

	grid = new GridLayout(0, 2);
	setLayout(grid);

	showallpack();
	showpack(Ver.class);
    }

    void showallpack() {
	Package[] packages;

	packages = Package.getAllPackages();
	
	for (int i = 0; i < packages.length; i++) {
	    printpack(packages[i]);
	}
    }

    void printpack(Package p) {
	System.out.println(p + ": ");
	System.out.println("\tname: " + p.getName());

	System.out.println(", specTitle: " + p.getSpecificationTitle() +
			   ", specVersion: " + p.getSpecificationVersion() +
			   ", specVendor: " + p.getSpecificationVendor());

	System.out.println("\timplTitle: " + p.getImplementationTitle() +
			   ", implVersion: " + p.getImplementationVersion() +
			   ", implVendor: " + p.getImplementationVendor());
    }

	
    void showpack(Class cl) {
	Package p = cl.getPackage();
	if (p == null) {
	    System.out.println("showpack package == null");
	    return;
	}

	printpack(p);

	showattr("Package", p.toString());
	showattr("\tspecTitle: ",  p.getSpecificationTitle());
	showattr("\tspecVersion: ",  p.getSpecificationVersion());
	showattr("\tspecVendor: ",  p.getSpecificationVendor());

	showattr("\timplTitle: ",  p.getImplementationTitle());
	showattr("\timplVersion ",  p.getImplementationVersion());
	showattr("\timplVendor ",  p.getImplementationVendor());

	try {
	    showcompat(p, "1.0", true);
	    showcompat(p, "1.0.1", true);
	    showcompat(p, "1.1", false);
	    showcompat(p, "1.0.1.1.1", false);
	    showcompat(p, ".9", false);
	} catch (Exception e) {
	    System.out.println("Recaught exception");
	    e.printStackTrace();
	}
    }

    void showcompat(Package p, String desired, boolean correct) {
	try {
	    boolean compat = p.isCompatibleWith(desired);
	    if (compat != correct) {
		System.out.print("Error: ");

		if (compat) {
		    System.out.println("Compatible with " + desired);
		} else {
		    System.out.println("Incompatible with " + desired);
		}
	    }
	    if (grid != null) {
		add(new Label(desired, Label.RIGHT));
		add(new TextField(compat ? "Compatible" : "Incompatible", 30));
	    }
	} catch (NumberFormatException e) {
	    if (grid != null) {
		add(new Label(desired, Label.RIGHT));
		add(new TextField("NumberFormatException ", 30));
	    }
	}
    }

    void showattr(String label, String attr) {

	if (grid != null) {
	    add(new Label(label, Label.RIGHT));
	    add(new TextField(attr, 30));
	}
	System.out.println(label + " = " +  attr);
    }
}
