/*
 * @(#)jcov_error.c	1.3 00/02/02
 *
 * Copyright 1999, 2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#include <stdlib.h>
#include "jcov.h"

void jcov_internal_error(int err_code)
{
    fprintf(stderr, "*** JCOV internal error (%d)\n", err_code);
    CALL(ProfilerExit)((jint)err_code);
}

void jcov_error(const char *message)
{
    fprintf(stderr, "*** JCOV error : %s\n", message);
}

void jcov_warn(const char *message)
{
    fprintf(stderr, "*** JCOV WARNING : %s\n", message);
}

void jcov_info(const char *message)
{
    fprintf(stdout, "### JCOV INFO : %s\n", message);
}

void jcov_error_stop(const char *message)
{
    jcov_error(message);
    CALL(ProfilerExit)((jint)1);
}
