/*
 * @(#)jcov_htables.h	1.4 01/04/21
 *
 * Copyright 1999-2001 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#ifndef _JCOV_HTABLES_H
#define _JCOV_HTABLES_H

#include "jvmpi.h"
#include "jni.h"
#include "jcov.h"

void jcov_htables_init(void);
void class_table_iterate(void *(*f)(void *, void *));
void class_key_table_iterate(void *(*f)(void *, void *));

int           compare_class_key(void *c1, void *c2);
jcov_class_t *lookup_class_by_key(jcov_class_t *class);
jcov_class_t *put_class_by_key(jcov_class_t **c);

int                  compare_hooked_classes(void *c1, void *c2);
unsigned int         size_hooked_class(void *c);
unsigned int         hash_hooked_class(void *c);
jcov_hooked_class_t *lookup_hooked_class(jcov_hash_t *table, char *name);
jcov_hooked_class_t *put_hooked_class(jcov_hash_t *table, jcov_hooked_class_t **c);
void                 remove_hooked_class(jcov_hash_t *table, jcov_hooked_class_t *c);

jcov_class_t *lookup_class_by_id(jobjectID class_id);
jcov_class_t *put_class_by_id(jcov_class_t **c);
void          remove_class_by_id(jobjectID class_id);
int           find_method_in_class(jcov_class_t *c, JVMPI_Method *m);

jcov_method_t *lookup_method(jmethodID method_id);
jcov_method_t *put_method(jcov_method_t **m);
jcov_method_t *lookup_method0(jmethodID method_id);
jcov_method_t *put_method0(jcov_method_t **m);
void remove_method(jmethodID method_id);
int array_lookup_method(JVMPI_Method *key,
			jcov_method_t **arr,
			int arr_len,
			int start_index);

jcov_thread_t *lookup_thread(JNIEnv *thread_id);
jcov_thread_t *put_thread(jcov_thread_t **thread);
void remove_thread(JNIEnv *thread_id);

#endif /* _JCOV_HTABLES_H */
