/*
 * @(#)realpath.c	1.3 00/02/02
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 * The dynamic library code in glibc does not seem to canonicalize
 * path names to when checking if a library has already been loaded.
 * As a result, if LD_LIBRARY_PATH is set with non-canonical paths
 * then the loading of libfontmanager.so-linked-against-libawt.so
 * causes a duplicate loading of libawt.so (the
 * System.loadLibrary("awt") call uses the canonical path name).
 *
 * This program is a simple workaround to the problem so that
 * .java_wrapper can set LD_LIBRARY_PATH to match the canonicalization
 * made by System.loadLibrary().
 */

#include <stdlib.h>              /* for realpath() */
#include <limits.h>              /* for PATH_MAX   */

int main(int argc, char *argv[])
{
    char resolved_path[PATH_MAX];
    char *result;

    if (argc != 2)
       return 1;
    result = realpath(argv[1], resolved_path);
    if (result == NULL)
       return 2;

    /* all is well. */
    printf("%s\n", resolved_path);
    return 0;
}
