/*
 * @(#)MPanelPeer.java	1.28 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.awt.motif;

import java.awt.*;
import java.awt.peer.*;

import sun.awt.SunGraphicsCallback;

class MPanelPeer extends MCanvasPeer implements PanelPeer {

    MPanelPeer() {}

    MPanelPeer(Component target) {
	super(target);
    }

    MPanelPeer(Component target, Object arg) {
	super(target, arg);
    }

    public Insets getInsets() {
	return new Insets(0, 0, 0, 0);
    }

    public void paint(Graphics g) {
        super.paint(g);
        SunGraphicsCallback.PaintHeavyweightComponentsCallback.getInstance().
            runComponents(((Container)target).getComponents(), g,
                          SunGraphicsCallback.LIGHTWEIGHTS |
                          SunGraphicsCallback.HEAVYWEIGHTS);
    }
    public void print(Graphics g) {
        super.print(g);
        SunGraphicsCallback.PrintHeavyweightComponentsCallback.getInstance().
            runComponents(((Container)target).getComponents(), g,
                          SunGraphicsCallback.LIGHTWEIGHTS |
                          SunGraphicsCallback.HEAVYWEIGHTS);
    }

    public void setBackground(Color c) {
	Component comp;
	int i;

	Container cont = (Container) target;
	synchronized(target.getTreeLock()) {
	    int n = cont.getComponentCount();
	    for(i=0; i < n; i++) {
	        comp = cont.getComponent(i);
	        MComponentPeer peer = (MComponentPeer) MToolkit.targetToPeer(comp);
	        if (peer != null) {
		    Color color = comp.getBackground();
                    if (color == null || color.equals(c)) {
			peer.setBackground(c);
		        peer.pSetBackground(c);
		    }
		    if ((comp instanceof java.awt.List) ||
			   (comp instanceof java.awt.TextArea) ||
			   (comp instanceof java.awt.ScrollPane)) {
		        peer.pSetScrollbarBackground(c);
		    }
 		}
	    }
	}
	pSetBackground(c);
    }

    public void setForeground(Color c) {
	Component comp;
	int i;

	Container cont = (Container) target;
	synchronized(target.getTreeLock()) {
	    int n = cont.getComponentCount();
	    for(i=0; i < n; i++) {
	        comp = cont.getComponent(i);
	        MComponentPeer peer = (MComponentPeer) MToolkit.targetToPeer(comp);
	        if (peer != null) {
		    Color color = comp.getForeground();
                    if (color == null || color.equals(c)) {
			peer.setForeground(c);
		        peer.pSetForeground(c);
		    }
		    if ((comp instanceof java.awt.List) ||
			   (comp instanceof java.awt.TextArea) ||
			   (comp instanceof java.awt.ScrollPane)) {
		        peer.pSetInnerForeground(c);
		    }
 		}
	    }
	}
	pSetForeground(c);
    }

    /**
     * DEPRECATED:  Replaced by getInsets().
     */
    public Insets insets() {
	return getInsets();
    }

}

