/*
 * @(#)MWindowAttributes.java	1.4 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.awt.motif;
import java.awt.Image;

class MWindowAttributes {
    static int NORMAL		= 0;
    static int ICONIC		= 1;
    static int MAXIMIZED	= 2;

    static int AWT_DECOR_NONE        = 0;
    static int AWT_DECOR_ALL         = 1;
    static int AWT_DECOR_BORDER      = 2;
    static int AWT_DECOR_RESIZEH     = 4;
    static int AWT_DECOR_TITLE       = 8;
    static int AWT_DECOR_MENU        = 0x10;
    static int AWT_DECOR_MINIMIZE    = 0x20;
    static int AWT_DECOR_MAXIMIZE    = 0x40;

    boolean nativeDecor;
    boolean initialFocus;
    boolean isResizable;
    int initialState;
    String title;
    java.awt.Image icon;
    int	decorations;		// for future expansion to be able to 
				// specify native decorations
    
    private static native void initIDs();
    
    static {
	initIDs();
    }

    MWindowAttributes() {
        nativeDecor = false;
        initialFocus = false;
        isResizable = false;
        initialState = NORMAL;
	title = null;
	icon = null;
	decorations = 0;
    }   
}

