/*
 * @(#)PrintControl.java	1.6 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.awt.motif;

import java.awt.*;

/** 
 * An interface for creating a PrintJob object from a given set of
 * print properties.
 *
 * @version 	1.6 02/02/00
 * @author 	Amy Fowler
 */
public interface PrintControl {

    /**
     * Printer destination type. 
     */
    public final static int PRINTER = 0;

    /**
     * File destination type.
     */
    public final static int FILE = 1;

    /**
     * Number of destination types.
     */
    public final static int DEST_N = 2;

    /**
     * Landscape print orientation.
     */
    public final static int LANDSCAPE = 0;

    /**
     * Portrait print orientation.
     */
    public final static int PORTRAIT = 1;

    /**
     * Number of orientation types.
     */
    public final static int ORIENT_N = 2;

    /**
     * Letter paper size.
     */
    public final static int PAPER_LETTER = 0;

    /**
     * Legal paper size.
     */
    public final static int PAPER_LEGAL = 1;

    /**
     * Excecutive paper size.
     */
    public final static int PAPER_EXECUTIVE = 2;

    /**
     * A4 paper size.
     */
    public final static int PAPER_A4 = 3;

    /**
     * Number of paper types.
     */
    public final static int PAPER_N = 4;


    public PrintJob createPrintJob(int destType, String destString, String lpOptions,
                      String bannerStr, int paperSize, int orient, int numCopies); 

}

        
        
