/*
 * @(#)PrintStatusDialog.java	1.7 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.awt.motif;

import java.awt.*;
import java.awt.event.*;


/** 
 * A class for creating a dialog to display print status
 * messages to the user.
 *
 * @version 	1.7 02/02/00
 * @author 	Amy Fowler
 */
public class PrintStatusDialog extends Dialog implements ActionListener {
    Panel buttonPanel;
    String command;

    PrintStatusDialog(Frame f, String title, String msg) {
        super(f, title, true);
        setLayout(new BorderLayout());

        Label l = new Label(msg);
        add("Center", l);

        buttonPanel = new Panel();
        buttonPanel.setLayout(new FlowLayout());
        add("South", buttonPanel);

    }

    public PrintStatusDialog(Frame f, String title, String msg,
                             String command) {
        this(f, title, msg);
        Button b = new Button(command);
        b.setActionCommand(command);
        buttonPanel.add(b);
        b.addActionListener(this);

        pack();
    }

    public PrintStatusDialog(Frame f, String title, String msg,
                             String command1, String command2) {
        this(f, title, msg, command1);
        Button b = new Button(command2);
        b.setActionCommand(command2);
        buttonPanel.add(b);
        b.addActionListener(this);

        pack();
    }

    public void actionPerformed(ActionEvent e) {
        command = e.getActionCommand();
        hide();
    }

    public String getCommand() {
        return command;
    }
}
 

        
        
