/*
 * @(#)X11Image.java	1.16 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.awt.motif;

import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.awt.image.ImageProducer;

import sun.awt.image.ImageRepresentation;

class X11Image extends sun.awt.image.Image {
    /**
     * Construct an image from an ImageProducer object.
     */
    public X11Image(ImageProducer producer) {
	super(producer);
    }

    public Graphics getGraphics() {
	throw new IllegalAccessError("getGraphics() only valid for images created with createImage(w, h)");
    }

    protected ImageRepresentation makeImageRep() {
	return new ImageRepresentation(this, ColorModel.getRGBdefault(),
                                       false);
    }

    protected ImageRepresentation getImageRep() {
	return super.getImageRep();
    }

    protected ColorModel getColorModel() {
        return super.getColorModel();
    }

    protected BufferedImage getBufferedImage() {
        return super.getBufferedImage();
    }

}
