/*
 * @(#)TinyCanvasPeer.java	1.11 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.awt.tiny;

import java.awt.*;
import java.awt.peer.*;

class TinyCanvasPeer extends TinyComponentPeer implements CanvasPeer {
    TinyCanvasPeer() {
    }

    TinyCanvasPeer(Canvas target) {
	winCreate((TinyComponentPeer)target.getParent().getPeer());
	init(target);
    }

    void paintComponent(Graphics g) {
	g.setColor(target.getBackground());
	g.fillRect(0, 0, width, height);
    }
    public void update(Graphics g) {
	target.update(g);
    }

    public boolean handleWindowEvent(Event evt) {
	switch(evt.id) {
	  case Event.KEY_PRESS:
	  case Event.KEY_RELEASE:
	  case Event.KEY_ACTION:
	  case Event.KEY_ACTION_RELEASE:
	  case Event.GOT_FOCUS:
	  case Event.LOST_FOCUS:
	    // NEW_EVENT_MODEL: already delivered to target
	    return true;
	  case Event.MOUSE_DOWN: 
	    requestFocus();
	    //fall-thru	
	  default:
	    evt.target = target;
	    targetEvent(evt);
	}
	return true;
    }

    public void requestFocus() {
	requestFocus(this);
    }
}




