/*
 * @(#)TinyDialogPeer.java	1.14 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.awt.tiny;

import java.awt.*;
import java.awt.peer.*;

class TinyDialogPeer extends TinyWindowPeer implements DialogPeer {
    TinyDialogPeer() {
    }

    TinyDialogPeer(Dialog target) {
	String str = target.getTitle() == null ? "Dialog" : target.getTitle();

	if (useTinyWindowManager()) {
	    frame = new TinyWindowFrame(this, str, target.getWarningString(), target.isResizable());
	} else {
	    frame = new TinyWinManagerFrame(this, str, target.getWarningString(), target.isResizable());
	}
	init(target);
    }

    public void setTitle(String title) {
	frame.setTitle(title);
    }
    public void setResizable(boolean r) {
	frame.setResizable(r);
    }	
    // Pass this on to the frame and let it deal with it.
    public void dispose() {
	frame.dispose();
    }
}

