/*
 * @(#)TinyFrame.java	1.11 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.awt.tiny;
/** 
 * @version     1.2 02/23/96
 * @author      Siebe Brouwer
 *
 * A base class for FrameClasses
 * see TinyWindowFrame.java TinyFramePeer.java
 * TinyWinManagerFrame.java TinyWindowPeer.java
 */

import java.awt.*;

abstract class TinyFrame extends TinyWindow {

    /**
     * return the insets of the frame
     */
    abstract Insets insets();

    /**
     * set the cursor type
     */
    abstract void setCursor(int cursorType);

    /**
     * set the title of the frame
     */
    abstract void setTitle(String title);

    /**
     * set Resizable
     */
    abstract void setResizable(boolean resizable);

    /**
     * set the menubar of the frame
     */
    abstract void setMenuBar(TinyMenuBarPeer menubar);

    /**
     * set the iconImage
     * used when the frame is Iconized
     */
    abstract void setIconImage(Image im);

    void winCreate(TinyWindow parent, int winManager) {
	if (parent != null) {
	    throw new RuntimeException("Frames with parents are not allowed");
	}

	super.winCreate(parent, winManager);
    }

    abstract void dispose();
}

