/*
 * @(#)TinyFramePeer.java	1.15 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.awt.tiny;

import java.util.Vector;
import java.awt.*;
import java.awt.peer.*;
import java.awt.image.ImageObserver;
import sun.awt.image.ImageRepresentation;

class TinyFramePeer extends TinyWindowPeer implements FramePeer {
    TinyFramePeer(Frame target) {
	if (useTinyWindowManager()) {
	    frame = new TinyWindowFrame(this, target.getTitle(), target.getWarningString(), target.isResizable());
	} else {
	    frame = new TinyWinManagerFrame(this, target.getTitle(), target.getWarningString(), target.isResizable());
	}
	Image icon = target.getIconImage();
	if (icon != null) {
	    setIconImage(icon);
	}
	init(target);
    }

    public void setTitle(String title) {
	frame.setTitle(title);
    }
    public void setResizable(boolean r) {
	frame.setResizable(r);
    }
    public void setIconImage(Image im) {
	frame.setIconImage(im);
    }
    public void setMenuBar(MenuBar mb) {
	frame.setMenuBar((mb == null) ? null : (TinyMenuBarPeer)mb.getPeer());
    }	
    public void setCursor(int cursorType) {
	frame.setCursor(cursorType);
    }
    // Pass this on to the frame and let it deal with it.
    public void dispose() {
	frame.dispose();
    }
}




