/*
 * @(#)TinyHorizontalScrollbar.java	1.9 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.awt.tiny;

import java.awt.*;

/**
 * A simple horizontal scroll bar. The scrollbar is made horizontal
 * by taking a vertical scrollbar and swapping the x and y coordinates.
 */
class TinyHorizontalScrollbar extends TinyVerticalScrollbar {
    void drawLine(Graphics g, int x1, int y1, int x2, int y2) {
	g.drawLine(y1, x1, y2, x2);
    }

    void fillRect(Graphics g, int x, int y, int w, int h) {
	g.fillRect(y, x, h, w);
    }

    void fillPolygon(Graphics g, int x[], int y[], int npts) {
	g.fillPolygon(y, x, npts);
    }

    void paint(Graphics g, Color colors[], int width, int height) {
	super.paint(g, colors, height, width);
    }

    boolean handleWindowEvent(Event evt, int width, int height) {
	evt.x ^= evt.y;
	evt.y ^= evt.x;
	evt.x ^= evt.y;
	return super.handleWindowEvent(evt, height, width);
    }
}
