/*
 * @(#)TinyImage.java	1.14 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.awt.tiny;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.image.ImageProducer;

import sun.awt.image.ImageRepresentation;

class TinyImage extends sun.awt.image.Image {
    /**
     * Construct an image from an ImageProducer object.
     */
    public TinyImage(ImageProducer producer) {
	super(producer);
    }

    public Graphics getGraphics() {
	Graphics g = new TinyGraphics(this);
	return g;
    }

    protected ImageRepresentation makeImageRep() {
        // REMIND:  might want a different color model/image type
	return new ImageRepresentation(this, ColorModel.getRGBdefault(),
                                       false);
    }

    protected ImageRepresentation getImageRep() {
	return super.getImageRep();
    }
}
