/*
 * @(#)TinyPanelPeer.java	1.12 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.awt.tiny;

import java.awt.*;
import java.awt.peer.*;

class TinyPanelPeer extends TinyCanvasPeer implements PanelPeer {
    TinyPanelPeer() {
    }

    TinyPanelPeer(Component target) {
	winCreate((TinyComponentPeer)target.getParent().getPeer());
	init(target);
    }

    public Insets getInsets() {
	return new Insets(0, 0, 0, 0);
    }

    public void print(Graphics g) {
	super.print(g);
	((Container)target).printComponents(g);
    }

    public boolean handleWindowEvent(Event evt) {
	switch(evt.id) {
	  case Event.KEY_PRESS:
	  case Event.KEY_RELEASE:
	  case Event.KEY_ACTION:
	  case Event.KEY_ACTION_RELEASE:
	  case Event.GOT_FOCUS:
	  case Event.LOST_FOCUS:
	    // NEW_EVENT_MODEL: already delivered to target
	    return true;
	  default:
	    evt.target = target;
	    targetEvent(evt);
	}
	return true;
    }

    public void scroll(int dx, int dy) {
	// REMIND: noop for now.
    }

    /**
     * DEPRECATED:  Replaced by getInsets().
     */
    public Insets insets() {
	return getInsets();
    }

}

