/*
 * @(#)clock.h	1.20 00/02/02
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 * External interface to the clock manager (generic to Green threads)
 */

#ifndef _JAVASOFT_GREEN_CLOCK_H_
#define _JAVASOFT_GREEN_CLOCK_H_

#include "timeval_md.h"
#include "threads_md.h"
#include "monitor_md.h"

/*
 * Operations on timevals.
 *
 * NB: timerCmp does not work for >=, <= or ==.
 */

#define timerIsSet(tvp)         ((tvp)->tv_sec || (tvp)->tv_usec)
#define timerCmp(tvp, uvp, cmp) \
        (((tvp)->tv_sec cmp (uvp)->tv_sec) || \
         ((tvp)->tv_sec == (uvp)->tv_sec && (tvp)->tv_usec cmp (uvp)->tv_usec))
#define timerEq(tvp, uvp) \
         ((tvp)->tv_sec == (uvp)->tv_sec && (tvp)->tv_usec == (uvp)->tv_usec)
#define timerClear(tvp)         (tvp)->tv_sec = (tvp)->tv_usec = 0

void timerAdd(timeval_t*, timeval_t*);
void timerSub(timeval_t*, timeval_t*);
void threadGetTimeout(timeval_t *, int*, int*);
void threadSetTimeout(timeval_t *, int, int);
/*
 * Bootstrap
 */
void clockInit(void);

/*
 * Cleanup
 */
void cleanupPendingAlarm(sys_thread_t *);

/*
 * Monitor timeout registery
 */
void registerAlarm(sys_thread_t *, timeval_t);

/*
 * Initialize clock
 */
void InitializeClock(void);

extern sys_thread_t *threadAlarmQ;

#endif /* !_JAVASOFT_GREEN_CLOCK_H_ */
