/*
 * @(#)context.h	1.20 00/02/02
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 * Generic include for Green contexts
 */

#ifndef _JAVASOFT_GREEN_CONTEXT_H_
#define _JAVASOFT_GREEN_CONTEXT_H_

#include "context_md.h"

#define CONTEXT(tid)    (&((tid)->mdcontext))

typedef struct  {
        stackp_t        base;
        uint_t          size;
} gstack_t;

#ifdef __linux__
void initContext(gcontext_t *uc, gstack_t *, unsigned int pc,
		 void (*death_func)(void), unsigned int arg);
#else
void initContext(ucontext_t *uc, gstack_t *, unsigned int pc,
		 void (*death_func)(void), unsigned int arg);
#endif
int allocateContextAndStack(sys_thread_t *tid, long stacksize);
void deleteContextAndStack(sys_thread_t *tid);
void cleanupPendingAlarm(sys_thread_t *tid);
void * currentStackPointer(sys_thread_t *tp);

#endif /* !_JAVASOFT_GREEN_CONTEXT_H_ */
