/*
 * @(#)context_md_solaris.h	1.32 00/02/02
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 * Solaris-dependent API
 */

#ifndef _JAVASOFT_SOLARIS_CONTEXT_MD_H_
#define _JAVASOFT_SOLARIS_CONTEXT_MD_H_

#include <ucontext.h>
#include <errno.h>
#include <setjmp.h>

/*
 * A solaris2 context.  Everything else is on the stack.
 */

typedef struct {
    unsigned int unix_errno;
    stackp_t current_sp;
    jmp_buf env;
} context_t;

/* Save state of the current content and call rescheduler */

void reschedule(void);


#define	switchContext(contextp) {			\
    errno = (contextp)->unix_errno;			\
    longjmp((contextp)->env, 1);			\
}


#define saveContext(contextp, sp)				\
    ((contextp)->current_sp = sp, setjmp((contextp)->env))

#define yieldContext(contextp)					\
{								\
    unsigned char *dummy;					\
    if (saveContext((contextp), (stackp_t)&dummy) == 0) {	\
	(contextp)->unix_errno = errno;				\
	reschedule();						\
    }								\
}

#endif /* !_JAVASOFT_SOLARIS_CONTEXT_MD_H_ */
