/*
 * @(#)itimer_md.h	1.17 00/02/02
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 * Machine or host dependent API.
 */

#ifndef _JAVASOFT_SOLARIS_ITIMER_H_
#define _JAVASOFT_SOLARIS_ITIMER_H_

#include <timeval_md.h>

/*
 *	timeval_t currentTime(): return the current time, a 64 bit
 *	    integer, in units of microseconds.
 *	unsigned int hostClockInit(): do any platform specific
 *	    initialization for the clock.  Return a monitor that the async
 *	    notification will be performed upon.
 *	void scheduleAlarm(timeval_t): schedule the alarm to occur
 *	    the indicated number of microseconds in the future.
 *	void cancelAlarm(): cancel the pending alarm (if any).
 */

timeval_t currentTime(void);
unsigned int hostClockInit(void);
void scheduleAlarm(timeval_t);
void cancelAlarm(void);

#endif /* !_JAVASOFT_SOLARIS_ITIMER_H_ */
