/*
 * @(#)mutex_md.h	1.8 00/03/16
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 * Interface to mutex HPI implementation for Solaris
 */

#ifndef _JAVASOFT_MUTEX_MD_H_
#define _JAVASOFT_MUTEX_MD_H_

#ifdef __solaris__
#include <synch.h>
#endif

/*
 * Generally, we would typedef mutex_t to be whatever the system
 * supplies.  But Solaris gives us mutex_t directly.
 */

#define mutexOwner(m) (*(sys_thread_t **)&((m)->lock.owner64))

#define mutexInit(m) memset(m, 0, sizeof(*m))
#define mutexDestroy(m) ((void) 0)
#define mutexLocked(m) \
	(mutexOwner(m) == greenThreadSelf())

#ifdef __linux__
typedef sig_atomic_t mutex_t;
#endif

int mutexLock(mutex_t * m);
int mutexUnlock(mutex_t * m);

#endif /* !_JAVASOFT_MUTEX_MD_H_ */
