/*
 * @(#)queue.h	1.14 00/02/02
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

/*
 * A set of queue handling macros for processes.  Generic to Green
 * threads package.
 */

#ifndef _JAVASOFT_GREEN_QUEUE_H_
#define _JAVASOFT_GREEN_QUEUE_H_

#include "monitor_md.h"
#include "threads_md.h"

typedef sys_thread_t * gt_queue_t;	/* linked through "waitq" field */

extern gt_queue_t runnable_queue;

void queueInsert(gt_queue_t *, sys_thread_t *);
int queueRemove(gt_queue_t *, sys_thread_t *);
int queueSignal(sys_mon_t *, gt_queue_t *);
void queueWait(sys_mon_t *, gt_queue_t *);
void queueBroadcast(sys_mon_t *);
#define queueRemoveHead(q, t) (t=*(q), (t ? *(q)=(t)->waitq : 0), t)

#endif /* !_JAVASOFT_GREEN_QUEUE_H_ */
