/*
 * Copyright 2000 Sun Microsystems, Inc. All rights reserved.
 * Copyright 2000 Sun Microsystems, Inc. Tous droits rservs.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 */

#pragma	ident	"@(#)main.c	1.4	00/05/04 SMI"

/*
 * Generate wrapper scripts for Java applications
 */

#include <stdlib.h>
#include <stdio.h>
#include <strings.h>
#include <unistd.h>
#include <fcntl.h>
#include <locale.h>

#include "javald.h"

static void
push_name(struct list **lp, char *name)
{
	struct list *l = malloc(sizeof (*l));
	l->name = name;
	l->next = *lp;
	*lp = l;
}

int
main(int argc, char *argv[])
{
	int c, fd;
	int errflg = 0;
	int dflg = 0;
	char *pgm;

	struct list *classlist = NULL;
	struct list *ldliblist = NULL;
	char *java_home = NULL;
	char *javaopts = NULL;
	char *wrapper = NULL;
	char *classname = NULL;

	(void) setlocale(LC_ALL, "");
#if !defined(TEXT_DOMAIN)
#define	TEXT_DOMAIN	"SYS_TEST"
#endif
	(void) textdomain(TEXT_DOMAIN);

	if (pgm = strrchr(*argv, '/'))
		pgm++;
	else
		pgm = *argv;

	while ((c = getopt(argc, argv, "C:R:H:o:j:d")) != EOF)
		switch (c) {
		case 'C':
			push_name(&classlist, optarg);
			break;
		case 'R':
			push_name(&ldliblist, optarg);
			break;
		case 'H':
			if (java_home)
				errflg++;
			else
				java_home = optarg;
			break;
		case 'o':
			if (wrapper)
				errflg++;
			else
				wrapper = optarg;
			break;
		case 'j':
			if (javaopts)
				errflg++;
			else
				javaopts = optarg;
			break;
		case 'd':
			dflg++;
			break;
		case '?':
			errflg++;
			break;
		}

	if (optind + 1 != argc)
		errflg++;
	else
		classname = argv[optind];

	if (errflg) {
		(void) fprintf(stderr, gettext("usage: %s [-C dir] "
			"[-R dir] [-H dir] [-j opts] [-o filename] "
			"classname\n"), pgm);
		return (1);
	}

	if (java_home == 0)
		java_home = DEFAULT_JAVA_HOME;

	if (classlist == NULL)
		push_name(&classlist, ".");

#ifdef notdef
	/*
	 * XXX	java itself will do this
	 */
	push_name(&classlist, DEFAULT_JAVA_CLASSES);
#endif

	if (wrapper == 0) {
		/*
		 * The default wrapper is placed in the current directory
		 */
		if ((wrapper = strrchr(classname, '/')) == 0)
			wrapper = classname;
		else
			wrapper++;
	}

	if ((fd = creat(wrapper, 0777)) == -1) {
		perror(wrapper);
		return (2);
	}

	if (emit_script(fd, dflg,
	    java_home, classlist, ldliblist, javaopts, classname))
		return (0);

	(void) unlink(wrapper);
	return (1);
}
