/*
 * @(#)robot_common.h	1.5 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
#ifndef _ROBOT_COMMON_H
#define _ROBOT_COMMON_H

#include "java_awt_event_InputEvent.h"
#include "java_awt_event_KeyEvent.h"
#include "java_awt_event_MouseEvent.h"

enum {
    RCMD_BEGIN = 0,
    RCMD_SETUP = RCMD_BEGIN,
    RCMD_MOVE,
    RCMD_BPRESS,
    RCMD_BRELEASE,
    RCMD_KPRESS,
    RCMD_KRELEASE,
    RCMD_GETPIXELS,
    RCMD_END = RCMD_GETPIXELS
};


/* MAKE SURE that all RCmdXXX's are padded to the same length */

typedef struct RCmdBase {
    int code;
    int pad1;
    int pad2;
    int pad3;
    int pad4;
    int pad5;
    int pad6;
} RCmdBase;

typedef struct RCmdSetup {
    int code;
    int pad1;
    int pad2;
    int pad3;
    int pad4;
    int pad5;
    int pad6;
} RCmdSetup;

typedef struct RCmdMove {
    int code;
    int screen;
    int x;
    int y;
    int pad4;
    int pad5;
    int pad6;
} RCmdMove;

typedef struct RCmdButton {
    int code;
    int buttonMask;
    int pad2;
    int pad3;
    int pad4;
    int pad5;
    int pad6;
} RCmdButton;

typedef struct RCmdKey {
    int code;
    int keySym;             /* This is to be an X11 KeySym. */
    int pad2;
    int pad3;
    int pad4;
    int pad5;
    int pad6;
} RCmdKey;

typedef struct RCmdGetPixels{
    int code;
    int screen;
    int x;
    int y;
    int width;
    int height;
    int pad6;
} RCmdGetPixels;

enum {
    RES_OUTOFMEMORY,
    RES_SETUP,
    RES_PIXELHEADER,
    RES_PIXELDATA,
    RES_RGBVAL
};

typedef struct RResultSetup {
    unsigned int code;
    int isXTestAvailable;
} RResultSetup;

typedef struct RResultPixelHeader {
    unsigned int code;
    unsigned int nRows;
    unsigned int nCols;
} RResultPixelHeader;

typedef enum RPollResult {
    RPOLL_ERROR,
    RPOLL_TIMEOUT,
    RPOLL_UNBLOCKED
} RPollResult;

extern const char * ROBOT_ARG0; /* special cookie passed to child process */

extern int robot_isCommandValid(int code);
extern void robot_traceln(const char * format, ...);
extern int robot_writeBytes(const char *role, int filedes, char *bytes, int nBytesToWrite);
extern int robot_readBytes(const char *role, int filedes, char *bytes, int nToRead);
extern RPollResult robot_pollForRead(int fd, int timeout);
extern void robot_readFlush();

#endif /* _ROBOT_COMMON_H */
