/*
 * @(#)X11DrawSurfaceTest.java	1.7 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

import java.awt.Frame;
import sun.awt.DrawingSurfaceInfo;
import sun.awt.X11DrawingSurface;

public class X11DrawSurfaceTest extends DrawSurfaceTest {
    public static void main(String argv[]) {
	Frame f = new Frame();

	X11DrawSurfaceTest dst = new X11DrawSurfaceTest();
	f.add(dst);

	f.pack();
	f.show();

	dst.start();
    }

    public DrawSurfaceTracker getTracker(DrawingSurfaceInfo dsi) {
	return new X11DrawSurfaceTracker(dsi);
    }
}

class X11DrawSurfaceTracker extends DrawSurfaceTracker {
    static {
	try {
	    System.loadLibrary("dst");
	} catch (Throwable t) {
	    t.printStackTrace();
	}
    }

    public X11DrawSurfaceTracker(DrawingSurfaceInfo dsi) {
	super(dsi);
    }

    private native void setup(int dpy, int draw,
			      int visid, int cmap,
			      int depth);

    private native void draw(float ctrlpts[],
			     float red, float green, float blue);

    int gc;
    int dpsctx;
    int xdsstate = -1;

    public void drawBezier(DrawingSurfaceInfo dsi, int state,
			   float ctrlpts[],
			   float red, float green, float blue) {
	if (dpsctx == 0 || state != xdsstate) {
	    X11DrawingSurface xds = (X11DrawingSurface) dsi.getSurface();
	    setup(xds.getDisplay(), xds.getDrawable(), xds.getVisualID(),
		  xds.getColormapID(), xds.getDepth());
	    xdsstate = state;
	}
	draw(ctrlpts, red, green, blue);
    }
}
