/*
 * @(#)WCanvasPeer.java	1.17 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.awt.windows;

import java.awt.*;
import java.awt.peer.*;
import sun.awt.DrawingSurface;
import sun.awt.DrawingSurfaceInfo;
import java.lang.ref.WeakReference;
import sun.awt.Win32GraphicsDevice;

class WCanvasPeer extends WComponentPeer
    implements CanvasPeer, DrawingSurface
{

    // Toolkit & peer internals

    WCanvasPeer(Component target) {
        super(target);
    }

	protected void initNonDefaultGC() {
        GraphicsConfiguration gc;
        gc = getTargetGC();
        if (gc != null) {
            //Add Canvas to list of Components to update after a
            //Display Settings change.
            ((Win32GraphicsDevice)gc.getDevice()).addNonDefaultGC(
             new WeakReference(target));
        }
	}

    native void create(WComponentPeer parent);

    void initialize() {
        super.initialize();
	Color bg = ((Component)target).getBackground();
	if (bg != null) {
	    setBackground(bg);
	}
    }

    public void paint(Graphics g) {
	Dimension d = ((Component)target).getSize();
        if (g instanceof Graphics2D ||
	    g instanceof sun.awt.Graphics2Delegate) {
	    // background color is setup correctly, so just use clearRect
	    g.clearRect(0, 0, d.width, d.height);
	} else {
	    // emulate clearRect
	    g.setColor(((Component)target).getBackground());
	    g.fillRect(0, 0, d.width, d.height);
	    g.setColor(((Component)target).getForeground());
	}
	super.paint(g);
    }

    public void print(Graphics g) {
	Dimension d = ((Component)target).getSize();
        if (g instanceof Graphics2D ||
	    g instanceof sun.awt.Graphics2Delegate) {
	    // background color is setup correctly, so just use clearRect
	    g.clearRect(0, 0, d.width, d.height);
	} else {
	    // emulate clearRect
	    g.setColor(((Component)target).getBackground());
	    g.fillRect(0, 0, d.width, d.height);
	    g.setColor(((Component)target).getForeground());
	}
	super.print(g);
    }

    public DrawingSurfaceInfo getDrawingSurfaceInfo() {
	return new WDrawingSurfaceInfo(this);
    }
}
