/*
 * @(#)WCheckboxMenuItemPeer.java	1.14 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package sun.awt.windows;

import java.awt.*;
import java.awt.peer.*;
import java.awt.event.ItemEvent;

class WCheckboxMenuItemPeer extends WMenuItemPeer implements CheckboxMenuItemPeer {

    // CheckboxMenuItemPeer implementation

    public native void setState(boolean t);

    // Toolkit & peer internals

    WCheckboxMenuItemPeer(CheckboxMenuItem target) {
        super(target);
        isCheckbox = true;
        setState(target.getState());
    }

    // native callbacks

    public void handleAction(final boolean state, final int modifiers) {
	final CheckboxMenuItem target = (CheckboxMenuItem)this.target;
	WToolkit.executeOnEventHandlerThread(target, new Runnable() {
	    public void run() {
		target.setState(state);
		postEvent(
		    new ItemEvent(target, ItemEvent.ITEM_STATE_CHANGED, target.getLabel(), 
                          state? ItemEvent.SELECTED : ItemEvent.DESELECTED));
	    }
	});
    }
}
