/*
 * @(#)WEmbeddedFrame.java	1.16 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.awt.windows;

import sun.awt.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.peer.ComponentPeer;
import java.util.*;

public class WEmbeddedFrame extends EmbeddedFrame {

    static {
        initIDs();
    }

    private int handle = 0;

    native void setThisPeer(Object lp);

    public WEmbeddedFrame() {
        this(0);
    }

    public WEmbeddedFrame(int handle) {
        this.handle = handle;
        WToolkit toolkit = (WToolkit)Toolkit.getDefaultToolkit();
        setThisPeer(toolkit.createEmbeddedFrame(this));
        show();
    }

    /*
     * Print the embedded frame and its children using the specified HDC.
     */
    void print(int hdc) {
        WPrintGraphics g = new WEmbeddedPrintGraphics(hdc);
        WPrintGraphicsWrapper gw = new WPrintGraphicsWrapper(g, null);
        printComponents(gw);
        gw.dispose();
    }
  
   /**
     * Initialize JNI field IDs
     */
    private static native void initIDs();
}

