/*
 * @(#)WImage.java	1.15 01/02/09
 *
 * Copyright 1996-2001 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.awt.windows;

import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.awt.image.ImageProducer;

import sun.awt.image.ImageRepresentation;

class WImage extends sun.awt.image.Image {
    /**
     * Construct an image from an ImageProducer object.
     */
    public WImage(ImageProducer producer) {
	super(producer);
    }

    public Graphics getGraphics() {
	throw new IllegalAccessError("getGraphics() only valid for images created with createImage(w, h)");
    }

    protected ImageRepresentation makeImageRep() {
        // WToolkit.makeColorModel() is incorrect for
        // auxillary screens.  Passing null ColorModel instead
        // which will use the CM of the source.
        return new ImageRepresentation(this, null, false);
    }

    protected ImageRepresentation getImageRep() {
	return super.getImageRep();
    }

    protected ColorModel getColorModel() {
        return super.getColorModel();
    }

    protected BufferedImage getBufferedImage() {
        return super.getBufferedImage();
    }
}
