/*
 * @(#)WPrintDialog.java	1.4 00/02/02
 *
 * Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.awt.windows;

import java.awt.*;
import java.awt.peer.*;

class WPrintDialog extends Dialog {
    static {
        initIDs();
    }

    private PrintJob job;
    private WPrintControl control;

    WPrintDialog(Frame parent, WPrintControl control) {
        super(parent, true);
	this.control = control;
	setLayout(null);
    }

    // Use native code to circumvent access restrictions on Component.peer
    private native void setPeer(ComponentPeer peer);

    public void addNotify() {
        synchronized(getTreeLock()) {
	    Container parent = getParent();
            if (parent != null && parent.getPeer() == null) {
                parent.addNotify();
            }

	    if (getPeer() == null) {
	        ComponentPeer peer = ((WToolkit)Toolkit.getDefaultToolkit()).
		    createWPrintDialog(this);
		setPeer(peer);
	    }
	    super.addNotify();
	}
    }

    PrintJob initJob() {
        show();
	return job;
    }

    /**
     * Initialize JNI field and method ids
     */
    private static native void initIDs();
}
