/*
 * @(#)jmath_md.c	1.21 00/02/02
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#include <windows.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <float.h>

/*
 * Implement the remainder operation for floating point.  Since fmod()
 * doesn't do the correct thing for infinity in the divisor, we have
 * to patch up the return values in some of those cases.
 */
double
drem(double dividend, double divisor) {
    double res;
    if (!_finite(divisor)) {
	if (_isnan(divisor))
	    return divisor;
	if (_finite(dividend))
	    return dividend;
    }
    res = fmod(dividend, divisor);
    /* With MSVC, "res == 0" succeeds when res is NaN. */
    if (!_isnan(res) && res == 0) {  /*MSFT fmod doesn't do -0.0 right*/
      return _copysign(0.0,dividend);
    } else {
      return res;
    }
}
