/*
 * @(#)awt_Container.cpp	1.10 00/04/06
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#include "awt_Container.h"
#include "awt.h"

/************************************************************************
 * AwtContainer fields
 */

jfieldID AwtContainer::ncomponentsID;
jfieldID AwtContainer::componentID;
jfieldID AwtContainer::layoutMgrID;
jmethodID AwtContainer::findComponentAtMID;

/************************************************************************
 * AwtContainer native methods
 */

extern "C" {

JNIEXPORT void JNICALL 
Java_java_awt_Container_initIDs(JNIEnv *env, jclass cls) {
    TRY;

    AwtContainer::ncomponentsID = env->GetFieldID(cls, "ncomponents", "I");
    AwtContainer::componentID =
        env->GetFieldID(cls, "component", "[Ljava/awt/Component;");

    AwtContainer::layoutMgrID = 
        env->GetFieldID(cls, "layoutMgr", "Ljava/awt/LayoutManager;");

    AwtContainer::findComponentAtMID =
        env->GetMethodID(cls, "findComponentAt", "(IIZZ)Ljava/awt/Component;");

    DASSERT(AwtContainer::ncomponentsID != NULL);
    DASSERT(AwtContainer::componentID != NULL);
    DASSERT(AwtContainer::layoutMgrID != NULL);
    DASSERT(AwtContainer::findComponentAtMID);

    CATCH_BAD_ALLOC;
}

} /* extern "C" */
