/*
 * @(#)awt_MasterPrinter.h	1.6 00/04/06
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
#ifndef _AWTMASTERPRINTER_H_
#define _AWTMASTERPRINTER_H_

#include "awt_Graphics.h"

#include <commdlg.h>

class AwtMasterPrinterGraphics : public AwtGraphics
{
public:
    AwtMasterPrinterGraphics();
    virtual ~AwtMasterPrinterGraphics();

    BOOL StartPrintJob(jobject pj, jobject dialogOwner);
    void StartPage();
    void EndPage();
    void EndPrintJob();

    struct CreateAndStartStruct {
        /* input parameters */
        jobject self;
        jobject control;
        jobject job;

        /* output parameters */
        jthrowable xcp;
    };

    static void CreateAndStart(void *lpvcass);

private:
    BOOL   m_printingPage;
    BOOL   m_printingJob;
    BOOL   m_fullBleed;
    BOOL   m_printResolution;
    HANDLE m_hPrinter; // not used when printing with native print dialog

    BOOL CreateDevModeAndDevNames(PRINTDLG *ppd, LPTSTR pPrinterName,
				  LPTSTR pPortName = NULL);
};

#endif /* _AWTMASTERPRINTER_H_ */
