/*
 * @(#)awt_PrintDialog.cpp	1.6 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#include "awt_PrintDialog.h"
#include "awt_Dialog.h"
#include "awt_PrintControl.h"
#include "awt_dlls.h"
#include <sun_awt_windows_WPrintDialog.h>
#include <sun_awt_windows_WPrintDialogPeer.h>

jfieldID AwtPrintDialog::jobID;
jfieldID AwtPrintDialog::controlID;
jfieldID AwtPrintDialog::parentID;


BOOL
AwtPrintDialog::PrintDlg(LPPRINTDLGA data) {
    AwtCommDialog::load_comdlg_procs();
    return (BOOL)AwtToolkit::GetInstance().
        InvokeFunction((void *(*)(void *))AwtCommDialog::PrintDlgWrapper,
                     data);
}

BOOL
AwtPrintDialog::PageSetupDlg(LPPAGESETUPDLGA data) {
    AwtCommDialog::load_comdlg_procs();
    return (BOOL)AwtToolkit::GetInstance().
        InvokeFunction((void *(*)(void *))AwtCommDialog::PageSetupDlgWrapper,
		             data);
}


extern "C" {

JNIEXPORT void JNICALL
Java_sun_awt_windows_WPrintDialog_initIDs(JNIEnv *env, jclass cls)
{
    TRY;

    AwtPrintDialog::jobID =
        env->GetFieldID(cls, "job", "Ljava/awt/PrintJob;");
    AwtPrintDialog::controlID =
        env->GetFieldID(cls, "control", "Lsun/awt/windows/WPrintControl;");

    DASSERT(AwtPrintDialog::jobID != NULL);
    DASSERT(AwtPrintDialog::controlID != NULL);

    CATCH_BAD_ALLOC;
}

JNIEXPORT void JNICALL
Java_sun_awt_windows_WPrintDialog_setPeer(JNIEnv *env, jobject target,
					  jobject peer)
{
    TRY;

    env->SetObjectField(target, AwtComponent::peerID, peer);

    CATCH_BAD_ALLOC;
}

JNIEXPORT void JNICALL
Java_sun_awt_windows_WPrintDialogPeer_initIDs(JNIEnv *env, jclass cls)
{
    TRY;

    AwtPrintDialog::parentID =
        env->GetFieldID(cls, "parent", "Lsun/awt/windows/WComponentPeer;");

    DASSERT(AwtPrintDialog::parentID != NULL);

    CATCH_BAD_ALLOC;
}

JNIEXPORT void JNICALL
Java_sun_awt_windows_WPrintDialogPeer__1show(JNIEnv *env, jobject peer)
{
    TRY;

    DASSERT(peer != NULL);
    jobject target = env->GetObjectField(peer, AwtObject::targetID);
    DASSERT(target != NULL);
    jobject parent = env->GetObjectField(peer, AwtPrintDialog::parentID);
    DASSERT(parent != NULL);
    jobject control = env->GetObjectField(target, AwtPrintDialog::controlID);
    DASSERT(control != NULL);

    AwtComponent *awtParent = (AwtComponent *)JNI_GET_PDATA(parent);
    DASSERT(awtParent != NULL);
    
    AwtDialog::ModalDisable(NULL);

    jobject job = env->CallObjectMethod(control,
					AwtPrintControl::createPrintJobID);

    env->SetObjectField(target, AwtPrintDialog::jobID, job);

    AwtDialog::ModalEnable(NULL);
    AwtDialog::ModalNextWindowToFront(awtParent->GetHWnd());

    CATCH_BAD_ALLOC;
}
    
} /* extern "C" */
