/*
 * @(#)awt_Win32GraphicsEnv.h	1.2 00/02/12
 *
 *  Copyright 1999-2001 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

#ifndef AWT_WIN32GRAPHICSENV_H
#define AWT_WIN32GRAPHICSENV_H

#include <windows.h>
#include <awt.h>

//ripped off from awt_MMStub.h
typedef HANDLE MHND;

class AwtWin32GraphicsEnv {
public:
    static void InitScreens(JNIEnv *env);
    static void DisposeScreens(JNIEnv *env);
    static HDC GetDCFromScreen(int screen);
    static MHND GetMHNDFromScreen(int screen);
    static int GetFirst256Screen(void) {return first256Screen;}
    static int GetNumScreens(void) {return awt_numScreens;}
    static MHND GetPrimaryMHND() {return monHds[awt_primaryScreen];}
    static void SetColorParams(JNIEnv *env);

private:
    static int FindFirst256Screen(void);
    static bool NeedToBuildPalette(void);

    static int awt_numScreens;
    static int awt_primaryScreen; // Win32 primary screen
    static MHND *monHds;        // array of monitors
    static int first256Screen;  // screen for which palette should be built
};

#endif //AWT_WIN32GRAPHICSENV_H
