/*
 * @(#)drawsurface.c	1.8 00/02/02
 *
 * Copyright 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */


#include "Win32DrawSurfaceTracker.h"
#include "jni_util.h"

#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <limits.h>

JNIEXPORT void JNICALL
Java_Win32DrawSurfaceTracker_draw(JNIEnv *env, jobject self,
			     jint lWnd, jint lBitmap, jint lDC,
			     jfloatArray ctrlpts,
			     jfloat red, jfloat green, jfloat blue)
{
    HDC hDC;
    POINT pts[4]; 
    HPEN hPen;
    int i;
    jfloat *ctrlptsPtr;

    if (ctrlpts == 0) {
	JNU_ThrowNullPointerException(env, "ctrlpts");
	return;
    }
    if ((*env)->GetArrayLength(env, ctrlpts) < 8) {
	JNU_ThrowArrayIndexOutOfBoundsException(env, "");
	return;
    }
    hDC = (HDC) lDC;
    ctrlptsPtr= (*env)->GetPrimitiveArrayCritical(env, ctrlpts, 0);
    for (i = 0; i < 4; i++) {
	pts[i].x = (long) ctrlptsPtr[i * 2 + 0];
	pts[i].y = (long) ctrlptsPtr[i * 2 + 1];
    }
    (*env)->ReleasePrimitiveArrayCritical(env, ctrlpts, ctrlptsPtr, 0);
    hPen = CreatePen(PS_SOLID, 0, RGB(((byte) (red * 255)),
				      ((byte) (green * 255)),
				      ((byte) (blue * 255))));
    SelectObject(hDC, hPen);
    PolyBezier(hDC, pts, 4);
    SelectObject(hDC, GetStockObject(NULL_PEN));
    DeleteObject(hPen);
}






