/*
 * @(#)ProbeAWTEvent.java	1.5 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.awt.robot.probe;

import java.awt.AWTEvent;

/**
 * ProbeObject that encapsulates AWTEvent structures.
 *
 * @see ProbeMonitor
 * @see ProbeObject
 *
 * @author David Herron <tt>&lt;David.Herron@eng.sun.com&gt;</tt>
 */
public class ProbeAWTEvent extends ProbeObject {

  /**
   * Initialize the object.
   *
   * @param evt The Event being encapsulated.
   * @param otherInfo Other information to be included.
   * @param method The method that created this object, intended
   *    to be used to record listener method names.
   */
  public ProbeAWTEvent(AWTEvent evt, String otherInfo, String method) {
    super(evt.getSource(), otherInfo);
    this.e = evt;
    this.method = method;
  }

  /**
   * Initialize the object.
   *
   * @param evt The Event being encapsulated.
   */
  public ProbeAWTEvent(AWTEvent evt) {
    this(evt, "", null);
  }

  AWTEvent e;
  String method;

  /**
   * Return the encapsulated AWTEvent.
   */
  public AWTEvent getEvent() { return e; }

  /**
   * Return the method that created this event object.
   */
  public String getMethod() { return method; }

  protected String paramString() {
    if (method != null)
      return "event=" + e.toString() + " method=" + method;
    else
      return "event=" + e.toString();
  }

}
