/*
 * @(#)ProbePropertyChangeEvent.java	1.5 00/02/02
 *
 * Copyright 1995-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package sun.awt.robot.probe;

import java.beans.PropertyChangeEvent;

public class ProbePropertyChangeEvent extends ProbeObject {

  PropertyChangeEvent e;
  String method;

  /**
   * Initialize the object.
   *
   * @param evt The Event being encapsulated.
   * @param otherInfo Other information to be included.
   */
  public ProbePropertyChangeEvent(PropertyChangeEvent evt, String otherInfo, String method) {
    super(evt.getSource(), otherInfo);
    this.e = evt;
    this.method = method;
  }

  /**
   * Initialize the object.
   *
   * @param evt The Event being encapsulated.
   */
  public ProbePropertyChangeEvent(PropertyChangeEvent evt) {
    super(evt.getSource(), "");
    this.e = evt;
  }

  /**
   * Retrieve the event structure.
   */
  public PropertyChangeEvent getEvent() { return e; }

  /**
   * Return the method that created this event object.
   */
  public String getMethod() { return method; }

  protected String paramString() {
    return "event=" + e.toString() + " method=" + method;
  }

}
